
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module DE10_Agilex_Clock_Controller(

	//////////// CLOCK //////////
	input 		          		CLK_100_B2A,
	input 		          		CLK_50_B2C,
	input 		          		CLK_50_B3A,
	input 		          		CLK_50_B3C,

	//////////// BUTTON //////////
	input 		     [1:0]		BUTTON,
	inout 		          		CPU_RESET_n,

	//////////// SW //////////
	input 		     [1:0]		SW,

	//////////// LED, Low Active //////////
	output		     [3:0]		LED,
	output		     [3:0]		LED_BRACKET,

	//////////// SI5340A //////////
	inout 		          		SI5340A_I2C_SCL,
	inout 		          		SI5340A_I2C_SDA,
	input 		          		SI5340A_LOL,
	input 		          		SI5340A_LOS_XAXB,
	inout		            		SI5340A_OE_n,
	inout		            		SI5340A_RST_n,
	
	
      ///////// QSFPRSV_REFCLK /////////
   input                      QSFPDDRSV_REFCLK_p,

	//////////// QSFPDD A //////////
	//output		          		QSFPDDA_INITMODE,
	//input 		          		QSFPDDA_INTERRUPT_n,
	//input 		          		QSFPDDA_MOD_PRS_n,
	//output		          		QSFPDDA_MOD_SEL_n,
	input 		          		QSFPDDA_REFCLK_p,
	//output		          		QSFPDDA_RST_n,
	//input 		     [7:0]		QSFPDDA_RX_n,
	//input 		     [7:0]		QSFPDDA_RX_p,
	//inout 		          		QSFPDDA_SCL,
	//inout 		          		QSFPDDA_SDA,
	//output		     [7:0]		QSFPDDA_TX_n,
	//output		     [7:0]		QSFPDDA_TX_p,

	//////////// QSFPDD B //////////
	//output		          		QSFPDDB_INITMODE,
	//input 		          		QSFPDDB_INTERRUPT_n,
	//input 		          		QSFPDDB_MOD_PRS_n,
	//output		          		QSFPDDB_MOD_SEL_n,
	input 		          		QSFPDDB_REFCLK_p
	//output		          		QSFPDDB_RST_n,
	//input 		     [7:0]		QSFPDDB_RX_n,
	//input 		     [7:0]		QSFPDDB_RX_p,
	//inout 		          		QSFPDDB_SCL,
	//inout 		          		QSFPDDB_SDA,
	//output		     [7:0]		QSFPDDB_TX_n,
	//output		     [7:0]		QSFPDDB_TX_p
);



//=======================================================
//  REG/WIRE declarations
//=======================================================
wire [3:0]  SW_SET0 ; 
wire [3:0]  HZ; 
wire        M50_1HZ ; 
wire        si5340a_controller_start;
wire        si5340a_config_done;
wire        tx_clkout_QSFPDDA_REFCLK_p;
wire        tx_clkout_QSFPDDB_REFCLK_p;
wire        tx_clkout_QSFPDDRSV_REFCLK_p ; 

//=======================================================
//  Structural coding
//=======================================================


//=======================================================
//  Configure SI5340A 
//=======================================================


//----- KEY Selection
BUT_SET S1( .CPU_RESET_n(CPU_RESET_n)  , .CLK (CLK_50_B2C), .BT(BUTTON[1]), .SW_MAX (8),  .SW_SET (SW_SET0) );


//----- Configure SI5340A 
`define XCVR_REF_644M53125     4'h0  
`define XCVR_REF_625M          4'h1  
`define XCVR_REF_322M265625    4'h2  
`define XCVR_REF_312M5         4'h3  
`define XCVR_REF_250M          4'h4  
`define XCVR_REF_184M32        4'h5 
`define XCVR_REF_156M25        4'h6 
`define XCVR_REF_125M          4'h7  
`define XCVR_REF_100M          4'h8 


//----- reconfig Si5340-----
assign si5340a_controller_start = ~BUTTON[0];

DE10AGILEX_SI5340A_CONFIG si5340a_controller(
    .iCLK                (CLK_50_B2C),
    .iRST_n              (1'b1),
    .iStart              (si5340a_controller_start),
    .iXCVR_REFCLK_0      ( SW_SET0    ),//to set QSFPDDA_REFCLK_p
    .iXCVR_REFCLK_1      ( SW_SET0    ),//to set QSFPDDB_REFCLK_p
	 .iXCVR_REFCLK_RSV    ( SW_SET0[0] ),//to set QSFPDDRSV_REFCLK_p, 1: enable out1(156M25), 0: disable out1
    .I2C_CLK             (SI5340A_I2C_SCL),
    .I2C_DATA            (SI5340A_I2C_SDA),
    .oPLL_REG_CONFIG_DONE(si5340a_config_done)
);

//assign SI5340A_OE_n  = 1'b0;
//assign SI5340A_RST_n = 1'b1;

assign CPU_RESET_n    =1'bz ; 

//----- heart
CLOCKMEM  HZ_CLK_50_B2C         ( .RESET_n(BUTTON[0]  ) ,.CLK( CLK_50_B2C                   ),.CLK_FREQ   ( 50000000 )  ,.CK_1HZ( HZ[0] ) ) ;
CLOCKMEM  HZ_QSFPDDA_REFCLK_p   ( .RESET_n(BUTTON[0]  ) ,.CLK( tx_clkout_QSFPDDA_REFCLK_p   ),.CLK_FREQ   ( 156250000)  ,.CK_1HZ( HZ[1] ) ) ;
CLOCKMEM  HZ_QSFPDDB_REFCLK_p   ( .RESET_n(BUTTON[0]  ) ,.CLK( tx_clkout_QSFPDDB_REFCLK_p   ),.CLK_FREQ   ( 156250000)  ,.CK_1HZ( HZ[2] ) ) ;
CLOCKMEM  HZ_QSFPDDRSV_REFCLK_p ( .RESET_n(BUTTON[0]  ) ,.CLK( tx_clkout_QSFPDDRSV_REFCLK_p ),.CLK_FREQ   ( 156250000)  ,.CK_1HZ( HZ[3] ) ) ;


//----- LED Display
assign LED         = si5340a_config_done ? HZ[3:0] : 4'b0000 ;

assign LED_BRACKET = 4'b1111 ; 

//----------REFCLK Measure , view SignalTapeII --------
//--1hz generater 
CLOCKMEM  ck2( .RESET_n(BUTTON[0]), .CLK(CLK_50_B2C) ,.CLK_FREQ ( 50000000 )  ,.CK_1HZ( M50_1HZ ) ) ;


//----view frequency by SignalTapeII --------
FRE_MEASURE fQSFPDDA_REFCLK_p   ( .RESET_n(BUTTON[0]),.MES_CLK (tx_clkout_QSFPDDA_REFCLK_p)   , .HZ1(M50_1HZ) , .FREQ( ) ); 
FRE_MEASURE fQSFPDDB_REFCLK_p   ( .RESET_n(BUTTON[0]),.MES_CLK (tx_clkout_QSFPDDB_REFCLK_p)   , .HZ1(M50_1HZ) , .FREQ( ) ); 
FRE_MEASURE fQSFPDDRSV_REFCLK_p ( .RESET_n(BUTTON[0]),.MES_CLK (tx_clkout_QSFPDDRSV_REFCLK_p) , .HZ1(M50_1HZ) , .FREQ( ) ); 
FRE_MEASURE fCLK_100_B2A        ( .RESET_n(BUTTON[0]),.MES_CLK (CLK_100_B2A)                  , .HZ1(M50_1HZ) , .FREQ(  ) ); 
FRE_MEASURE fCLK_50_B2C         ( .RESET_n(BUTTON[0]),.MES_CLK (CLK_50_B2C )                  , .HZ1(M50_1HZ) , .FREQ(  ) ); 
FRE_MEASURE fCLK_50_B3A         ( .RESET_n(BUTTON[0]),.MES_CLK (CLK_50_B3A )                  , .HZ1(M50_1HZ) , .FREQ(  ) ); 
FRE_MEASURE fCLK_50_B3C         ( .RESET_n(BUTTON[0]),.MES_CLK (CLK_50_B3C )                  , .HZ1(M50_1HZ) , .FREQ(  ) ); 


//--refclock by way of xcvrphy  to  pll_out1 
e_tile_pll visu0( .pll_refclk0( QSFPDDA_REFCLK_p  ), .pll_clkout1 ( tx_clkout_QSFPDDA_REFCLK_p  ));
e_tile_pll visu1( .pll_refclk0( QSFPDDB_REFCLK_p  ), .pll_clkout1 ( tx_clkout_QSFPDDB_REFCLK_p  ));
e_tile_pll visu2( .pll_refclk0( QSFPDDRSV_REFCLK_p), .pll_clkout1 ( tx_clkout_QSFPDDRSV_REFCLK_p));

endmodule
