// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


//-----------------------------------------------------------------------------------
// This confidential and proprietary software may be used only as authorized by
// a licensing agreement from Intel
// copyright notice must be reproduced on all authorized copies.
//-----------------------------------------------------------------------------------
// Copyright (C) 2017 Intel Corporation. All rights reserved.  Intel products are
// protected under numerous U.S. and foreign patents, maskwork rights, copyrights and
// other intellectual property laws.
//-----------------------------------------------------------------------------------
//  Project Name:  wharf_rock gen4x8 256 bits @ 500MHZ to 512 bits @ 250 MHz adapter
//  Module Name :  intel_pcie_whr_gen4x8_pm_if
//  Author      :  sdsawant
//  Date        :  Wed Sep 28 16:52:43 2019
//  Description :
//-----------------------------------------------------------------------------------

module  intel_pcie_whr_gen4x8_pm_if
 #(
     parameter intended_device_family = "Stratix 10"
  )
  (
   input              clk500,
   input              rst_clk500_n,
   input              clk250,
   input              rst_clk250_n,
   input  logic [2:0] pm_state_i,
   input  logic [7:0] apps_pm_xmt_pme_i,
   input              app_ready_entr_l23_i,
   input              apps_pm_xmt_turnoff_i,
   input              app_init_rst_i,
   input              app_xfer_pending_i,
   output logic [2:0] pm_state_o,
   output logic [7:0] apps_pm_xmt_pme_o,
   output logic       app_ready_entr_l23_o,
   output logic       apps_pm_xmt_turnoff_o,
   output logic       app_init_rst_o,
   output logic       app_xfer_pending_o
  );

  logic [2:0] pm_state_q;
  logic [7:0] apps_pm_xmt_pme_q;
  logic app_ready_entr_l23_q;
  logic apps_pm_xmt_turnoff_q;
  logic app_init_rst_q;
  logic app_xfer_pending_q;

  logic [2:0] pm_state_o_q;
  logic [7:0] apps_pm_xmt_pme_o_q;
  logic app_ready_entr_l23_o_q;
  logic apps_pm_xmt_turnoff_o_q;
  logic app_init_rst_o_q;
  logic app_xfer_pending_o_q;

  always @(posedge clk500) begin
    pm_state_q <= pm_state_i;
  end

  always @(posedge clk250) begin 
    pm_state_o <= pm_state_o_q;
  end

  always @(posedge clk250) begin 
    apps_pm_xmt_pme_q     <= apps_pm_xmt_pme_i;
    app_ready_entr_l23_q  <= app_ready_entr_l23_i;
    apps_pm_xmt_turnoff_q <= apps_pm_xmt_turnoff_i;
    app_init_rst_q        <= app_init_rst_i;
    app_xfer_pending_q    <= app_xfer_pending_i;
  end

  intel_pcie_whr_gen4x8_sync_vec #(.DWIDTH(3)) pm_state_sync (.wr_clk(clk500), .rd_clk(clk250), .wr_rst_n(rst_clk500_n),
                              .rd_rst_n(rst_clk250_n), .din(pm_state_q), .dout(pm_state_o_q));

  intel_pcie_whr_gen4x8_sync_vec #(.DWIDTH(8)) apps_pm_xmt_pme_sync (.wr_clk(clk250), .rd_clk(clk500), .wr_rst_n(rst_clk250_n),
                                   .rd_rst_n(rst_clk500_n), .din(apps_pm_xmt_pme_q), .dout(apps_pm_xmt_pme_o_q));

  intel_pcie_whr_gen4x8_sync_bit #(.DWIDTH(1)) app_ready_entr_l23_sync (.clk(clk500), .rst_n(rst_clk500_n),
                                   .din(app_ready_entr_l23_q), .dout(app_ready_entr_l23_o_q));

  intel_pcie_whr_gen4x8_sync_pulse apps_pm_xmt_turnoff_sync (.wr_clk(clk250), .rd_clk(clk500), .wr_rst_n(rst_clk250_n),
                                                  .rd_rst_n(rst_clk500_n), .din(apps_pm_xmt_turnoff_q), .dout(apps_pm_xmt_turnoff_o_q));

  intel_pcie_whr_gen4x8_sync_pulse app_init_rst_sync (.wr_clk(clk250), .rd_clk(clk500), .wr_rst_n(rst_clk250_n),
                                                  .rd_rst_n(rst_clk500_n), .din(app_init_rst_q), .dout(app_init_rst_o_q));

  intel_pcie_whr_gen4x8_sync_bit #(.DWIDTH(1)) app_xfer_pending_sync (.clk(clk500), .rst_n(rst_clk500_n),
                                   .din(app_xfer_pending_q), .dout(app_xfer_pending_o_q));

  always @(posedge clk500) begin 
    apps_pm_xmt_pme_o     <= apps_pm_xmt_pme_o_q;
    app_ready_entr_l23_o  <= app_ready_entr_l23_o_q;
    apps_pm_xmt_turnoff_o <= apps_pm_xmt_turnoff_o_q;
    app_init_rst_o        <= app_init_rst_o_q;
    app_xfer_pending_o    <= app_xfer_pending_o_q;
  end
endmodule