// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


module phy_user_avmm_arb(
///////////////AVMM ARB//////////////
//pld_ports
//from/to ATOM
interface   pld_phy0_user_avmm_ports,
interface   pld_phy1_user_avmm_ports,
interface   pld_phy2_user_avmm_ports,
interface   pld_phy3_user_avmm_ports,
interface   pld_phy4_user_avmm_ports,
//from/To soft logic
//hip_ports
interface 	hip_int_phy_user_avmm_ports
);

//////use the top 5 bit of address : addr[20:16] to decode which PHY quad to reconfigure/////
//PHY0 
assign pld_phy0_user_avmm_ports.user_avmm_clk				= hip_int_phy_user_avmm_ports.user_avmm_clk;
assign pld_phy0_user_avmm_ports.user_avmm_read				= hip_int_phy_user_avmm_ports.phyq_sel[0]? hip_int_phy_user_avmm_ports.user_avmm_read: 0;
assign pld_phy0_user_avmm_ports.user_avmm_write 			= hip_int_phy_user_avmm_ports.phyq_sel[0]? hip_int_phy_user_avmm_ports.user_avmm_write: 0;
assign pld_phy0_user_avmm_ports.user_avmm_writedata			= hip_int_phy_user_avmm_ports.phyq_sel[0]? hip_int_phy_user_avmm_ports.user_avmm_writedata: 0;
assign pld_phy0_user_avmm_ports.user_avmm_address			= hip_int_phy_user_avmm_ports.phyq_sel[0]?  hip_int_phy_user_avmm_ports.user_avmm_address[20:0]: 0;
//PHY1
assign pld_phy1_user_avmm_ports.user_avmm_clk				= hip_int_phy_user_avmm_ports.user_avmm_clk;
assign pld_phy1_user_avmm_ports.user_avmm_read				= hip_int_phy_user_avmm_ports.phyq_sel[1]? hip_int_phy_user_avmm_ports.user_avmm_read: 0;
assign pld_phy1_user_avmm_ports.user_avmm_write 			= hip_int_phy_user_avmm_ports.phyq_sel[1]? hip_int_phy_user_avmm_ports.user_avmm_write: 0;
assign pld_phy1_user_avmm_ports.user_avmm_writedata			= hip_int_phy_user_avmm_ports.phyq_sel[1]? hip_int_phy_user_avmm_ports.user_avmm_writedata: 0;
assign pld_phy1_user_avmm_ports.user_avmm_address			= hip_int_phy_user_avmm_ports.phyq_sel[1]?  hip_int_phy_user_avmm_ports.user_avmm_address[20:0]: 0;
//PHY2 
assign pld_phy2_user_avmm_ports.user_avmm_clk				= hip_int_phy_user_avmm_ports.user_avmm_clk;
assign pld_phy2_user_avmm_ports.user_avmm_read				= hip_int_phy_user_avmm_ports.phyq_sel[2]? hip_int_phy_user_avmm_ports.user_avmm_read: 0;
assign pld_phy2_user_avmm_ports.user_avmm_write 			= hip_int_phy_user_avmm_ports.phyq_sel[2]? hip_int_phy_user_avmm_ports.user_avmm_write: 0;
assign pld_phy2_user_avmm_ports.user_avmm_writedata			= hip_int_phy_user_avmm_ports.phyq_sel[2]? hip_int_phy_user_avmm_ports.user_avmm_writedata: 0;
assign pld_phy2_user_avmm_ports.user_avmm_address			= hip_int_phy_user_avmm_ports.phyq_sel[2]? hip_int_phy_user_avmm_ports.user_avmm_address[20:0]: 0;
//PHY3 
assign pld_phy3_user_avmm_ports.user_avmm_clk				= hip_int_phy_user_avmm_ports.user_avmm_clk;
assign pld_phy3_user_avmm_ports.user_avmm_read				= hip_int_phy_user_avmm_ports.phyq_sel[3]? hip_int_phy_user_avmm_ports.user_avmm_read: 0;
assign pld_phy3_user_avmm_ports.user_avmm_write 			= hip_int_phy_user_avmm_ports.phyq_sel[3]? hip_int_phy_user_avmm_ports.user_avmm_write: 0;
assign pld_phy3_user_avmm_ports.user_avmm_writedata			= hip_int_phy_user_avmm_ports.phyq_sel[3]? hip_int_phy_user_avmm_ports.user_avmm_writedata: 0;
assign pld_phy3_user_avmm_ports.user_avmm_address			= hip_int_phy_user_avmm_ports.phyq_sel[3]?  hip_int_phy_user_avmm_ports.user_avmm_address[20:0]: 0;
//PHY4 
assign pld_phy4_user_avmm_ports.user_avmm_clk				= hip_int_phy_user_avmm_ports.user_avmm_clk;
assign pld_phy4_user_avmm_ports.user_avmm_read				= hip_int_phy_user_avmm_ports.phyq_sel[4]? hip_int_phy_user_avmm_ports.user_avmm_read: 0;
assign pld_phy4_user_avmm_ports.user_avmm_write 			= hip_int_phy_user_avmm_ports.phyq_sel[4]? hip_int_phy_user_avmm_ports.user_avmm_write: 0;
assign pld_phy4_user_avmm_ports.user_avmm_writedata			= hip_int_phy_user_avmm_ports.phyq_sel[4]? hip_int_phy_user_avmm_ports.user_avmm_writedata: 0;
assign pld_phy4_user_avmm_ports.user_avmm_address			= hip_int_phy_user_avmm_ports.phyq_sel[4]?  hip_int_phy_user_avmm_ports.user_avmm_address[20:0]: 0;

assign hip_int_phy_user_avmm_ports.user_avmm_readdatavalid 	=	pld_phy0_user_avmm_ports.user_avmm_readdatavalid | pld_phy1_user_avmm_ports.user_avmm_readdatavalid | pld_phy2_user_avmm_ports.user_avmm_readdatavalid | pld_phy3_user_avmm_ports.user_avmm_readdatavalid | pld_phy4_user_avmm_ports.user_avmm_readdatavalid;
assign hip_int_phy_user_avmm_ports.user_avmm_readdata 			=	pld_phy0_user_avmm_ports.user_avmm_readdata | pld_phy1_user_avmm_ports.user_avmm_readdata | pld_phy2_user_avmm_ports.user_avmm_readdata | pld_phy3_user_avmm_ports.user_avmm_readdata | pld_phy4_user_avmm_ports.user_avmm_readdata;
assign hip_int_phy_user_avmm_ports.user_avmm_writedone 		=	pld_phy0_user_avmm_ports.user_avmm_writedone | pld_phy1_user_avmm_ports.user_avmm_writedone | pld_phy2_user_avmm_ports.user_avmm_writedone | pld_phy3_user_avmm_ports.user_avmm_writedone | pld_phy4_user_avmm_ports.user_avmm_writedone;

endmodule // phy_user_avmm_arb
