// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


module ptile_pcie_user_avmm_adapter (
   // input             clk,
   input             rst_n,

   // // from AIB FIFO side
   // input             hip_readdatavalid,
   // input    [7:0]    hip_readdata,
   // input             hip_writedone,

   // // from PLD
   // input             pld_read,
   // input             pld_write,
   // input    [20:0]   pld_addr,
   // input    [7:0]    pld_writedata,

   // output            hip_read,
   // output            hip_write,
   // output   [20:0]   hip_addr,
   // output   [7:0]    hip_writedata,

   // output            pld_waitrequest,
   // output            pld_readdatavalid,
   // output   [7:0]    pld_readdata
   //PLD port
  interface pld_user_avmm_ports,
  interface app_user_avmm_ports
);
   reg               pld_waitrequest_r;
   reg               req_in_process_r;
   reg               hip_read_r;
   reg               hip_write_r;
   reg      [20:0]   hip_addr_r;
   reg      [7:0]    hip_writedata_r;
   reg      [4:0]    hip_phyq_sel_r;

   assign app_user_avmm_ports.app_user_avmm_waitrequest   = pld_waitrequest_r;
   assign app_user_avmm_ports.app_user_avmm_readdatavalid = pld_user_avmm_ports.user_avmm_readdatavalid;
   assign app_user_avmm_ports.app_user_avmm_readdata      = pld_user_avmm_ports.user_avmm_readdata;
   assign pld_user_avmm_ports.user_avmm_clk               = app_user_avmm_ports.app_user_avmm_clk;
   assign pld_user_avmm_ports.user_avmm_read              = hip_read_r;
   assign pld_user_avmm_ports.user_avmm_write             = hip_write_r;
   assign pld_user_avmm_ports.user_avmm_address           = hip_addr_r;
   assign pld_user_avmm_ports.user_avmm_writedata         = hip_writedata_r;
   assign pld_user_avmm_ports.phyq_sel                    = hip_phyq_sel_r;

   always @ (posedge app_user_avmm_ports.app_user_avmm_clk or negedge rst_n)
   begin
      if (~rst_n)
      begin
         pld_waitrequest_r <= 1'b1;
         req_in_process_r            <= 1'b0;
      end
      else
      begin
         req_in_process_r
            <= (pld_user_avmm_ports.user_avmm_writedone | pld_user_avmm_ports.user_avmm_readdatavalid) ? 1'b0
             : ((app_user_avmm_ports.app_user_avmm_read | app_user_avmm_ports.app_user_avmm_write) &
                ~pld_waitrequest_r) ? 1'b1
             : req_in_process_r;

         pld_waitrequest_r
            <= (pld_waitrequest_r &
                (~req_in_process_r |
                 req_in_process_r &
                 (pld_user_avmm_ports.user_avmm_writedone | pld_user_avmm_ports.user_avmm_readdatavalid))) ? 1'b0
             : ((app_user_avmm_ports.app_user_avmm_read | app_user_avmm_ports.app_user_avmm_write) &
                ~pld_waitrequest_r) ? 1'b1
             : pld_waitrequest_r;
      end
   end




   always @ (posedge app_user_avmm_ports.app_user_avmm_clk or negedge rst_n)
   begin
      if (~rst_n)
      begin
         hip_read_r      <= 1'b0;
         hip_write_r     <= 1'b0;
         hip_addr_r      <= 21'h0;
         hip_writedata_r <= 8'h0;
         hip_phyq_sel_r  <= 5'b0;
      end
      else
      begin
         hip_read_r      <= app_user_avmm_ports.app_user_avmm_read  & ~pld_waitrequest_r;
         hip_write_r     <= app_user_avmm_ports.app_user_avmm_write & ~pld_waitrequest_r;
         hip_addr_r      <= app_user_avmm_ports.app_user_avmm_address;
         hip_writedata_r <= app_user_avmm_ports.app_user_avmm_writedata;
         hip_phyq_sel_r  <= app_user_avmm_ports.app_phyq_sel;
      end
   end


endmodule


