// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


//-----------------------------------------------------------------------------------
// This confidential and proprietary software may be used only as authorized by
// a licensing agreement from Intel
// copyright notice must be reproduced on all authorized copies.
//-----------------------------------------------------------------------------------
// Copyright (C) 2017 Intel Corporation. All rights reserved.  Intel products are
// protected under numerous U.S. and foreign patents, maskwork rights, copyrights and
// other intellectual property laws.
//-----------------------------------------------------------------------------------
//  Project Name:  wharf_rock gen4x8 256 bits @ 500MHZ to 512 bits @ 250 MHz adapter
//  Module Name :  intel_pcie_whr_gen4x8_hot_plug_if
//  Author      :  sdsawant
//  Date        :  Wed Sep 28 16:52:43 2019
//  Description :
//-----------------------------------------------------------------------------------

module  intel_pcie_whr_gen4x8_hot_plug_if
 #(
     parameter intended_device_family = "Stratix 10"
  )
  (
   input  clk500,
   input  rst_clk500_n,
   input  clk250,
   input  rst_clk250_n,
   input  sys_atten_button_pressed_i,
   input  sys_pwr_fault_det_i,
   input  sys_mrl_sensor_chged_i,
   input  sys_pre_det_chged_i,
   input  sys_cmd_cpled_int_i,
   input  sys_pre_det_state_i,
   input  sys_mrl_sensor_state_i,
   input  sys_eml_interlock_engaged_i,
   input  sys_aux_pwr_det_i,
   output sys_atten_button_pressed_o,
   output sys_pwr_fault_det_o,
   output sys_mrl_sensor_chged_o,
   output sys_pre_det_chged_o,
   output sys_cmd_cpled_int_o,
   output sys_pre_det_state_o,
   output sys_mrl_sensor_state_o,
   output sys_eml_interlock_engaged_o,
   output sys_aux_pwr_det_o
  );

  intel_pcie_whr_gen4x8_sync_vec #(.DWIDTH(1)) sys_atten_button_pressed_sync (.wr_clk(clk250), .rd_clk(clk500), .wr_rst_n(rst_clk250_n),
                              .rd_rst_n(rst_clk500_n), .din(sys_atten_button_pressed_i), .dout(sys_atten_button_pressed_o));

  intel_pcie_whr_gen4x8_sync_vec #(.DWIDTH(1)) sys_pwr_fault_det_sync (.wr_clk(clk250), .rd_clk(clk500), .wr_rst_n(rst_clk250_n),
                              .rd_rst_n(rst_clk500_n), .din(sys_pwr_fault_det_i), .dout(sys_pwr_fault_det_o));

  intel_pcie_whr_gen4x8_sync_vec #(.DWIDTH(1)) sys_mrl_sensor_chged_sync (.wr_clk(clk250), .rd_clk(clk500), .wr_rst_n(rst_clk250_n),
                              .rd_rst_n(rst_clk500_n), .din(sys_mrl_sensor_chged_i), .dout(sys_mrl_sensor_chged_o));

  intel_pcie_whr_gen4x8_sync_vec #(.DWIDTH(1)) sys_pre_det_chged_sync (.wr_clk(clk250), .rd_clk(clk500), .wr_rst_n(rst_clk250_n),
                              .rd_rst_n(rst_clk500_n), .din(sys_pre_det_chged_i), .dout(sys_pre_det_chged_o));

  intel_pcie_whr_gen4x8_sync_vec #(.DWIDTH(1)) sys_cmd_cpled_int_sync (.wr_clk(clk250), .rd_clk(clk500), .wr_rst_n(rst_clk250_n),
                              .rd_rst_n(rst_clk500_n), .din(sys_cmd_cpled_int_i), .dout(sys_cmd_cpled_int_o));

  intel_pcie_whr_gen4x8_sync_vec #(.DWIDTH(1)) sys_pre_det_state_sync (.wr_clk(clk250), .rd_clk(clk500), .wr_rst_n(rst_clk250_n),
                              .rd_rst_n(rst_clk500_n), .din(sys_pre_det_state_i), .dout(sys_pre_det_state_o));

  intel_pcie_whr_gen4x8_sync_vec #(.DWIDTH(1)) sys_mrl_sensor_state_sync (.wr_clk(clk250), .rd_clk(clk500), .wr_rst_n(rst_clk250_n),
                              .rd_rst_n(rst_clk500_n), .din(sys_mrl_sensor_state_i), .dout(sys_mrl_sensor_state_o));

  intel_pcie_whr_gen4x8_sync_vec #(.DWIDTH(1)) sys_eml_interlock_engaged_sync (.wr_clk(clk250), .rd_clk(clk500), .wr_rst_n(rst_clk250_n),
                              .rd_rst_n(rst_clk500_n), .din(sys_eml_interlock_engaged_i), .dout(sys_eml_interlock_engaged_o));

  intel_pcie_whr_gen4x8_sync_vec #(.DWIDTH(1)) sys_aux_pwr_det_sync (.wr_clk(clk250), .rd_clk(clk500), .wr_rst_n(rst_clk250_n),
                              .rd_rst_n(rst_clk500_n), .din(sys_aux_pwr_det_i), .dout(sys_aux_pwr_det_o));

endmodule