// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


//-----------------------------------------------------------------------------
// This confidential and proprietary software may be used only as authorized by
// a licensing agreement from Intel
// copyright notice must be reproduced on all authorized copies.
//-----------------------------------------------------------------------------
// Copyright (C) 2017 Intel Corporation. All rights reserved.  Intel products are
// protected under numerous U.S. and foreign patents, maskwork rights, copyrights and
// other intellectual property laws.
//-----------------------------------------------------------------------------
//  Project Name:  wharf_rock
//  Module Name :  wrpcie_rx_deskew
//  Author      :  jaewonse
//  Date        :  Tue Feb 20 22:16:04 2018
//  Description :  Send deskew marker evey 32 cycles
//-----------------------------------------------------------------------------

module  whr_tx_deskew  #(
  parameter                                       NUM_CHAN = 4
) (
  input                                           pld_clk,
  input                                           pld_rst_n,

		output [NUM_CHAN-1:0]                           rx_dsk_marker_o
);
		reg                                             rx_dsk_marker_q;
		reg    [NUM_CHAN-1:0]                           rx_dsk_marker_2q;
		reg    [4:0]                                    counter_32_q;

		assign rx_dsk_marker_o  = rx_dsk_marker_2q;

		always @(posedge pld_clk) begin
				if (!pld_rst_n) begin
						counter_32_q                                <= 5'h0;
						rx_dsk_marker_q                             <= 1'b0;
						rx_dsk_marker_2q                            <= {(NUM_CHAN){1'b0}};
				end else begin
						counter_32_q                                <= counter_32_q + 1'b1;
						rx_dsk_marker_q                             <= (counter_32_q == 5'h10) ? 1'b1: 1'b0;
						rx_dsk_marker_2q                            <= {(NUM_CHAN){rx_dsk_marker_q}};
				end
		end 

endmodule