
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module DE10_Agilex_spi_Master(

	//////////// CLOCK //////////
	input 		          		CLK_100_B2A,
	input 		          		CLK_50_B2C,
	input 		          		CLK_50_B3A,
	input 		          		CLK_50_B3C,

	//////////// BUTTON //////////
	input 		     [1:0]		BUTTON,
	input 		          		CPU_RESET_n,

	//////////// SW //////////
	input 		     [1:0]		SW,

	//////////// LED, Low Active //////////
	output		     [3:0]		LED,
	output		     [3:0]		LED_BRACKET,

	//////////// System Information Interface //////////
	output		          		INFO_SPI_CS_n,
	input 		          		INFO_SPI_MISO,
	output		          		INFO_SPI_MOSI,
	output		          		INFO_SPI_SCLK
);


//=======================================================
//  REG/WIRE declarations
//=======================================================
//System Monitor IP
//IP interface
wire        Info_Valid;
wire [15:0] Board_Version	;//A~F.ex BOARD_VERSION = 16'h000b ,express to revB
wire [15:0] MaxCode_Version;//0~F.ex MAX10_VERSION = 16'h0004 ,express to rev4
wire [15:0] PowerIn_Voltage;//unit : Celsius degree    
wire [15:0] PowerIn_Current;//unit : Celsius degree    
wire [15:0] CORE_Voltage	;//unit : mv   
wire [15:0] CORE_Current	;//unit : mA  
wire [15:0] Fan_Speed	   ;//unit : rpm  
wire [15:0] Fan_Speed2	   ;//unit : rpm 
wire [15:0] Temp_FPGA	   ;//unit : Celsius degree 
wire [15:0] Temp_Board	   ;//unit : Celsius degree 
wire [15:0] PIN_STATUS	   ;//
wire [15:0] Temp_SDM	      ;//unit : Celsius degree 
wire [15:0] Temp_ETILE	   ;//unit : Celsius degree 
wire [15:0] Temp_PTILE	   ;//unit : Celsius degree 
wire [15:0] CORE_Voltage2	;//unit : mv
wire [15:0] CORE_Current2	;//unit : mA                                         
wire [15:0] Temp_Board2	   ;//unit : Celsius degree 
wire [15:0] Shutdown_flag  ;


//----reg
reg [15:0] rBoard_Version	;
reg [15:0] rMaxCode_Version;
reg [15:0] rPowerIn_Voltage;
reg [15:0] rPowerIn_Current;
reg [15:0] rCORE_Voltage	;
reg [15:0] rCORE_Current	;
reg [15:0] rFan_Speed	   ;
reg [15:0] rFan_Speed2	   ;
reg [15:0] rTemp_FPGA	   ; 
reg [15:0] rTemp_Board	   ; 
reg [15:0] rPIN_STATUS	   ; 
reg [15:0] rTemp_SDM	      ;
reg [15:0] rTemp_ETILE	   ;
reg [15:0] rTemp_PTILE	   ;
reg [15:0] rCORE_Voltage2	;
reg [15:0] rCORE_Current2	;
reg [15:0] rTemp_Board2	   ; 
reg [15:0] rShutdown_flag  ;


//=======================================================
//  Structural coding
//=======================================================

          

                
BOARD_INFO BOARD_INFO_i(    
             .RESET_N          (BUTTON[0]    ),  // input
             .CLK_50           (CLK_50_B2C   ),  // input

             // 4-pin SPI master interface
             .SCLK             (INFO_SPI_SCLK), // output
             .MISO             (INFO_SPI_MISO), // input
             .MOSI             (INFO_SPI_MOSI), // output
             .CS_n             (INFO_SPI_CS_n), // output

             // status report (output)
             .Info_Valid       ( Info_Valid     ), //1: following data is valid
             .Board_Version	 ( Board_Version	), //A~F.ex BOARD_VERSION = 16'h000b ,express to revB
             .MaxCode_Version  ( MaxCode_Version), //0~F.ex MAX10_VERSION = 16'h0004 ,express to rev4
             .PowerIn_Voltage  ( PowerIn_Voltage), //unit : Celsius degree    
             .PowerIn_Current  ( PowerIn_Current), //unit : Celsius degree    
             .CORE_Voltage	    ( CORE_Voltage	), //unit : mv   
             .CORE_Current	    ( CORE_Current	), //unit : mA  
				 .Fan_Speed	       ( Fan_Speed	   ), //unit : rpm
				 .Fan_Speed2	    ( Fan_Speed2	   ), //unit : rpm                                        
             .Temp_FPGA	       ( Temp_FPGA	   ), //unit : Celsius degree 
				 .Temp_Board	    ( Temp_Board	   ), //unit : Celsius degree
				 .PIN_STATUS	    ( PIN_STATUS	   ),  
				 .Temp_SDM	       ( Temp_SDM	      ), //unit : Celsius degree
				 .Temp_ETILE	    ( Temp_ETILE	   ), //unit : Celsius degree 
				 .Temp_PTILE	    ( Temp_PTILE	   ), //unit : Celsius degree 
				 .CORE_Voltage2	 ( CORE_Voltage2	), //unit : mv
				 .CORE_Current2	 ( CORE_Current2	), //unit : mA
				 .Temp_Board2	    ( Temp_Board2	   ),  //unit : Celsius degree 
             .Shutdown_flag	 ( Shutdown_flag  )			 
				 
);





always @(posedge CLK_50_B2C ) begin
    if (Info_Valid) begin
        rBoard_Version	<= Board_Version	;
        rMaxCode_Version<= MaxCode_Version;
        rPowerIn_Voltage<= PowerIn_Voltage;
        rPowerIn_Current<= PowerIn_Current;
        rCORE_Voltage	<= CORE_Voltage	;
        rCORE_Current	<= CORE_Current	;
        rFan_Speed	   <= Fan_Speed	   ;
		  rFan_Speed2	   <= Fan_Speed2	   ;
		  rTemp_FPGA	   <= Temp_FPGA	   ;
		  rTemp_Board	   <= Temp_Board	   ;
		  rPIN_STATUS	   <= PIN_STATUS	   ;
		  rTemp_SDM	      <= Temp_SDM	      ;
		  rTemp_ETILE	   <= Temp_ETILE	   ;
		  rTemp_PTILE	   <= Temp_PTILE	   ;
		  rCORE_Voltage2	<= CORE_Voltage2	;
		  rCORE_Current2	<= CORE_Current2	;
		  rTemp_Board2	   <= Temp_Board2	   ;
		  rShutdown_flag  <= Shutdown_flag  ;
    end
end


endmodule
