
namespace eval ex_100G {
  proc get_design_libraries {} {
    set libraries [dict create]
    dict set libraries altera_common_sv_packages 1
    dict set libraries xcvrnphy_fme_301          1
    dict set libraries alt_ehipc3_fm_2010        1
    dict set libraries ex_100G                   1
    return $libraries
  }
  
  proc get_memory_files {QSYS_SIMDIR} {
    set memory_files [list]
    lappend memory_files "[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/serdes.firmware.rom"]"
    return $memory_files
  }
  
  proc get_common_design_files {USER_DEFINED_COMPILE_OPTIONS USER_DEFINED_VERILOG_COMPILE_OPTIONS USER_DEFINED_VHDL_COMPILE_OPTIONS QSYS_SIMDIR} {
    set design_files [dict create]
    dict set design_files "altera_common_sv_packages::altera_xcvr_native_s10_functions_h" "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/altera_xcvr_native_s10_functions_h.sv"]\"  -work altera_common_sv_packages"
    return $design_files
  }
  
  proc get_design_files {USER_DEFINED_COMPILE_OPTIONS USER_DEFINED_VERILOG_COMPILE_OPTIONS USER_DEFINED_VHDL_COMPILE_OPTIONS QSYS_SIMDIR} {
    set design_files [list]
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/alt_xcvr_arbiter.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"                                 
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/altera_std_synchronizer_nocut.v"]\"  -work xcvrnphy_fme_301"                                            
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/alt_xcvr_resync_std.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"                              
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/s10_avmm_h_etile.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"                                 
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/alt_xcvr_native_avmm_csr_etile.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"                   
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/alt_xcvr_native_rcfg_arb.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"                         
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/alt_xcvr_native_rx_reset_seq_etile.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"               
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/alt_xcvr_native_tx_reset_seq_etile.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"               
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/alt_xcvr_reset_counter_s10_etile.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"                 
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/altera_xcvr_reset_control_etile.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"                  
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/altera_xcvr_reset_top_etile.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"                      
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/altera_xcvr_ical_int_table.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"                       
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/altera_xcvr_ical_top_etile.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"                       
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/altera_xcvr_ical_etile.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"                           
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/altera_xcvr_pma_spico_reset_etile.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"                
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/altera_xcvr_native_dskw_pam4.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"                     
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/alt_xcvr_resync_etile.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"                            
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/altera_std_synchronizer_nocut_etile.v"]\"  -work xcvrnphy_fme_301"                                      
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/ex_100G_xcvrnphy_fme_301_zwzkini.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"                 
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_301/sim/alt_xcvr_native_rcfg_opt_logic_zwzkini.sv"]\" -l altera_common_sv_packages -work xcvrnphy_fme_301"           
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/ex_100G_alt_ehipc3_fm_xcvrnphy_fme_2010_wlnvbui.v"]\"  -work alt_ehipc3_fm_2010"                      
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/ex_100G_alt_ehipc3_fm_2010_yhw6zey.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"           
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_package.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                        
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_dr_package.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                        
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_dp_mux.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                         
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_clock_mon.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                      
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_ml_soft.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                        
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_ehip_sync_fifo_rk.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"              
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_kpfec_cadence_gen.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"              
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_rcfg_arb.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                          
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/checker_fifo.v"]\"  -work alt_ehipc3_fm_2010"                                                         
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/reset_timer.v"]\"  -work alt_ehipc3_fm_2010"                                                          
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/test_harness.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                                 
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/xgmii_sink.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                                   
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/xgmii_src.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                                    
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/pcs_scfifo_mlab.v"]\"  -work alt_ehipc3_fm_2010"                                                      
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_100g_4w_aligner.v"]\"  -work alt_ehipc3_fm_2010"                                        
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_100g_adapter_data_aligner.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"      
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_100g_adapter_data_aligner_async.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_100g_adapter_rptr_addgen.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"       
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_100g_adapter_rx.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_100g_adapter_rx_async.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"          
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_100g_adapter_tx.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_100g_adapter_tx_async.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"          
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_100g_adapter_wptr_addgen.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"       
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_100g_avalon_to_if.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"              
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_100g_block_buffer.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_100g_fifo_coupler.v"]\"  -work alt_ehipc3_fm_2010"                                      
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_100g_gb_4to8.v"]\"  -work alt_ehipc3_fm_2010"                                           
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_100g_gearbox.v"]\"  -work alt_ehipc3_fm_2010"                                           
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_100g_if_to_avst.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_100g_rx_aligner.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_accumulators.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                   
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_altera_std_synchronizer_nocut.v"]\"  -work alt_ehipc3_fm_2010"                          
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_block_gearbox.v"]\"  -work alt_ehipc3_fm_2010"                                          
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_data_sync.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                      
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_dcfifo_mlab.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                    
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_delay_reg.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_dropped_frame_count.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"            
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_if_filter5.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                     
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_mlab.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                           
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_pointer_synchronizer.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"           
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_preamble_filter2.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"               
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_reset_synchronizer.v"]\"  -work alt_ehipc3_fm_2010"                                     
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_scfifo_mlab.v"]\"  -work alt_ehipc3_fm_2010"                                            
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_adapter_rx.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                  
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_adapter_rx_async.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"            
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_adapter_tx.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                  
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_adapter_tx_async.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"            
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_avalon_to_if.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_if_to_avalon.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_word_aligner.v"]\"  -work alt_ehipc3_fm_2010"                                           
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_word_shifter.v"]\"  -work alt_ehipc3_fm_2010"                                           
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/intc_mlab6_a1r1w1_fm.v"]\"  -work alt_ehipc3_fm_2010"                                                 
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/intc_mlab_fm.v"]\"  -work alt_ehipc3_fm_2010"                                                         
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/intc_sync6_m_fm.v"]\"  -work alt_ehipc3_fm_2010"                                                      
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_mac_enable_avmm.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_pause.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                       
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sm_recover.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                     
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_rx_deskew.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                      
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_tx_deskew.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                      
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_word_delay_mlab.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_alias_csr.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                      
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_avmm_32to8.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                     
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_csr.v"]\"  -work alt_ehipc3_fm_2010"                                                    
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_avmm_32to8.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                  
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_clock_crosser.v"]\"  -work alt_ehipc3_fm_2010"                                          
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_ml_ptp.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                         
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_ml_ptp_avmm_csr_bank.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"           
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_ml_ptp_ckt_cal.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                 
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_ml_ptp_convert_commands.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"        
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_ml_ptp_opcode_writer.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"           
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_ml_ptp_ref_ts_capture.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"          
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_ml_ptp_rx_tam_capture.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"          
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_ml_ptp_ts_converter.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"            
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_ml_ptp_tx_tam_capture.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"          
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_ptp_rx_ts_adj_detect.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"           
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_clock_crosser.v"]\"  -work alt_ehipc3_fm_2010"                                       
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                         
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_avmm_csr_bank.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"           
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_avmm_csr_bank_sn.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"        
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_calc_tam.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_ckt_cal.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                 
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_compute_ts.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"              
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_convert_commands.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"        
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_opcode_writer.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"           
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_ref_ts_capture.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"          
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_ref_ts_capture_sn.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"       
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_rx_deskew.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"               
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_rx_tam_capture.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"          
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_rx_tam_capture_sn.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"       
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_sn.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                      
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_sn_latency.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"              
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_sn_roll_over.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"            
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_sn_sclk.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                 
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_sn_tam.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                  
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_sn_wire_delay.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"           
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_sticky_register.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"         
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_sub_nano.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_tam_adj_detect.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"          
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_tam_capture_count.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"       
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_ts_converter.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"            
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_ts_converter_sn.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"         
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_tx_tam_capture.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"          
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ptp_tx_tam_capture_sn.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"       
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_and3t0.v"]\"  -work alt_ehipc3_fm_2010"                                                 
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_and3t1.v"]\"  -work alt_ehipc3_fm_2010"                                                 
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_and4t0.v"]\"  -work alt_ehipc3_fm_2010"                                                 
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_and4t1.v"]\"  -work alt_ehipc3_fm_2010"                                                 
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_cnt6.v"]\"  -work alt_ehipc3_fm_2010"                                                   
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_eqc15h7cfbt2.v"]\"  -work alt_ehipc3_fm_2010"                                           
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_eqc19h4e1fbt2.v"]\"  -work alt_ehipc3_fm_2010"                                          
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_eqc4h9t1.v"]\"  -work alt_ehipc3_fm_2010"                                               
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_eqc5h07t1.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_eqc5h0ft1.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_eqc5h18t1.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_eqc5h1bt1.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_eqc5h1ft1.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_fmon8.v"]\"  -work alt_ehipc3_fm_2010"                                                  
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_lut6.v"]\"  -work alt_ehipc3_fm_2010"                                                   
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_metronome32000.v"]\"  -work alt_ehipc3_fm_2010"                                         
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_metronome320000.v"]\"  -work alt_ehipc3_fm_2010"                                        
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_mux2w1t0s0.v"]\"  -work alt_ehipc3_fm_2010"                                             
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_mux2w1t0s1.v"]\"  -work alt_ehipc3_fm_2010"                                             
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_mux2w1t0s2.v"]\"  -work alt_ehipc3_fm_2010"                                             
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_mux2w1t1s2.v"]\"  -work alt_ehipc3_fm_2010"                                             
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_mux4w1t0s0.v"]\"  -work alt_ehipc3_fm_2010"                                             
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_mux4w1t0s1.v"]\"  -work alt_ehipc3_fm_2010"                                             
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_mux4w1t1s1.v"]\"  -work alt_ehipc3_fm_2010"                                             
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_mux8w1t2s1.v"]\"  -work alt_ehipc3_fm_2010"                                             
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_ripple16.v"]\"  -work alt_ehipc3_fm_2010"                                               
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_addc2h0t1.v"]\"  -work alt_ehipc3_fm_2010"                                           
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_and2t0.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_and2t1.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_and3t0.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_and4t0.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_and4t1.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_and8t2.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_cnt2c.v"]\"  -work alt_ehipc3_fm_2010"                                               
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_delay1w2.v"]\"  -work alt_ehipc3_fm_2010"                                            
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_delay2w2.v"]\"  -work alt_ehipc3_fm_2010"                                            
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_delay3w1.v"]\"  -work alt_ehipc3_fm_2010"                                            
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_delay3w64c.v"]\"  -work alt_ehipc3_fm_2010"                                          
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_delay4w1.v"]\"  -work alt_ehipc3_fm_2010"                                            
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_delay5w1.v"]\"  -work alt_ehipc3_fm_2010"                                            
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_delay6w1.v"]\"  -work alt_ehipc3_fm_2010"                                            
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_descram64.v"]\"  -work alt_ehipc3_fm_2010"                                           
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_eq2t0.v"]\"  -work alt_ehipc3_fm_2010"                                               
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_eq2t1.v"]\"  -work alt_ehipc3_fm_2010"                                               
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_eq3t0.v"]\"  -work alt_ehipc3_fm_2010"                                               
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_eq3t1.v"]\"  -work alt_ehipc3_fm_2010"                                               
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_eq4t1.v"]\"  -work alt_ehipc3_fm_2010"                                               
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_eq8t1.v"]\"  -work alt_ehipc3_fm_2010"                                               
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_eq9t1.v"]\"  -work alt_ehipc3_fm_2010"                                               
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_eqc4hft1.v"]\"  -work alt_ehipc3_fm_2010"                                            
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_eqc5h1bt1.v"]\"  -work alt_ehipc3_fm_2010"                                           
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_eqc5h1dt1.v"]\"  -work alt_ehipc3_fm_2010"                                           
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_eqc9h1fbt2.v"]\"  -work alt_ehipc3_fm_2010"                                          
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_eqc9h1fdt2.v"]\"  -work alt_ehipc3_fm_2010"                                          
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_etag.v"]\"  -work alt_ehipc3_fm_2010"                                                
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ethdec.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_ethenc.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_lut6.v"]\"  -work alt_ehipc3_fm_2010"                                                
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_mlab.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                        
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_mlab64a2r1w1.v"]\"  -work alt_ehipc3_fm_2010"                                        
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_mx16r.v"]\"  -work alt_ehipc3_fm_2010"                                               
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_mx4r.v"]\"  -work alt_ehipc3_fm_2010"                                                
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_or2t0.v"]\"  -work alt_ehipc3_fm_2010"                                               
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_or2t1.v"]\"  -work alt_ehipc3_fm_2010"                                               
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_or4t0.v"]\"  -work alt_ehipc3_fm_2010"                                               
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_or4t1.v"]\"  -work alt_ehipc3_fm_2010"                                               
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_or_r.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                        
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_scram64.v"]\"  -work alt_ehipc3_fm_2010"                                             
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_subc2h0t1.v"]\"  -work alt_ehipc3_fm_2010"                                           
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_xor1t0.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_xor1t1.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_xor2t0.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_xor2t1.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_xor3t0.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_xor3t1.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_xor4t0.v"]\"  -work alt_ehipc3_fm_2010"                                              
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_status_sync.v"]\"  -work alt_ehipc3_fm_2010"                                            
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sync1r1.v"]\"  -work alt_ehipc3_fm_2010"                                                
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_ehip_rst.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                       
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_reset_controller.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"               
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_rx_ch_rst.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                      
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_tx_ch_rst.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                      
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_sl_soft.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                        
    lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../alt_ehipc3_fm_2010/sim/alt_ehipc3_fm_hard_yhw6zey.sv"]\" -l altera_common_sv_packages -work alt_ehipc3_fm_2010"                   
    lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/ex_100G.v"]\"  -work ex_100G"                                                                                                   
    return $design_files
  }
  
  proc get_elab_options {SIMULATOR_TOOL_BITNESS} {
    set ELAB_OPTIONS ""
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $ELAB_OPTIONS
  }
  
  
  proc get_sim_options {SIMULATOR_TOOL_BITNESS} {
    set SIM_OPTIONS ""
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $SIM_OPTIONS
  }
  
  
  proc get_env_variables {SIMULATOR_TOOL_BITNESS} {
    set ENV_VARIABLES [dict create]
    set LD_LIBRARY_PATH [dict create]
    dict set ENV_VARIABLES "LD_LIBRARY_PATH" $LD_LIBRARY_PATH
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $ENV_VARIABLES
  }
  
  
  proc normalize_path {FILEPATH} {
      if {[catch { package require fileutil } err]} { 
          return $FILEPATH 
      } 
      set path [fileutil::lexnormalize [file join [pwd] $FILEPATH]]  
      if {[file pathtype $FILEPATH] eq "relative"} { 
          set path [fileutil::relative [pwd] $path] 
      } 
      return $path 
  } 
}
