	component demo_control is
		port (
			clk_clk                             : in  std_logic                     := 'X';             -- clk
			demo_mgmt_waitrequest               : in  std_logic                     := 'X';             -- waitrequest
			demo_mgmt_readdata                  : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			demo_mgmt_readdatavalid             : in  std_logic                     := 'X';             -- readdatavalid
			demo_mgmt_burstcount                : out std_logic_vector(0 downto 0);                     -- burstcount
			demo_mgmt_writedata                 : out std_logic_vector(31 downto 0);                    -- writedata
			demo_mgmt_address                   : out std_logic_vector(8 downto 0);                     -- address
			demo_mgmt_write                     : out std_logic;                                        -- write
			demo_mgmt_read                      : out std_logic;                                        -- read
			demo_mgmt_byteenable                : out std_logic_vector(3 downto 0);                     -- byteenable
			demo_mgmt_debugaccess               : out std_logic;                                        -- debugaccess
			issp_sources_source                 : out std_logic_vector(8 downto 0);                     -- source
			measure_payload_pio_h_export        : in  std_logic_vector(31 downto 0) := (others => 'X'); -- export
			measure_payload_pio_l_export        : in  std_logic_vector(31 downto 0) := (others => 'X'); -- export
			measure_time_pio_export             : out std_logic_vector(31 downto 0);                    -- export
			source_mgmt_waitrequest             : in  std_logic                     := 'X';             -- waitrequest
			source_mgmt_readdata                : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			source_mgmt_readdatavalid           : in  std_logic                     := 'X';             -- readdatavalid
			source_mgmt_burstcount              : out std_logic_vector(0 downto 0);                     -- burstcount
			source_mgmt_writedata               : out std_logic_vector(31 downto 0);                    -- writedata
			source_mgmt_address                 : out std_logic_vector(29 downto 0);                    -- address
			source_mgmt_write                   : out std_logic;                                        -- write
			source_mgmt_read                    : out std_logic;                                        -- read
			source_mgmt_byteenable              : out std_logic_vector(3 downto 0);                     -- byteenable
			source_mgmt_debugaccess             : out std_logic;                                        -- debugaccess
			reset_reset_n                       : in  std_logic                     := 'X';             -- reset_n
			rx_coreclk_cnt_pio_export           : in  std_logic_vector(31 downto 0) := (others => 'X'); -- export
			rx_coreclk_sync_clk_clk             : in  std_logic                     := 'X';             -- clk
			rx_coreclk_sync_in_reset_reset_n    : in  std_logic                     := 'X';             -- reset_n
			rx_coreclk_sync_out_reset_reset_n   : out std_logic;                                        -- reset_n
			rx_coreclk_sync_out_reset_1_reset_n : out std_logic;                                        -- reset_n
			rx_lanes_status_pio_export          : in  std_logic_vector(31 downto 0) := (others => 'X'); -- export
			sync_reset_reset                    : out std_logic;                                        -- reset
			system_status_pio_export            : in  std_logic_vector(31 downto 0) := (others => 'X'); -- export
			tx_coreclk_sync_clk_clk             : in  std_logic                     := 'X';             -- clk
			tx_coreclk_sync_in_reset_reset_n    : in  std_logic                     := 'X';             -- reset_n
			tx_coreclk_sync_out_reset_reset_n   : out std_logic;                                        -- reset_n
			tx_coreclk_sync_out_reset_1_reset_n : out std_logic;                                        -- reset_n
			tx_lanes_status_pio_export          : in  std_logic_vector(31 downto 0) := (others => 'X'); -- export
			txrx_lanes_status_pio_export        : in  std_logic_vector(31 downto 0) := (others => 'X')  -- export
		);
	end component demo_control;

	u0 : component demo_control
		port map (
			clk_clk                             => CONNECTED_TO_clk_clk,                             --                         clk.clk
			demo_mgmt_waitrequest               => CONNECTED_TO_demo_mgmt_waitrequest,               --                   demo_mgmt.waitrequest
			demo_mgmt_readdata                  => CONNECTED_TO_demo_mgmt_readdata,                  --                            .readdata
			demo_mgmt_readdatavalid             => CONNECTED_TO_demo_mgmt_readdatavalid,             --                            .readdatavalid
			demo_mgmt_burstcount                => CONNECTED_TO_demo_mgmt_burstcount,                --                            .burstcount
			demo_mgmt_writedata                 => CONNECTED_TO_demo_mgmt_writedata,                 --                            .writedata
			demo_mgmt_address                   => CONNECTED_TO_demo_mgmt_address,                   --                            .address
			demo_mgmt_write                     => CONNECTED_TO_demo_mgmt_write,                     --                            .write
			demo_mgmt_read                      => CONNECTED_TO_demo_mgmt_read,                      --                            .read
			demo_mgmt_byteenable                => CONNECTED_TO_demo_mgmt_byteenable,                --                            .byteenable
			demo_mgmt_debugaccess               => CONNECTED_TO_demo_mgmt_debugaccess,               --                            .debugaccess
			issp_sources_source                 => CONNECTED_TO_issp_sources_source,                 --                issp_sources.source
			measure_payload_pio_h_export        => CONNECTED_TO_measure_payload_pio_h_export,        --       measure_payload_pio_h.export
			measure_payload_pio_l_export        => CONNECTED_TO_measure_payload_pio_l_export,        --       measure_payload_pio_l.export
			measure_time_pio_export             => CONNECTED_TO_measure_time_pio_export,             --            measure_time_pio.export
			source_mgmt_waitrequest             => CONNECTED_TO_source_mgmt_waitrequest,             --                 source_mgmt.waitrequest
			source_mgmt_readdata                => CONNECTED_TO_source_mgmt_readdata,                --                            .readdata
			source_mgmt_readdatavalid           => CONNECTED_TO_source_mgmt_readdatavalid,           --                            .readdatavalid
			source_mgmt_burstcount              => CONNECTED_TO_source_mgmt_burstcount,              --                            .burstcount
			source_mgmt_writedata               => CONNECTED_TO_source_mgmt_writedata,               --                            .writedata
			source_mgmt_address                 => CONNECTED_TO_source_mgmt_address,                 --                            .address
			source_mgmt_write                   => CONNECTED_TO_source_mgmt_write,                   --                            .write
			source_mgmt_read                    => CONNECTED_TO_source_mgmt_read,                    --                            .read
			source_mgmt_byteenable              => CONNECTED_TO_source_mgmt_byteenable,              --                            .byteenable
			source_mgmt_debugaccess             => CONNECTED_TO_source_mgmt_debugaccess,             --                            .debugaccess
			reset_reset_n                       => CONNECTED_TO_reset_reset_n,                       --                       reset.reset_n
			rx_coreclk_cnt_pio_export           => CONNECTED_TO_rx_coreclk_cnt_pio_export,           --          rx_coreclk_cnt_pio.export
			rx_coreclk_sync_clk_clk             => CONNECTED_TO_rx_coreclk_sync_clk_clk,             --         rx_coreclk_sync_clk.clk
			rx_coreclk_sync_in_reset_reset_n    => CONNECTED_TO_rx_coreclk_sync_in_reset_reset_n,    --    rx_coreclk_sync_in_reset.reset_n
			rx_coreclk_sync_out_reset_reset_n   => CONNECTED_TO_rx_coreclk_sync_out_reset_reset_n,   --   rx_coreclk_sync_out_reset.reset_n
			rx_coreclk_sync_out_reset_1_reset_n => CONNECTED_TO_rx_coreclk_sync_out_reset_1_reset_n, -- rx_coreclk_sync_out_reset_1.reset_n
			rx_lanes_status_pio_export          => CONNECTED_TO_rx_lanes_status_pio_export,          --         rx_lanes_status_pio.export
			sync_reset_reset                    => CONNECTED_TO_sync_reset_reset,                    --                  sync_reset.reset
			system_status_pio_export            => CONNECTED_TO_system_status_pio_export,            --           system_status_pio.export
			tx_coreclk_sync_clk_clk             => CONNECTED_TO_tx_coreclk_sync_clk_clk,             --         tx_coreclk_sync_clk.clk
			tx_coreclk_sync_in_reset_reset_n    => CONNECTED_TO_tx_coreclk_sync_in_reset_reset_n,    --    tx_coreclk_sync_in_reset.reset_n
			tx_coreclk_sync_out_reset_reset_n   => CONNECTED_TO_tx_coreclk_sync_out_reset_reset_n,   --   tx_coreclk_sync_out_reset.reset_n
			tx_coreclk_sync_out_reset_1_reset_n => CONNECTED_TO_tx_coreclk_sync_out_reset_1_reset_n, -- tx_coreclk_sync_out_reset_1.reset_n
			tx_lanes_status_pio_export          => CONNECTED_TO_tx_lanes_status_pio_export,          --         tx_lanes_status_pio.export
			txrx_lanes_status_pio_export        => CONNECTED_TO_txrx_lanes_status_pio_export         --       txrx_lanes_status_pio.export
		);

