// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// (C) 2001-2019 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// (C) 2001-2019 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// (C) 2001-2019 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// (C) 2001-2018 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


`timescale 1ps/1ps

module cascaded_counter #
  (
    parameter                     NUM_ADD_BLOCK                         = 8,              	// Number of adder block
    parameter                     ADD_BLOCK_BITS                        = 8			// Bits per block
  )
  (
	input reset,count_enable,clock,
	
	input [(NUM_ADD_BLOCK*ADD_BLOCK_BITS-1):0] data_in,
	output reg [(NUM_ADD_BLOCK*ADD_BLOCK_BITS-1):0] data_out
	
  );
  
reg [(NUM_ADD_BLOCK-1):0] prep_count,next_prep_count ;

		
always @(posedge clock) begin
        if (reset == 1'b1) begin
		prep_count <= 0;
        end else begin	
		prep_count 		 	 <= next_prep_count;
        end
end
		
		
		
		always @ *begin
		if (reset == 1'b1) begin

		next_prep_count[0] <= 1'd0;
		data_out[(ADD_BLOCK_BITS-1):0] <=  {(ADD_BLOCK_BITS){1'd0}};
		end else begin 
		
				if (count_enable)begin
				data_out[(ADD_BLOCK_BITS-1):0] <= data_in[(ADD_BLOCK_BITS-1):0] + {{(ADD_BLOCK_BITS-1){1'b0}}, 1'd1};
				end else begin
				data_out[(ADD_BLOCK_BITS-1):0] <= data_in[(ADD_BLOCK_BITS-1):0];
				end

				case ({(&data_out[(ADD_BLOCK_BITS-1):0]),count_enable})
				0: next_prep_count[0] <= prep_count[0];
				1: next_prep_count[0] <= 1'd0;
				2: next_prep_count[0] <= 1'd1;
				3: next_prep_count[0] <= 1'd1;
				default:next_prep_count[0] <= 1'd1;
				endcase
		
			end
		end 


		genvar i;

		generate 
		for (i = 1; i < NUM_ADD_BLOCK; i = i + 1) begin : add_block

			always @ * begin

				if (reset == 1'b1) begin
				data_out[(i*(ADD_BLOCK_BITS)+(ADD_BLOCK_BITS-1)):(i*(ADD_BLOCK_BITS))]<= {(ADD_BLOCK_BITS){1'd0}};
				next_prep_count[i] <= 1'd0;
				end else 
				begin
				
					if (count_enable&&(&prep_count[i-1:0]))begin
					data_out[(i*(ADD_BLOCK_BITS)+(ADD_BLOCK_BITS-1)):(i*(ADD_BLOCK_BITS))] <= data_in[(i*(ADD_BLOCK_BITS)+(ADD_BLOCK_BITS-1)):(i*(ADD_BLOCK_BITS))] + {{(ADD_BLOCK_BITS-1){1'b0}}, 1'd1};
					end else begin
					data_out[(i*(ADD_BLOCK_BITS)+(ADD_BLOCK_BITS-1)):(i*(ADD_BLOCK_BITS))] <= data_in[(i*(ADD_BLOCK_BITS)+(ADD_BLOCK_BITS-1)):(i*(ADD_BLOCK_BITS))];
					end
					
					case ({(&data_out[(i*(ADD_BLOCK_BITS)+(ADD_BLOCK_BITS-1)):(i*(ADD_BLOCK_BITS))]),count_enable})
					0: next_prep_count[i] <= prep_count[i];
					1: next_prep_count[i] <= 1'd0;
					2: next_prep_count[i] <= 1'd1;
					3: next_prep_count[i] <= 1'd1;
					default:next_prep_count[i] <= 1'd1;
					endcase

				end
				end
		end

		endgenerate
  
  endmodule
