// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// (C) 2001-2019 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// (C) 2001-2018 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


`timescale 1 ps / 1 ps


//
// Bus state machine state definitions
//
`define  BSM_IDLE             2'b00
`define  BSM_ACTIVE_LOCAL     2'b01
`define  BSM_ACTIVE_SOURCE    2'b10
`define  BSM_ACTIVE_SINK      2'b11


//
// CSR offsets
//
`define  DEMO_MGMT_CONTROL_OFFSET                        9'h0

`define  DEMO_MGMT_SRC_BURST_COUNT_OFFSET                9'h10
`define  DEMO_MGMT_SRC_WORDS_TRANS_L_OFFSET              9'h14
`define  DEMO_MGMT_SRC_WORDS_TRANS_H_OFFSET              9'h18
`define  DEMO_MGMT_SRC_TOTAL_ERRORS_OFFSET               9'h1C

`define  DEMO_MGMT_SNK_BURST_COUNT_OFFSET                9'h20
`define  DEMO_MGMT_SNK_WORDS_RECVD_L_OFFSET              9'h24
`define  DEMO_MGMT_SNK_WORDS_RECVD_H_OFFSET              9'h28
`define  DEMO_MGMT_SNK_TOTAL_ERRORS_OFFSET               9'h2C
`define  DEMO_MGMT_SNK_OVERFLOW_ERRORS_OFFSET            9'h30
`define  DEMO_MGMT_SNK_LOSS_ALIGN_NORMAL_ERRORS_OFFSET   9'h34
`define  DEMO_MGMT_SNK_DATA_ERRORS_OFFSET     			 9'h38
`define  DEMO_MGMT_SNK_LANE_SWAP_ERRORS_OFFSET           9'h3C
`define  DEMO_MGMT_SNK_LANE_SEQUENCE_ERRORS_OFFSET       9'h40
`define  DEMO_MGMT_SNK_LANE_ALIGNMENT_ERRORS_OFFSET      9'h44

`define  DEMO_MGMT_SNK_MF_CRC_ERRORS_BASE_OFFSET      	 9'h48
`define  DEMO_MGMT_SNK_PCS_DATA_ERRORS_BASE_OFFSET       9'h4C
`define  DEMO_MGMT_SNK_DESKEW_ERRORS_OFFSET      		 9'h64
`define  DEMO_MGMT_SRC_OVERFLOW_ERRORS_OFFSET           9'h50
// `define  DEMO_MGMT_SNK_UNDERFLOW_ERRORS_OFFSET           9'h6C
`define  DEMO_MGMT_SRC_FATAL_ERRORS_OFFSET      		 9'h54
`define  DEMO_MGMT_SRC_CORRECTABLE_ERRORS_OFFSET      	 9'h58
`define  DEMO_MGMT_SLV_FATAL_ERRORS_OFFSET      		 9'h5C
`define  DEMO_MGMT_SLV_CORRECTABLE_ERRORS_OFFSET      	 9'h60
// `define  DEMO_MGMT_SNK_FATAL_ERRORS_OFFSET      		 9'h64
// `define  DEMO_MGMT_SNK_CORRECTABLE_ERRORS_OFFSET         9'h68

module demo_mgmt #
(
parameter                     lanes = 4
)
(
// Source core interface
output                        source_reset,
input                         source_user_clock,
input                         source_user_clock_reset,
input                         source_error,

// Sink core interface
output                        sink_reset,
input                         sink_user_clock,
input                         sink_user_clock_reset,
input       [(lanes*2)+3-1:0]   sink_error,

// Traffic checker control and status
input       [26:0]            tc_burst_count,
input       [63:0]            tc_words_received,
input       [lanes-1:0]       tc_lane_swap_error,
input       [lanes-1:0]       tc_lane_sequence_error,
input       [lanes-1:0]       tc_lane_alignment_error,

// FIFO Status
input       	       	     snk_overflow_errors,
input       	       	     src_overflow_errors,
// input		 				 snk_underflow_errors,
input						 src_fatal_errors,
input						 src_correctable_errors,   
// input						 snk_fatal_errors,
// input						 snk_correctable_errors,
// input						 slave_fatal_errors,
// input						 slave_correctable_errors,    

// Traffic generator control and status
output                        tg_enable,
output                        tg_test_mode,
output                        tg_enable_stalls,
output                        crc_err_inject,
output                        enable_slave_mode,
output                        prbs_enable,
input       [26:0]            tg_burst_count,
input       [63:0]            tg_words_transferred,

// Demo management interface
input                         demo_mgmt_clk,
input                         demo_mgmt_clk_reset,
input       [8:0]             demo_mgmt_address,
input                         demo_mgmt_read,
output reg  [31:0]            demo_mgmt_readdata,
input                         demo_mgmt_write,
input       [31:0]            demo_mgmt_writedata,
output reg                    demo_mgmt_waitrequest,

//phy_mgmt_select interface
output 			 					phy_mgmt_select,

//pcs mode
input 								pcs_mode,

//op mode
input 								op_mode,

//crc mode
input 								crc_mode,

//fec mode
input 								fec_mode,

//crete type
input 								crete_type
);

wire                          sync_demo_mgmt_clk_reset;

reg                           demo_ctrl_dec;

reg         [31:0]            demo_ctrl_stat_csr;

reg         [31:0]            source_total_errors_csr;
reg         [31:0]            source_csr_capture;
reg         [31:0]            source_csr_mux_data;
wire                          source_read_n;
reg                           source_read_req_n;
wire                          source_read_ack_n;
wire                          ai_source_read_req_n;
wire                          ai_source_read_ack_n;

// reg         [31:0]            sink_underflow_errors_csr;
reg         [31:0]            sink_overflow_errors_csr;
reg         [31:0]            src_overflow_errors_csr;
reg         [31:0]            src_fatal_errors_csr;
reg         [31:0]            src_correctable_errors_csr;
//reg         [31:0]            slave_fatal_errors_csr;
//reg         [31:0]            slave_correctable_errors_csr;
// reg         [31:0]            snk_fatal_errors_csr;
// reg         [31:0]            snk_correctable_errors_csr;
reg         [31:0]            sink_loss_of_alignment_normal_errors_csr;
reg         [31:0]            sink_data_errors_csr;
reg         [31:0]            sink_deskew_errors_csr;
//reg         [31:0]            sink_meta_frame_crc_errors_csr[lanes];
//reg         [31:0]            sink_pcs_data_errors_csr[lanes];
reg         [31:0]            sink_meta_frame_crc_errors_csr;
reg         [31:0]            sink_pcs_data_errors_csr;
reg         [31:0]            sink_total_errors_csr;
reg         [31:0]            sink_csr_capture;
reg         [31:0]            sink_csr_mux_data;
wire                          sink_read_n;
reg                           sink_read_req_n;
wire                          sink_read_ack_n;
wire                          ai_sink_read_req_n;
wire                          ai_sink_read_ack_n;

reg         [31:0]            tc_lane_swap_errors_csr;
reg         [31:0]            tc_lane_sequence_errors_csr;
reg         [31:0]            tc_lane_alignment_errors_csr;

reg         [1:0]             bus_state, next_bus_state;
reg                           next_demo_mgmt_waitrequest;
reg         [4:0]             timeout_counter, next_timeout_counter;
reg         [5:0]             count_stretch_src_reset;
reg         [5:0]             count_stretch_snk_reset;

wire        [31:0]            lanes_wire32         = lanes;
wire        [4:0]             lanes_wire5          = lanes_wire32[4:0];
wire                          source_comb_reset;
wire                          sink_comb_reset;


assign source_comb_reset      = demo_ctrl_stat_csr[0]; 
assign sink_comb_reset        = demo_ctrl_stat_csr[1]; 
assign tg_test_mode           = demo_ctrl_stat_csr[2];
assign tg_enable_stalls       = demo_ctrl_stat_csr[3];
assign tg_enable              = demo_ctrl_stat_csr[4];
assign crc_err_inject         = demo_ctrl_stat_csr[5];
assign enable_slave_mode      = demo_ctrl_stat_csr[6];
assign phy_mgmt_select        = demo_ctrl_stat_csr[7];
assign prbs_enable        	 =  demo_ctrl_stat_csr[8];
//
// source reset synchronizer.
//
altera_std_synchronizer_nocut #
(
.depth(3),
.rst_value(1)
)
source_reset_sync 
(
.clk(source_user_clock), 
.reset_n(~source_comb_reset), 
.din(1'b0), 
.dout(source_reset)
);

//
// sink reset synchronizer.
//
altera_std_synchronizer_nocut #
(
.depth(3),
.rst_value(1)
)
sink_reset_sync 
(
.clk(sink_user_clock), 
.reset_n(~sink_comb_reset), 
.din(1'b0), 
.dout(sink_reset)
);


//
// Management reset synchronizer.
//
altera_std_synchronizer_nocut #
(
.depth(2),
.rst_value(1)
) 
demo_mgmt_clk_reset_sync 
(
.clk(demo_mgmt_clk), 
.reset_n(~demo_mgmt_clk_reset), 
.din(1'b0), 
.dout(sync_demo_mgmt_clk_reset)
);


//
// Handshake request block for read of source CSRs
//
dp_hs_req source_req_block
(
.async_reset_n(~sync_demo_mgmt_clk_reset),
.sync_reset_n(1'b1),
.sync_ctrl(2'd2),
.si_clk(demo_mgmt_clk),
.si_req_n(source_read_req_n),
.si_ack_n(source_read_ack_n),
.ai_req_n(ai_source_read_req_n),
.ai_ack_n(ai_source_read_ack_n)
);


//
// Handshake request block for read of sink CSRs
//
dp_hs_req sink_req_block
(
.async_reset_n(~sync_demo_mgmt_clk_reset),
.sync_reset_n(1'b1),
.sync_ctrl(2'd2),
.si_clk(demo_mgmt_clk),
.si_req_n(sink_read_req_n),
.si_ack_n(sink_read_ack_n),
.ai_req_n(ai_sink_read_req_n),
.ai_ack_n(ai_sink_read_ack_n)
);

reg       [(lanes*2)+2:0]   sink_error_d;
reg       tc_lane_swap_error_d, tc_lane_sequence_error_d, tc_lane_alignment_error_d, sink_error_decoded;

reg source_enable, source_enable_d;
 always @(posedge source_user_clock or posedge source_user_clock_reset or posedge source_reset) begin
 if (source_user_clock_reset || source_reset) begin
source_enable <= 1'b0;
source_enable_d <= 1'b0;
end else begin
source_enable <= 1'b1;
source_enable_d <= source_enable;
end
end

reg sink_enable, sink_enable_d;
reg sink_total_err_clr, sink_total_err_clr_d;
reg sink_err_clr, sink_err_clr_d, sink_crc_err_clr, sink_crc_err_clr_d, sink_psc_data_err_clr, sink_psc_data_err_clr_d;
always @(posedge sink_user_clock or posedge sink_user_clock_reset or posedge sink_reset) begin
	if (sink_user_clock_reset || sink_reset) begin
	sink_err_clr <= 1'b1;
	sink_crc_err_clr <= 1'b1;
	sink_psc_data_err_clr <= 1'b1;
	sink_total_err_clr <= 1'b1;
	sink_total_err_clr_d <= 1'b1;
	sink_err_clr_d <= 1'b1;
	sink_crc_err_clr_d <= 1'b1;
	sink_psc_data_err_clr_d <= 1'b1;
	sink_enable <= 1'b0;
	sink_enable_d <= 1'b0;
	end else begin
	sink_enable <= 1'b1;
	sink_err_clr <= 1'b0;
	sink_crc_err_clr <= 1'b0;
	sink_psc_data_err_clr <= 1'b0;
	sink_total_err_clr <= 1'b0;
	sink_total_err_clr_d <= sink_total_err_clr;
	sink_err_clr_d <= sink_err_clr;
	sink_crc_err_clr_d <= sink_crc_err_clr;
	sink_psc_data_err_clr_d <= sink_psc_data_err_clr;
	sink_enable_d <= sink_enable;
	end
end

always @(posedge sink_user_clock) begin
if (~sink_enable_d)
tc_lane_swap_error_d <= 1'b0;
else
tc_lane_swap_error_d <= |tc_lane_swap_error;
end

always @(posedge sink_user_clock) begin
if (~sink_enable_d)
tc_lane_sequence_error_d <= 1'b0;
else
tc_lane_sequence_error_d <= |tc_lane_sequence_error;
end

always @(posedge sink_user_clock) begin
if (~sink_enable_d)
tc_lane_alignment_error_d <= 1'b0;
else
tc_lane_alignment_error_d <= |tc_lane_alignment_error;
end

always @(posedge sink_user_clock) begin
if (sink_total_err_clr_d) begin
sink_error_d <= {(lanes*2+3){1'b0}};
sink_error_decoded <= 1'b0;
end else begin
sink_error_d <= sink_error;
sink_error_decoded <= (|sink_error_d != 0) ? 1'b1 : 1'b0;
end
end

reg [26:0]  tc_burst_count_d, tg_burst_count_d;
reg [63:0]  tc_words_received_d, tg_words_transferred_d;
// always @(posedge sink_user_clock) begin
// if (~sink_enable_d) begin
// tc_burst_count_d <= 27'd0;
// end else begin
// tc_burst_count_d <= tc_burst_count;
// end
// end

always @(posedge sink_user_clock) begin
tc_burst_count_d <= tc_burst_count;
tc_words_received_d <= tc_words_received;
end

always @(posedge source_user_clock) begin
tg_burst_count_d <= tg_burst_count;
tg_words_transferred_d <= tg_words_transferred;
end

//
// Decode register selects.
//
wire [8:0] demo_mgmt_address_decoded;
assign demo_mgmt_address_decoded = (demo_mgmt_address > `DEMO_MGMT_SRC_CORRECTABLE_ERRORS_OFFSET)? `DEMO_MGMT_SRC_CORRECTABLE_ERRORS_OFFSET:demo_mgmt_address;

always @* begin

demo_ctrl_dec  = 1'b0;

case (demo_mgmt_address_decoded)

`DEMO_MGMT_CONTROL_OFFSET:                         begin demo_ctrl_dec = 1'b1; source_read_req_n = 1'b1; sink_read_req_n = 1'b1; end

`DEMO_MGMT_SRC_BURST_COUNT_OFFSET:                 begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b0; sink_read_req_n = 1'b1; end
`DEMO_MGMT_SRC_WORDS_TRANS_L_OFFSET:               begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b0; sink_read_req_n = 1'b1; end
`DEMO_MGMT_SRC_WORDS_TRANS_H_OFFSET:               begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b0; sink_read_req_n = 1'b1; end
`DEMO_MGMT_SRC_TOTAL_ERRORS_OFFSET:                begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b0; sink_read_req_n = 1'b1; end
`DEMO_MGMT_SRC_OVERFLOW_ERRORS_OFFSET:       	   begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b0; sink_read_req_n = 1'b1; end
`DEMO_MGMT_SNK_BURST_COUNT_OFFSET:                 begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end
`DEMO_MGMT_SNK_WORDS_RECVD_L_OFFSET:               begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end
`DEMO_MGMT_SNK_WORDS_RECVD_H_OFFSET:               begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end
`DEMO_MGMT_SNK_TOTAL_ERRORS_OFFSET:                begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end
`DEMO_MGMT_SNK_OVERFLOW_ERRORS_OFFSET:             begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end
`DEMO_MGMT_SNK_LOSS_ALIGN_NORMAL_ERRORS_OFFSET:    begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end
`DEMO_MGMT_SNK_DATA_ERRORS_OFFSET:      		   begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end
`DEMO_MGMT_SNK_LANE_SWAP_ERRORS_OFFSET:            begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end
`DEMO_MGMT_SNK_LANE_SEQUENCE_ERRORS_OFFSET:        begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end
`DEMO_MGMT_SNK_LANE_ALIGNMENT_ERRORS_OFFSET:       begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end
`DEMO_MGMT_SNK_DESKEW_ERRORS_OFFSET:       		   begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end
`DEMO_MGMT_SNK_MF_CRC_ERRORS_BASE_OFFSET:          begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end
`DEMO_MGMT_SNK_PCS_DATA_ERRORS_BASE_OFFSET:        begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end
// `DEMO_MGMT_SNK_UNDERFLOW_ERRORS_OFFSET:       	   begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end
 `DEMO_MGMT_SRC_FATAL_ERRORS_OFFSET:            	   begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b0; sink_read_req_n = 1'b1; end
 `DEMO_MGMT_SRC_CORRECTABLE_ERRORS_OFFSET:          begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b0; sink_read_req_n = 1'b1; end
// `DEMO_MGMT_SLV_FATAL_ERRORS_OFFSET:            	   begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end
// `DEMO_MGMT_SLV_CORRECTABLE_ERRORS_OFFSET:          begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end
// `DEMO_MGMT_SNK_FATAL_ERRORS_OFFSET:            	   begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end		
// `DEMO_MGMT_SNK_CORRECTABLE_ERRORS_OFFSET:          begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b0; end	
default:                                           begin demo_ctrl_dec = 1'b0; source_read_req_n = 1'b1; sink_read_req_n = 1'b1; end

endcase

end


/* synthesis translate_off */

reg [0:255] bus_state_encode;     // This string is for simulation debug

always @ (bus_state) begin

case (bus_state)

`BSM_IDLE:           bus_state_encode   <= "IDLE";
`BSM_ACTIVE_LOCAL:   bus_state_encode   <= "ACTIVE_LOCAL";
`BSM_ACTIVE_SOURCE:  bus_state_encode   <= "ACTIVE_SOURCE";
`BSM_ACTIVE_SINK:    bus_state_encode   <= "ACTIVE_SINK";
default:             bus_state_encode   <= "*** Error: Unknown State ***";

endcase

end

/* synthesis translate_on */


//
// Bus State Machine storage
//
always @(posedge demo_mgmt_clk or posedge sync_demo_mgmt_clk_reset) begin

if (sync_demo_mgmt_clk_reset) begin

bus_state               <= `BSM_IDLE;
demo_mgmt_waitrequest   <= 1'b1;
timeout_counter         <= 5'h1F;

end else begin

bus_state               <= next_bus_state;
demo_mgmt_waitrequest   <= next_demo_mgmt_waitrequest;
timeout_counter         <= next_timeout_counter;

end

end


//
// Bus State Machine decoder
//
always @(*) begin


case (bus_state)

`BSM_IDLE: begin

next_bus_state             = (source_read_req_n == 1'b0)                             ? `BSM_ACTIVE_SOURCE :
(sink_read_req_n   == 1'b0)                             ? `BSM_ACTIVE_SINK   :
((demo_mgmt_read == 1'b1) || (demo_mgmt_write == 1'b1)) ? `BSM_ACTIVE_LOCAL  : `BSM_IDLE;

next_demo_mgmt_waitrequest = (source_read_req_n == 1'b0) ? 1'b1 :
(sink_read_req_n   == 1'b0) ? 1'b1 :
(((demo_mgmt_read == 1'b1) || (demo_mgmt_write == 1'b1)) && (demo_mgmt_waitrequest == 1'b1)) ? 1'b0 : 1'b1;

next_timeout_counter       = 5'h1F;

end


//
// Access CSRs in the demo_mgmt_clk clock domain, zero wait states
//
`BSM_ACTIVE_LOCAL: begin

next_bus_state             = `BSM_IDLE;

next_demo_mgmt_waitrequest = 1'b1;

next_timeout_counter       = 5'h1F;

end


//
// Access CSRs in the source_user_clock clock domain
//
`BSM_ACTIVE_SOURCE: begin

next_bus_state             = (demo_mgmt_waitrequest == 1'b0) ? `BSM_IDLE : `BSM_ACTIVE_SOURCE;

next_demo_mgmt_waitrequest = (timeout_counter == 5'h00) ?  1'b0 : source_read_ack_n;

next_timeout_counter       = (demo_mgmt_waitrequest == 1'b0) ? 5'h1F : timeout_counter - 5'h01;

end


//
// Access CSRs in the sink_user_clock clock domain
//
`BSM_ACTIVE_SINK: begin

next_bus_state             = (demo_mgmt_waitrequest == 1'b0) ? `BSM_IDLE : `BSM_ACTIVE_SINK;

next_demo_mgmt_waitrequest = (timeout_counter == 5'h00) ?  1'b0 : sink_read_ack_n;

next_timeout_counter       = (demo_mgmt_waitrequest == 1'b0) ? 5'h1F : timeout_counter - 5'h01;

end

endcase

end


//
// Output Data MUX. This block selects the register data for read cycles.
//
always @(posedge demo_mgmt_clk or posedge sync_demo_mgmt_clk_reset) begin

if (sync_demo_mgmt_clk_reset) begin

demo_mgmt_readdata      <= 32'd0;

end else if (timeout_counter == 5'h00) begin

demo_mgmt_readdata      <= 32'hFFFFFFFF;

end else begin

case (demo_mgmt_address_decoded)

`DEMO_MGMT_CONTROL_OFFSET:                         demo_mgmt_readdata <= demo_ctrl_stat_csr;

`DEMO_MGMT_SRC_BURST_COUNT_OFFSET:                 demo_mgmt_readdata <= source_csr_capture;
`DEMO_MGMT_SRC_WORDS_TRANS_L_OFFSET:               demo_mgmt_readdata <= source_csr_capture;
`DEMO_MGMT_SRC_WORDS_TRANS_H_OFFSET:               demo_mgmt_readdata <= source_csr_capture;
`DEMO_MGMT_SRC_TOTAL_ERRORS_OFFSET:                demo_mgmt_readdata <= source_csr_capture;
`DEMO_MGMT_SRC_FATAL_ERRORS_OFFSET:            	   demo_mgmt_readdata <= source_csr_capture;
`DEMO_MGMT_SRC_CORRECTABLE_ERRORS_OFFSET:          demo_mgmt_readdata <= source_csr_capture;
`DEMO_MGMT_SRC_OVERFLOW_ERRORS_OFFSET:             demo_mgmt_readdata <= source_csr_capture;
`DEMO_MGMT_SNK_BURST_COUNT_OFFSET:                 demo_mgmt_readdata <= sink_csr_capture;
`DEMO_MGMT_SNK_WORDS_RECVD_L_OFFSET:               demo_mgmt_readdata <= sink_csr_capture;
`DEMO_MGMT_SNK_WORDS_RECVD_H_OFFSET:               demo_mgmt_readdata <= sink_csr_capture;
`DEMO_MGMT_SNK_TOTAL_ERRORS_OFFSET:                demo_mgmt_readdata <= sink_csr_capture;
`DEMO_MGMT_SNK_OVERFLOW_ERRORS_OFFSET:             demo_mgmt_readdata <= sink_csr_capture;
`DEMO_MGMT_SNK_LOSS_ALIGN_NORMAL_ERRORS_OFFSET:    demo_mgmt_readdata <= sink_csr_capture;
`DEMO_MGMT_SNK_DATA_ERRORS_OFFSET:      		   demo_mgmt_readdata <= sink_csr_capture;
`DEMO_MGMT_SNK_LANE_SWAP_ERRORS_OFFSET:            demo_mgmt_readdata <= sink_csr_capture;
`DEMO_MGMT_SNK_LANE_SEQUENCE_ERRORS_OFFSET:        demo_mgmt_readdata <= sink_csr_capture;
`DEMO_MGMT_SNK_LANE_ALIGNMENT_ERRORS_OFFSET:       demo_mgmt_readdata <= sink_csr_capture;
`DEMO_MGMT_SNK_DESKEW_ERRORS_OFFSET:         	   demo_mgmt_readdata <= sink_csr_capture;
`DEMO_MGMT_SNK_MF_CRC_ERRORS_BASE_OFFSET:          demo_mgmt_readdata <= sink_csr_capture;
`DEMO_MGMT_SNK_PCS_DATA_ERRORS_BASE_OFFSET:        demo_mgmt_readdata <= sink_csr_capture;
`DEMO_MGMT_SLV_FATAL_ERRORS_OFFSET:            	   demo_mgmt_readdata <= sink_csr_capture;  
`DEMO_MGMT_SLV_CORRECTABLE_ERRORS_OFFSET:          demo_mgmt_readdata <= sink_csr_capture;  
// `DEMO_MGMT_SNK_UNDERFLOW_ERRORS_OFFSET:       	   demo_mgmt_readdata <= sink_csr_capture;
// `DEMO_MGMT_SNK_FATAL_ERRORS_OFFSET:            	   demo_mgmt_readdata <= sink_csr_capture;
// `DEMO_MGMT_SNK_CORRECTABLE_ERRORS_OFFSET:          demo_mgmt_readdata <= sink_csr_capture;
default:                                           demo_mgmt_readdata <= 32'h00000000;

endcase

end

end



//
// Demo Control/Status CSR - Generic control and status for the demo
//
// Register bitfields: [31:27] RO - Number of lanes on the link
//                     [26]    RO - Crete type : 0 = htile, 1 = etile
//                     [25]    RO - PCS mode: 1 = PAM4, 0 = NRZ
//                     [24]    RO - Operation mode: 1 = FULL, 0 = BASIC
//                     [23]    RO - CRC mode: 1 = Enabled, 0 = Disabled
//                     [22]    RO - FEC mode: 1 = Enabled, 0 = Disabled
//                     [21:09] RO - reserved
//			  		   [8]     RW - Enable PRBS instead of Incremental
//			  		   [7]     RW - Select for Tx or Rx phy_mgmt
//                     [6]     RW - Enable master/slave switching
//                     [5]     RW - CRC Error Insertion
//                     [4]     RW - Enable traffic generator
//                     [3]     RW - Enable stall generation
//                     [2]     RW - Test Mode
//                     [1]     RW - Sink reset, active high
//                     [0]     RW - Source reset, active high
//
   always @(posedge demo_mgmt_clk or posedge sync_demo_mgmt_clk_reset) begin

if (sync_demo_mgmt_clk_reset) begin
demo_ctrl_stat_csr <= {lanes_wire5, crete_type, pcs_mode, op_mode, crc_mode, fec_mode, 13'd0, 9'b00000011};
end else begin

if ((demo_ctrl_dec == 1'b1) && (demo_mgmt_write == 1'b1)) begin
demo_ctrl_stat_csr <= {lanes_wire5,crete_type,pcs_mode,op_mode, crc_mode, fec_mode, 13'h00000, demo_mgmt_writedata[8:0]};
end else begin

demo_ctrl_stat_csr <= (demo_ctrl_stat_csr & 32'hFFFFFFFC) ;
//demo_ctrl_stat_csr <= demo_ctrl_stat_csr ;
end

end

end





//*********************************************************************
//
// Source User Clock Domain Logic
//
//*********************************************************************

//
// Handshake response block for read request indication
//
dp_hs_resp source_resp_block
(
.async_reset_n(~source_user_clock_reset),
.sync_reset_n(1'b1),
.sync_ctrl(2'd2),
.si_clk(source_user_clock),
.si_req_n(source_read_n),
.si_ack_n(source_read_n),
.ai_req_n(ai_source_read_req_n),
.ai_ack_n(ai_source_read_ack_n)
);


//
// Source Capture Register MUX. This block selects the source register data for read cycles.
//
always @(*) begin

case (demo_mgmt_address)

`DEMO_MGMT_SRC_BURST_COUNT_OFFSET:                 source_csr_mux_data = {5'd0, tg_burst_count_d};
`DEMO_MGMT_SRC_WORDS_TRANS_L_OFFSET:               source_csr_mux_data = tg_words_transferred_d[31:00];
`DEMO_MGMT_SRC_WORDS_TRANS_H_OFFSET:               source_csr_mux_data = tg_words_transferred_d[63:32];
`DEMO_MGMT_SRC_TOTAL_ERRORS_OFFSET:                source_csr_mux_data = source_total_errors_csr;
`DEMO_MGMT_SRC_FATAL_ERRORS_OFFSET:            	   source_csr_mux_data = src_fatal_errors_csr;  
`DEMO_MGMT_SRC_CORRECTABLE_ERRORS_OFFSET:          source_csr_mux_data = src_correctable_errors_csr;  
`DEMO_MGMT_SRC_OVERFLOW_ERRORS_OFFSET:             source_csr_mux_data = src_overflow_errors_csr;  
default:                                           source_csr_mux_data = 32'h00000000;

endcase

end

// Source User Clock Domain CSR Capture Register
//
always @(posedge source_user_clock) begin
if (~source_enable_d) begin

source_csr_capture <= 32'd0;

end else begin

source_csr_capture <= source_csr_mux_data;
end

end


//
// Source FIFO Overflow CSR
//
always @(posedge source_user_clock) begin
if (~source_enable_d) begin

src_overflow_errors_csr <= 32'd0;

end else begin

src_overflow_errors_csr <= (src_overflow_errors != 1'b0) ? src_overflow_errors_csr + 32'd1 : src_overflow_errors_csr;

end

end

   //
// Source Total Error Count CSR
//

reg source_error_nc;

always @(posedge source_user_clock) begin
if (~source_enable_d) begin

source_total_errors_csr <= 32'd0;
source_error_nc <= 0;

end else begin

source_error_nc <= source_error;
source_total_errors_csr <= source_total_errors_csr +  source_error_nc;

end

end

//
// Source FIFO Fatal Errors Count CSR

always @(posedge source_user_clock) begin
if (~source_enable_d) begin

src_fatal_errors_csr <= 32'd0;

end else begin

src_fatal_errors_csr <= (src_fatal_errors != 1'b0) ? src_fatal_errors_csr + 32'd1 : src_fatal_errors_csr;

end

end

//
// Source FIFO Correctable Errors Count CSR
//
always @(posedge source_user_clock) begin
if (~source_enable_d) begin

src_correctable_errors_csr <= 32'd0;

end else begin

src_correctable_errors_csr <= (src_correctable_errors != 1'b0) ? src_correctable_errors_csr + 32'd1 : src_correctable_errors_csr;

end

end

//*********************************************************************
//
// Sink User Clock Domain Logic
//
//*********************************************************************

//
// Handshake response block for read request indication
//
dp_hs_resp sink_resp_block
(
.async_reset_n(~sink_user_clock_reset),
.sync_reset_n(1'b1),
.sync_ctrl(2'd2),
.si_clk(sink_user_clock),
.si_req_n(sink_read_n),
.si_ack_n(sink_read_n),
.ai_req_n(ai_sink_read_req_n),
.ai_ack_n(ai_sink_read_ack_n)
);


//
// Sink Capture Register MUX. This block selects the sink register data for read cycles.
//
wire [4:0] lane_num = demo_mgmt_address[4:0];
always @(*) begin

case (demo_mgmt_address_decoded)

`DEMO_MGMT_SNK_BURST_COUNT_OFFSET:                 sink_csr_mux_data = {5'd0, tc_burst_count_d};
`DEMO_MGMT_SNK_WORDS_RECVD_L_OFFSET:               sink_csr_mux_data = tc_words_received_d[31:00];
`DEMO_MGMT_SNK_WORDS_RECVD_H_OFFSET:               sink_csr_mux_data = tc_words_received_d[63:32];
`DEMO_MGMT_SNK_TOTAL_ERRORS_OFFSET:                sink_csr_mux_data = sink_total_errors_csr;
`DEMO_MGMT_SNK_OVERFLOW_ERRORS_OFFSET:             sink_csr_mux_data = sink_overflow_errors_csr;
`DEMO_MGMT_SNK_LOSS_ALIGN_NORMAL_ERRORS_OFFSET:    sink_csr_mux_data = sink_loss_of_alignment_normal_errors_csr;
`DEMO_MGMT_SNK_DATA_ERRORS_OFFSET:      		   sink_csr_mux_data =  sink_data_errors_csr;
`DEMO_MGMT_SNK_LANE_SWAP_ERRORS_OFFSET:            sink_csr_mux_data = tc_lane_swap_errors_csr;
`DEMO_MGMT_SNK_LANE_SEQUENCE_ERRORS_OFFSET:        sink_csr_mux_data = tc_lane_sequence_errors_csr;
`DEMO_MGMT_SNK_LANE_ALIGNMENT_ERRORS_OFFSET:       sink_csr_mux_data = tc_lane_alignment_errors_csr;
//`DEMO_MGMT_SNK_MF_CRC_ERRORS_BASE_OFFSET:          sink_csr_mux_data = sink_meta_frame_crc_errors_csr[lane_num] ;
//`DEMO_MGMT_SNK_PCS_DATA_ERRORS_BASE_OFFSET:        sink_csr_mux_data = sink_pcs_data_errors_csr[lane_num] ;
`DEMO_MGMT_SNK_MF_CRC_ERRORS_BASE_OFFSET:          sink_csr_mux_data = sink_meta_frame_crc_errors_csr ;
`DEMO_MGMT_SNK_PCS_DATA_ERRORS_BASE_OFFSET:        sink_csr_mux_data = sink_pcs_data_errors_csr ;
`DEMO_MGMT_SNK_DESKEW_ERRORS_OFFSET:         	   sink_csr_mux_data = sink_deskew_errors_csr ;
//`DEMO_MGMT_SLV_FATAL_ERRORS_OFFSET:            	   sink_csr_mux_data = slave_fatal_errors_csr;  
//`DEMO_MGMT_SLV_CORRECTABLE_ERRORS_OFFSET:          sink_csr_mux_data = slave_correctable_errors_csr;  
// `DEMO_MGMT_SNK_UNDERFLOW_ERRORS_OFFSET:            sink_csr_mux_data = sink_underflow_errors_csr;     
// `DEMO_MGMT_SNK_FATAL_ERRORS_OFFSET:            	   sink_csr_mux_data = snk_fatal_errors_csr;  
// `DEMO_MGMT_SNK_CORRECTABLE_ERRORS_OFFSET:          sink_csr_mux_data = snk_correctable_errors_csr;  			
default:                                           sink_csr_mux_data = 32'h00000000; 

endcase

end


//
// Sink User Clock Domain CSR Capture Register
//
always @(posedge sink_user_clock) begin
if (~sink_enable_d) begin
sink_csr_capture <= 32'd0;

end else begin

sink_csr_capture <= sink_csr_mux_data;
end

end


//
// Sink Total Errors Count CSR
//
always @(posedge sink_user_clock) begin
if (sink_err_clr_d) begin
sink_total_errors_csr <= 32'd0;

end else begin

sink_total_errors_csr <= (sink_error_decoded == 1'b1) ? sink_total_errors_csr + 32'd1 : sink_total_errors_csr;

end

end


// Sink FIFO Underflow Error Count CSR
/* 
always @(posedge sink_user_clock) begin

if (sink_user_clock_reset) begin

sink_underflow_errors_csr <= 32'd0;

end else begin

sink_underflow_errors_csr <= (snk_underflow_errors == 1'b1) ? sink_underflow_errors_csr + 32'd1 : sink_underflow_errors_csr;

end

end */

// Sink FIFO Overflow Error Count CSR

always @(posedge sink_user_clock) begin
if (~sink_enable_d) begin

sink_overflow_errors_csr <= 32'd0;

end else begin

sink_overflow_errors_csr <= (snk_overflow_errors == 1'b1) ? sink_overflow_errors_csr + 32'd1 : sink_overflow_errors_csr;

end

end

// Sink FIFO Fatal Error Count CSR

// always @(posedge sink_user_clock) begin

// if (~sink_enable) begin

// snk_fatal_errors_csr <= 32'd0;

// end else begin

// snk_fatal_errors_csr <= (snk_fatal_errors == 1'b1) ? snk_fatal_errors_csr + 32'd1 : snk_fatal_errors_csr;

// end

// end

// Sink FIFO Correctable Error Count CSR

// always @(posedge sink_user_clock) begin

// if (~sink_enable) begin

// snk_correctable_errors_csr <= 32'd0;

// end else begin

// snk_correctable_errors_csr <= (snk_correctable_errors == 1'b1) ? snk_correctable_errors_csr + 32'd1 : snk_correctable_errors_csr;

// end

// end

// Slave FIFO Fatal Errors Count CSR

/* always @(posedge sink_user_clock) begin
if (~sink_enable_d) begin

slave_fatal_errors_csr <= 32'd0;

end else begin

slave_fatal_errors_csr <= (slave_fatal_errors != 1'b0) ? slave_fatal_errors_csr + 32'd1 : slave_fatal_errors_csr;

end

end

//
// Slave FIFO Correctable Errors Count CSR
//
always @(posedge sink_user_clock) begin
if (~sink_enable_d) begin

slave_correctable_errors_csr <= 32'd0;

end else begin

slave_correctable_errors_csr <= (slave_correctable_errors != 1'b0) ? slave_correctable_errors_csr + 32'd1 : slave_correctable_errors_csr;

end

end */

   //
   // Sink Loss of Lane Alignment During Normal Operation Error Count CSR
   //
always @(posedge sink_user_clock) begin
if (sink_err_clr_d) begin
sink_loss_of_alignment_normal_errors_csr <= 32'd0;

end else begin

sink_loss_of_alignment_normal_errors_csr <= (sink_error_d[lanes] == 1'b1) ? sink_loss_of_alignment_normal_errors_csr + 32'd1 : sink_loss_of_alignment_normal_errors_csr;

end

end


//
// Sink Data Error Count CSR
//
always @(posedge sink_user_clock) begin
if (sink_err_clr_d) begin
sink_data_errors_csr <= 32'd0;

end else begin

sink_data_errors_csr <= (sink_error_d[lanes+1] == 1'b1) ? sink_data_errors_csr + 32'd1 : sink_data_errors_csr;

end

end


// Sink Deskew CSR
//
always @(posedge sink_user_clock) begin
if (sink_err_clr_d) begin
sink_deskew_errors_csr <= 32'd0;

end else begin

sink_deskew_errors_csr <= (sink_error_d[lanes+2] == 1'b1) ? sink_deskew_errors_csr + 32'd1 : sink_deskew_errors_csr;

end

end

//
// Traffic Checker Lane Swap Error Count CSR
//
always @(posedge sink_user_clock) begin
if (~sink_enable_d) begin

	tc_lane_swap_errors_csr <= 32'd0;

end else begin

tc_lane_swap_errors_csr <= (tc_lane_swap_error_d == 1'b1) ? tc_lane_swap_errors_csr + 32'd1 : tc_lane_swap_errors_csr;

end

end


   //
// Traffic Checker Lane Sequence Error Count CSR
//
always @(posedge sink_user_clock) begin
if (~sink_enable_d) begin

tc_lane_sequence_errors_csr <= 32'd0;

end else begin

tc_lane_sequence_errors_csr <= (tc_lane_sequence_error_d == 1'b1) ? tc_lane_sequence_errors_csr + 32'd1 : tc_lane_sequence_errors_csr;

end

end


   //
   // Traffic Checker Lane Alignment Error Count CSR
   //
always @(posedge sink_user_clock) begin
if (~sink_enable_d) begin

tc_lane_alignment_errors_csr <= 32'd0;

end else begin

tc_lane_alignment_errors_csr <= (tc_lane_alignment_error_d == 1'b1) ? tc_lane_alignment_errors_csr + 32'd1 : tc_lane_alignment_errors_csr;

end

end


//
// Per-lane Register Instantiation
//
//genvar lane;
//
//generate
//
//for (lane = 0; lane < lanes; lane = lane + 1) begin : lane_register_inst

	//
// Sink Per Lane CRC Error Count CSR
//
always @(posedge sink_user_clock) begin
if (sink_crc_err_clr_d) begin
sink_meta_frame_crc_errors_csr <= 32'd0;

end else begin

//sink_meta_frame_crc_errors_csr[lane] <= (sink_error_d[lane] == 1'b1) ? sink_meta_frame_crc_errors_csr[lane] + 32'd1 : sink_meta_frame_crc_errors_csr[lane];
sink_meta_frame_crc_errors_csr <= (|sink_error_d[lanes-1:0] == 1'b1) ? sink_meta_frame_crc_errors_csr + 32'd1 : sink_meta_frame_crc_errors_csr;
end

end


//
// Sink Per Lane PCS Data Error Count CSR
//
always @(posedge sink_user_clock) begin
if (sink_psc_data_err_clr_d) begin
//sink_pcs_data_errors_csr[lane] <= 32'd0;
sink_pcs_data_errors_csr <= 32'd0;

end else begin

//sink_pcs_data_errors_csr[lane] <= (sink_error_d[lanes+2+lane] == 1'b1) ? sink_pcs_data_errors_csr[lane] + 32'd1 : sink_pcs_data_errors_csr[lane];
sink_pcs_data_errors_csr <= (|sink_error_d[(lanes*2)+2:lanes+3] == 1'b1) ? sink_pcs_data_errors_csr + 32'd1 : sink_pcs_data_errors_csr;
end
end

//end
//
//endgenerate


endmodule  // demo_mgmt
