// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


module ecc_chk_dsk_top# (
parameter PCIE_IP_MODE_EPX16 = "pcie_x16",
parameter PCIE_IP_MODE_EPX8 = "pcie_x8x8",
parameter PCIE_IP_MODE_RPX4 = "pcie_x4x4x4x4",
parameter DEVICE_WIDTH = "pcie_x16",
parameter core16_enable_ecc_hwtcl = 0,
parameter core8_enable_ecc_hwtcl = 0,
parameter core4_0_enable_ecc_hwtcl = 0,
parameter core4_1_enable_ecc_hwtcl = 0
) (
/////////////////deskew ////////////////////

//`define SIM_MODE
//`define RANDOM_AIB_SKEW
input i_clk,
input [3:0] i_rst_n,


input 	[107:0] 		s0_3_1__core_periphery__data_to_core,   
input 	[107:0] 		s0_4_1__core_periphery__data_to_core,
input 	[107:0] 		s0_9_1__core_periphery__data_to_core,
input 	[107:0] 		s0_10_1__core_periphery__data_to_core,
input 	[107:0] 		s0_15_1__core_periphery__data_to_core,
input 	[107:0] 		s0_16_1__core_periphery__data_to_core,
input 	[107:0] 		s0_22_1__core_periphery__data_to_core,
input 	[107:0] 		s0_23_1__core_periphery__data_to_core,
input 	[107:0] 		s0_28_1__core_periphery__data_to_core,
input 	[107:0] 		s0_29_1__core_periphery__data_to_core,
input 	[107:0] 		s0_34_1__core_periphery__data_to_core,
input 	[107:0] 		s0_35_1__core_periphery__data_to_core,
input 	[107:0] 		s0_43_1__core_periphery__data_to_core,
input 	[107:0] 		s0_44_1__core_periphery__data_to_core,
input 	[107:0] 		s0_49_1__core_periphery__data_to_core,
input 	[107:0] 		s0_50_1__core_periphery__data_to_core,
input 	[107:0] 		s0_55_1__core_periphery__data_to_core,
input 	[107:0] 		s0_56_1__core_periphery__data_to_core,
input 	[107:0] 		s0_62_1__core_periphery__data_to_core,
input 	[107:0] 		s0_63_1__core_periphery__data_to_core,
input 	[107:0] 		s0_74_1__core_periphery__data_to_core,
input 	[107:0] 		s0_75_1__core_periphery__data_to_core,
input 	[107:0] 		s0_83_1__core_periphery__data_to_core,
input 	[107:0] 		s0_84_1__core_periphery__data_to_core,
input 	[107:0] 		s0_89_1__core_periphery__data_to_core,
input 	[107:0] 		s0_90_1__core_periphery__data_to_core,
input 	[107:0] 		s0_95_1__core_periphery__data_to_core,
input 	[107:0] 		s0_96_1__core_periphery__data_to_core,
input 	[107:0] 		s0_102_1__core_periphery__data_to_core,
input 	[107:0] 		s0_103_1__core_periphery__data_to_core,
input 	[107:0] 		s0_108_1__core_periphery__data_to_core,
input 	[107:0] 		s0_109_1__core_periphery__data_to_core,
input 	[107:0] 		s0_114_1__core_periphery__data_to_core,
input 	[107:0] 		s0_115_1__core_periphery__data_to_core,
input 	[107:0] 		s0_123_1__core_periphery__data_to_core,
input 	[107:0] 		s0_124_1__core_periphery__data_to_core,
input 	[107:0] 		s0_129_1__core_periphery__data_to_core,
input 	[107:0] 		s0_130_1__core_periphery__data_to_core,
input 	[107:0] 		s0_135_1__core_periphery__data_to_core,
input 	[107:0] 		s0_136_1__core_periphery__data_to_core,
input   [107:0]			s0_142_1__core_periphery__data_to_core,
input   [107:0]			s0_143_1__core_periphery__data_to_core,


output  [77:0] 	ch0_rx_data_out, 
output  [77:0] 	ch1_rx_data_out, 
output  [77:0] 	ch2_rx_data_out, 
output  [77:0] 	ch3_rx_data_out, 
output  [77:0] 	ch4_rx_data_out, 
output  [77:0] 	ch5_rx_data_out, 
output  [77:0] 	ch6_rx_data_out, 
output  [77:0] 	ch7_rx_data_out, 
output  [77:0] 	ch8_rx_data_out, 
output  [77:0] 	ch9_rx_data_out, 
output  [77:0] 	ch11_rx_data_out, 
output  [77:0] 	ch12_rx_data_out, 
output  [77:0] 	ch13_rx_data_out, 
output  [77:0] 	ch14_rx_data_out, 
output  [77:0] 	ch15_rx_data_out, 
output  [77:0] 	ch16_rx_data_out, 
output  [77:0] 	ch17_rx_data_out, 
output  [77:0] 	ch18_rx_data_out, 
output  [77:0] 	ch19_rx_data_out, 
output  [77:0] 	ch20_rx_data_out, 
output  [77:0] 	ch21_rx_data_out,



output o_int_sec_ch0,
output o_int_sec_ch1,
output o_int_sec_ch2,
output o_int_sec_ch3,
output o_int_sec_ch4,
output o_int_sec_ch5,
output o_int_sec_ch6,
output o_int_sec_ch7,
output o_int_sec_ch8,
output o_int_sec_ch9,
output o_int_sec_ch11,
output o_int_sec_ch12,
output o_int_sec_ch13,
output o_int_sec_ch14,
output o_int_sec_ch15,
output o_int_sec_ch16,
output o_int_sec_ch17,
output o_int_sec_ch18,
output o_int_sec_ch19,
output o_int_sec_ch20,
output o_int_sec_ch21,

output o_int_ded_ch0,
output o_int_ded_ch1,
output o_int_ded_ch2,
output o_int_ded_ch3,
output o_int_ded_ch4,
output o_int_ded_ch5,
output o_int_ded_ch6,
output o_int_ded_ch7,
output o_int_ded_ch8,
output o_int_ded_ch9,
output o_int_ded_ch11,
output o_int_ded_ch12,
output o_int_ded_ch13,
output o_int_ded_ch14,
output o_int_ded_ch15,
output o_int_ded_ch16,
output o_int_ded_ch17,
output o_int_ded_ch18,
output o_int_ded_ch19,
output o_int_ded_ch20,
output o_int_ded_ch21,

output [6:0] o_syndrome_ch0,
output [6:0] o_syndrome_ch1,
output [6:0] o_syndrome_ch2,
output [6:0] o_syndrome_ch3,
output [6:0] o_syndrome_ch4,
output [6:0] o_syndrome_ch5,
output [6:0] o_syndrome_ch6,
output [6:0] o_syndrome_ch7,
output [6:0] o_syndrome_ch8,
output [6:0] o_syndrome_ch9,
output [6:0] o_syndrome_ch11,
output [6:0] o_syndrome_ch12,
output [6:0] o_syndrome_ch13,
output [6:0] o_syndrome_ch14,
output [6:0] o_syndrome_ch15,
output [6:0] o_syndrome_ch16,
output [6:0] o_syndrome_ch17,
output [6:0] o_syndrome_ch18,
output [6:0] o_syndrome_ch19,
output [6:0] o_syndrome_ch20,
output [6:0] o_syndrome_ch21,

output o_rx_dsk_mon_err_status_port0,
output [2:0] o_rx_dsk_status_port0,
output o_rx_dsk_done_port0,
output o_rx_dsk_eval_done_port0,

output o_rx_dsk_mon_err_status_port1,
output [2:0] o_rx_dsk_status_port1,
output o_rx_dsk_done_port1,
output o_rx_dsk_eval_done_port1,

output o_rx_dsk_mon_err_status_port2,
output [2:0] o_rx_dsk_status_port2,
output o_rx_dsk_done_port2,
output o_rx_dsk_eval_done_port2,

output o_rx_dsk_mon_err_status_port3,
output [2:0] o_rx_dsk_status_port3,
output o_rx_dsk_done_port3,
output o_rx_dsk_eval_done_port3,


output [13:0] 	tx_dsk_marker_port0,
output [6:0] 	tx_dsk_marker_port1,
output [4:0] 	tx_dsk_marker_port2,
output [4:0] 	tx_dsk_marker_port3
);

wire  [77:0] 	ch0_rx_data_in; 
wire  [77:0] 	ch1_rx_data_in; 
wire  [77:0] 	ch2_rx_data_in; 
wire  [77:0] 	ch3_rx_data_in; 
wire  [77:0] 	ch4_rx_data_in; 
wire  [77:0] 	ch5_rx_data_in; 
wire  [77:0] 	ch6_rx_data_in; 
wire  [77:0] 	ch7_rx_data_in; 
wire  [77:0] 	ch8_rx_data_in; 
wire  [77:0] 	ch9_rx_data_in; 
wire  [77:0] 	ch10_rx_data_in; 
wire  [77:0] 	ch11_rx_data_in; 
wire  [77:0] 	ch12_rx_data_in; 
wire  [77:0] 	ch13_rx_data_in; 
wire  [77:0] 	ch14_rx_data_in; 
wire  [77:0] 	ch15_rx_data_in; 
wire  [77:0] 	ch16_rx_data_in; 
wire  [77:0] 	ch17_rx_data_in; 
wire  [77:0] 	ch18_rx_data_in; 
wire  [77:0] 	ch19_rx_data_in; 
wire  [77:0] 	ch20_rx_data_in; 
wire  [77:0] 	ch21_rx_data_in; 


wire  [77:0] 	ch0_rx_ecc_data_in; 
wire  [77:0] 	ch1_rx_ecc_data_in; 
wire  [77:0] 	ch2_rx_ecc_data_in; 
wire  [77:0] 	ch3_rx_ecc_data_in; 
wire  [77:0] 	ch4_rx_ecc_data_in; 
wire  [77:0] 	ch5_rx_ecc_data_in; 
wire  [77:0] 	ch6_rx_ecc_data_in; 
wire  [77:0] 	ch7_rx_ecc_data_in; 
wire  [77:0] 	ch8_rx_ecc_data_in; 
wire  [77:0] 	ch9_rx_ecc_data_in; 
wire  [77:0] 	ch10_rx_ecc_data_in; 
wire  [77:0] 	ch11_rx_ecc_data_in; 
wire  [77:0] 	ch12_rx_ecc_data_in; 
wire  [77:0] 	ch13_rx_ecc_data_in; 
wire  [77:0] 	ch14_rx_ecc_data_in; 
wire  [77:0] 	ch15_rx_ecc_data_in; 
wire  [77:0] 	ch16_rx_ecc_data_in; 
wire  [77:0] 	ch17_rx_ecc_data_in; 
wire  [77:0] 	ch18_rx_ecc_data_in; 
wire  [77:0] 	ch19_rx_ecc_data_in; 
wire  [77:0] 	ch20_rx_ecc_data_in; 
wire  [77:0] 	ch21_rx_ecc_data_in; 

wire  [69:0] 	ch0_rx_ecc_data_out; 
wire  [69:0] 	ch1_rx_ecc_data_out; 
wire  [69:0] 	ch2_rx_ecc_data_out; 
wire  [69:0] 	ch3_rx_ecc_data_out; 
wire  [69:0] 	ch4_rx_ecc_data_out; 
wire  [69:0] 	ch5_rx_ecc_data_out; 
wire  [69:0] 	ch6_rx_ecc_data_out; 
wire  [69:0] 	ch7_rx_ecc_data_out; 
wire  [69:0] 	ch8_rx_ecc_data_out; 
wire  [69:0] 	ch9_rx_ecc_data_out; 
wire  [69:0] 	ch11_rx_ecc_data_out; 
wire  [69:0] 	ch12_rx_ecc_data_out; 
wire  [69:0] 	ch13_rx_ecc_data_out; 
wire  [69:0] 	ch14_rx_ecc_data_out; 
wire  [69:0] 	ch15_rx_ecc_data_out; 
wire  [69:0] 	ch16_rx_ecc_data_out; 
wire  [69:0] 	ch17_rx_ecc_data_out; 
wire  [69:0] 	ch18_rx_ecc_data_out; 
wire  [69:0] 	ch19_rx_ecc_data_out; 
wire  [69:0] 	ch20_rx_ecc_data_out; 
wire  [69:0] 	ch21_rx_ecc_data_out;


wire	[77:0] 			ch0_rx_dsk_data_out; 
wire	[77:0] 			ch1_rx_dsk_data_out; 
wire	[77:0] 			ch2_rx_dsk_data_out; 
wire	[77:0] 			ch3_rx_dsk_data_out; 
wire	[77:0] 			ch4_rx_dsk_data_out; 
wire	[77:0] 			ch5_rx_dsk_data_out; 
wire	[77:0] 			ch6_rx_dsk_data_out; 
wire	[77:0] 			ch7_rx_dsk_data_out; 
wire	[77:0] 			ch8_rx_dsk_data_out; 
wire	[77:0] 			ch9_rx_dsk_data_out; 
wire	[77:0] 			ch11_rx_dsk_data_out; 
wire	[77:0] 			ch12_rx_dsk_data_out; 
wire	[77:0] 			ch13_rx_dsk_data_out; 
wire	[77:0] 			ch14_rx_dsk_data_out; 
wire	[77:0] 			ch15_rx_dsk_data_out; 
wire	[77:0] 			ch16_rx_dsk_data_out; 
wire	[77:0] 			ch17_rx_dsk_data_out; 
wire	[77:0] 			ch18_rx_dsk_data_out; 
wire	[77:0] 			ch19_rx_dsk_data_out; 
wire	[77:0] 			ch20_rx_dsk_data_out; 
wire	[77:0] 			ch21_rx_dsk_data_out;



reg  [77:0] 	ch0_rx_data_in_r; 
reg  [77:0] 	ch1_rx_data_in_r; 
reg  [77:0] 	ch2_rx_data_in_r; 
reg  [77:0] 	ch3_rx_data_in_r; 
reg  [77:0] 	ch4_rx_data_in_r; 
reg  [77:0] 	ch5_rx_data_in_r; 
reg  [77:0] 	ch6_rx_data_in_r; 
reg  [77:0] 	ch7_rx_data_in_r; 
reg  [77:0] 	ch8_rx_data_in_r; 
reg  [77:0] 	ch9_rx_data_in_r; 
reg  [77:0] 	ch10_rx_data_in_r; 
reg  [77:0] 	ch11_rx_data_in_r; 
reg  [77:0] 	ch12_rx_data_in_r; 
reg  [77:0] 	ch13_rx_data_in_r; 
reg  [77:0] 	ch14_rx_data_in_r; 
reg  [77:0] 	ch15_rx_data_in_r; 
reg  [77:0] 	ch16_rx_data_in_r; 
reg  [77:0] 	ch17_rx_data_in_r; 
reg  [77:0] 	ch18_rx_data_in_r; 
reg  [77:0] 	ch19_rx_data_in_r; 
reg  [77:0] 	ch20_rx_data_in_r; 
reg  [77:0] 	ch21_rx_data_in_r; 

logic p0_reset;
logic p1_reset;
logic p2_reset;
logic p3_reset;

assign p0_reset = i_rst_n[0];
assign p1_reset = i_rst_n[1];
assign p2_reset = i_rst_n[2];
assign p3_reset = i_rst_n[3];

integer i;

localparam deskew_enable = 1;
							
   generate if (DEVICE_WIDTH == "pcie_x16")	begin						


always @(posedge i_clk)
begin 
	if(p0_reset == 0)
	begin 
	

		ch2_rx_data_in_r <= 0;
		ch3_rx_data_in_r <= 0;
		ch4_rx_data_in_r <= 0;
		ch5_rx_data_in_r <= 0;
		ch6_rx_data_in_r <= 0;
		ch7_rx_data_in_r <= 0;
		ch8_rx_data_in_r <= 0;
		ch9_rx_data_in_r <= 0;
		ch11_rx_data_in_r <= 0;
		ch12_rx_data_in_r <= 0;
		ch13_rx_data_in_r <= 0;
		ch14_rx_data_in_r <= 0;
		ch15_rx_data_in_r <= 0;
		ch16_rx_data_in_r <= 0;
		ch17_rx_data_in_r <= 0;

	
	end 
	
	else 
	begin 

		ch2_rx_data_in_r <= ch2_rx_data_in;
		ch3_rx_data_in_r <= ch3_rx_data_in;
		ch4_rx_data_in_r <= ch4_rx_data_in;
		ch5_rx_data_in_r <= ch5_rx_data_in;
		ch6_rx_data_in_r <= ch6_rx_data_in;
		ch7_rx_data_in_r <= ch7_rx_data_in;
		ch8_rx_data_in_r <= ch8_rx_data_in;
		ch9_rx_data_in_r <= ch9_rx_data_in;
		ch11_rx_data_in_r <= ch11_rx_data_in;
		ch12_rx_data_in_r <= ch12_rx_data_in;
		ch13_rx_data_in_r <= ch13_rx_data_in;
		ch14_rx_data_in_r <= ch14_rx_data_in;
		ch15_rx_data_in_r <= ch15_rx_data_in;
		ch16_rx_data_in_r <= ch16_rx_data_in;
		ch17_rx_data_in_r <= ch17_rx_data_in;

	end 
end 







localparam AIB_WIDTH = 78;
localparam NUM_CHAN = 15; 
localparam ECC_OUT_WIDTH = 70;
genvar ww;

logic [NUM_CHAN * AIB_WIDTH-1:0] i_rx_ecc_data;
logic [NUM_CHAN * ECC_OUT_WIDTH-1:0] o_rx_ecc_data;
logic [NUM_CHAN-1:0] [AIB_WIDTH-1:0] data_in;
logic [NUM_CHAN-1:0] [ECC_OUT_WIDTH-1:0] data_out;
logic [NUM_CHAN-1:0] o_int_sec;
logic [NUM_CHAN-1:0] o_int_ded;
logic [NUM_CHAN-1:0] o_syndrome;

assign i_rx_ecc_data	 =  (	
							{{ch17_rx_ecc_data_in}, 
							{ch16_rx_ecc_data_in}, 
							{ch15_rx_ecc_data_in},
							{ch14_rx_ecc_data_in}, 
							{ch13_rx_ecc_data_in}, 
							{ch12_rx_ecc_data_in},
							{ch11_rx_ecc_data_in},  
							{ch9_rx_ecc_data_in}, 
							{ch8_rx_ecc_data_in},
							{ch7_rx_ecc_data_in},
							{ch6_rx_ecc_data_in}, 
							{ch5_rx_ecc_data_in},
							{ch4_rx_ecc_data_in}, 
							{ch3_rx_ecc_data_in}, 
							{ch2_rx_ecc_data_in} }   
						);


//ecc module instantaition
for(ww=0; ww<NUM_CHAN; ww++) begin:ecc_module_instantiation
				
		assign  data_in[ww] = i_rx_ecc_data[ww*AIB_WIDTH+:AIB_WIDTH]	;	
		
				wrlib_ecc_dec_c78_d70 inst_rx_ecc (

				   .o_int_sec 		(o_int_sec[ww]),
				   .o_int_ded		(o_int_ded[ww]),
				   .o_syndrome		(o_syndrome[ww]),
				   .i_code			(data_in[ww]),
				   .o_data			(data_out[ww])

				);
			
		assign o_rx_ecc_data[ww*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] = data_out[ww];
		
end:ecc_module_instantiation 



assign  ch2_rx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? {ch2_rx_data_in_r[77:70],70'd0} :	ch2_rx_data_in_r[77:0] ;						
assign  ch3_rx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? {ch3_rx_data_in_r[77:70],70'd0} : 	ch3_rx_data_in_r[77:0] ;	
assign  ch4_rx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? {ch4_rx_data_in_r[77:70],70'd0} : 	ch4_rx_data_in_r[77:0] ;	
assign  ch5_rx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? {ch5_rx_data_in_r[77:70],70'd0} : 	ch5_rx_data_in_r[77:0] ;
assign  ch6_rx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? {ch6_rx_data_in_r[77:70],70'd0} : 	ch6_rx_data_in_r[77:0] ;
assign  ch7_rx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? {ch7_rx_data_in_r[77:70],70'd0} : 	ch7_rx_data_in_r[77:0] ;	
assign  ch8_rx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? {ch8_rx_data_in_r[77:70],70'd0} : 	ch8_rx_data_in_r[77:0] ;
assign  ch9_rx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? {ch9_rx_data_in_r[77:70],70'd0} : 	ch9_rx_data_in_r[77:0] ;
assign  ch11_rx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? {ch11_rx_data_in_r[77:70],70'd0} : 	ch11_rx_data_in_r[77:0] ;	
assign  ch12_rx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? {ch12_rx_data_in_r[77:70],70'd0} :    ch12_rx_data_in_r[77:0] ;	
assign  ch13_rx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? {ch13_rx_data_in_r[77:70],70'd0} :    ch13_rx_data_in_r[77:0] ;
assign  ch14_rx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? {ch14_rx_data_in_r[77:70],70'd0} :    ch14_rx_data_in_r[77:0] ;
assign  ch15_rx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? {ch15_rx_data_in_r[77:70],70'd0} :    ch15_rx_data_in_r[77:0] ;
assign  ch16_rx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? {ch16_rx_data_in_r[77:70],70'd0} :    ch16_rx_data_in_r[77:0] ;	
assign  ch17_rx_ecc_data_in 	= (core16_enable_ecc_hwtcl ==1'b0) ? {ch17_rx_data_in_r[77:70],70'd0} :    ch17_rx_data_in_r[77:0] ; 



assign  ch2_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch2_rx_data_in_r[69:0]    :   o_rx_ecc_data[0*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //  ch2_rx_ecc0_data_out;						
assign  ch3_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch3_rx_data_in_r[69:0]    :   o_rx_ecc_data[1*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch3_rx_ecc0_data_out;	
assign  ch4_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch4_rx_data_in_r[69:0]    :   o_rx_ecc_data[2*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch4_rx_ecc0_data_out;	
assign  ch5_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch5_rx_data_in_r[69:0]    :   o_rx_ecc_data[3*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch5_rx_ecc0_data_out;
assign  ch6_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch6_rx_data_in_r[69:0]    :   o_rx_ecc_data[4*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch6_rx_ecc0_data_out;
assign  ch7_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch7_rx_data_in_r[69:0]    :   o_rx_ecc_data[5*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch7_rx_ecc0_data_out;	
assign  ch8_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch8_rx_data_in_r[69:0]    :   o_rx_ecc_data[6*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch8_rx_ecc0_data_out;
assign  ch9_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch9_rx_data_in_r[69:0]    :   o_rx_ecc_data[7*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch9_rx_ecc0_data_out;
assign  ch11_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch11_rx_data_in_r[69:0]   :   o_rx_ecc_data[8*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch11_rx_ecc0_data_out;	
assign  ch12_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ?    ch12_rx_data_in_r[69:0]   :   o_rx_ecc_data[9*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch12_rx_ecc0_data_out;	
assign  ch13_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ?    ch13_rx_data_in_r[69:0]   :   o_rx_ecc_data[10*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch13_rx_ecc0_data_out;
assign  ch14_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ?    ch14_rx_data_in_r[69:0]   :   o_rx_ecc_data[11*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch14_rx_ecc0_data_out;
assign  ch15_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ?    ch15_rx_data_in_r[69:0]   :   o_rx_ecc_data[12*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch15_rx_ecc0_data_out;
assign  ch16_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ?    ch16_rx_data_in_r[69:0]   :   o_rx_ecc_data[13*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch16_rx_ecc0_data_out;	
assign  ch17_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ?    ch17_rx_data_in_r[69:0]   :   o_rx_ecc_data[14*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch17_rx_ecc0_data_out; 




// mux to enable or disable ECC
/* assign  ch2_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch2_rx_ecc_data_in[69:0]    :   o_rx_ecc_data[0*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //  ch2_rx_ecc0_data_out;						
assign  ch3_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch3_rx_ecc_data_in[69:0]    :   o_rx_ecc_data[1*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch3_rx_ecc0_data_out;	
assign  ch4_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch4_rx_ecc_data_in[69:0]    :   o_rx_ecc_data[2*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch4_rx_ecc0_data_out;	
assign  ch5_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch5_rx_ecc_data_in[69:0]    :   o_rx_ecc_data[3*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch5_rx_ecc0_data_out;
assign  ch6_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch6_rx_ecc_data_in[69:0]    :   o_rx_ecc_data[4*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch6_rx_ecc0_data_out;
assign  ch7_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch7_rx_ecc_data_in[69:0]    :   o_rx_ecc_data[5*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch7_rx_ecc0_data_out;	
assign  ch8_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch8_rx_ecc_data_in[69:0]    :   o_rx_ecc_data[6*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch8_rx_ecc0_data_out;
assign  ch9_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch9_rx_ecc_data_in[69:0]    :   o_rx_ecc_data[7*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch9_rx_ecc0_data_out;
assign  ch11_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ? 	ch11_rx_ecc_data_in[69:0]   :   o_rx_ecc_data[8*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch11_rx_ecc0_data_out;	
assign  ch12_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ?    ch12_rx_ecc_data_in[69:0]   :   o_rx_ecc_data[9*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch12_rx_ecc0_data_out;	
assign  ch13_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ?    ch13_rx_ecc_data_in[69:0]   :   o_rx_ecc_data[10*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch13_rx_ecc0_data_out;
assign  ch14_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ?    ch14_rx_ecc_data_in[69:0]   :   o_rx_ecc_data[11*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch14_rx_ecc0_data_out;
assign  ch15_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ?    ch15_rx_ecc_data_in[69:0]   :   o_rx_ecc_data[12*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch15_rx_ecc0_data_out;
assign  ch16_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ?    ch16_rx_ecc_data_in[69:0]   :   o_rx_ecc_data[13*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch16_rx_ecc0_data_out;	
assign  ch17_rx_ecc_data_out 	= (core16_enable_ecc_hwtcl ==1'b0) ?    ch17_rx_ecc_data_in[69:0]   :   o_rx_ecc_data[14*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch17_rx_ecc0_data_out;
 */



//mux to enable/disable deskew module

assign ch2_rx_data_out  =  (deskew_enable ==1'b1) ?  ch2_rx_dsk_data_out : {ch2_rx_ecc_data_in[77:70], ch2_rx_ecc_data_out[69:0]};
assign ch3_rx_data_out  =  (deskew_enable ==1'b1) ?  ch3_rx_dsk_data_out : {ch3_rx_ecc_data_in[77:70], ch3_rx_ecc_data_out[69:0]};
assign ch4_rx_data_out  =  (deskew_enable ==1'b1) ?  ch4_rx_dsk_data_out : {ch4_rx_ecc_data_in[77:70], ch4_rx_ecc_data_out[69:0]};
assign ch5_rx_data_out  =  (deskew_enable ==1'b1) ?  ch5_rx_dsk_data_out : {ch5_rx_ecc_data_in[77:70], ch5_rx_ecc_data_out[69:0]};
assign ch6_rx_data_out  =  (deskew_enable ==1'b1) ?  ch6_rx_dsk_data_out : {ch6_rx_ecc_data_in[77:70], ch6_rx_ecc_data_out[69:0]};
assign ch7_rx_data_out  =  (deskew_enable ==1'b1) ?  ch7_rx_dsk_data_out : {ch7_rx_ecc_data_in[77:70], ch7_rx_ecc_data_out[69:0]};
assign ch8_rx_data_out  =  (deskew_enable ==1'b1) ?  ch8_rx_dsk_data_out : {ch8_rx_ecc_data_in[77:70], ch8_rx_ecc_data_out[69:0]};
assign ch9_rx_data_out  =  (deskew_enable ==1'b1) ?  ch9_rx_dsk_data_out : {ch9_rx_ecc_data_in[77:70], ch9_rx_ecc_data_out[69:0]};
assign ch11_rx_data_out  =  (deskew_enable ==1'b1) ?  ch11_rx_dsk_data_out : {ch11_rx_ecc_data_in[77:70], ch11_rx_ecc_data_out[69:0]};
assign ch12_rx_data_out  =  (deskew_enable ==1'b1) ?  ch12_rx_dsk_data_out : {ch12_rx_ecc_data_in[77:70], ch12_rx_ecc_data_out[69:0]};
assign ch13_rx_data_out  =  (deskew_enable ==1'b1) ?  ch13_rx_dsk_data_out : {ch13_rx_ecc_data_in[77:70], ch13_rx_ecc_data_out[69:0]};
assign ch14_rx_data_out  =  (deskew_enable ==1'b1) ?  ch14_rx_dsk_data_out : {ch14_rx_ecc_data_in[77:70], ch14_rx_ecc_data_out[69:0]};
assign ch15_rx_data_out  =  (deskew_enable ==1'b1) ?  ch15_rx_dsk_data_out : {ch15_rx_ecc_data_in[77:70], ch15_rx_ecc_data_out[69:0]};
assign ch16_rx_data_out  =  (deskew_enable ==1'b1) ?  ch16_rx_dsk_data_out : {ch16_rx_ecc_data_in[77:70], ch16_rx_ecc_data_out[69:0]};
assign ch17_rx_data_out  =  (deskew_enable ==1'b1) ?  ch17_rx_dsk_data_out : {ch17_rx_ecc_data_in[77:70], ch17_rx_ecc_data_out[69:0]};





`ifdef SIM_MODE     //Enable SIM_MODE and MAX_AIB_SKEW/RANDOM_AIB_SKEW to insert skew in the datapath

 
logic [NUM_CHAN-1:0][7:0] delay;
wire [77:0] ch2_rx_ecc_data_in_dly;
wire [77:0] ch3_rx_ecc_data_in_dly;
wire [77:0] ch4_rx_ecc_data_in_dly;
wire [77:0] ch5_rx_ecc_data_in_dly;
wire [77:0] ch6_rx_ecc_data_in_dly;
wire [77:0] ch7_rx_ecc_data_in_dly;
wire [77:0] ch8_rx_ecc_data_in_dly;
wire [77:0] ch9_rx_ecc_data_in_dly;
wire [77:0] ch11_rx_ecc_data_in_dly;
wire [77:0] ch12_rx_ecc_data_in_dly;
wire [77:0] ch13_rx_ecc_data_in_dly;
wire [77:0] ch14_rx_ecc_data_in_dly;
wire [77:0] ch15_rx_ecc_data_in_dly;
wire [77:0] ch16_rx_ecc_data_in_dly;
wire [77:0] ch17_rx_ecc_data_in_dly;

wire [77:0] ch2_rx_ecc_data_out_dly;
wire [77:0] ch3_rx_ecc_data_out_dly;
wire [77:0] ch4_rx_ecc_data_out_dly;
wire [77:0] ch5_rx_ecc_data_out_dly;
wire [77:0] ch6_rx_ecc_data_out_dly;
wire [77:0] ch7_rx_ecc_data_out_dly;
wire [77:0] ch8_rx_ecc_data_out_dly;
wire [77:0] ch9_rx_ecc_data_out_dly;
wire [77:0] ch11_rx_ecc_data_out_dly;
wire [77:0] ch12_rx_ecc_data_out_dly;
wire [77:0] ch13_rx_ecc_data_out_dly;
wire [77:0] ch14_rx_ecc_data_out_dly;
wire [77:0] ch15_rx_ecc_data_out_dly;
wire [77:0] ch16_rx_ecc_data_out_dly;
wire [77:0] ch17_rx_ecc_data_out_dly;

logic [NUM_CHAN*AIB_WIDTH-1:0] aib_data;
logic [NUM_CHAN*AIB_WIDTH-1:0] o_aib_data;
logic [NUM_CHAN-1:0] [AIB_WIDTH-1:0] data;
logic [NUM_CHAN-1:0] [AIB_WIDTH-1:0] q;



// Logic to generate SKEW. MAX_AIB_SKEW -- adds 5 skews in each channel. RANDOM_AIB_SKEW -- adds random skew ranging from 1,5 in each channel
always_comb begin : loop_for_number_of_aib_channels
		for(i = 0; i<NUM_CHAN; i=i+1) begin // loop for number of aib channels
		`ifdef MAX_AIB_SKEW
					  delay[i][7:0] = 5; // Whatever is max delay supported on rx path.
		`elsif RANDOM_AIB_SKEW
					  delay[i][7:0] = $urandom_range(1,5);
		`else 
					  delay[i][7:0] = 0;                                                                     
		`endif
		end
		end :loop_for_number_of_aib_channels
		
		



assign aib_data	 =  (	
							{//ch18_pld_rx_fabric_data_out[78:40],ch18_pld_rx_fabric_data_out[38:0], 
							{ch17_rx_ecc_data_in[77:70], ch17_rx_ecc_data_out[69:0]}, 
							{ch16_rx_ecc_data_in[77:70], ch16_rx_ecc_data_out[69:0]}, 
							{ch15_rx_ecc_data_in[77:70], ch15_rx_ecc_data_out[69:0]},
							{ch14_rx_ecc_data_in[77:70], ch14_rx_ecc_data_out[69:0]}, 
							{ch13_rx_ecc_data_in[77:70], ch13_rx_ecc_data_out[69:0]}, 
							{ch12_rx_ecc_data_in[77:70], ch12_rx_ecc_data_out[69:0]},
							{ch11_rx_ecc_data_in[77:70], ch11_rx_ecc_data_out[69:0]}, 
							//  ch10_pld_rx_fabric_data_out[78:40],ch10_pld_rx_fabric_data_out[38:0], 
							{ch9_rx_ecc_data_in[77:70], ch9_rx_ecc_data_out[69:0]}, 
							{ch8_rx_ecc_data_in[77:70], ch8_rx_ecc_data_out[69:0]},
							{ch7_rx_ecc_data_in[77:70], ch7_rx_ecc_data_out[69:0]},
							{ch6_rx_ecc_data_in[77:70], ch6_rx_ecc_data_out[69:0]}, 
							{ch5_rx_ecc_data_in[77:70], ch5_rx_ecc_data_out[69:0]},
							{ch4_rx_ecc_data_in[77:70], ch4_rx_ecc_data_out[69:0]}, 
							{ch3_rx_ecc_data_in[77:70], ch3_rx_ecc_data_out[69:0]}, 
							{ch2_rx_ecc_data_in[77:70], ch2_rx_ecc_data_out[69:0]}				}    
						);





//delay logic to add skew to the data path 
for(ww=0; ww<NUM_CHAN; ww++) begin:delay_module
				
		assign  data[ww] = aib_data[ww*AIB_WIDTH+:AIB_WIDTH]	;	
		
				hip_aib_adaptor
				# (
					.DWIDTH (78)
				) inst_hip_aib_adaptor (

				   .delay 		(delay[ww]),
				   .clk			(i_clk),
				   .rst_n		(p0_reset),
				   .d			(data[ww]),
				   .q			(q[ww])

				);
			
		assign o_aib_data[ww*AIB_WIDTH+:AIB_WIDTH] = q[ww];
		
end:delay_module
//endgenerate 



assign {	
		{//ch18_pld_rx_fabric_data_out[78:40],ch18_pld_rx_fabric_data_out[38:0], 
		{ch17_rx_ecc_data_out_dly[77:70], ch17_rx_ecc_data_out_dly[69:0]}, 
		{ch16_rx_ecc_data_out_dly[77:70], ch16_rx_ecc_data_out_dly[69:0]}, 
		{ch15_rx_ecc_data_out_dly[77:70], ch15_rx_ecc_data_out_dly[69:0]},
		{ch14_rx_ecc_data_out_dly[77:70], ch14_rx_ecc_data_out_dly[69:0]}, 
		{ch13_rx_ecc_data_out_dly[77:70], ch13_rx_ecc_data_out_dly[69:0]}, 
		{ch12_rx_ecc_data_out_dly[77:70], ch12_rx_ecc_data_out_dly[69:0]},
	    {ch11_rx_ecc_data_out_dly[77:70], ch11_rx_ecc_data_out_dly[69:0]}, 
		//  ch10_pld_rx_fabric_data_out[78:40],ch10_pld_rx_fabric_data_out[38:0], 
		{ch9_rx_ecc_data_out_dly[77:70], ch9_rx_ecc_data_out_dly[69:0]}, 
		{ch8_rx_ecc_data_out_dly[77:70], ch8_rx_ecc_data_out_dly[69:0]},
		{ch7_rx_ecc_data_out_dly[77:70], ch7_rx_ecc_data_out_dly[69:0]},
		{ch6_rx_ecc_data_out_dly[77:70], ch6_rx_ecc_data_out_dly[69:0]}, 
		{ch5_rx_ecc_data_out_dly[77:70], ch5_rx_ecc_data_out_dly[69:0]},
		{ch4_rx_ecc_data_out_dly[77:70], ch4_rx_ecc_data_out_dly[69:0]}, 
		{ch3_rx_ecc_data_out_dly[77:70], ch3_rx_ecc_data_out_dly[69:0]}, 
		{ch2_rx_ecc_data_out_dly[77:70], ch2_rx_ecc_data_out_dly[69:0]}	}    
		}																		=   o_aib_data;



		
		
		



			whr_rx_deskew 
			#(
				.DEVICE_WIDTH 							   (DEVICE_WIDTH							  ),
				.PCIE_IP_MODE                              (PCIE_IP_MODE_EPX16                        ),
				.NUM_CHAN                                  (15                            			  ),
				.AIB_WIDTH                                 (78                                        ),
				.DSK_WIDTH                                 (77                                        ),
				.DSK_MARKER_POS                            (69                                        ),
				.DSK_DATA_PAR_WIDTH                        (64                                        ),
				.PARITY_SEG_WIDTH                          (8                                         ),
				.DIS_MONITOR                               (0                                         )
			 ) u_wrpcie_deskew_0_15_port0 (.pld_clk(i_clk),
								.pld_rst_n(p0_reset),
								.cfg_force_dsk_done_i(1'b0),
								//.i_cfg_dsk_chan_sel(15'h7FFF),
								.cfg_k_device_width_i(2'b00),
								.cfg_dsk_clr_i(1'b0),
								.aib_data_i({//ch18_pld_rx_fabric_data_out[78:40],ch18_pld_rx_fabric_data_out[38:0], 
												{ch17_rx_ecc_data_out_dly[77:70], ch17_rx_ecc_data_out_dly[69:0]}, 
												{ch16_rx_ecc_data_out_dly[77:70], ch16_rx_ecc_data_out_dly[69:0]}, 
												{ch15_rx_ecc_data_out_dly[77:70], ch15_rx_ecc_data_out_dly[69:0]},
												{ch14_rx_ecc_data_out_dly[77:70], ch14_rx_ecc_data_out_dly[69:0]}, 
												{ch13_rx_ecc_data_out_dly[77:70], ch13_rx_ecc_data_out_dly[69:0]}, 
												{ch12_rx_ecc_data_out_dly[77:70], ch12_rx_ecc_data_out_dly[69:0]},
												{ch11_rx_ecc_data_out_dly[77:70], ch11_rx_ecc_data_out_dly[69:0]}, 
                                //  ch10_pld_rx_fabric_data_out[78:40],ch10_pld_rx_fabric_data_out[38:0], 
												{ch9_rx_ecc_data_out_dly[77:70], ch9_rx_ecc_data_out_dly[69:0]}, 
												{ch8_rx_ecc_data_out_dly[77:70], ch8_rx_ecc_data_out_dly[69:0]},
												{ch7_rx_ecc_data_out_dly[77:70], ch7_rx_ecc_data_out_dly[69:0]},
												{ch6_rx_ecc_data_out_dly[77:70], ch6_rx_ecc_data_out_dly[69:0]}, 
												{ch5_rx_ecc_data_out_dly[77:70], ch5_rx_ecc_data_out_dly[69:0]},
												{ch4_rx_ecc_data_out_dly[77:70], ch4_rx_ecc_data_out_dly[69:0]}, 
												{ch3_rx_ecc_data_out_dly[77:70], ch3_rx_ecc_data_out_dly[69:0]}, 
												{ch2_rx_ecc_data_out_dly[77:70], ch2_rx_ecc_data_out_dly[69:0]}				}),
								.aib_data_deskewed_o({//ch18_pld_rx_fabric_data_out[78:40],ch18_pld_rx_fabric_data_out[38:0], 
											{ch17_rx_dsk_data_out[77:70], ch17_rx_dsk_data_out[68:0]},
											{ch16_rx_dsk_data_out[77:70], ch16_rx_dsk_data_out[68:0]},
											{ch15_rx_dsk_data_out[77:70], ch15_rx_dsk_data_out[68:0]},
											{ch14_rx_dsk_data_out[77:70], ch14_rx_dsk_data_out[68:0]},
											{ch13_rx_dsk_data_out[77:70], ch13_rx_dsk_data_out[68:0]},
											{ch12_rx_dsk_data_out[77:70], ch12_rx_dsk_data_out[68:0]},
											{ch11_rx_dsk_data_out[77:70], ch11_rx_dsk_data_out[68:0]},
                                //  ch10_pld_rx_fabric_data_out[78:40],ch10_pld_rx_fabric_data_out[38:0], 
											{ch9_rx_dsk_data_out[77:70], ch9_rx_dsk_data_out[68:0]},
											{ch8_rx_dsk_data_out[77:70], ch8_rx_dsk_data_out[68:0]},
											{ch7_rx_dsk_data_out[77:70], ch7_rx_dsk_data_out[68:0]},
											{ch6_rx_dsk_data_out[77:70], ch6_rx_dsk_data_out[68:0]},
											{ch5_rx_dsk_data_out[77:70], ch5_rx_dsk_data_out[68:0]},
											{ch4_rx_dsk_data_out[77:70], ch4_rx_dsk_data_out[68:0]},
											{ch3_rx_dsk_data_out[77:70], ch3_rx_dsk_data_out[68:0]},
											{ch2_rx_dsk_data_out[77:70], ch2_rx_dsk_data_out[68:0]}			}),
								.cfg_dsk_active_chans_o(),
								.cfg_dsk_monitor_err_o(),
								.cfg_dsk_mon_err_status_o(),
								.fsr_dsk_mon_err_status_o(o_rx_dsk_mon_err_status_port0),
								.fsr_dsk_status_o(o_rx_dsk_status_port0),
								.fsr_dsk_vld_o(o_rx_dsk_done_port0),   //data is successfully deskewed
								.fsr_dsk_eval_done_o(o_rx_dsk_eval_done_port0));	

`else 








			whr_rx_deskew 
			#(
				.DEVICE_WIDTH 							   (DEVICE_WIDTH							  ),
				.PCIE_IP_MODE                              (PCIE_IP_MODE_EPX16                        ),
				.NUM_CHAN                                  (15                            			  ),
				.AIB_WIDTH                                 (78                                        ),
				.DSK_WIDTH                                 (77                                        ),
				.DSK_MARKER_POS                            (69                                        ),
				.DSK_DATA_PAR_WIDTH                        (64                                        ),
				.PARITY_SEG_WIDTH                          (8                                         ),
				.DIS_MONITOR                               (0                                         )
			 ) u_wrpcie_deskew_0_15_port0 (.pld_clk(i_clk),
								.pld_rst_n(p0_reset),
								.cfg_force_dsk_done_i(1'b0),
								//.i_cfg_dsk_chan_sel(15'h7FFF),
								.cfg_k_device_width_i(2'b00),
								.cfg_dsk_clr_i(1'b0),
								.aib_data_i({//ch18_pld_rx_fabric_data_out[78:40],ch18_pld_rx_fabric_data_out[38:0], 
												{ch17_rx_ecc_data_in[77:70], ch17_rx_ecc_data_out[69:0]}, 
												{ch16_rx_ecc_data_in[77:70], ch16_rx_ecc_data_out[69:0]}, 
												{ch15_rx_ecc_data_in[77:70], ch15_rx_ecc_data_out[69:0]},
												{ch14_rx_ecc_data_in[77:70], ch14_rx_ecc_data_out[69:0]}, 
												{ch13_rx_ecc_data_in[77:70], ch13_rx_ecc_data_out[69:0]}, 
												{ch12_rx_ecc_data_in[77:70], ch12_rx_ecc_data_out[69:0]},
												{ch11_rx_ecc_data_in[77:70], ch11_rx_ecc_data_out[69:0]}, 
                                //  ch10_pld_rx_fabric_data_out[78:40],ch10_pld_rx_fabric_data_out[38:0], 
												{ch9_rx_ecc_data_in[77:70], ch9_rx_ecc_data_out[69:0]}, 
												{ch8_rx_ecc_data_in[77:70], ch8_rx_ecc_data_out[69:0]},
												{ch7_rx_ecc_data_in[77:70], ch7_rx_ecc_data_out[69:0]},
												{ch6_rx_ecc_data_in[77:70], ch6_rx_ecc_data_out[69:0]}, 
												{ch5_rx_ecc_data_in[77:70], ch5_rx_ecc_data_out[69:0]},
												{ch4_rx_ecc_data_in[77:70], ch4_rx_ecc_data_out[69:0]}, 
												{ch3_rx_ecc_data_in[77:70], ch3_rx_ecc_data_out[69:0]}, 
												{ch2_rx_ecc_data_in[77:70], ch2_rx_ecc_data_out[69:0]}				}),
								.aib_data_deskewed_o({//ch18_pld_rx_fabric_data_out[78:40],ch18_pld_rx_fabric_data_out[38:0], 
											{ch17_rx_dsk_data_out[77:70], ch17_rx_dsk_data_out[68:0]},
											{ch16_rx_dsk_data_out[77:70], ch16_rx_dsk_data_out[68:0]},
											{ch15_rx_dsk_data_out[77:70], ch15_rx_dsk_data_out[68:0]},
											{ch14_rx_dsk_data_out[77:70], ch14_rx_dsk_data_out[68:0]},
											{ch13_rx_dsk_data_out[77:70], ch13_rx_dsk_data_out[68:0]},
											{ch12_rx_dsk_data_out[77:70], ch12_rx_dsk_data_out[68:0]},
											{ch11_rx_dsk_data_out[77:70], ch11_rx_dsk_data_out[68:0]},
                                //  ch10_pld_rx_fabric_data_out[78:40],ch10_pld_rx_fabric_data_out[38:0], 
											{ch9_rx_dsk_data_out[77:70], ch9_rx_dsk_data_out[68:0]},
											{ch8_rx_dsk_data_out[77:70], ch8_rx_dsk_data_out[68:0]},
											{ch7_rx_dsk_data_out[77:70], ch7_rx_dsk_data_out[68:0]},
											{ch6_rx_dsk_data_out[77:70], ch6_rx_dsk_data_out[68:0]},
											{ch5_rx_dsk_data_out[77:70], ch5_rx_dsk_data_out[68:0]},
											{ch4_rx_dsk_data_out[77:70], ch4_rx_dsk_data_out[68:0]},
											{ch3_rx_dsk_data_out[77:70], ch3_rx_dsk_data_out[68:0]},
											{ch2_rx_dsk_data_out[77:70], ch2_rx_dsk_data_out[68:0]}			}),
								.cfg_dsk_active_chans_o(),
								.cfg_dsk_monitor_err_o(),
								.cfg_dsk_mon_err_status_o(),
								.fsr_dsk_mon_err_status_o(o_rx_dsk_mon_err_status_port0),
								.fsr_dsk_status_o(o_rx_dsk_status_port0),
								.fsr_dsk_vld_o(o_rx_dsk_done_port0),
								.fsr_dsk_eval_done_o(o_rx_dsk_eval_done_port0));		


`endif // SIM_MODE
			




			assign ch2_rx_dsk_data_out[69]		= 1'b0;
			assign ch3_rx_dsk_data_out[69]		= 1'b0;
			assign ch4_rx_dsk_data_out[69]		= 1'b0;
			assign ch5_rx_dsk_data_out[69]		= 1'b0;
			assign ch6_rx_dsk_data_out[69]		= 1'b0;
			assign ch7_rx_dsk_data_out[69]		= 1'b0;
			assign ch8_rx_dsk_data_out[69]		= 1'b0;
			assign ch9_rx_dsk_data_out[69]		= 1'b0;
			assign ch11_rx_dsk_data_out[69]		= 1'b0;
			assign ch12_rx_dsk_data_out[69]		= 1'b0;
			assign ch13_rx_dsk_data_out[69]		= 1'b0;
			assign ch14_rx_dsk_data_out[69]		= 1'b0;
			assign ch15_rx_dsk_data_out[69]		= 1'b0;
			assign ch16_rx_dsk_data_out[69]		= 1'b0;
			assign ch17_rx_dsk_data_out[69]		= 1'b0;




		// Logic to generate Marker bit to be sent on the TX datapath	
			whr_tx_deskew  #(
				.NUM_CHAN     ( 14 	)
								) u_tx_deskew_0_15_port0 (
			.pld_clk         (i_clk                          				),
			.pld_rst_n       (p0_reset                            			),
		    .rx_dsk_marker_o (tx_dsk_marker_port0                           ));

			
			



							
							
			//assign ch2_rx_dsk_data_in[79] = s0_16_1__core_periphery__data_to_core[70];
			assign ch2_rx_data_in[77] = s0_16_1__core_periphery__data_to_core[100];
			assign ch2_rx_data_in[76] = s0_16_1__core_periphery__data_to_core[102];
			assign ch2_rx_data_in[75] = s0_16_1__core_periphery__data_to_core[72];
			assign ch2_rx_data_in[74] = s0_16_1__core_periphery__data_to_core[74];
			assign ch2_rx_data_in[73] = s0_16_1__core_periphery__data_to_core[75];
			assign ch2_rx_data_in[72] = s0_16_1__core_periphery__data_to_core[104];
			assign ch2_rx_data_in[71] = s0_16_1__core_periphery__data_to_core[105];
			assign ch2_rx_data_in[70] = s0_16_1__core_periphery__data_to_core[107];
			assign ch2_rx_data_in[69] = s0_16_1__core_periphery__data_to_core[77];
			assign ch2_rx_data_in[68] = s0_16_1__core_periphery__data_to_core[78];
			assign ch2_rx_data_in[67] = s0_16_1__core_periphery__data_to_core[79];
			assign ch2_rx_data_in[66] = s0_15_1__core_periphery__data_to_core[26];
			assign ch2_rx_data_in[65] = s0_15_1__core_periphery__data_to_core[24];
			assign ch2_rx_data_in[64] = s0_15_1__core_periphery__data_to_core[3];
			assign ch2_rx_data_in[63] = s0_15_1__core_periphery__data_to_core[2];
			assign ch2_rx_data_in[62] = s0_15_1__core_periphery__data_to_core[1];
			assign ch2_rx_data_in[61] = s0_15_1__core_periphery__data_to_core[31];
			assign ch2_rx_data_in[60] = s0_15_1__core_periphery__data_to_core[30];
			assign ch2_rx_data_in[59] = s0_15_1__core_periphery__data_to_core[28];
			assign ch2_rx_data_in[58] = s0_15_1__core_periphery__data_to_core[7];
			assign ch2_rx_data_in[57] = s0_15_1__core_periphery__data_to_core[5];
			assign ch2_rx_data_in[56] = s0_15_1__core_periphery__data_to_core[35];
			assign ch2_rx_data_in[55] = s0_15_1__core_periphery__data_to_core[33];
			assign ch2_rx_data_in[54] = s0_15_1__core_periphery__data_to_core[11];
			assign ch2_rx_data_in[53] = s0_15_1__core_periphery__data_to_core[10];
			assign ch2_rx_data_in[52] = s0_15_1__core_periphery__data_to_core[9];
			assign ch2_rx_data_in[51] = s0_15_1__core_periphery__data_to_core[8];
			assign ch2_rx_data_in[50] = s0_15_1__core_periphery__data_to_core[38];
			assign ch2_rx_data_in[49] = s0_15_1__core_periphery__data_to_core[36];
			assign ch2_rx_data_in[48] = s0_15_1__core_periphery__data_to_core[15];
			assign ch2_rx_data_in[47] = s0_15_1__core_periphery__data_to_core[14];
			assign ch2_rx_data_in[46] = s0_15_1__core_periphery__data_to_core[13];
			assign ch2_rx_data_in[45] = s0_15_1__core_periphery__data_to_core[43];
			assign ch2_rx_data_in[44] = s0_15_1__core_periphery__data_to_core[42];
			assign ch2_rx_data_in[43] = s0_15_1__core_periphery__data_to_core[40];
			assign ch2_rx_data_in[42] = s0_15_1__core_periphery__data_to_core[19];
			assign ch2_rx_data_in[41] = s0_15_1__core_periphery__data_to_core[17];
			assign ch2_rx_data_in[40] = s0_15_1__core_periphery__data_to_core[47];
			assign ch2_rx_data_in[39] = s0_15_1__core_periphery__data_to_core[45];
			//assign ch2_rx_data_in[39] = s0_15_1__core_periphery__data_to_core[23];
			assign ch2_rx_data_in[38] = s0_15_1__core_periphery__data_to_core[22];
			assign ch2_rx_data_in[37] = s0_15_1__core_periphery__data_to_core[20];
			assign ch2_rx_data_in[36] = s0_15_1__core_periphery__data_to_core[51];
			assign ch2_rx_data_in[35] = s0_15_1__core_periphery__data_to_core[49];
			assign ch2_rx_data_in[34] = s0_15_1__core_periphery__data_to_core[80];
			assign ch2_rx_data_in[33] = s0_15_1__core_periphery__data_to_core[82];
			assign ch2_rx_data_in[32] = s0_15_1__core_periphery__data_to_core[52];
			assign ch2_rx_data_in[31] = s0_15_1__core_periphery__data_to_core[54];
			assign ch2_rx_data_in[30] = s0_15_1__core_periphery__data_to_core[55];
			assign ch2_rx_data_in[29] = s0_15_1__core_periphery__data_to_core[84];
			assign ch2_rx_data_in[28] = s0_15_1__core_periphery__data_to_core[86];
			assign ch2_rx_data_in[27] = s0_15_1__core_periphery__data_to_core[87];
			assign ch2_rx_data_in[26] = s0_15_1__core_periphery__data_to_core[57];
			assign ch2_rx_data_in[25] = s0_15_1__core_periphery__data_to_core[58];
			assign ch2_rx_data_in[24] = s0_15_1__core_periphery__data_to_core[88];
			assign ch2_rx_data_in[23] = s0_15_1__core_periphery__data_to_core[90];
			assign ch2_rx_data_in[22] = s0_15_1__core_periphery__data_to_core[60];
			assign ch2_rx_data_in[21] = s0_15_1__core_periphery__data_to_core[62];
			assign ch2_rx_data_in[20] = s0_15_1__core_periphery__data_to_core[63];
			assign ch2_rx_data_in[19] = s0_15_1__core_periphery__data_to_core[92];
			assign ch2_rx_data_in[18] = s0_15_1__core_periphery__data_to_core[93];
			assign ch2_rx_data_in[17] = s0_15_1__core_periphery__data_to_core[95];
			assign ch2_rx_data_in[16] = s0_15_1__core_periphery__data_to_core[65];
			assign ch2_rx_data_in[15] = s0_15_1__core_periphery__data_to_core[66];
			assign ch2_rx_data_in[14] = s0_15_1__core_periphery__data_to_core[67];
			assign ch2_rx_data_in[13] = s0_15_1__core_periphery__data_to_core[96];
			assign ch2_rx_data_in[12] = s0_15_1__core_periphery__data_to_core[98];
			assign ch2_rx_data_in[11] = s0_15_1__core_periphery__data_to_core[99];
			assign ch2_rx_data_in[10] = s0_15_1__core_periphery__data_to_core[69];
			assign ch2_rx_data_in[9] = s0_15_1__core_periphery__data_to_core[70];
			assign ch2_rx_data_in[8] = s0_15_1__core_periphery__data_to_core[100];
			assign ch2_rx_data_in[7] = s0_15_1__core_periphery__data_to_core[102];
			assign ch2_rx_data_in[6] = s0_15_1__core_periphery__data_to_core[72];
			assign ch2_rx_data_in[5] = s0_15_1__core_periphery__data_to_core[74];
			assign ch2_rx_data_in[4] = s0_15_1__core_periphery__data_to_core[75];
			assign ch2_rx_data_in[3] = s0_15_1__core_periphery__data_to_core[104];
			assign ch2_rx_data_in[2] = s0_15_1__core_periphery__data_to_core[105];
			assign ch2_rx_data_in[1] = s0_15_1__core_periphery__data_to_core[107];
			assign ch2_rx_data_in[0] = s0_15_1__core_periphery__data_to_core[77];

			//channel 3

			//assign ch3_rx_data_in[79] = s0_23_1__core_periphery__data_to_core[70];
			assign ch3_rx_data_in[77] = s0_23_1__core_periphery__data_to_core[100];
			assign ch3_rx_data_in[76] = s0_23_1__core_periphery__data_to_core[102];
			assign ch3_rx_data_in[75] = s0_23_1__core_periphery__data_to_core[72];
			assign ch3_rx_data_in[74] = s0_23_1__core_periphery__data_to_core[74];
			assign ch3_rx_data_in[73] = s0_23_1__core_periphery__data_to_core[75];
			assign ch3_rx_data_in[72] = s0_23_1__core_periphery__data_to_core[104];
			assign ch3_rx_data_in[71] = s0_23_1__core_periphery__data_to_core[105];
			assign ch3_rx_data_in[70] = s0_23_1__core_periphery__data_to_core[107];
			assign ch3_rx_data_in[69] = s0_23_1__core_periphery__data_to_core[77];
			assign ch3_rx_data_in[68] = s0_23_1__core_periphery__data_to_core[78];
			assign ch3_rx_data_in[67] = s0_23_1__core_periphery__data_to_core[79];
			assign ch3_rx_data_in[66] = s0_22_1__core_periphery__data_to_core[26];
			assign ch3_rx_data_in[65] = s0_22_1__core_periphery__data_to_core[24];
			assign ch3_rx_data_in[64] = s0_22_1__core_periphery__data_to_core[3];
			assign ch3_rx_data_in[63] = s0_22_1__core_periphery__data_to_core[2];
			assign ch3_rx_data_in[62] = s0_22_1__core_periphery__data_to_core[1];
			assign ch3_rx_data_in[61] = s0_22_1__core_periphery__data_to_core[31];
			assign ch3_rx_data_in[60] = s0_22_1__core_periphery__data_to_core[30];
			assign ch3_rx_data_in[59] = s0_22_1__core_periphery__data_to_core[28];
			assign ch3_rx_data_in[58] = s0_22_1__core_periphery__data_to_core[7];
			assign ch3_rx_data_in[57] = s0_22_1__core_periphery__data_to_core[5];
			assign ch3_rx_data_in[56] = s0_22_1__core_periphery__data_to_core[35];
			assign ch3_rx_data_in[55] = s0_22_1__core_periphery__data_to_core[33];
			assign ch3_rx_data_in[54] = s0_22_1__core_periphery__data_to_core[11];
			assign ch3_rx_data_in[53] = s0_22_1__core_periphery__data_to_core[10];
			assign ch3_rx_data_in[52] = s0_22_1__core_periphery__data_to_core[9];
			assign ch3_rx_data_in[51] = s0_22_1__core_periphery__data_to_core[8];
			assign ch3_rx_data_in[50] = s0_22_1__core_periphery__data_to_core[38];
			assign ch3_rx_data_in[49] = s0_22_1__core_periphery__data_to_core[36];
			assign ch3_rx_data_in[48] = s0_22_1__core_periphery__data_to_core[15];
			assign ch3_rx_data_in[47] = s0_22_1__core_periphery__data_to_core[14];
			assign ch3_rx_data_in[46] = s0_22_1__core_periphery__data_to_core[13];
			assign ch3_rx_data_in[45] = s0_22_1__core_periphery__data_to_core[43];
			assign ch3_rx_data_in[44] = s0_22_1__core_periphery__data_to_core[42];
			assign ch3_rx_data_in[43] = s0_22_1__core_periphery__data_to_core[40];
			assign ch3_rx_data_in[42] = s0_22_1__core_periphery__data_to_core[19];
			assign ch3_rx_data_in[41] = s0_22_1__core_periphery__data_to_core[17];
			assign ch3_rx_data_in[40] = s0_22_1__core_periphery__data_to_core[47];
			assign ch3_rx_data_in[39] = s0_22_1__core_periphery__data_to_core[45];
			//assign ch3_rx_data_in[39] = s0_22_1__core_periphery__data_to_core[23];
			assign ch3_rx_data_in[38] = s0_22_1__core_periphery__data_to_core[22];
			assign ch3_rx_data_in[37] = s0_22_1__core_periphery__data_to_core[20];
			assign ch3_rx_data_in[36] = s0_22_1__core_periphery__data_to_core[51];
			assign ch3_rx_data_in[35] = s0_22_1__core_periphery__data_to_core[49];
			assign ch3_rx_data_in[34] = s0_22_1__core_periphery__data_to_core[80];
			assign ch3_rx_data_in[33] = s0_22_1__core_periphery__data_to_core[82];
			assign ch3_rx_data_in[32] = s0_22_1__core_periphery__data_to_core[52];
			assign ch3_rx_data_in[31] = s0_22_1__core_periphery__data_to_core[54];
			assign ch3_rx_data_in[30] = s0_22_1__core_periphery__data_to_core[55];
			assign ch3_rx_data_in[29] = s0_22_1__core_periphery__data_to_core[84];
			assign ch3_rx_data_in[28] = s0_22_1__core_periphery__data_to_core[86];
			assign ch3_rx_data_in[27] = s0_22_1__core_periphery__data_to_core[87];
			assign ch3_rx_data_in[26] = s0_22_1__core_periphery__data_to_core[57];
			assign ch3_rx_data_in[25] = s0_22_1__core_periphery__data_to_core[58];
			assign ch3_rx_data_in[24] = s0_22_1__core_periphery__data_to_core[88];
			assign ch3_rx_data_in[23] = s0_22_1__core_periphery__data_to_core[90];
			assign ch3_rx_data_in[22] = s0_22_1__core_periphery__data_to_core[60];
			assign ch3_rx_data_in[21] = s0_22_1__core_periphery__data_to_core[62];
			assign ch3_rx_data_in[20] = s0_22_1__core_periphery__data_to_core[63];
			assign ch3_rx_data_in[19] = s0_22_1__core_periphery__data_to_core[92];
			assign ch3_rx_data_in[18] = s0_22_1__core_periphery__data_to_core[93];
			assign ch3_rx_data_in[17] = s0_22_1__core_periphery__data_to_core[95];
			assign ch3_rx_data_in[16] = s0_22_1__core_periphery__data_to_core[65];
			assign ch3_rx_data_in[15] = s0_22_1__core_periphery__data_to_core[66];
			assign ch3_rx_data_in[14] = s0_22_1__core_periphery__data_to_core[67];
			assign ch3_rx_data_in[13] = s0_22_1__core_periphery__data_to_core[96];
			assign ch3_rx_data_in[12] = s0_22_1__core_periphery__data_to_core[98];
			assign ch3_rx_data_in[11] = s0_22_1__core_periphery__data_to_core[99];
			assign ch3_rx_data_in[10] = s0_22_1__core_periphery__data_to_core[69];
			assign ch3_rx_data_in[9] = s0_22_1__core_periphery__data_to_core[70];
			assign ch3_rx_data_in[8] = s0_22_1__core_periphery__data_to_core[100];
			assign ch3_rx_data_in[7] = s0_22_1__core_periphery__data_to_core[102];
			assign ch3_rx_data_in[6] = s0_22_1__core_periphery__data_to_core[72];
			assign ch3_rx_data_in[5] = s0_22_1__core_periphery__data_to_core[74];
			assign ch3_rx_data_in[4] = s0_22_1__core_periphery__data_to_core[75];
			assign ch3_rx_data_in[3] = s0_22_1__core_periphery__data_to_core[104];
			assign ch3_rx_data_in[2] = s0_22_1__core_periphery__data_to_core[105];
			assign ch3_rx_data_in[1] = s0_22_1__core_periphery__data_to_core[107];
			assign ch3_rx_data_in[0] = s0_22_1__core_periphery__data_to_core[77];

			//channel 4

			//assign ch4_rx_data_in[79] = s0_29_1__core_periphery__data_to_core[70];
			assign ch4_rx_data_in[77] = s0_29_1__core_periphery__data_to_core[100];
			assign ch4_rx_data_in[76] = s0_29_1__core_periphery__data_to_core[102];
			assign ch4_rx_data_in[75] = s0_29_1__core_periphery__data_to_core[72];
			assign ch4_rx_data_in[74] = s0_29_1__core_periphery__data_to_core[74];
			assign ch4_rx_data_in[73] = s0_29_1__core_periphery__data_to_core[75];
			assign ch4_rx_data_in[72] = s0_29_1__core_periphery__data_to_core[104];
			assign ch4_rx_data_in[71] = s0_29_1__core_periphery__data_to_core[105];
			assign ch4_rx_data_in[70] = s0_29_1__core_periphery__data_to_core[107];
			assign ch4_rx_data_in[69] = s0_29_1__core_periphery__data_to_core[77];
			assign ch4_rx_data_in[68] = s0_29_1__core_periphery__data_to_core[78];
			assign ch4_rx_data_in[67] = s0_29_1__core_periphery__data_to_core[79];
			assign ch4_rx_data_in[66] = s0_28_1__core_periphery__data_to_core[26];
			assign ch4_rx_data_in[65] = s0_28_1__core_periphery__data_to_core[24];
			assign ch4_rx_data_in[64] = s0_28_1__core_periphery__data_to_core[3];
			assign ch4_rx_data_in[63] = s0_28_1__core_periphery__data_to_core[2];
			assign ch4_rx_data_in[62] = s0_28_1__core_periphery__data_to_core[1];
			assign ch4_rx_data_in[61] = s0_28_1__core_periphery__data_to_core[31];
			assign ch4_rx_data_in[60] = s0_28_1__core_periphery__data_to_core[30];
			assign ch4_rx_data_in[59] = s0_28_1__core_periphery__data_to_core[28];
			assign ch4_rx_data_in[58] = s0_28_1__core_periphery__data_to_core[7];
			assign ch4_rx_data_in[57] = s0_28_1__core_periphery__data_to_core[5];
			assign ch4_rx_data_in[56] = s0_28_1__core_periphery__data_to_core[35];
			assign ch4_rx_data_in[55] = s0_28_1__core_periphery__data_to_core[33];
			assign ch4_rx_data_in[54] = s0_28_1__core_periphery__data_to_core[11];
			assign ch4_rx_data_in[53] = s0_28_1__core_periphery__data_to_core[10];
			assign ch4_rx_data_in[52] = s0_28_1__core_periphery__data_to_core[9];
			assign ch4_rx_data_in[51] = s0_28_1__core_periphery__data_to_core[8];
			assign ch4_rx_data_in[50] = s0_28_1__core_periphery__data_to_core[38];
			assign ch4_rx_data_in[49] = s0_28_1__core_periphery__data_to_core[36];
			assign ch4_rx_data_in[48] = s0_28_1__core_periphery__data_to_core[15];
			assign ch4_rx_data_in[47] = s0_28_1__core_periphery__data_to_core[14];
			assign ch4_rx_data_in[46] = s0_28_1__core_periphery__data_to_core[13];
			assign ch4_rx_data_in[45] = s0_28_1__core_periphery__data_to_core[43];
			assign ch4_rx_data_in[44] = s0_28_1__core_periphery__data_to_core[42];
			assign ch4_rx_data_in[43] = s0_28_1__core_periphery__data_to_core[40];
			assign ch4_rx_data_in[42] = s0_28_1__core_periphery__data_to_core[19];
			assign ch4_rx_data_in[41] = s0_28_1__core_periphery__data_to_core[17];
			assign ch4_rx_data_in[40] = s0_28_1__core_periphery__data_to_core[47];
			assign ch4_rx_data_in[39] = s0_28_1__core_periphery__data_to_core[45];
			//assign ch4_rx_data_in[39] = s0_28_1__core_periphery__data_to_core[23];
			assign ch4_rx_data_in[38] = s0_28_1__core_periphery__data_to_core[22];
			assign ch4_rx_data_in[37] = s0_28_1__core_periphery__data_to_core[20];
			assign ch4_rx_data_in[36] = s0_28_1__core_periphery__data_to_core[51];
			assign ch4_rx_data_in[35] = s0_28_1__core_periphery__data_to_core[49];
			assign ch4_rx_data_in[34] = s0_28_1__core_periphery__data_to_core[80];
			assign ch4_rx_data_in[33] = s0_28_1__core_periphery__data_to_core[82];
			assign ch4_rx_data_in[32] = s0_28_1__core_periphery__data_to_core[52];
			assign ch4_rx_data_in[31] = s0_28_1__core_periphery__data_to_core[54];
			assign ch4_rx_data_in[30] = s0_28_1__core_periphery__data_to_core[55];
			assign ch4_rx_data_in[29] = s0_28_1__core_periphery__data_to_core[84];
			assign ch4_rx_data_in[28] = s0_28_1__core_periphery__data_to_core[86];
			assign ch4_rx_data_in[27] = s0_28_1__core_periphery__data_to_core[87];
			assign ch4_rx_data_in[26] = s0_28_1__core_periphery__data_to_core[57];
			assign ch4_rx_data_in[25] = s0_28_1__core_periphery__data_to_core[58];
			assign ch4_rx_data_in[24] = s0_28_1__core_periphery__data_to_core[88];
			assign ch4_rx_data_in[23] = s0_28_1__core_periphery__data_to_core[90];
			assign ch4_rx_data_in[22] = s0_28_1__core_periphery__data_to_core[60];
			assign ch4_rx_data_in[21] = s0_28_1__core_periphery__data_to_core[62];
			assign ch4_rx_data_in[20] = s0_28_1__core_periphery__data_to_core[63];
			assign ch4_rx_data_in[19] = s0_28_1__core_periphery__data_to_core[92];
			assign ch4_rx_data_in[18] = s0_28_1__core_periphery__data_to_core[93];
			assign ch4_rx_data_in[17] = s0_28_1__core_periphery__data_to_core[95];
			assign ch4_rx_data_in[16] = s0_28_1__core_periphery__data_to_core[65];
			assign ch4_rx_data_in[15] = s0_28_1__core_periphery__data_to_core[66];
			assign ch4_rx_data_in[14] = s0_28_1__core_periphery__data_to_core[67];
			assign ch4_rx_data_in[13] = s0_28_1__core_periphery__data_to_core[96];
			assign ch4_rx_data_in[12] = s0_28_1__core_periphery__data_to_core[98];
			assign ch4_rx_data_in[11] = s0_28_1__core_periphery__data_to_core[99];
			assign ch4_rx_data_in[10] = s0_28_1__core_periphery__data_to_core[69];
			assign ch4_rx_data_in[9] = s0_28_1__core_periphery__data_to_core[70];
			assign ch4_rx_data_in[8] = s0_28_1__core_periphery__data_to_core[100];
			assign ch4_rx_data_in[7] = s0_28_1__core_periphery__data_to_core[102];
			assign ch4_rx_data_in[6] = s0_28_1__core_periphery__data_to_core[72];
			assign ch4_rx_data_in[5] = s0_28_1__core_periphery__data_to_core[74];
			assign ch4_rx_data_in[4] = s0_28_1__core_periphery__data_to_core[75];
			assign ch4_rx_data_in[3] = s0_28_1__core_periphery__data_to_core[104];
			assign ch4_rx_data_in[2] = s0_28_1__core_periphery__data_to_core[105];
			assign ch4_rx_data_in[1] = s0_28_1__core_periphery__data_to_core[107];
			assign ch4_rx_data_in[0] = s0_28_1__core_periphery__data_to_core[77];

			//channel 5

			//assign ch5_rx_data_in[79] = s0_35_1__core_periphery__data_to_core[70];
			assign ch5_rx_data_in[77] = s0_35_1__core_periphery__data_to_core[100];
			assign ch5_rx_data_in[76] = s0_35_1__core_periphery__data_to_core[102];
			assign ch5_rx_data_in[75] = s0_35_1__core_periphery__data_to_core[72];
			assign ch5_rx_data_in[74] = s0_35_1__core_periphery__data_to_core[74];
			assign ch5_rx_data_in[73] = s0_35_1__core_periphery__data_to_core[75];
			assign ch5_rx_data_in[72] = s0_35_1__core_periphery__data_to_core[104];
			assign ch5_rx_data_in[71] = s0_35_1__core_periphery__data_to_core[105];
			assign ch5_rx_data_in[70] = s0_35_1__core_periphery__data_to_core[107];
			assign ch5_rx_data_in[69] = s0_35_1__core_periphery__data_to_core[77];
			assign ch5_rx_data_in[68] = s0_35_1__core_periphery__data_to_core[78];
			assign ch5_rx_data_in[67] = s0_35_1__core_periphery__data_to_core[79];
			assign ch5_rx_data_in[66] = s0_34_1__core_periphery__data_to_core[26];
			assign ch5_rx_data_in[65] = s0_34_1__core_periphery__data_to_core[24];
			assign ch5_rx_data_in[64] = s0_34_1__core_periphery__data_to_core[3];
			assign ch5_rx_data_in[63] = s0_34_1__core_periphery__data_to_core[2];
			assign ch5_rx_data_in[62] = s0_34_1__core_periphery__data_to_core[1];
			assign ch5_rx_data_in[61] = s0_34_1__core_periphery__data_to_core[31];
			assign ch5_rx_data_in[60] = s0_34_1__core_periphery__data_to_core[30];
			assign ch5_rx_data_in[59] = s0_34_1__core_periphery__data_to_core[28];
			assign ch5_rx_data_in[58] = s0_34_1__core_periphery__data_to_core[7];
			assign ch5_rx_data_in[57] = s0_34_1__core_periphery__data_to_core[5];
			assign ch5_rx_data_in[56] = s0_34_1__core_periphery__data_to_core[35];
			assign ch5_rx_data_in[55] = s0_34_1__core_periphery__data_to_core[33];
			assign ch5_rx_data_in[54] = s0_34_1__core_periphery__data_to_core[11];
			assign ch5_rx_data_in[53] = s0_34_1__core_periphery__data_to_core[10];
			assign ch5_rx_data_in[52] = s0_34_1__core_periphery__data_to_core[9];
			assign ch5_rx_data_in[51] = s0_34_1__core_periphery__data_to_core[8];
			assign ch5_rx_data_in[50] = s0_34_1__core_periphery__data_to_core[38];
			assign ch5_rx_data_in[49] = s0_34_1__core_periphery__data_to_core[36];
			assign ch5_rx_data_in[48] = s0_34_1__core_periphery__data_to_core[15];
			assign ch5_rx_data_in[47] = s0_34_1__core_periphery__data_to_core[14];
			assign ch5_rx_data_in[46] = s0_34_1__core_periphery__data_to_core[13];
			assign ch5_rx_data_in[45] = s0_34_1__core_periphery__data_to_core[43];
			assign ch5_rx_data_in[44] = s0_34_1__core_periphery__data_to_core[42];
			assign ch5_rx_data_in[43] = s0_34_1__core_periphery__data_to_core[40];
			assign ch5_rx_data_in[42] = s0_34_1__core_periphery__data_to_core[19];
			assign ch5_rx_data_in[41] = s0_34_1__core_periphery__data_to_core[17];
			assign ch5_rx_data_in[40] = s0_34_1__core_periphery__data_to_core[47];
			assign ch5_rx_data_in[39] = s0_34_1__core_periphery__data_to_core[45];
			//assign ch5_rx_data_in[39] = s0_34_1__core_periphery__data_to_core[23];
			assign ch5_rx_data_in[38] = s0_34_1__core_periphery__data_to_core[22];
			assign ch5_rx_data_in[37] = s0_34_1__core_periphery__data_to_core[20];
			assign ch5_rx_data_in[36] = s0_34_1__core_periphery__data_to_core[51];
			assign ch5_rx_data_in[35] = s0_34_1__core_periphery__data_to_core[49];
			assign ch5_rx_data_in[34] = s0_34_1__core_periphery__data_to_core[80];
			assign ch5_rx_data_in[33] = s0_34_1__core_periphery__data_to_core[82];
			assign ch5_rx_data_in[32] = s0_34_1__core_periphery__data_to_core[52];
			assign ch5_rx_data_in[31] = s0_34_1__core_periphery__data_to_core[54];
			assign ch5_rx_data_in[30] = s0_34_1__core_periphery__data_to_core[55];
			assign ch5_rx_data_in[29] = s0_34_1__core_periphery__data_to_core[84];
			assign ch5_rx_data_in[28] = s0_34_1__core_periphery__data_to_core[86];
			assign ch5_rx_data_in[27] = s0_34_1__core_periphery__data_to_core[87];
			assign ch5_rx_data_in[26] = s0_34_1__core_periphery__data_to_core[57];
			assign ch5_rx_data_in[25] = s0_34_1__core_periphery__data_to_core[58];
			assign ch5_rx_data_in[24] = s0_34_1__core_periphery__data_to_core[88];
			assign ch5_rx_data_in[23] = s0_34_1__core_periphery__data_to_core[90];
			assign ch5_rx_data_in[22] = s0_34_1__core_periphery__data_to_core[60];
			assign ch5_rx_data_in[21] = s0_34_1__core_periphery__data_to_core[62];
			assign ch5_rx_data_in[20] = s0_34_1__core_periphery__data_to_core[63];
			assign ch5_rx_data_in[19] = s0_34_1__core_periphery__data_to_core[92];
			assign ch5_rx_data_in[18] = s0_34_1__core_periphery__data_to_core[93];
			assign ch5_rx_data_in[17] = s0_34_1__core_periphery__data_to_core[95];
			assign ch5_rx_data_in[16] = s0_34_1__core_periphery__data_to_core[65];
			assign ch5_rx_data_in[15] = s0_34_1__core_periphery__data_to_core[66];
			assign ch5_rx_data_in[14] = s0_34_1__core_periphery__data_to_core[67];
			assign ch5_rx_data_in[13] = s0_34_1__core_periphery__data_to_core[96];
			assign ch5_rx_data_in[12] = s0_34_1__core_periphery__data_to_core[98];
			assign ch5_rx_data_in[11] = s0_34_1__core_periphery__data_to_core[99];
			assign ch5_rx_data_in[10] = s0_34_1__core_periphery__data_to_core[69];
			assign ch5_rx_data_in[9] = s0_34_1__core_periphery__data_to_core[70];
			assign ch5_rx_data_in[8] = s0_34_1__core_periphery__data_to_core[100];
			assign ch5_rx_data_in[7] = s0_34_1__core_periphery__data_to_core[102];
			assign ch5_rx_data_in[6] = s0_34_1__core_periphery__data_to_core[72];
			assign ch5_rx_data_in[5] = s0_34_1__core_periphery__data_to_core[74];
			assign ch5_rx_data_in[4] = s0_34_1__core_periphery__data_to_core[75];
			assign ch5_rx_data_in[3] = s0_34_1__core_periphery__data_to_core[104];
			assign ch5_rx_data_in[2] = s0_34_1__core_periphery__data_to_core[105];
			assign ch5_rx_data_in[1] = s0_34_1__core_periphery__data_to_core[107];
			assign ch5_rx_data_in[0] = s0_34_1__core_periphery__data_to_core[77];


			//channel 6

			//assign ch6_rx_data_in[79] = s0_44_1__core_periphery__data_to_core[70];
			assign ch6_rx_data_in[77] = s0_44_1__core_periphery__data_to_core[100];
			assign ch6_rx_data_in[76] = s0_44_1__core_periphery__data_to_core[102];
			assign ch6_rx_data_in[75] = s0_44_1__core_periphery__data_to_core[72];
			assign ch6_rx_data_in[74] = s0_44_1__core_periphery__data_to_core[74];
			assign ch6_rx_data_in[73] = s0_44_1__core_periphery__data_to_core[75];
			assign ch6_rx_data_in[72] = s0_44_1__core_periphery__data_to_core[104];
			assign ch6_rx_data_in[71] = s0_44_1__core_periphery__data_to_core[105];
			assign ch6_rx_data_in[70] = s0_44_1__core_periphery__data_to_core[107];
			assign ch6_rx_data_in[69] = s0_44_1__core_periphery__data_to_core[77];
			assign ch6_rx_data_in[68] = s0_44_1__core_periphery__data_to_core[78];
			assign ch6_rx_data_in[67] = s0_44_1__core_periphery__data_to_core[79];
			assign ch6_rx_data_in[66] = s0_43_1__core_periphery__data_to_core[26];
			assign ch6_rx_data_in[65] = s0_43_1__core_periphery__data_to_core[24];
			assign ch6_rx_data_in[64] = s0_43_1__core_periphery__data_to_core[3];
			assign ch6_rx_data_in[63] = s0_43_1__core_periphery__data_to_core[2];
			assign ch6_rx_data_in[62] = s0_43_1__core_periphery__data_to_core[1];
			assign ch6_rx_data_in[61] = s0_43_1__core_periphery__data_to_core[31];
			assign ch6_rx_data_in[60] = s0_43_1__core_periphery__data_to_core[30];
			assign ch6_rx_data_in[59] = s0_43_1__core_periphery__data_to_core[28];
			assign ch6_rx_data_in[58] = s0_43_1__core_periphery__data_to_core[7];
			assign ch6_rx_data_in[57] = s0_43_1__core_periphery__data_to_core[5];
			assign ch6_rx_data_in[56] = s0_43_1__core_periphery__data_to_core[35];
			assign ch6_rx_data_in[55] = s0_43_1__core_periphery__data_to_core[33];
			assign ch6_rx_data_in[54] = s0_43_1__core_periphery__data_to_core[11];
			assign ch6_rx_data_in[53] = s0_43_1__core_periphery__data_to_core[10];
			assign ch6_rx_data_in[52] = s0_43_1__core_periphery__data_to_core[9];
			assign ch6_rx_data_in[51] = s0_43_1__core_periphery__data_to_core[8];
			assign ch6_rx_data_in[50] = s0_43_1__core_periphery__data_to_core[38];
			assign ch6_rx_data_in[49] = s0_43_1__core_periphery__data_to_core[36];
			assign ch6_rx_data_in[48] = s0_43_1__core_periphery__data_to_core[15];
			assign ch6_rx_data_in[47] = s0_43_1__core_periphery__data_to_core[14];
			assign ch6_rx_data_in[46] = s0_43_1__core_periphery__data_to_core[13];
			assign ch6_rx_data_in[45] = s0_43_1__core_periphery__data_to_core[43];
			assign ch6_rx_data_in[44] = s0_43_1__core_periphery__data_to_core[42];
			assign ch6_rx_data_in[43] = s0_43_1__core_periphery__data_to_core[40];
			assign ch6_rx_data_in[42] = s0_43_1__core_periphery__data_to_core[19];
			assign ch6_rx_data_in[41] = s0_43_1__core_periphery__data_to_core[17];
			assign ch6_rx_data_in[40] = s0_43_1__core_periphery__data_to_core[47];
			assign ch6_rx_data_in[39] = s0_43_1__core_periphery__data_to_core[45];
			//assign ch6_rx_data_in[39] = s0_43_1__core_periphery__data_to_core[23];
			assign ch6_rx_data_in[38] = s0_43_1__core_periphery__data_to_core[22];
			assign ch6_rx_data_in[37] = s0_43_1__core_periphery__data_to_core[20];
			assign ch6_rx_data_in[36] = s0_43_1__core_periphery__data_to_core[51];
			assign ch6_rx_data_in[35] = s0_43_1__core_periphery__data_to_core[49];
			assign ch6_rx_data_in[34] = s0_43_1__core_periphery__data_to_core[80];
			assign ch6_rx_data_in[33] = s0_43_1__core_periphery__data_to_core[82];
			assign ch6_rx_data_in[32] = s0_43_1__core_periphery__data_to_core[52];
			assign ch6_rx_data_in[31] = s0_43_1__core_periphery__data_to_core[54];
			assign ch6_rx_data_in[30] = s0_43_1__core_periphery__data_to_core[55];
			assign ch6_rx_data_in[29] = s0_43_1__core_periphery__data_to_core[84];
			assign ch6_rx_data_in[28] = s0_43_1__core_periphery__data_to_core[86];
			assign ch6_rx_data_in[27] = s0_43_1__core_periphery__data_to_core[87];
			assign ch6_rx_data_in[26] = s0_43_1__core_periphery__data_to_core[57];
			assign ch6_rx_data_in[25] = s0_43_1__core_periphery__data_to_core[58];
			assign ch6_rx_data_in[24] = s0_43_1__core_periphery__data_to_core[88];
			assign ch6_rx_data_in[23] = s0_43_1__core_periphery__data_to_core[90];
			assign ch6_rx_data_in[22] = s0_43_1__core_periphery__data_to_core[60];
			assign ch6_rx_data_in[21] = s0_43_1__core_periphery__data_to_core[62];
			assign ch6_rx_data_in[20] = s0_43_1__core_periphery__data_to_core[63];
			assign ch6_rx_data_in[19] = s0_43_1__core_periphery__data_to_core[92];
			assign ch6_rx_data_in[18] = s0_43_1__core_periphery__data_to_core[93];
			assign ch6_rx_data_in[17] = s0_43_1__core_periphery__data_to_core[95];
			assign ch6_rx_data_in[16] = s0_43_1__core_periphery__data_to_core[65];
			assign ch6_rx_data_in[15] = s0_43_1__core_periphery__data_to_core[66];
			assign ch6_rx_data_in[14] = s0_43_1__core_periphery__data_to_core[67];
			assign ch6_rx_data_in[13] = s0_43_1__core_periphery__data_to_core[96];
			assign ch6_rx_data_in[12] = s0_43_1__core_periphery__data_to_core[98];
			assign ch6_rx_data_in[11] = s0_43_1__core_periphery__data_to_core[99];
			assign ch6_rx_data_in[10] = s0_43_1__core_periphery__data_to_core[69];
			assign ch6_rx_data_in[9] = s0_43_1__core_periphery__data_to_core[70];
			assign ch6_rx_data_in[8] = s0_43_1__core_periphery__data_to_core[100];
			assign ch6_rx_data_in[7] = s0_43_1__core_periphery__data_to_core[102];
			assign ch6_rx_data_in[6] = s0_43_1__core_periphery__data_to_core[72];
			assign ch6_rx_data_in[5] = s0_43_1__core_periphery__data_to_core[74];
			assign ch6_rx_data_in[4] = s0_43_1__core_periphery__data_to_core[75];
			assign ch6_rx_data_in[3] = s0_43_1__core_periphery__data_to_core[104];
			assign ch6_rx_data_in[2] = s0_43_1__core_periphery__data_to_core[105];
			assign ch6_rx_data_in[1] = s0_43_1__core_periphery__data_to_core[107];
			assign ch6_rx_data_in[0] = s0_43_1__core_periphery__data_to_core[77];


			//channel 7

			//assign ch7_rx_data_in[79] = s0_50_1__core_periphery__data_to_core[70];
			assign ch7_rx_data_in[77] = s0_50_1__core_periphery__data_to_core[100];
			assign ch7_rx_data_in[76] = s0_50_1__core_periphery__data_to_core[102];
			assign ch7_rx_data_in[75] = s0_50_1__core_periphery__data_to_core[72];
			assign ch7_rx_data_in[74] = s0_50_1__core_periphery__data_to_core[74];
			assign ch7_rx_data_in[73] = s0_50_1__core_periphery__data_to_core[75];
			assign ch7_rx_data_in[72] = s0_50_1__core_periphery__data_to_core[104];
			assign ch7_rx_data_in[71] = s0_50_1__core_periphery__data_to_core[105];
			assign ch7_rx_data_in[70] = s0_50_1__core_periphery__data_to_core[107];
			assign ch7_rx_data_in[69] = s0_50_1__core_periphery__data_to_core[77];
			assign ch7_rx_data_in[68] = s0_50_1__core_periphery__data_to_core[78];
			assign ch7_rx_data_in[67] = s0_50_1__core_periphery__data_to_core[79];
			assign ch7_rx_data_in[66] = s0_49_1__core_periphery__data_to_core[26];
			assign ch7_rx_data_in[65] = s0_49_1__core_periphery__data_to_core[24];
			assign ch7_rx_data_in[64] = s0_49_1__core_periphery__data_to_core[3];
			assign ch7_rx_data_in[63] = s0_49_1__core_periphery__data_to_core[2];
			assign ch7_rx_data_in[62] = s0_49_1__core_periphery__data_to_core[1];
			assign ch7_rx_data_in[61] = s0_49_1__core_periphery__data_to_core[31];
			assign ch7_rx_data_in[60] = s0_49_1__core_periphery__data_to_core[30];
			assign ch7_rx_data_in[59] = s0_49_1__core_periphery__data_to_core[28];
			assign ch7_rx_data_in[58] = s0_49_1__core_periphery__data_to_core[7];
			assign ch7_rx_data_in[57] = s0_49_1__core_periphery__data_to_core[5];
			assign ch7_rx_data_in[56] = s0_49_1__core_periphery__data_to_core[35];
			assign ch7_rx_data_in[55] = s0_49_1__core_periphery__data_to_core[33];
			assign ch7_rx_data_in[54] = s0_49_1__core_periphery__data_to_core[11];
			assign ch7_rx_data_in[53] = s0_49_1__core_periphery__data_to_core[10];
			assign ch7_rx_data_in[52] = s0_49_1__core_periphery__data_to_core[9];
			assign ch7_rx_data_in[51] = s0_49_1__core_periphery__data_to_core[8];
			assign ch7_rx_data_in[50] = s0_49_1__core_periphery__data_to_core[38];
			assign ch7_rx_data_in[49] = s0_49_1__core_periphery__data_to_core[36];
			assign ch7_rx_data_in[48] = s0_49_1__core_periphery__data_to_core[15];
			assign ch7_rx_data_in[47] = s0_49_1__core_periphery__data_to_core[14];
			assign ch7_rx_data_in[46] = s0_49_1__core_periphery__data_to_core[13];
			assign ch7_rx_data_in[45] = s0_49_1__core_periphery__data_to_core[43];
			assign ch7_rx_data_in[44] = s0_49_1__core_periphery__data_to_core[42];
			assign ch7_rx_data_in[43] = s0_49_1__core_periphery__data_to_core[40];
			assign ch7_rx_data_in[42] = s0_49_1__core_periphery__data_to_core[19];
			assign ch7_rx_data_in[41] = s0_49_1__core_periphery__data_to_core[17];
			assign ch7_rx_data_in[40] = s0_49_1__core_periphery__data_to_core[47];
			assign ch7_rx_data_in[39] = s0_49_1__core_periphery__data_to_core[45];
			//assign ch7_rx_data_in[39] = s0_49_1__core_periphery__data_to_core[23];
			assign ch7_rx_data_in[38] = s0_49_1__core_periphery__data_to_core[22];
			assign ch7_rx_data_in[37] = s0_49_1__core_periphery__data_to_core[20];
			assign ch7_rx_data_in[36] = s0_49_1__core_periphery__data_to_core[51];
			assign ch7_rx_data_in[35] = s0_49_1__core_periphery__data_to_core[49];
			assign ch7_rx_data_in[34] = s0_49_1__core_periphery__data_to_core[80];
			assign ch7_rx_data_in[33] = s0_49_1__core_periphery__data_to_core[82];
			assign ch7_rx_data_in[32] = s0_49_1__core_periphery__data_to_core[52];
			assign ch7_rx_data_in[31] = s0_49_1__core_periphery__data_to_core[54];
			assign ch7_rx_data_in[30] = s0_49_1__core_periphery__data_to_core[55];
			assign ch7_rx_data_in[29] = s0_49_1__core_periphery__data_to_core[84];
			assign ch7_rx_data_in[28] = s0_49_1__core_periphery__data_to_core[86];
			assign ch7_rx_data_in[27] = s0_49_1__core_periphery__data_to_core[87];
			assign ch7_rx_data_in[26] = s0_49_1__core_periphery__data_to_core[57];
			assign ch7_rx_data_in[25] = s0_49_1__core_periphery__data_to_core[58];
			assign ch7_rx_data_in[24] = s0_49_1__core_periphery__data_to_core[88];
			assign ch7_rx_data_in[23] = s0_49_1__core_periphery__data_to_core[90];
			assign ch7_rx_data_in[22] = s0_49_1__core_periphery__data_to_core[60];
			assign ch7_rx_data_in[21] = s0_49_1__core_periphery__data_to_core[62];
			assign ch7_rx_data_in[20] = s0_49_1__core_periphery__data_to_core[63];
			assign ch7_rx_data_in[19] = s0_49_1__core_periphery__data_to_core[92];
			assign ch7_rx_data_in[18] = s0_49_1__core_periphery__data_to_core[93];
			assign ch7_rx_data_in[17] = s0_49_1__core_periphery__data_to_core[95];
			assign ch7_rx_data_in[16] = s0_49_1__core_periphery__data_to_core[65];
			assign ch7_rx_data_in[15] = s0_49_1__core_periphery__data_to_core[66];
			assign ch7_rx_data_in[14] = s0_49_1__core_periphery__data_to_core[67];
			assign ch7_rx_data_in[13] = s0_49_1__core_periphery__data_to_core[96];
			assign ch7_rx_data_in[12] = s0_49_1__core_periphery__data_to_core[98];
			assign ch7_rx_data_in[11] = s0_49_1__core_periphery__data_to_core[99];
			assign ch7_rx_data_in[10] = s0_49_1__core_periphery__data_to_core[69];
			assign ch7_rx_data_in[9] = s0_49_1__core_periphery__data_to_core[70];
			assign ch7_rx_data_in[8] = s0_49_1__core_periphery__data_to_core[100];
			assign ch7_rx_data_in[7] = s0_49_1__core_periphery__data_to_core[102];
			assign ch7_rx_data_in[6] = s0_49_1__core_periphery__data_to_core[72];
			assign ch7_rx_data_in[5] = s0_49_1__core_periphery__data_to_core[74];
			assign ch7_rx_data_in[4] = s0_49_1__core_periphery__data_to_core[75];
			assign ch7_rx_data_in[3] = s0_49_1__core_periphery__data_to_core[104];
			assign ch7_rx_data_in[2] = s0_49_1__core_periphery__data_to_core[105];
			assign ch7_rx_data_in[1] = s0_49_1__core_periphery__data_to_core[107];
			assign ch7_rx_data_in[0] = s0_49_1__core_periphery__data_to_core[77];

			//channel 8

			//assign ch8_rx_data_in[79] = s0_56_1__core_periphery__data_to_core[70];
			assign ch8_rx_data_in[77] = s0_56_1__core_periphery__data_to_core[100];
			assign ch8_rx_data_in[76] = s0_56_1__core_periphery__data_to_core[102];
			assign ch8_rx_data_in[75] = s0_56_1__core_periphery__data_to_core[72];
			assign ch8_rx_data_in[74] = s0_56_1__core_periphery__data_to_core[74];
			assign ch8_rx_data_in[73] = s0_56_1__core_periphery__data_to_core[75];
			assign ch8_rx_data_in[72] = s0_56_1__core_periphery__data_to_core[104];
			assign ch8_rx_data_in[71] = s0_56_1__core_periphery__data_to_core[105];
			assign ch8_rx_data_in[70] = s0_56_1__core_periphery__data_to_core[107];
			assign ch8_rx_data_in[69] = s0_56_1__core_periphery__data_to_core[77];
			assign ch8_rx_data_in[68] = s0_56_1__core_periphery__data_to_core[78];
			assign ch8_rx_data_in[67] = s0_56_1__core_periphery__data_to_core[79];
			assign ch8_rx_data_in[66] = s0_55_1__core_periphery__data_to_core[26];
			assign ch8_rx_data_in[65] = s0_55_1__core_periphery__data_to_core[24];
			assign ch8_rx_data_in[64] = s0_55_1__core_periphery__data_to_core[3];
			assign ch8_rx_data_in[63] = s0_55_1__core_periphery__data_to_core[2];
			assign ch8_rx_data_in[62] = s0_55_1__core_periphery__data_to_core[1];
			assign ch8_rx_data_in[61] = s0_55_1__core_periphery__data_to_core[31];
			assign ch8_rx_data_in[60] = s0_55_1__core_periphery__data_to_core[30];
			assign ch8_rx_data_in[59] = s0_55_1__core_periphery__data_to_core[28];
			assign ch8_rx_data_in[58] = s0_55_1__core_periphery__data_to_core[7];
			assign ch8_rx_data_in[57] = s0_55_1__core_periphery__data_to_core[5];
			assign ch8_rx_data_in[56] = s0_55_1__core_periphery__data_to_core[35];
			assign ch8_rx_data_in[55] = s0_55_1__core_periphery__data_to_core[33];
			assign ch8_rx_data_in[54] = s0_55_1__core_periphery__data_to_core[11];
			assign ch8_rx_data_in[53] = s0_55_1__core_periphery__data_to_core[10];
			assign ch8_rx_data_in[52] = s0_55_1__core_periphery__data_to_core[9];
			assign ch8_rx_data_in[51] = s0_55_1__core_periphery__data_to_core[8];
			assign ch8_rx_data_in[50] = s0_55_1__core_periphery__data_to_core[38];
			assign ch8_rx_data_in[49] = s0_55_1__core_periphery__data_to_core[36];
			assign ch8_rx_data_in[48] = s0_55_1__core_periphery__data_to_core[15];
			assign ch8_rx_data_in[47] = s0_55_1__core_periphery__data_to_core[14];
			assign ch8_rx_data_in[46] = s0_55_1__core_periphery__data_to_core[13];
			assign ch8_rx_data_in[45] = s0_55_1__core_periphery__data_to_core[43];
			assign ch8_rx_data_in[44] = s0_55_1__core_periphery__data_to_core[42];
			assign ch8_rx_data_in[43] = s0_55_1__core_periphery__data_to_core[40];
			assign ch8_rx_data_in[42] = s0_55_1__core_periphery__data_to_core[19];
			assign ch8_rx_data_in[41] = s0_55_1__core_periphery__data_to_core[17];
			assign ch8_rx_data_in[40] = s0_55_1__core_periphery__data_to_core[47];
			assign ch8_rx_data_in[39] = s0_55_1__core_periphery__data_to_core[45];
			//assign ch8_rx_data_in[39] = s0_55_1__core_periphery__data_to_core[23];
			assign ch8_rx_data_in[38] = s0_55_1__core_periphery__data_to_core[22];
			assign ch8_rx_data_in[37] = s0_55_1__core_periphery__data_to_core[20];
			assign ch8_rx_data_in[36] = s0_55_1__core_periphery__data_to_core[51];
			assign ch8_rx_data_in[35] = s0_55_1__core_periphery__data_to_core[49];
			assign ch8_rx_data_in[34] = s0_55_1__core_periphery__data_to_core[80];
			assign ch8_rx_data_in[33] = s0_55_1__core_periphery__data_to_core[82];
			assign ch8_rx_data_in[32] = s0_55_1__core_periphery__data_to_core[52];
			assign ch8_rx_data_in[31] = s0_55_1__core_periphery__data_to_core[54];
			assign ch8_rx_data_in[30] = s0_55_1__core_periphery__data_to_core[55];
			assign ch8_rx_data_in[29] = s0_55_1__core_periphery__data_to_core[84];
			assign ch8_rx_data_in[28] = s0_55_1__core_periphery__data_to_core[86];
			assign ch8_rx_data_in[27] = s0_55_1__core_periphery__data_to_core[87];
			assign ch8_rx_data_in[26] = s0_55_1__core_periphery__data_to_core[57];
			assign ch8_rx_data_in[25] = s0_55_1__core_periphery__data_to_core[58];
			assign ch8_rx_data_in[24] = s0_55_1__core_periphery__data_to_core[88];
			assign ch8_rx_data_in[23] = s0_55_1__core_periphery__data_to_core[90];
			assign ch8_rx_data_in[22] = s0_55_1__core_periphery__data_to_core[60];
			assign ch8_rx_data_in[21] = s0_55_1__core_periphery__data_to_core[62];
			assign ch8_rx_data_in[20] = s0_55_1__core_periphery__data_to_core[63];
			assign ch8_rx_data_in[19] = s0_55_1__core_periphery__data_to_core[92];
			assign ch8_rx_data_in[18] = s0_55_1__core_periphery__data_to_core[93];
			assign ch8_rx_data_in[17] = s0_55_1__core_periphery__data_to_core[95];
			assign ch8_rx_data_in[16] = s0_55_1__core_periphery__data_to_core[65];
			assign ch8_rx_data_in[15] = s0_55_1__core_periphery__data_to_core[66];
			assign ch8_rx_data_in[14] = s0_55_1__core_periphery__data_to_core[67];
			assign ch8_rx_data_in[13] = s0_55_1__core_periphery__data_to_core[96];
			assign ch8_rx_data_in[12] = s0_55_1__core_periphery__data_to_core[98];
			assign ch8_rx_data_in[11] = s0_55_1__core_periphery__data_to_core[99];
			assign ch8_rx_data_in[10] = s0_55_1__core_periphery__data_to_core[69];
			assign ch8_rx_data_in[9] = s0_55_1__core_periphery__data_to_core[70];
			assign ch8_rx_data_in[8] = s0_55_1__core_periphery__data_to_core[100];
			assign ch8_rx_data_in[7] = s0_55_1__core_periphery__data_to_core[102];
			assign ch8_rx_data_in[6] = s0_55_1__core_periphery__data_to_core[72];
			assign ch8_rx_data_in[5] = s0_55_1__core_periphery__data_to_core[74];
			assign ch8_rx_data_in[4] = s0_55_1__core_periphery__data_to_core[75];
			assign ch8_rx_data_in[3] = s0_55_1__core_periphery__data_to_core[104];
			assign ch8_rx_data_in[2] = s0_55_1__core_periphery__data_to_core[105];
			assign ch8_rx_data_in[1] = s0_55_1__core_periphery__data_to_core[107];
			assign ch8_rx_data_in[0] = s0_55_1__core_periphery__data_to_core[77];


			//channel 9

			//assign ch9_rx_data_in[79] = s0_63_1__core_periphery__data_to_core[70];
			assign ch9_rx_data_in[77] = s0_63_1__core_periphery__data_to_core[100];
			assign ch9_rx_data_in[76] = s0_63_1__core_periphery__data_to_core[102];
			assign ch9_rx_data_in[75] = s0_63_1__core_periphery__data_to_core[72];
			assign ch9_rx_data_in[74] = s0_63_1__core_periphery__data_to_core[74];
			assign ch9_rx_data_in[73] = s0_63_1__core_periphery__data_to_core[75];
			assign ch9_rx_data_in[72] = s0_63_1__core_periphery__data_to_core[104];
			assign ch9_rx_data_in[71] = s0_63_1__core_periphery__data_to_core[105];
			assign ch9_rx_data_in[70] = s0_63_1__core_periphery__data_to_core[107];
			assign ch9_rx_data_in[69] = s0_63_1__core_periphery__data_to_core[77];
			assign ch9_rx_data_in[68] = s0_63_1__core_periphery__data_to_core[78];
			assign ch9_rx_data_in[67] = s0_63_1__core_periphery__data_to_core[79];
			assign ch9_rx_data_in[66] = s0_62_1__core_periphery__data_to_core[26];
			assign ch9_rx_data_in[65] = s0_62_1__core_periphery__data_to_core[24];
			assign ch9_rx_data_in[64] = s0_62_1__core_periphery__data_to_core[3];
			assign ch9_rx_data_in[63] = s0_62_1__core_periphery__data_to_core[2];
			assign ch9_rx_data_in[62] = s0_62_1__core_periphery__data_to_core[1];
			assign ch9_rx_data_in[61] = s0_62_1__core_periphery__data_to_core[31];
			assign ch9_rx_data_in[60] = s0_62_1__core_periphery__data_to_core[30];
			assign ch9_rx_data_in[59] = s0_62_1__core_periphery__data_to_core[28];
			assign ch9_rx_data_in[58] = s0_62_1__core_periphery__data_to_core[7];
			assign ch9_rx_data_in[57] = s0_62_1__core_periphery__data_to_core[5];
			assign ch9_rx_data_in[56] = s0_62_1__core_periphery__data_to_core[35];
			assign ch9_rx_data_in[55] = s0_62_1__core_periphery__data_to_core[33];
			assign ch9_rx_data_in[54] = s0_62_1__core_periphery__data_to_core[11];
			assign ch9_rx_data_in[53] = s0_62_1__core_periphery__data_to_core[10];
			assign ch9_rx_data_in[52] = s0_62_1__core_periphery__data_to_core[9];
			assign ch9_rx_data_in[51] = s0_62_1__core_periphery__data_to_core[8];
			assign ch9_rx_data_in[50] = s0_62_1__core_periphery__data_to_core[38];
			assign ch9_rx_data_in[49] = s0_62_1__core_periphery__data_to_core[36];
			assign ch9_rx_data_in[48] = s0_62_1__core_periphery__data_to_core[15];
			assign ch9_rx_data_in[47] = s0_62_1__core_periphery__data_to_core[14];
			assign ch9_rx_data_in[46] = s0_62_1__core_periphery__data_to_core[13];
			assign ch9_rx_data_in[45] = s0_62_1__core_periphery__data_to_core[43];
			assign ch9_rx_data_in[44] = s0_62_1__core_periphery__data_to_core[42];
			assign ch9_rx_data_in[43] = s0_62_1__core_periphery__data_to_core[40];
			assign ch9_rx_data_in[42] = s0_62_1__core_periphery__data_to_core[19];
			assign ch9_rx_data_in[41] = s0_62_1__core_periphery__data_to_core[17];
			assign ch9_rx_data_in[40] = s0_62_1__core_periphery__data_to_core[47];
			assign ch9_rx_data_in[39] = s0_62_1__core_periphery__data_to_core[45];
			//assign ch9_rx_data_in[39] = s0_62_1__core_periphery__data_to_core[23];
			assign ch9_rx_data_in[38] = s0_62_1__core_periphery__data_to_core[22];
			assign ch9_rx_data_in[37] = s0_62_1__core_periphery__data_to_core[20];
			assign ch9_rx_data_in[36] = s0_62_1__core_periphery__data_to_core[51];
			assign ch9_rx_data_in[35] = s0_62_1__core_periphery__data_to_core[49];
			assign ch9_rx_data_in[34] = s0_62_1__core_periphery__data_to_core[80];
			assign ch9_rx_data_in[33] = s0_62_1__core_periphery__data_to_core[82];
			assign ch9_rx_data_in[32] = s0_62_1__core_periphery__data_to_core[52];
			assign ch9_rx_data_in[31] = s0_62_1__core_periphery__data_to_core[54];
			assign ch9_rx_data_in[30] = s0_62_1__core_periphery__data_to_core[55];
			assign ch9_rx_data_in[29] = s0_62_1__core_periphery__data_to_core[84];
			assign ch9_rx_data_in[28] = s0_62_1__core_periphery__data_to_core[86];
			assign ch9_rx_data_in[27] = s0_62_1__core_periphery__data_to_core[87];
			assign ch9_rx_data_in[26] = s0_62_1__core_periphery__data_to_core[57];
			assign ch9_rx_data_in[25] = s0_62_1__core_periphery__data_to_core[58];
			assign ch9_rx_data_in[24] = s0_62_1__core_periphery__data_to_core[88];
			assign ch9_rx_data_in[23] = s0_62_1__core_periphery__data_to_core[90];
			assign ch9_rx_data_in[22] = s0_62_1__core_periphery__data_to_core[60];
			assign ch9_rx_data_in[21] = s0_62_1__core_periphery__data_to_core[62];
			assign ch9_rx_data_in[20] = s0_62_1__core_periphery__data_to_core[63];
			assign ch9_rx_data_in[19] = s0_62_1__core_periphery__data_to_core[92];
			assign ch9_rx_data_in[18] = s0_62_1__core_periphery__data_to_core[93];
			assign ch9_rx_data_in[17] = s0_62_1__core_periphery__data_to_core[95];
			assign ch9_rx_data_in[16] = s0_62_1__core_periphery__data_to_core[65];
			assign ch9_rx_data_in[15] = s0_62_1__core_periphery__data_to_core[66];
			assign ch9_rx_data_in[14] = s0_62_1__core_periphery__data_to_core[67];
			assign ch9_rx_data_in[13] = s0_62_1__core_periphery__data_to_core[96];
			assign ch9_rx_data_in[12] = s0_62_1__core_periphery__data_to_core[98];
			assign ch9_rx_data_in[11] = s0_62_1__core_periphery__data_to_core[99];
			assign ch9_rx_data_in[10] = s0_62_1__core_periphery__data_to_core[69];
			assign ch9_rx_data_in[9] = s0_62_1__core_periphery__data_to_core[70];
			assign ch9_rx_data_in[8] = s0_62_1__core_periphery__data_to_core[100];
			assign ch9_rx_data_in[7] = s0_62_1__core_periphery__data_to_core[102];
			assign ch9_rx_data_in[6] = s0_62_1__core_periphery__data_to_core[72];
			assign ch9_rx_data_in[5] = s0_62_1__core_periphery__data_to_core[74];
			assign ch9_rx_data_in[4] = s0_62_1__core_periphery__data_to_core[75];
			assign ch9_rx_data_in[3] = s0_62_1__core_periphery__data_to_core[104];
			assign ch9_rx_data_in[2] = s0_62_1__core_periphery__data_to_core[105];
			assign ch9_rx_data_in[1] = s0_62_1__core_periphery__data_to_core[107];
			assign ch9_rx_data_in[0] = s0_62_1__core_periphery__data_to_core[77];


			//assign ch11_rx_data_in[79] = s0_75_1__core_periphery__data_to_core[70];
			assign ch11_rx_data_in[77] = s0_75_1__core_periphery__data_to_core[100];
			assign ch11_rx_data_in[76] = s0_75_1__core_periphery__data_to_core[102];
			assign ch11_rx_data_in[75] = s0_75_1__core_periphery__data_to_core[72];
			assign ch11_rx_data_in[74] = s0_75_1__core_periphery__data_to_core[74];
			assign ch11_rx_data_in[73] = s0_75_1__core_periphery__data_to_core[75];
			assign ch11_rx_data_in[72] = s0_75_1__core_periphery__data_to_core[104];
			assign ch11_rx_data_in[71] = s0_75_1__core_periphery__data_to_core[105];
			assign ch11_rx_data_in[70] = s0_75_1__core_periphery__data_to_core[107];
			assign ch11_rx_data_in[69] = s0_75_1__core_periphery__data_to_core[77];
			assign ch11_rx_data_in[68] = s0_75_1__core_periphery__data_to_core[78];
			assign ch11_rx_data_in[67] = s0_75_1__core_periphery__data_to_core[79];
			assign ch11_rx_data_in[66] = s0_74_1__core_periphery__data_to_core[26];
			assign ch11_rx_data_in[65] = s0_74_1__core_periphery__data_to_core[24];
			assign ch11_rx_data_in[64] = s0_74_1__core_periphery__data_to_core[3];
			assign ch11_rx_data_in[63] = s0_74_1__core_periphery__data_to_core[2];
			assign ch11_rx_data_in[62] = s0_74_1__core_periphery__data_to_core[1];
			assign ch11_rx_data_in[61] = s0_74_1__core_periphery__data_to_core[31];
			assign ch11_rx_data_in[60] = s0_74_1__core_periphery__data_to_core[30];
			assign ch11_rx_data_in[59] = s0_74_1__core_periphery__data_to_core[28];
			assign ch11_rx_data_in[58] = s0_74_1__core_periphery__data_to_core[7];
			assign ch11_rx_data_in[57] = s0_74_1__core_periphery__data_to_core[5];
			assign ch11_rx_data_in[56] = s0_74_1__core_periphery__data_to_core[35];
			assign ch11_rx_data_in[55] = s0_74_1__core_periphery__data_to_core[33];
			assign ch11_rx_data_in[54] = s0_74_1__core_periphery__data_to_core[11];
			assign ch11_rx_data_in[53] = s0_74_1__core_periphery__data_to_core[10];
			assign ch11_rx_data_in[52] = s0_74_1__core_periphery__data_to_core[9];
			assign ch11_rx_data_in[51] = s0_74_1__core_periphery__data_to_core[8];
			assign ch11_rx_data_in[50] = s0_74_1__core_periphery__data_to_core[38];
			assign ch11_rx_data_in[49] = s0_74_1__core_periphery__data_to_core[36];
			assign ch11_rx_data_in[48] = s0_74_1__core_periphery__data_to_core[15];
			assign ch11_rx_data_in[47] = s0_74_1__core_periphery__data_to_core[14];
			assign ch11_rx_data_in[46] = s0_74_1__core_periphery__data_to_core[13];
			assign ch11_rx_data_in[45] = s0_74_1__core_periphery__data_to_core[43];
			assign ch11_rx_data_in[44] = s0_74_1__core_periphery__data_to_core[42];
			assign ch11_rx_data_in[43] = s0_74_1__core_periphery__data_to_core[40];
			assign ch11_rx_data_in[42] = s0_74_1__core_periphery__data_to_core[19];
			assign ch11_rx_data_in[41] = s0_74_1__core_periphery__data_to_core[17];
			assign ch11_rx_data_in[40] = s0_74_1__core_periphery__data_to_core[47];
			assign ch11_rx_data_in[39] = s0_74_1__core_periphery__data_to_core[45];
			//assign ch11_rx_data_in[39] = s0_74_1__core_periphery__data_to_core[23];
			assign ch11_rx_data_in[38] = s0_74_1__core_periphery__data_to_core[22];
			assign ch11_rx_data_in[37] = s0_74_1__core_periphery__data_to_core[20];
			assign ch11_rx_data_in[36] = s0_74_1__core_periphery__data_to_core[51];
			assign ch11_rx_data_in[35] = s0_74_1__core_periphery__data_to_core[49];
			assign ch11_rx_data_in[34] = s0_74_1__core_periphery__data_to_core[80];
			assign ch11_rx_data_in[33] = s0_74_1__core_periphery__data_to_core[82];
			assign ch11_rx_data_in[32] = s0_74_1__core_periphery__data_to_core[52];
			assign ch11_rx_data_in[31] = s0_74_1__core_periphery__data_to_core[54];
			assign ch11_rx_data_in[30] = s0_74_1__core_periphery__data_to_core[55];
			assign ch11_rx_data_in[29] = s0_74_1__core_periphery__data_to_core[84];
			assign ch11_rx_data_in[28] = s0_74_1__core_periphery__data_to_core[86];
			assign ch11_rx_data_in[27] = s0_74_1__core_periphery__data_to_core[87];
			assign ch11_rx_data_in[26] = s0_74_1__core_periphery__data_to_core[57];
			assign ch11_rx_data_in[25] = s0_74_1__core_periphery__data_to_core[58];
			assign ch11_rx_data_in[24] = s0_74_1__core_periphery__data_to_core[88];
			assign ch11_rx_data_in[23] = s0_74_1__core_periphery__data_to_core[90];
			assign ch11_rx_data_in[22] = s0_74_1__core_periphery__data_to_core[60];
			assign ch11_rx_data_in[21] = s0_74_1__core_periphery__data_to_core[62];
			assign ch11_rx_data_in[20] = s0_74_1__core_periphery__data_to_core[63];
			assign ch11_rx_data_in[19] = s0_74_1__core_periphery__data_to_core[92];
			assign ch11_rx_data_in[18] = s0_74_1__core_periphery__data_to_core[93];
			assign ch11_rx_data_in[17] = s0_74_1__core_periphery__data_to_core[95];
			assign ch11_rx_data_in[16] = s0_74_1__core_periphery__data_to_core[65];
			assign ch11_rx_data_in[15] = s0_74_1__core_periphery__data_to_core[66];
			assign ch11_rx_data_in[14] = s0_74_1__core_periphery__data_to_core[67];
			assign ch11_rx_data_in[13] = s0_74_1__core_periphery__data_to_core[96];
			assign ch11_rx_data_in[12] = s0_74_1__core_periphery__data_to_core[98];
			assign ch11_rx_data_in[11] = s0_74_1__core_periphery__data_to_core[99];
			assign ch11_rx_data_in[10] = s0_74_1__core_periphery__data_to_core[69];
			assign ch11_rx_data_in[9] = s0_74_1__core_periphery__data_to_core[70];
			assign ch11_rx_data_in[8] = s0_74_1__core_periphery__data_to_core[100];
			assign ch11_rx_data_in[7] = s0_74_1__core_periphery__data_to_core[102];
			assign ch11_rx_data_in[6] = s0_74_1__core_periphery__data_to_core[72];
			assign ch11_rx_data_in[5] = s0_74_1__core_periphery__data_to_core[74];
			assign ch11_rx_data_in[4] = s0_74_1__core_periphery__data_to_core[75];
			assign ch11_rx_data_in[3] = s0_74_1__core_periphery__data_to_core[104];
			assign ch11_rx_data_in[2] = s0_74_1__core_periphery__data_to_core[105];
			assign ch11_rx_data_in[1] = s0_74_1__core_periphery__data_to_core[107];
			assign ch11_rx_data_in[0] = s0_74_1__core_periphery__data_to_core[77];


			//channel 12

			//assign ch12_rx_data_in[79] = s0_84_1__core_periphery__data_to_core[70];
			assign ch12_rx_data_in[77] = s0_84_1__core_periphery__data_to_core[100];
			assign ch12_rx_data_in[76] = s0_84_1__core_periphery__data_to_core[102];
			assign ch12_rx_data_in[75] = s0_84_1__core_periphery__data_to_core[72];
			assign ch12_rx_data_in[74] = s0_84_1__core_periphery__data_to_core[74];
			assign ch12_rx_data_in[73] = s0_84_1__core_periphery__data_to_core[75];
			assign ch12_rx_data_in[72] = s0_84_1__core_periphery__data_to_core[104];
			assign ch12_rx_data_in[71] = s0_84_1__core_periphery__data_to_core[105];
			assign ch12_rx_data_in[70] = s0_84_1__core_periphery__data_to_core[107];
			assign ch12_rx_data_in[69] = s0_84_1__core_periphery__data_to_core[77];
			assign ch12_rx_data_in[68] = s0_84_1__core_periphery__data_to_core[78];
			assign ch12_rx_data_in[67] = s0_84_1__core_periphery__data_to_core[79];
			assign ch12_rx_data_in[66] = s0_83_1__core_periphery__data_to_core[26];
			assign ch12_rx_data_in[65] = s0_83_1__core_periphery__data_to_core[24];
			assign ch12_rx_data_in[64] = s0_83_1__core_periphery__data_to_core[3];
			assign ch12_rx_data_in[63] = s0_83_1__core_periphery__data_to_core[2];
			assign ch12_rx_data_in[62] = s0_83_1__core_periphery__data_to_core[1];
			assign ch12_rx_data_in[61] = s0_83_1__core_periphery__data_to_core[31];
			assign ch12_rx_data_in[60] = s0_83_1__core_periphery__data_to_core[30];
			assign ch12_rx_data_in[59] = s0_83_1__core_periphery__data_to_core[28];
			assign ch12_rx_data_in[58] = s0_83_1__core_periphery__data_to_core[7];
			assign ch12_rx_data_in[57] = s0_83_1__core_periphery__data_to_core[5];
			assign ch12_rx_data_in[56] = s0_83_1__core_periphery__data_to_core[35];
			assign ch12_rx_data_in[55] = s0_83_1__core_periphery__data_to_core[33];
			assign ch12_rx_data_in[54] = s0_83_1__core_periphery__data_to_core[11];
			assign ch12_rx_data_in[53] = s0_83_1__core_periphery__data_to_core[10];
			assign ch12_rx_data_in[52] = s0_83_1__core_periphery__data_to_core[9];
			assign ch12_rx_data_in[51] = s0_83_1__core_periphery__data_to_core[8];
			assign ch12_rx_data_in[50] = s0_83_1__core_periphery__data_to_core[38];
			assign ch12_rx_data_in[49] = s0_83_1__core_periphery__data_to_core[36];
			assign ch12_rx_data_in[48] = s0_83_1__core_periphery__data_to_core[15];
			assign ch12_rx_data_in[47] = s0_83_1__core_periphery__data_to_core[14];
			assign ch12_rx_data_in[46] = s0_83_1__core_periphery__data_to_core[13];
			assign ch12_rx_data_in[45] = s0_83_1__core_periphery__data_to_core[43];
			assign ch12_rx_data_in[44] = s0_83_1__core_periphery__data_to_core[42];
			assign ch12_rx_data_in[43] = s0_83_1__core_periphery__data_to_core[40];
			assign ch12_rx_data_in[42] = s0_83_1__core_periphery__data_to_core[19];
			assign ch12_rx_data_in[41] = s0_83_1__core_periphery__data_to_core[17];
			assign ch12_rx_data_in[40] = s0_83_1__core_periphery__data_to_core[47];
			assign ch12_rx_data_in[39] = s0_83_1__core_periphery__data_to_core[45];
			//assign ch12_rx_data_in[39] = s0_83_1__core_periphery__data_to_core[23];
			assign ch12_rx_data_in[38] = s0_83_1__core_periphery__data_to_core[22];
			assign ch12_rx_data_in[37] = s0_83_1__core_periphery__data_to_core[20];
			assign ch12_rx_data_in[36] = s0_83_1__core_periphery__data_to_core[51];
			assign ch12_rx_data_in[35] = s0_83_1__core_periphery__data_to_core[49];
			assign ch12_rx_data_in[34] = s0_83_1__core_periphery__data_to_core[80];
			assign ch12_rx_data_in[33] = s0_83_1__core_periphery__data_to_core[82];
			assign ch12_rx_data_in[32] = s0_83_1__core_periphery__data_to_core[52];
			assign ch12_rx_data_in[31] = s0_83_1__core_periphery__data_to_core[54];
			assign ch12_rx_data_in[30] = s0_83_1__core_periphery__data_to_core[55];
			assign ch12_rx_data_in[29] = s0_83_1__core_periphery__data_to_core[84];
			assign ch12_rx_data_in[28] = s0_83_1__core_periphery__data_to_core[86];
			assign ch12_rx_data_in[27] = s0_83_1__core_periphery__data_to_core[87];
			assign ch12_rx_data_in[26] = s0_83_1__core_periphery__data_to_core[57];
			assign ch12_rx_data_in[25] = s0_83_1__core_periphery__data_to_core[58];
			assign ch12_rx_data_in[24] = s0_83_1__core_periphery__data_to_core[88];
			assign ch12_rx_data_in[23] = s0_83_1__core_periphery__data_to_core[90];
			assign ch12_rx_data_in[22] = s0_83_1__core_periphery__data_to_core[60];
			assign ch12_rx_data_in[21] = s0_83_1__core_periphery__data_to_core[62];
			assign ch12_rx_data_in[20] = s0_83_1__core_periphery__data_to_core[63];
			assign ch12_rx_data_in[19] = s0_83_1__core_periphery__data_to_core[92];
			assign ch12_rx_data_in[18] = s0_83_1__core_periphery__data_to_core[93];
			assign ch12_rx_data_in[17] = s0_83_1__core_periphery__data_to_core[95];
			assign ch12_rx_data_in[16] = s0_83_1__core_periphery__data_to_core[65];
			assign ch12_rx_data_in[15] = s0_83_1__core_periphery__data_to_core[66];
			assign ch12_rx_data_in[14] = s0_83_1__core_periphery__data_to_core[67];
			assign ch12_rx_data_in[13] = s0_83_1__core_periphery__data_to_core[96];
			assign ch12_rx_data_in[12] = s0_83_1__core_periphery__data_to_core[98];
			assign ch12_rx_data_in[11] = s0_83_1__core_periphery__data_to_core[99];
			assign ch12_rx_data_in[10] = s0_83_1__core_periphery__data_to_core[69];
			assign ch12_rx_data_in[9] = s0_83_1__core_periphery__data_to_core[70];
			assign ch12_rx_data_in[8] = s0_83_1__core_periphery__data_to_core[100];
			assign ch12_rx_data_in[7] = s0_83_1__core_periphery__data_to_core[102];
			assign ch12_rx_data_in[6] = s0_83_1__core_periphery__data_to_core[72];
			assign ch12_rx_data_in[5] = s0_83_1__core_periphery__data_to_core[74];
			assign ch12_rx_data_in[4] = s0_83_1__core_periphery__data_to_core[75];
			assign ch12_rx_data_in[3] = s0_83_1__core_periphery__data_to_core[104];
			assign ch12_rx_data_in[2] = s0_83_1__core_periphery__data_to_core[105];
			assign ch12_rx_data_in[1] = s0_83_1__core_periphery__data_to_core[107];
			assign ch12_rx_data_in[0] = s0_83_1__core_periphery__data_to_core[77];



			//channel 13

			//assign ch13_rx_data_in[79] = s0_90_1__core_periphery__data_to_core[70];
			assign ch13_rx_data_in[77] = s0_90_1__core_periphery__data_to_core[100];
			assign ch13_rx_data_in[76] = s0_90_1__core_periphery__data_to_core[102];
			assign ch13_rx_data_in[75] = s0_90_1__core_periphery__data_to_core[72];
			assign ch13_rx_data_in[74] = s0_90_1__core_periphery__data_to_core[74];
			assign ch13_rx_data_in[73] = s0_90_1__core_periphery__data_to_core[75];
			assign ch13_rx_data_in[72] = s0_90_1__core_periphery__data_to_core[104];
			assign ch13_rx_data_in[71] = s0_90_1__core_periphery__data_to_core[105];
			assign ch13_rx_data_in[70] = s0_90_1__core_periphery__data_to_core[107];
			assign ch13_rx_data_in[69] = s0_90_1__core_periphery__data_to_core[77];
			assign ch13_rx_data_in[68] = s0_90_1__core_periphery__data_to_core[78];
			assign ch13_rx_data_in[67] = s0_90_1__core_periphery__data_to_core[79];
			assign ch13_rx_data_in[66] = s0_89_1__core_periphery__data_to_core[26];
			assign ch13_rx_data_in[65] = s0_89_1__core_periphery__data_to_core[24];
			assign ch13_rx_data_in[64] = s0_89_1__core_periphery__data_to_core[3];
			assign ch13_rx_data_in[63] = s0_89_1__core_periphery__data_to_core[2];
			assign ch13_rx_data_in[62] = s0_89_1__core_periphery__data_to_core[1];
			assign ch13_rx_data_in[61] = s0_89_1__core_periphery__data_to_core[31];
			assign ch13_rx_data_in[60] = s0_89_1__core_periphery__data_to_core[30];
			assign ch13_rx_data_in[59] = s0_89_1__core_periphery__data_to_core[28];
			assign ch13_rx_data_in[58] = s0_89_1__core_periphery__data_to_core[7];
			assign ch13_rx_data_in[57] = s0_89_1__core_periphery__data_to_core[5];
			assign ch13_rx_data_in[56] = s0_89_1__core_periphery__data_to_core[35];
			assign ch13_rx_data_in[55] = s0_89_1__core_periphery__data_to_core[33];
			assign ch13_rx_data_in[54] = s0_89_1__core_periphery__data_to_core[11];
			assign ch13_rx_data_in[53] = s0_89_1__core_periphery__data_to_core[10];
			assign ch13_rx_data_in[52] = s0_89_1__core_periphery__data_to_core[9];
			assign ch13_rx_data_in[51] = s0_89_1__core_periphery__data_to_core[8];
			assign ch13_rx_data_in[50] = s0_89_1__core_periphery__data_to_core[38];
			assign ch13_rx_data_in[49] = s0_89_1__core_periphery__data_to_core[36];
			assign ch13_rx_data_in[48] = s0_89_1__core_periphery__data_to_core[15];
			assign ch13_rx_data_in[47] = s0_89_1__core_periphery__data_to_core[14];
			assign ch13_rx_data_in[46] = s0_89_1__core_periphery__data_to_core[13];
			assign ch13_rx_data_in[45] = s0_89_1__core_periphery__data_to_core[43];
			assign ch13_rx_data_in[44] = s0_89_1__core_periphery__data_to_core[42];
			assign ch13_rx_data_in[43] = s0_89_1__core_periphery__data_to_core[40];
			assign ch13_rx_data_in[42] = s0_89_1__core_periphery__data_to_core[19];
			assign ch13_rx_data_in[41] = s0_89_1__core_periphery__data_to_core[17];
			assign ch13_rx_data_in[40] = s0_89_1__core_periphery__data_to_core[47];
			assign ch13_rx_data_in[39] = s0_89_1__core_periphery__data_to_core[45];
			//assign ch13_rx_data_in[39] = s0_89_1__core_periphery__data_to_core[23];
			assign ch13_rx_data_in[38] = s0_89_1__core_periphery__data_to_core[22];
			assign ch13_rx_data_in[37] = s0_89_1__core_periphery__data_to_core[20];
			assign ch13_rx_data_in[36] = s0_89_1__core_periphery__data_to_core[51];
			assign ch13_rx_data_in[35] = s0_89_1__core_periphery__data_to_core[49];
			assign ch13_rx_data_in[34] = s0_89_1__core_periphery__data_to_core[80];
			assign ch13_rx_data_in[33] = s0_89_1__core_periphery__data_to_core[82];
			assign ch13_rx_data_in[32] = s0_89_1__core_periphery__data_to_core[52];
			assign ch13_rx_data_in[31] = s0_89_1__core_periphery__data_to_core[54];
			assign ch13_rx_data_in[30] = s0_89_1__core_periphery__data_to_core[55];
			assign ch13_rx_data_in[29] = s0_89_1__core_periphery__data_to_core[84];
			assign ch13_rx_data_in[28] = s0_89_1__core_periphery__data_to_core[86];
			assign ch13_rx_data_in[27] = s0_89_1__core_periphery__data_to_core[87];
			assign ch13_rx_data_in[26] = s0_89_1__core_periphery__data_to_core[57];
			assign ch13_rx_data_in[25] = s0_89_1__core_periphery__data_to_core[58];
			assign ch13_rx_data_in[24] = s0_89_1__core_periphery__data_to_core[88];
			assign ch13_rx_data_in[23] = s0_89_1__core_periphery__data_to_core[90];
			assign ch13_rx_data_in[22] = s0_89_1__core_periphery__data_to_core[60];
			assign ch13_rx_data_in[21] = s0_89_1__core_periphery__data_to_core[62];
			assign ch13_rx_data_in[20] = s0_89_1__core_periphery__data_to_core[63];
			assign ch13_rx_data_in[19] = s0_89_1__core_periphery__data_to_core[92];
			assign ch13_rx_data_in[18] = s0_89_1__core_periphery__data_to_core[93];
			assign ch13_rx_data_in[17] = s0_89_1__core_periphery__data_to_core[95];
			assign ch13_rx_data_in[16] = s0_89_1__core_periphery__data_to_core[65];
			assign ch13_rx_data_in[15] = s0_89_1__core_periphery__data_to_core[66];
			assign ch13_rx_data_in[14] = s0_89_1__core_periphery__data_to_core[67];
			assign ch13_rx_data_in[13] = s0_89_1__core_periphery__data_to_core[96];
			assign ch13_rx_data_in[12] = s0_89_1__core_periphery__data_to_core[98];
			assign ch13_rx_data_in[11] = s0_89_1__core_periphery__data_to_core[99];
			assign ch13_rx_data_in[10] = s0_89_1__core_periphery__data_to_core[69];
			assign ch13_rx_data_in[9] = s0_89_1__core_periphery__data_to_core[70];
			assign ch13_rx_data_in[8] = s0_89_1__core_periphery__data_to_core[100];
			assign ch13_rx_data_in[7] = s0_89_1__core_periphery__data_to_core[102];
			assign ch13_rx_data_in[6] = s0_89_1__core_periphery__data_to_core[72];
			assign ch13_rx_data_in[5] = s0_89_1__core_periphery__data_to_core[74];
			assign ch13_rx_data_in[4] = s0_89_1__core_periphery__data_to_core[75];
			assign ch13_rx_data_in[3] = s0_89_1__core_periphery__data_to_core[104];
			assign ch13_rx_data_in[2] = s0_89_1__core_periphery__data_to_core[105];
			assign ch13_rx_data_in[1] = s0_89_1__core_periphery__data_to_core[107];
			assign ch13_rx_data_in[0] = s0_89_1__core_periphery__data_to_core[77];


			//channel 14

			//assign ch14_rx_data_in[79] = s0_96_1__core_periphery__data_to_core[70];
			assign ch14_rx_data_in[77] = s0_96_1__core_periphery__data_to_core[100];
			assign ch14_rx_data_in[76] = s0_96_1__core_periphery__data_to_core[102];
			assign ch14_rx_data_in[75] = s0_96_1__core_periphery__data_to_core[72];
			assign ch14_rx_data_in[74] = s0_96_1__core_periphery__data_to_core[74];
			assign ch14_rx_data_in[73] = s0_96_1__core_periphery__data_to_core[75];
			assign ch14_rx_data_in[72] = s0_96_1__core_periphery__data_to_core[104];
			assign ch14_rx_data_in[71] = s0_96_1__core_periphery__data_to_core[105];
			assign ch14_rx_data_in[70] = s0_96_1__core_periphery__data_to_core[107];
			assign ch14_rx_data_in[69] = s0_96_1__core_periphery__data_to_core[77];
			assign ch14_rx_data_in[68] = s0_96_1__core_periphery__data_to_core[78];
			assign ch14_rx_data_in[67] = s0_96_1__core_periphery__data_to_core[79];
			assign ch14_rx_data_in[66] = s0_95_1__core_periphery__data_to_core[26];
			assign ch14_rx_data_in[65] = s0_95_1__core_periphery__data_to_core[24];
			assign ch14_rx_data_in[64] = s0_95_1__core_periphery__data_to_core[3];
			assign ch14_rx_data_in[63] = s0_95_1__core_periphery__data_to_core[2];
			assign ch14_rx_data_in[62] = s0_95_1__core_periphery__data_to_core[1];
			assign ch14_rx_data_in[61] = s0_95_1__core_periphery__data_to_core[31];
			assign ch14_rx_data_in[60] = s0_95_1__core_periphery__data_to_core[30];
			assign ch14_rx_data_in[59] = s0_95_1__core_periphery__data_to_core[28];
			assign ch14_rx_data_in[58] = s0_95_1__core_periphery__data_to_core[7];
			assign ch14_rx_data_in[57] = s0_95_1__core_periphery__data_to_core[5];
			assign ch14_rx_data_in[56] = s0_95_1__core_periphery__data_to_core[35];
			assign ch14_rx_data_in[55] = s0_95_1__core_periphery__data_to_core[33];
			assign ch14_rx_data_in[54] = s0_95_1__core_periphery__data_to_core[11];
			assign ch14_rx_data_in[53] = s0_95_1__core_periphery__data_to_core[10];
			assign ch14_rx_data_in[52] = s0_95_1__core_periphery__data_to_core[9];
			assign ch14_rx_data_in[51] = s0_95_1__core_periphery__data_to_core[8];
			assign ch14_rx_data_in[50] = s0_95_1__core_periphery__data_to_core[38];
			assign ch14_rx_data_in[49] = s0_95_1__core_periphery__data_to_core[36];
			assign ch14_rx_data_in[48] = s0_95_1__core_periphery__data_to_core[15];
			assign ch14_rx_data_in[47] = s0_95_1__core_periphery__data_to_core[14];
			assign ch14_rx_data_in[46] = s0_95_1__core_periphery__data_to_core[13];
			assign ch14_rx_data_in[45] = s0_95_1__core_periphery__data_to_core[43];
			assign ch14_rx_data_in[44] = s0_95_1__core_periphery__data_to_core[42];
			assign ch14_rx_data_in[43] = s0_95_1__core_periphery__data_to_core[40];
			assign ch14_rx_data_in[42] = s0_95_1__core_periphery__data_to_core[19];
			assign ch14_rx_data_in[41] = s0_95_1__core_periphery__data_to_core[17];
			assign ch14_rx_data_in[40] = s0_95_1__core_periphery__data_to_core[47];
			assign ch14_rx_data_in[39] = s0_95_1__core_periphery__data_to_core[45];
			//assign ch14_rx_data_in[39] = s0_95_1__core_periphery__data_to_core[23];
			assign ch14_rx_data_in[38] = s0_95_1__core_periphery__data_to_core[22];
			assign ch14_rx_data_in[37] = s0_95_1__core_periphery__data_to_core[20];
			assign ch14_rx_data_in[36] = s0_95_1__core_periphery__data_to_core[51];
			assign ch14_rx_data_in[35] = s0_95_1__core_periphery__data_to_core[49];
			assign ch14_rx_data_in[34] = s0_95_1__core_periphery__data_to_core[80];
			assign ch14_rx_data_in[33] = s0_95_1__core_periphery__data_to_core[82];
			assign ch14_rx_data_in[32] = s0_95_1__core_periphery__data_to_core[52];
			assign ch14_rx_data_in[31] = s0_95_1__core_periphery__data_to_core[54];
			assign ch14_rx_data_in[30] = s0_95_1__core_periphery__data_to_core[55];
			assign ch14_rx_data_in[29] = s0_95_1__core_periphery__data_to_core[84];
			assign ch14_rx_data_in[28] = s0_95_1__core_periphery__data_to_core[86];
			assign ch14_rx_data_in[27] = s0_95_1__core_periphery__data_to_core[87];
			assign ch14_rx_data_in[26] = s0_95_1__core_periphery__data_to_core[57];
			assign ch14_rx_data_in[25] = s0_95_1__core_periphery__data_to_core[58];
			assign ch14_rx_data_in[24] = s0_95_1__core_periphery__data_to_core[88];
			assign ch14_rx_data_in[23] = s0_95_1__core_periphery__data_to_core[90];
			assign ch14_rx_data_in[22] = s0_95_1__core_periphery__data_to_core[60];
			assign ch14_rx_data_in[21] = s0_95_1__core_periphery__data_to_core[62];
			assign ch14_rx_data_in[20] = s0_95_1__core_periphery__data_to_core[63];
			assign ch14_rx_data_in[19] = s0_95_1__core_periphery__data_to_core[92];
			assign ch14_rx_data_in[18] = s0_95_1__core_periphery__data_to_core[93];
			assign ch14_rx_data_in[17] = s0_95_1__core_periphery__data_to_core[95];
			assign ch14_rx_data_in[16] = s0_95_1__core_periphery__data_to_core[65];
			assign ch14_rx_data_in[15] = s0_95_1__core_periphery__data_to_core[66];
			assign ch14_rx_data_in[14] = s0_95_1__core_periphery__data_to_core[67];
			assign ch14_rx_data_in[13] = s0_95_1__core_periphery__data_to_core[96];
			assign ch14_rx_data_in[12] = s0_95_1__core_periphery__data_to_core[98];
			assign ch14_rx_data_in[11] = s0_95_1__core_periphery__data_to_core[99];
			assign ch14_rx_data_in[10] = s0_95_1__core_periphery__data_to_core[69];
			assign ch14_rx_data_in[9] = s0_95_1__core_periphery__data_to_core[70];
			assign ch14_rx_data_in[8] = s0_95_1__core_periphery__data_to_core[100];
			assign ch14_rx_data_in[7] = s0_95_1__core_periphery__data_to_core[102];
			assign ch14_rx_data_in[6] = s0_95_1__core_periphery__data_to_core[72];
			assign ch14_rx_data_in[5] = s0_95_1__core_periphery__data_to_core[74];
			assign ch14_rx_data_in[4] = s0_95_1__core_periphery__data_to_core[75];
			assign ch14_rx_data_in[3] = s0_95_1__core_periphery__data_to_core[104];
			assign ch14_rx_data_in[2] = s0_95_1__core_periphery__data_to_core[105];
			assign ch14_rx_data_in[1] = s0_95_1__core_periphery__data_to_core[107];
			assign ch14_rx_data_in[0] = s0_95_1__core_periphery__data_to_core[77];


			//channel 15

			//assign ch15_rx_data_in[79] = s0_103_1__core_periphery__data_to_core[70];
			assign ch15_rx_data_in[77] = s0_103_1__core_periphery__data_to_core[100];
			assign ch15_rx_data_in[76] = s0_103_1__core_periphery__data_to_core[102];
			assign ch15_rx_data_in[75] = s0_103_1__core_periphery__data_to_core[72];
			assign ch15_rx_data_in[74] = s0_103_1__core_periphery__data_to_core[74];
			assign ch15_rx_data_in[73] = s0_103_1__core_periphery__data_to_core[75];
			assign ch15_rx_data_in[72] = s0_103_1__core_periphery__data_to_core[104];
			assign ch15_rx_data_in[71] = s0_103_1__core_periphery__data_to_core[105];
			assign ch15_rx_data_in[70] = s0_103_1__core_periphery__data_to_core[107];
			assign ch15_rx_data_in[69] = s0_103_1__core_periphery__data_to_core[77];
			assign ch15_rx_data_in[68] = s0_103_1__core_periphery__data_to_core[78];
			assign ch15_rx_data_in[67] = s0_103_1__core_periphery__data_to_core[79];
			assign ch15_rx_data_in[66] = s0_102_1__core_periphery__data_to_core[26];
			assign ch15_rx_data_in[65] = s0_102_1__core_periphery__data_to_core[24];
			assign ch15_rx_data_in[64] = s0_102_1__core_periphery__data_to_core[3];
			assign ch15_rx_data_in[63] = s0_102_1__core_periphery__data_to_core[2];
			assign ch15_rx_data_in[62] = s0_102_1__core_periphery__data_to_core[1];
			assign ch15_rx_data_in[61] = s0_102_1__core_periphery__data_to_core[31];
			assign ch15_rx_data_in[60] = s0_102_1__core_periphery__data_to_core[30];
			assign ch15_rx_data_in[59] = s0_102_1__core_periphery__data_to_core[28];
			assign ch15_rx_data_in[58] = s0_102_1__core_periphery__data_to_core[7];
			assign ch15_rx_data_in[57] = s0_102_1__core_periphery__data_to_core[5];
			assign ch15_rx_data_in[56] = s0_102_1__core_periphery__data_to_core[35];
			assign ch15_rx_data_in[55] = s0_102_1__core_periphery__data_to_core[33];
			assign ch15_rx_data_in[54] = s0_102_1__core_periphery__data_to_core[11];
			assign ch15_rx_data_in[53] = s0_102_1__core_periphery__data_to_core[10];
			assign ch15_rx_data_in[52] = s0_102_1__core_periphery__data_to_core[9];
			assign ch15_rx_data_in[51] = s0_102_1__core_periphery__data_to_core[8];
			assign ch15_rx_data_in[50] = s0_102_1__core_periphery__data_to_core[38];
			assign ch15_rx_data_in[49] = s0_102_1__core_periphery__data_to_core[36];
			assign ch15_rx_data_in[48] = s0_102_1__core_periphery__data_to_core[15];
			assign ch15_rx_data_in[47] = s0_102_1__core_periphery__data_to_core[14];
			assign ch15_rx_data_in[46] = s0_102_1__core_periphery__data_to_core[13];
			assign ch15_rx_data_in[45] = s0_102_1__core_periphery__data_to_core[43];
			assign ch15_rx_data_in[44] = s0_102_1__core_periphery__data_to_core[42];
			assign ch15_rx_data_in[43] = s0_102_1__core_periphery__data_to_core[40];
			assign ch15_rx_data_in[42] = s0_102_1__core_periphery__data_to_core[19];
			assign ch15_rx_data_in[41] = s0_102_1__core_periphery__data_to_core[17];
			assign ch15_rx_data_in[40] = s0_102_1__core_periphery__data_to_core[47];
			assign ch15_rx_data_in[39] = s0_102_1__core_periphery__data_to_core[45];
			//assign ch15_rx_data_in[39] = s0_102_1__core_periphery__data_to_core[23];
			assign ch15_rx_data_in[38] = s0_102_1__core_periphery__data_to_core[22];
			assign ch15_rx_data_in[37] = s0_102_1__core_periphery__data_to_core[20];
			assign ch15_rx_data_in[36] = s0_102_1__core_periphery__data_to_core[51];
			assign ch15_rx_data_in[35] = s0_102_1__core_periphery__data_to_core[49];
			assign ch15_rx_data_in[34] = s0_102_1__core_periphery__data_to_core[80];
			assign ch15_rx_data_in[33] = s0_102_1__core_periphery__data_to_core[82];
			assign ch15_rx_data_in[32] = s0_102_1__core_periphery__data_to_core[52];
			assign ch15_rx_data_in[31] = s0_102_1__core_periphery__data_to_core[54];
			assign ch15_rx_data_in[30] = s0_102_1__core_periphery__data_to_core[55];
			assign ch15_rx_data_in[29] = s0_102_1__core_periphery__data_to_core[84];
			assign ch15_rx_data_in[28] = s0_102_1__core_periphery__data_to_core[86];
			assign ch15_rx_data_in[27] = s0_102_1__core_periphery__data_to_core[87];
			assign ch15_rx_data_in[26] = s0_102_1__core_periphery__data_to_core[57];
			assign ch15_rx_data_in[25] = s0_102_1__core_periphery__data_to_core[58];
			assign ch15_rx_data_in[24] = s0_102_1__core_periphery__data_to_core[88];
			assign ch15_rx_data_in[23] = s0_102_1__core_periphery__data_to_core[90];
			assign ch15_rx_data_in[22] = s0_102_1__core_periphery__data_to_core[60];
			assign ch15_rx_data_in[21] = s0_102_1__core_periphery__data_to_core[62];
			assign ch15_rx_data_in[20] = s0_102_1__core_periphery__data_to_core[63];
			assign ch15_rx_data_in[19] = s0_102_1__core_periphery__data_to_core[92];
			assign ch15_rx_data_in[18] = s0_102_1__core_periphery__data_to_core[93];
			assign ch15_rx_data_in[17] = s0_102_1__core_periphery__data_to_core[95];
			assign ch15_rx_data_in[16] = s0_102_1__core_periphery__data_to_core[65];
			assign ch15_rx_data_in[15] = s0_102_1__core_periphery__data_to_core[66];
			assign ch15_rx_data_in[14] = s0_102_1__core_periphery__data_to_core[67];
			assign ch15_rx_data_in[13] = s0_102_1__core_periphery__data_to_core[96];
			assign ch15_rx_data_in[12] = s0_102_1__core_periphery__data_to_core[98];
			assign ch15_rx_data_in[11] = s0_102_1__core_periphery__data_to_core[99];
			assign ch15_rx_data_in[10] = s0_102_1__core_periphery__data_to_core[69];
			assign ch15_rx_data_in[9] = s0_102_1__core_periphery__data_to_core[70];
			assign ch15_rx_data_in[8] = s0_102_1__core_periphery__data_to_core[100];
			assign ch15_rx_data_in[7] = s0_102_1__core_periphery__data_to_core[102];
			assign ch15_rx_data_in[6] = s0_102_1__core_periphery__data_to_core[72];
			assign ch15_rx_data_in[5] = s0_102_1__core_periphery__data_to_core[74];
			assign ch15_rx_data_in[4] = s0_102_1__core_periphery__data_to_core[75];
			assign ch15_rx_data_in[3] = s0_102_1__core_periphery__data_to_core[104];
			assign ch15_rx_data_in[2] = s0_102_1__core_periphery__data_to_core[105];
			assign ch15_rx_data_in[1] = s0_102_1__core_periphery__data_to_core[107];
			assign ch15_rx_data_in[0] = s0_102_1__core_periphery__data_to_core[77];


			//channel 16

			//assign ch16_rx_data_in[79] = s0_109_1__core_periphery__data_to_core[70];
			assign ch16_rx_data_in[77] = s0_109_1__core_periphery__data_to_core[100];
			assign ch16_rx_data_in[76] = s0_109_1__core_periphery__data_to_core[102];
			assign ch16_rx_data_in[75] = s0_109_1__core_periphery__data_to_core[72];
			assign ch16_rx_data_in[74] = s0_109_1__core_periphery__data_to_core[74];
			assign ch16_rx_data_in[73] = s0_109_1__core_periphery__data_to_core[75];
			assign ch16_rx_data_in[72] = s0_109_1__core_periphery__data_to_core[104];
			assign ch16_rx_data_in[71] = s0_109_1__core_periphery__data_to_core[105];
			assign ch16_rx_data_in[70] = s0_109_1__core_periphery__data_to_core[107];
			assign ch16_rx_data_in[69] = s0_109_1__core_periphery__data_to_core[77];
			assign ch16_rx_data_in[68] = s0_109_1__core_periphery__data_to_core[78];
			assign ch16_rx_data_in[67] = s0_109_1__core_periphery__data_to_core[79];
			assign ch16_rx_data_in[66] = s0_108_1__core_periphery__data_to_core[26];
			assign ch16_rx_data_in[65] = s0_108_1__core_periphery__data_to_core[24];
			assign ch16_rx_data_in[64] = s0_108_1__core_periphery__data_to_core[3];
			assign ch16_rx_data_in[63] = s0_108_1__core_periphery__data_to_core[2];
			assign ch16_rx_data_in[62] = s0_108_1__core_periphery__data_to_core[1];
			assign ch16_rx_data_in[61] = s0_108_1__core_periphery__data_to_core[31];
			assign ch16_rx_data_in[60] = s0_108_1__core_periphery__data_to_core[30];
			assign ch16_rx_data_in[59] = s0_108_1__core_periphery__data_to_core[28];
			assign ch16_rx_data_in[58] = s0_108_1__core_periphery__data_to_core[7];
			assign ch16_rx_data_in[57] = s0_108_1__core_periphery__data_to_core[5];
			assign ch16_rx_data_in[56] = s0_108_1__core_periphery__data_to_core[35];
			assign ch16_rx_data_in[55] = s0_108_1__core_periphery__data_to_core[33];
			assign ch16_rx_data_in[54] = s0_108_1__core_periphery__data_to_core[11];
			assign ch16_rx_data_in[53] = s0_108_1__core_periphery__data_to_core[10];
			assign ch16_rx_data_in[52] = s0_108_1__core_periphery__data_to_core[9];
			assign ch16_rx_data_in[51] = s0_108_1__core_periphery__data_to_core[8];
			assign ch16_rx_data_in[50] = s0_108_1__core_periphery__data_to_core[38];
			assign ch16_rx_data_in[49] = s0_108_1__core_periphery__data_to_core[36];
			assign ch16_rx_data_in[48] = s0_108_1__core_periphery__data_to_core[15];
			assign ch16_rx_data_in[47] = s0_108_1__core_periphery__data_to_core[14];
			assign ch16_rx_data_in[46] = s0_108_1__core_periphery__data_to_core[13];
			assign ch16_rx_data_in[45] = s0_108_1__core_periphery__data_to_core[43];
			assign ch16_rx_data_in[44] = s0_108_1__core_periphery__data_to_core[42];
			assign ch16_rx_data_in[43] = s0_108_1__core_periphery__data_to_core[40];
			assign ch16_rx_data_in[42] = s0_108_1__core_periphery__data_to_core[19];
			assign ch16_rx_data_in[41] = s0_108_1__core_periphery__data_to_core[17];
			assign ch16_rx_data_in[40] = s0_108_1__core_periphery__data_to_core[47];
			assign ch16_rx_data_in[39] = s0_108_1__core_periphery__data_to_core[45];
			//assign ch16_rx_data_in[39] = s0_108_1__core_periphery__data_to_core[23];
			assign ch16_rx_data_in[38] = s0_108_1__core_periphery__data_to_core[22];
			assign ch16_rx_data_in[37] = s0_108_1__core_periphery__data_to_core[20];
			assign ch16_rx_data_in[36] = s0_108_1__core_periphery__data_to_core[51];
			assign ch16_rx_data_in[35] = s0_108_1__core_periphery__data_to_core[49];
			assign ch16_rx_data_in[34] = s0_108_1__core_periphery__data_to_core[80];
			assign ch16_rx_data_in[33] = s0_108_1__core_periphery__data_to_core[82];
			assign ch16_rx_data_in[32] = s0_108_1__core_periphery__data_to_core[52];
			assign ch16_rx_data_in[31] = s0_108_1__core_periphery__data_to_core[54];
			assign ch16_rx_data_in[30] = s0_108_1__core_periphery__data_to_core[55];
			assign ch16_rx_data_in[29] = s0_108_1__core_periphery__data_to_core[84];
			assign ch16_rx_data_in[28] = s0_108_1__core_periphery__data_to_core[86];
			assign ch16_rx_data_in[27] = s0_108_1__core_periphery__data_to_core[87];
			assign ch16_rx_data_in[26] = s0_108_1__core_periphery__data_to_core[57];
			assign ch16_rx_data_in[25] = s0_108_1__core_periphery__data_to_core[58];
			assign ch16_rx_data_in[24] = s0_108_1__core_periphery__data_to_core[88];
			assign ch16_rx_data_in[23] = s0_108_1__core_periphery__data_to_core[90];
			assign ch16_rx_data_in[22] = s0_108_1__core_periphery__data_to_core[60];
			assign ch16_rx_data_in[21] = s0_108_1__core_periphery__data_to_core[62];
			assign ch16_rx_data_in[20] = s0_108_1__core_periphery__data_to_core[63];
			assign ch16_rx_data_in[19] = s0_108_1__core_periphery__data_to_core[92];
			assign ch16_rx_data_in[18] = s0_108_1__core_periphery__data_to_core[93];
			assign ch16_rx_data_in[17] = s0_108_1__core_periphery__data_to_core[95];
			assign ch16_rx_data_in[16] = s0_108_1__core_periphery__data_to_core[65];
			assign ch16_rx_data_in[15] = s0_108_1__core_periphery__data_to_core[66];
			assign ch16_rx_data_in[14] = s0_108_1__core_periphery__data_to_core[67];
			assign ch16_rx_data_in[13] = s0_108_1__core_periphery__data_to_core[96];
			assign ch16_rx_data_in[12] = s0_108_1__core_periphery__data_to_core[98];
			assign ch16_rx_data_in[11] = s0_108_1__core_periphery__data_to_core[99];
			assign ch16_rx_data_in[10] = s0_108_1__core_periphery__data_to_core[69];
			assign ch16_rx_data_in[9] = s0_108_1__core_periphery__data_to_core[70];
			assign ch16_rx_data_in[8] = s0_108_1__core_periphery__data_to_core[100];
			assign ch16_rx_data_in[7] = s0_108_1__core_periphery__data_to_core[102];
			assign ch16_rx_data_in[6] = s0_108_1__core_periphery__data_to_core[72];
			assign ch16_rx_data_in[5] = s0_108_1__core_periphery__data_to_core[74];
			assign ch16_rx_data_in[4] = s0_108_1__core_periphery__data_to_core[75];
			assign ch16_rx_data_in[3] = s0_108_1__core_periphery__data_to_core[104];
			assign ch16_rx_data_in[2] = s0_108_1__core_periphery__data_to_core[105];
			assign ch16_rx_data_in[1] = s0_108_1__core_periphery__data_to_core[107];
			assign ch16_rx_data_in[0] = s0_108_1__core_periphery__data_to_core[77];


			//channel 17


			//assign ch17_rx_data_in[79] = s0_115_1__core_periphery__data_to_core[70];
			assign ch17_rx_data_in[77] = s0_115_1__core_periphery__data_to_core[100];
			assign ch17_rx_data_in[76] = s0_115_1__core_periphery__data_to_core[102];
			assign ch17_rx_data_in[75] = s0_115_1__core_periphery__data_to_core[72];
			assign ch17_rx_data_in[74] = s0_115_1__core_periphery__data_to_core[74];
			assign ch17_rx_data_in[73] = s0_115_1__core_periphery__data_to_core[75];
			assign ch17_rx_data_in[72] = s0_115_1__core_periphery__data_to_core[104];
			assign ch17_rx_data_in[71] = s0_115_1__core_periphery__data_to_core[105];
			assign ch17_rx_data_in[70] = s0_115_1__core_periphery__data_to_core[107];
			assign ch17_rx_data_in[69] = s0_115_1__core_periphery__data_to_core[77];
			assign ch17_rx_data_in[68] = s0_115_1__core_periphery__data_to_core[78];
			assign ch17_rx_data_in[67] = s0_115_1__core_periphery__data_to_core[79];
			assign ch17_rx_data_in[66] = s0_114_1__core_periphery__data_to_core[26];
			assign ch17_rx_data_in[65] = s0_114_1__core_periphery__data_to_core[24];
			assign ch17_rx_data_in[64] = s0_114_1__core_periphery__data_to_core[3];
			assign ch17_rx_data_in[63] = s0_114_1__core_periphery__data_to_core[2];
			assign ch17_rx_data_in[62] = s0_114_1__core_periphery__data_to_core[1];
			assign ch17_rx_data_in[61] = s0_114_1__core_periphery__data_to_core[31];
			assign ch17_rx_data_in[60] = s0_114_1__core_periphery__data_to_core[30];
			assign ch17_rx_data_in[59] = s0_114_1__core_periphery__data_to_core[28];
			assign ch17_rx_data_in[58] = s0_114_1__core_periphery__data_to_core[7];
			assign ch17_rx_data_in[57] = s0_114_1__core_periphery__data_to_core[5];
			assign ch17_rx_data_in[56] = s0_114_1__core_periphery__data_to_core[35];
			assign ch17_rx_data_in[55] = s0_114_1__core_periphery__data_to_core[33];
			assign ch17_rx_data_in[54] = s0_114_1__core_periphery__data_to_core[11];
			assign ch17_rx_data_in[53] = s0_114_1__core_periphery__data_to_core[10];
			assign ch17_rx_data_in[52] = s0_114_1__core_periphery__data_to_core[9];
			assign ch17_rx_data_in[51] = s0_114_1__core_periphery__data_to_core[8];
			assign ch17_rx_data_in[50] = s0_114_1__core_periphery__data_to_core[38];
			assign ch17_rx_data_in[49] = s0_114_1__core_periphery__data_to_core[36];
			assign ch17_rx_data_in[48] = s0_114_1__core_periphery__data_to_core[15];
			assign ch17_rx_data_in[47] = s0_114_1__core_periphery__data_to_core[14];
			assign ch17_rx_data_in[46] = s0_114_1__core_periphery__data_to_core[13];
			assign ch17_rx_data_in[45] = s0_114_1__core_periphery__data_to_core[43];
			assign ch17_rx_data_in[44] = s0_114_1__core_periphery__data_to_core[42];
			assign ch17_rx_data_in[43] = s0_114_1__core_periphery__data_to_core[40];
			assign ch17_rx_data_in[42] = s0_114_1__core_periphery__data_to_core[19];
			assign ch17_rx_data_in[41] = s0_114_1__core_periphery__data_to_core[17];
			assign ch17_rx_data_in[40] = s0_114_1__core_periphery__data_to_core[47];
			assign ch17_rx_data_in[39] = s0_114_1__core_periphery__data_to_core[45];
			//assign ch17_rx_data_in[39] = s0_114_1__core_periphery__data_to_core[23];
			assign ch17_rx_data_in[38] = s0_114_1__core_periphery__data_to_core[22];
			assign ch17_rx_data_in[37] = s0_114_1__core_periphery__data_to_core[20];
			assign ch17_rx_data_in[36] = s0_114_1__core_periphery__data_to_core[51];
			assign ch17_rx_data_in[35] = s0_114_1__core_periphery__data_to_core[49];
			assign ch17_rx_data_in[34] = s0_114_1__core_periphery__data_to_core[80];
			assign ch17_rx_data_in[33] = s0_114_1__core_periphery__data_to_core[82];
			assign ch17_rx_data_in[32] = s0_114_1__core_periphery__data_to_core[52];
			assign ch17_rx_data_in[31] = s0_114_1__core_periphery__data_to_core[54];
			assign ch17_rx_data_in[30] = s0_114_1__core_periphery__data_to_core[55];
			assign ch17_rx_data_in[29] = s0_114_1__core_periphery__data_to_core[84];
			assign ch17_rx_data_in[28] = s0_114_1__core_periphery__data_to_core[86];
			assign ch17_rx_data_in[27] = s0_114_1__core_periphery__data_to_core[87];
			assign ch17_rx_data_in[26] = s0_114_1__core_periphery__data_to_core[57];
			assign ch17_rx_data_in[25] = s0_114_1__core_periphery__data_to_core[58];
			assign ch17_rx_data_in[24] = s0_114_1__core_periphery__data_to_core[88];
			assign ch17_rx_data_in[23] = s0_114_1__core_periphery__data_to_core[90];
			assign ch17_rx_data_in[22] = s0_114_1__core_periphery__data_to_core[60];
			assign ch17_rx_data_in[21] = s0_114_1__core_periphery__data_to_core[62];
			assign ch17_rx_data_in[20] = s0_114_1__core_periphery__data_to_core[63];
			assign ch17_rx_data_in[19] = s0_114_1__core_periphery__data_to_core[92];
			assign ch17_rx_data_in[18] = s0_114_1__core_periphery__data_to_core[93];
			assign ch17_rx_data_in[17] = s0_114_1__core_periphery__data_to_core[95];
			assign ch17_rx_data_in[16] = s0_114_1__core_periphery__data_to_core[65];
			assign ch17_rx_data_in[15] = s0_114_1__core_periphery__data_to_core[66];
			assign ch17_rx_data_in[14] = s0_114_1__core_periphery__data_to_core[67];
			assign ch17_rx_data_in[13] = s0_114_1__core_periphery__data_to_core[96];
			assign ch17_rx_data_in[12] = s0_114_1__core_periphery__data_to_core[98];
			assign ch17_rx_data_in[11] = s0_114_1__core_periphery__data_to_core[99];
			assign ch17_rx_data_in[10] = s0_114_1__core_periphery__data_to_core[69];
			assign ch17_rx_data_in[9] = s0_114_1__core_periphery__data_to_core[70];
			assign ch17_rx_data_in[8] = s0_114_1__core_periphery__data_to_core[100];
			assign ch17_rx_data_in[7] = s0_114_1__core_periphery__data_to_core[102];
			assign ch17_rx_data_in[6] = s0_114_1__core_periphery__data_to_core[72];
			assign ch17_rx_data_in[5] = s0_114_1__core_periphery__data_to_core[74];
			assign ch17_rx_data_in[4] = s0_114_1__core_periphery__data_to_core[75];
			assign ch17_rx_data_in[3] = s0_114_1__core_periphery__data_to_core[104];
			assign ch17_rx_data_in[2] = s0_114_1__core_periphery__data_to_core[105];
			assign ch17_rx_data_in[1] = s0_114_1__core_periphery__data_to_core[107];
			assign ch17_rx_data_in[0] = s0_114_1__core_periphery__data_to_core[77];
				
		end	
	endgenerate

	
	
	 generate if (DEVICE_WIDTH == "pcie_x8x8")  begin


always @(posedge i_clk)
begin 
	if(p0_reset == 0)
	begin 
	

		ch2_rx_data_in_r <= 0;
		ch3_rx_data_in_r <= 0;
		ch4_rx_data_in_r <= 0;
		ch5_rx_data_in_r <= 0;
		ch6_rx_data_in_r <= 0;
		ch7_rx_data_in_r <= 0;
		ch8_rx_data_in_r <= 0;
		ch9_rx_data_in_r <= 0;

	
	end 
	
	else 
	begin 

		ch2_rx_data_in_r <= ch2_rx_data_in;
		ch3_rx_data_in_r <= ch3_rx_data_in;
		ch4_rx_data_in_r <= ch4_rx_data_in;
		ch5_rx_data_in_r <= ch5_rx_data_in;
		ch6_rx_data_in_r <= ch6_rx_data_in;
		ch7_rx_data_in_r <= ch7_rx_data_in;
		ch8_rx_data_in_r <= ch8_rx_data_in;
		ch9_rx_data_in_r <= ch9_rx_data_in;



	end 
end

always @(posedge i_clk)
begin 
	if(p1_reset == 0)
	begin 
	

		ch12_rx_data_in_r <= 0;
		ch13_rx_data_in_r <= 0;
		ch14_rx_data_in_r <= 0;
		ch15_rx_data_in_r <= 0;
		ch16_rx_data_in_r <= 0;
		ch18_rx_data_in_r <= 0;
		ch19_rx_data_in_r <= 0;
		ch20_rx_data_in_r <= 0;
	
	end 
	
	else 
	begin 

		ch12_rx_data_in_r <= ch12_rx_data_in;
		ch13_rx_data_in_r <= ch13_rx_data_in;
		ch14_rx_data_in_r <= ch14_rx_data_in;
		ch15_rx_data_in_r <= ch15_rx_data_in;
		ch16_rx_data_in_r <= ch16_rx_data_in;
		ch18_rx_data_in_r <= ch18_rx_data_in;
		ch19_rx_data_in_r <= ch19_rx_data_in;
		ch20_rx_data_in_r <= ch20_rx_data_in;


	end 
end
		
localparam AIB_WIDTH = 78;
localparam NUM_CHAN = 16; 
localparam ECC_OUT_WIDTH = 70;
genvar ww;

logic [NUM_CHAN * AIB_WIDTH-1:0] i_rx_ecc_data;
logic [NUM_CHAN * ECC_OUT_WIDTH-1:0] o_rx_ecc_data;
logic [NUM_CHAN-1:0] [AIB_WIDTH-1:0] data_in;
logic [NUM_CHAN-1:0] [ECC_OUT_WIDTH-1:0] data_out;
logic [NUM_CHAN-1:0] o_int_sec;
logic [NUM_CHAN-1:0] o_int_ded;
logic [NUM_CHAN-1:0] o_syndrome;

assign i_rx_ecc_data	 =  (	
							{{ch20_rx_ecc_data_in},
							{ch19_rx_ecc_data_in}, 
							{ch18_rx_ecc_data_in}, 
							{ch16_rx_ecc_data_in},
							{ch15_rx_ecc_data_in}, 
							{ch14_rx_ecc_data_in}, 
							{ch13_rx_ecc_data_in},
							{ch12_rx_ecc_data_in},  
							{ch9_rx_ecc_data_in}, 
							{ch8_rx_ecc_data_in},
							{ch7_rx_ecc_data_in},
							{ch6_rx_ecc_data_in}, 
							{ch5_rx_ecc_data_in},
							{ch4_rx_ecc_data_in}, 
							{ch3_rx_ecc_data_in}, 
							{ch2_rx_ecc_data_in} }   
						);


//ecc module instantaition
for(ww=0; ww<NUM_CHAN; ww++) begin:ecc_module_instantiation
				
		assign  data_in[ww] = i_rx_ecc_data[ww*AIB_WIDTH+:AIB_WIDTH]	;	
		
				wrlib_ecc_dec_c78_d70 inst_rx_ecc (

				   .o_int_sec 		(o_int_sec[ww]),
				   .o_int_ded		(o_int_ded[ww]),
				   .o_syndrome		(o_syndrome[ww]),
				   .i_code			(data_in[ww]),
				   .o_data			(data_out[ww])

				);
			
		assign o_rx_ecc_data[ww*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] = data_out[ww];
		
end:ecc_module_instantiation 



assign  ch2_rx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? {ch2_rx_data_in_r[77:70],70'd0} :	ch2_rx_data_in_r[77:0] ;						
assign  ch3_rx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? {ch3_rx_data_in_r[77:70],70'd0} : 	ch3_rx_data_in_r[77:0] ;	
assign  ch4_rx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? {ch4_rx_data_in_r[77:70],70'd0} : 	ch4_rx_data_in_r[77:0] ;	
assign  ch5_rx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? {ch5_rx_data_in_r[77:70],70'd0} : 	ch5_rx_data_in_r[77:0] ;
assign  ch6_rx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? {ch6_rx_data_in_r[77:70],70'd0} : 	ch6_rx_data_in_r[77:0] ;
assign  ch7_rx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? {ch7_rx_data_in_r[77:70],70'd0} : 	ch7_rx_data_in_r[77:0] ;	
assign  ch8_rx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? {ch8_rx_data_in_r[77:70],70'd0} : 	ch8_rx_data_in_r[77:0] ;
assign  ch9_rx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? {ch9_rx_data_in_r[77:70],70'd0} : 	ch9_rx_data_in_r[77:0] ;	
assign  ch12_rx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? {ch12_rx_data_in_r[77:70],70'd0} :    ch12_rx_data_in_r[77:0] ;	
assign  ch13_rx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? {ch13_rx_data_in_r[77:70],70'd0} :    ch13_rx_data_in_r[77:0] ;
assign  ch14_rx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? {ch14_rx_data_in_r[77:70],70'd0} :    ch14_rx_data_in_r[77:0] ;
assign  ch15_rx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? {ch15_rx_data_in_r[77:70],70'd0} :    ch15_rx_data_in_r[77:0] ;
assign  ch16_rx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? {ch16_rx_data_in_r[77:70],70'd0} :    ch16_rx_data_in_r[77:0] ;	
assign  ch18_rx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? {ch18_rx_data_in_r[77:70],70'd0} :    ch18_rx_data_in_r[77:0] ; 
assign  ch19_rx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? {ch19_rx_data_in_r[77:70],70'd0} :    ch19_rx_data_in_r[77:0] ; 
assign  ch20_rx_ecc_data_in 	= (core8_enable_ecc_hwtcl ==1'b0) ? {ch20_rx_data_in_r[77:70],70'd0} :    ch20_rx_data_in_r[77:0] ; 



// mux to enable or disable ECC
assign  ch2_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch2_rx_data_in_r[69:0]    :   o_rx_ecc_data[0*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //  ch2_rx_ecc0_data_out;						
assign  ch3_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch3_rx_data_in_r[69:0]    :   o_rx_ecc_data[1*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch3_rx_ecc0_data_out;	
assign  ch4_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch4_rx_data_in_r[69:0]    :   o_rx_ecc_data[2*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch4_rx_ecc0_data_out;	
assign  ch5_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch5_rx_data_in_r[69:0]    :   o_rx_ecc_data[3*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch5_rx_ecc0_data_out;
assign  ch6_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch6_rx_data_in_r[69:0]    :   o_rx_ecc_data[4*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch6_rx_ecc0_data_out;
assign  ch7_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch7_rx_data_in_r[69:0]    :   o_rx_ecc_data[5*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch7_rx_ecc0_data_out;	
assign  ch8_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch8_rx_data_in_r[69:0]    :   o_rx_ecc_data[6*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch8_rx_ecc0_data_out;
assign  ch9_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch9_rx_data_in_r[69:0]    :   o_rx_ecc_data[7*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch9_rx_ecc0_data_out;
assign  ch12_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch12_rx_data_in_r[69:0]   :   o_rx_ecc_data[8*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch12_rx_ecc0_data_out;	
assign  ch13_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ?    ch13_rx_data_in_r[69:0]   :   o_rx_ecc_data[9*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch13_rx_ecc0_data_out;	
assign  ch14_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ?    ch14_rx_data_in_r[69:0]   :   o_rx_ecc_data[10*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch14_rx_ecc0_data_out;
assign  ch15_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ?    ch15_rx_data_in_r[69:0]   :   o_rx_ecc_data[11*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch15_rx_ecc0_data_out;
assign  ch16_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ?    ch16_rx_data_in_r[69:0]   :   o_rx_ecc_data[12*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch16_rx_ecc0_data_out;
assign  ch18_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ?    ch18_rx_data_in_r[69:0]   :   o_rx_ecc_data[13*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch18_rx_ecc0_data_out;	
assign  ch19_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ?    ch19_rx_data_in_r[69:0]   :   o_rx_ecc_data[14*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch19_rx_ecc0_data_out;		
assign  ch20_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ?    ch20_rx_data_in_r[69:0]   :   o_rx_ecc_data[15*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch20_rx_ecc0_data_out;
 



// mux to enable or disable ECC
/* assign  ch2_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch2_rx_ecc_data_in[69:0]    :   o_rx_ecc_data[0*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //  ch2_rx_ecc0_data_out;						
assign  ch3_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch3_rx_ecc_data_in[69:0]    :   o_rx_ecc_data[1*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch3_rx_ecc0_data_out;	
assign  ch4_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch4_rx_ecc_data_in[69:0]    :   o_rx_ecc_data[2*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch4_rx_ecc0_data_out;	
assign  ch5_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch5_rx_ecc_data_in[69:0]    :   o_rx_ecc_data[3*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch5_rx_ecc0_data_out;
assign  ch6_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch6_rx_ecc_data_in[69:0]    :   o_rx_ecc_data[4*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch6_rx_ecc0_data_out;
assign  ch7_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch7_rx_ecc_data_in[69:0]    :   o_rx_ecc_data[5*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch7_rx_ecc0_data_out;	
assign  ch8_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch8_rx_ecc_data_in[69:0]    :   o_rx_ecc_data[6*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch8_rx_ecc0_data_out;
assign  ch9_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch9_rx_ecc_data_in[69:0]    :   o_rx_ecc_data[7*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch9_rx_ecc0_data_out;
assign  ch12_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ? 	ch12_rx_ecc_data_in[69:0]   :   o_rx_ecc_data[8*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch12_rx_ecc0_data_out;	
assign  ch13_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ?    ch13_rx_ecc_data_in[69:0]   :   o_rx_ecc_data[9*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch13_rx_ecc0_data_out;	
assign  ch14_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ?    ch14_rx_ecc_data_in[69:0]   :   o_rx_ecc_data[10*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch14_rx_ecc0_data_out;
assign  ch15_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ?    ch15_rx_ecc_data_in[69:0]   :   o_rx_ecc_data[11*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch15_rx_ecc0_data_out;
assign  ch16_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ?    ch16_rx_ecc_data_in[69:0]   :   o_rx_ecc_data[12*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch16_rx_ecc0_data_out;
assign  ch18_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ?    ch18_rx_ecc_data_in[69:0]   :   o_rx_ecc_data[13*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch18_rx_ecc0_data_out;	
assign  ch19_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ?    ch19_rx_ecc_data_in[69:0]   :   o_rx_ecc_data[14*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch19_rx_ecc0_data_out;		
assign  ch20_rx_ecc_data_out 	= (core8_enable_ecc_hwtcl ==1'b0) ?    ch20_rx_ecc_data_in[69:0]   :   o_rx_ecc_data[15*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch20_rx_ecc0_data_out;
 */
 
 
//mux to enable/disable deskew module
//localparam deskew_enable = 1'b1;
assign ch2_rx_data_out  =  (deskew_enable ==1'b1) ?  ch2_rx_dsk_data_out : {ch2_rx_ecc_data_in[77:70], ch2_rx_ecc_data_out[69:0]};
assign ch3_rx_data_out  =  (deskew_enable ==1'b1) ?  ch3_rx_dsk_data_out : {ch3_rx_ecc_data_in[77:70], ch3_rx_ecc_data_out[69:0]};
assign ch4_rx_data_out  =  (deskew_enable ==1'b1) ?  ch4_rx_dsk_data_out : {ch4_rx_ecc_data_in[77:70], ch4_rx_ecc_data_out[69:0]};
assign ch5_rx_data_out  =  (deskew_enable ==1'b1) ?  ch5_rx_dsk_data_out : {ch5_rx_ecc_data_in[77:70], ch5_rx_ecc_data_out[69:0]};
assign ch6_rx_data_out  =  (deskew_enable ==1'b1) ?  ch6_rx_dsk_data_out : {ch6_rx_ecc_data_in[77:70], ch6_rx_ecc_data_out[69:0]};
assign ch7_rx_data_out  =  (deskew_enable ==1'b1) ?  ch7_rx_dsk_data_out : {ch7_rx_ecc_data_in[77:70], ch7_rx_ecc_data_out[69:0]};
assign ch8_rx_data_out  =  (deskew_enable ==1'b1) ?  ch8_rx_dsk_data_out : {ch8_rx_ecc_data_in[77:70], ch8_rx_ecc_data_out[69:0]};
assign ch9_rx_data_out  =  (deskew_enable ==1'b1) ?  ch9_rx_dsk_data_out : {ch9_rx_ecc_data_in[77:70], ch9_rx_ecc_data_out[69:0]};
assign ch12_rx_data_out  =  (deskew_enable ==1'b1) ?  ch12_rx_dsk_data_out : {ch12_rx_ecc_data_in[77:70], ch12_rx_ecc_data_out[69:0]};
assign ch13_rx_data_out  =  (deskew_enable ==1'b1) ?  ch13_rx_dsk_data_out : {ch13_rx_ecc_data_in[77:70], ch13_rx_ecc_data_out[69:0]};
assign ch14_rx_data_out  =  (deskew_enable ==1'b1) ?  ch14_rx_dsk_data_out : {ch14_rx_ecc_data_in[77:70], ch14_rx_ecc_data_out[69:0]};
assign ch15_rx_data_out  =  (deskew_enable ==1'b1) ?  ch15_rx_dsk_data_out : {ch15_rx_ecc_data_in[77:70], ch15_rx_ecc_data_out[69:0]};
assign ch16_rx_data_out  =  (deskew_enable ==1'b1) ?  ch16_rx_dsk_data_out : {ch16_rx_ecc_data_in[77:70], ch16_rx_ecc_data_out[69:0]};
assign ch18_rx_data_out  =  (deskew_enable ==1'b1) ?  ch18_rx_dsk_data_out : {ch18_rx_ecc_data_in[77:70], ch18_rx_ecc_data_out[69:0]};
assign ch19_rx_data_out  =  (deskew_enable ==1'b1) ?  ch19_rx_dsk_data_out : {ch19_rx_ecc_data_in[77:70], ch19_rx_ecc_data_out[69:0]};
assign ch20_rx_data_out  =  (deskew_enable ==1'b1) ?  ch20_rx_dsk_data_out : {ch20_rx_ecc_data_in[77:70], ch20_rx_ecc_data_out[69:0]};






		   
`ifdef SIM_MODE

 
logic [NUM_CHAN-1:0][7:0] delay;
wire [77:0] ch2_rx_ecc_data_in_dly;
wire [77:0] ch3_rx_ecc_data_in_dly;
wire [77:0] ch4_rx_ecc_data_in_dly;
wire [77:0] ch5_rx_ecc_data_in_dly;
wire [77:0] ch6_rx_ecc_data_in_dly;
wire [77:0] ch7_rx_ecc_data_in_dly;
wire [77:0] ch8_rx_ecc_data_in_dly;
wire [77:0] ch9_rx_ecc_data_in_dly;
//wire [77:0] ch11_rx_ecc_data_in_dly;
wire [77:0] ch12_rx_ecc_data_in_dly;
wire [77:0] ch13_rx_ecc_data_in_dly;
wire [77:0] ch14_rx_ecc_data_in_dly;
wire [77:0] ch15_rx_ecc_data_in_dly;
wire [77:0] ch16_rx_ecc_data_in_dly;
wire [77:0] ch18_rx_ecc_data_in_dly;
wire [77:0] ch19_rx_ecc_data_in_dly;
wire [77:0] ch20_rx_ecc_data_in_dly;

wire [77:0] ch2_rx_ecc_data_out_dly;
wire [77:0] ch3_rx_ecc_data_out_dly;
wire [77:0] ch4_rx_ecc_data_out_dly;
wire [77:0] ch5_rx_ecc_data_out_dly;
wire [77:0] ch6_rx_ecc_data_out_dly;
wire [77:0] ch7_rx_ecc_data_out_dly;
wire [77:0] ch8_rx_ecc_data_out_dly;
wire [77:0] ch9_rx_ecc_data_out_dly;
//wire [77:0] ch11_rx_ecc_data_out_dly;
wire [77:0] ch12_rx_ecc_data_out_dly;
wire [77:0] ch13_rx_ecc_data_out_dly;
wire [77:0] ch14_rx_ecc_data_out_dly;
wire [77:0] ch15_rx_ecc_data_out_dly;
wire [77:0] ch16_rx_ecc_data_out_dly;
wire [77:0] ch18_rx_ecc_data_out_dly;
wire [77:0] ch19_rx_ecc_data_out_dly;
wire [77:0] ch20_rx_ecc_data_out_dly;

logic [NUM_CHAN*AIB_WIDTH-1:0] aib_data;
logic [NUM_CHAN*AIB_WIDTH-1:0] o_aib_data;
logic [NUM_CHAN-1:0] [AIB_WIDTH-1:0] data;
logic [NUM_CHAN-1:0] [AIB_WIDTH-1:0] q;



// Logic to generate SKEW. MAX_AIB_SKEW -- adds 5 skews in each channel. RANDOM_AIB_SKEW -- adds random skew ranging from 1,5 in each channel
always_comb begin : loop_for_number_of_aib_channels
		for(i = 0; i<NUM_CHAN; i=i+1) begin // loop for number of aib channels
		`ifdef MAX_AIB_SKEW
					  delay[i][7:0] = 5; // Whatever is max delay supported on rx path.
		`elsif RANDOM_AIB_SKEW
					  delay[i][7:0] = $urandom_range(1,5);
		`else 
					  delay[i][7:0] = 0;                                                                     
		`endif
		end
		end :loop_for_number_of_aib_channels
		
		



assign aib_data	 =  (	
							{//ch18_pld_rx_fabric_data_out[78:40],ch18_pld_rx_fabric_data_out[38:0], 
							{ch20_rx_ecc_data_in[77:70], ch20_rx_ecc_data_out[69:0]},
							{ch19_rx_ecc_data_in[77:70], ch19_rx_ecc_data_out[69:0]}, 
							{ch18_rx_ecc_data_in[77:70], ch18_rx_ecc_data_out[69:0]}, 
							{ch16_rx_ecc_data_in[77:70], ch16_rx_ecc_data_out[69:0]},
							{ch15_rx_ecc_data_in[77:70], ch15_rx_ecc_data_out[69:0]}, 
							{ch14_rx_ecc_data_in[77:70], ch14_rx_ecc_data_out[69:0]}, 
							{ch13_rx_ecc_data_in[77:70], ch13_rx_ecc_data_out[69:0]},
							{ch12_rx_ecc_data_in[77:70], ch12_rx_ecc_data_out[69:0]}, 
							//  ch10_pld_rx_fabric_data_out[78:40],ch10_pld_rx_fabric_data_out[38:0], 
							{ch9_rx_ecc_data_in[77:70], ch9_rx_ecc_data_out[69:0]}, 
							{ch8_rx_ecc_data_in[77:70], ch8_rx_ecc_data_out[69:0]},
							{ch7_rx_ecc_data_in[77:70], ch7_rx_ecc_data_out[69:0]},
							{ch6_rx_ecc_data_in[77:70], ch6_rx_ecc_data_out[69:0]}, 
							{ch5_rx_ecc_data_in[77:70], ch5_rx_ecc_data_out[69:0]},
							{ch4_rx_ecc_data_in[77:70], ch4_rx_ecc_data_out[69:0]}, 
							{ch3_rx_ecc_data_in[77:70], ch3_rx_ecc_data_out[69:0]}, 
							{ch2_rx_ecc_data_in[77:70], ch2_rx_ecc_data_out[69:0]}				}    
						);





//delay logic to add skew to the data path 
for(ww=0; ww<8; ww++) begin:delay_module_1
				
		assign  data[ww] = aib_data[ww*AIB_WIDTH+:AIB_WIDTH]	;	
		
				hip_aib_adaptor
				# (
					.DWIDTH (78)
				) inst_hip_aib_adaptor (

				   .delay 		(delay[ww]),
				   .clk			(i_clk),
				   .rst_n		(p0_reset),
				   .d			(data[ww]),
				   .q			(q[ww])

				);
			
		assign o_aib_data[ww*AIB_WIDTH+:AIB_WIDTH] = q[ww];
		
end:delay_module_1

for(ww=8; ww<16; ww++) begin:delay_module_2
				
		assign  data[ww] = aib_data[ww*AIB_WIDTH+:AIB_WIDTH]	;	
		
				hip_aib_adaptor
				# (
					.DWIDTH (78)
				) inst_hip_aib_adaptor (

				   .delay 		(delay[ww]),
				   .clk			(i_clk),
				   .rst_n		(p1_reset),
				   .d			(data[ww]),
				   .q			(q[ww])

				);
			
		assign o_aib_data[ww*AIB_WIDTH+:AIB_WIDTH] = q[ww];
		
end:delay_module_2
//endgenerate 



assign {	
		{//ch18_pld_rx_fabric_data_out[78:40],ch18_pld_rx_fabric_data_out[38:0], 
		{ch20_rx_ecc_data_out_dly[77:70], ch20_rx_ecc_data_out_dly[69:0]},
		{ch19_rx_ecc_data_out_dly[77:70], ch19_rx_ecc_data_out_dly[69:0]}, 
		{ch18_rx_ecc_data_out_dly[77:70], ch18_rx_ecc_data_out_dly[69:0]}, 
		{ch16_rx_ecc_data_out_dly[77:70], ch16_rx_ecc_data_out_dly[69:0]},
		{ch15_rx_ecc_data_out_dly[77:70], ch15_rx_ecc_data_out_dly[69:0]}, 
		{ch14_rx_ecc_data_out_dly[77:70], ch14_rx_ecc_data_out_dly[69:0]}, 
		{ch13_rx_ecc_data_out_dly[77:70], ch13_rx_ecc_data_out_dly[69:0]},
		{ch12_rx_ecc_data_out_dly[77:70], ch12_rx_ecc_data_out_dly[69:0]}, 
		//  ch10_pld_rx_fabric_data_out[78:40],ch10_pld_rx_fabric_data_out[38:0], 
		{ch9_rx_ecc_data_out_dly[77:70], ch9_rx_ecc_data_out_dly[69:0]}, 
		{ch8_rx_ecc_data_out_dly[77:70], ch8_rx_ecc_data_out_dly[69:0]},
		{ch7_rx_ecc_data_out_dly[77:70], ch7_rx_ecc_data_out_dly[69:0]},
		{ch6_rx_ecc_data_out_dly[77:70], ch6_rx_ecc_data_out_dly[69:0]}, 
		{ch5_rx_ecc_data_out_dly[77:70], ch5_rx_ecc_data_out_dly[69:0]},
		{ch4_rx_ecc_data_out_dly[77:70], ch4_rx_ecc_data_out_dly[69:0]}, 
		{ch3_rx_ecc_data_out_dly[77:70], ch3_rx_ecc_data_out_dly[69:0]}, 
		{ch2_rx_ecc_data_out_dly[77:70], ch2_rx_ecc_data_out_dly[69:0]}}    
		}   														=   o_aib_data;
		




		   whr_rx_deskew 
			#(
				.DEVICE_WIDTH 							   (DEVICE_WIDTH							  ),
				.PCIE_IP_MODE                              (PCIE_IP_MODE_EPX16                       ),
				.NUM_CHAN                                  (8                            			  ),
				.AIB_WIDTH                                 (78                                        ),
				.DSK_WIDTH                                 (77                                        ),
				.DSK_MARKER_POS                            (69                                        ),
				.DSK_DATA_PAR_WIDTH                        (64                                        ),
				.PARITY_SEG_WIDTH                          (8                                         ),
				.DIS_MONITOR                               (0                                         )
			) u_wrpcie_deskew_0_8_port0 (
									.pld_clk(i_clk),
									.pld_rst_n(p0_reset),
									.cfg_force_dsk_done_i(1'b0),
									//.cfg_k_device_width_i(8'hFF),
									.cfg_k_device_width_i(2'b00),
									.cfg_dsk_clr_i(1'b0),
						.aib_data_i({
									{ch9_rx_ecc_data_out_dly[77:70], ch9_rx_ecc_data_out_dly[69:0]},
									{ch8_rx_ecc_data_out_dly[77:70], ch8_rx_ecc_data_out_dly[69:0]}, 
									{ch7_rx_ecc_data_out_dly[77:70], ch7_rx_ecc_data_out_dly[69:0]},
									{ch6_rx_ecc_data_out_dly[77:70], ch6_rx_ecc_data_out_dly[69:0]},
									{ch5_rx_ecc_data_out_dly[77:70], ch5_rx_ecc_data_out_dly[69:0]},
									{ch4_rx_ecc_data_out_dly[77:70], ch4_rx_ecc_data_out_dly[69:0]},
									{ch3_rx_ecc_data_out_dly[77:70], ch3_rx_ecc_data_out_dly[69:0]},
									{ch2_rx_ecc_data_out_dly[77:70], ch2_rx_ecc_data_out_dly[69:0]}				}),
                      .aib_data_deskewed_o({
											{ch9_rx_dsk_data_out[77:70], ch9_rx_dsk_data_out[68:0]}, 
											{ch8_rx_dsk_data_out[77:70], ch8_rx_dsk_data_out[68:0]}, 
											{ch7_rx_dsk_data_out[77:70], ch7_rx_dsk_data_out[68:0]},
											{ch6_rx_dsk_data_out[77:70], ch6_rx_dsk_data_out[68:0]},
											{ch5_rx_dsk_data_out[77:70], ch5_rx_dsk_data_out[68:0]},
											{ch4_rx_dsk_data_out[77:70], ch4_rx_dsk_data_out[68:0]},
											{ch3_rx_dsk_data_out[77:70], ch3_rx_dsk_data_out[68:0]},
											{ch2_rx_dsk_data_out[77:70], ch2_rx_dsk_data_out[68:0]}				}),
                      .cfg_dsk_active_chans_o(),
                      .cfg_dsk_monitor_err_o(),
                      .cfg_dsk_mon_err_status_o(),
                      .fsr_dsk_mon_err_status_o(o_rx_dsk_mon_err_status_port0),
                      .fsr_dsk_status_o(o_rx_dsk_status_port0),
                      .fsr_dsk_vld_o(o_rx_dsk_done_port0),
					  .fsr_dsk_eval_done_o(o_rx_dsk_eval_done_port0));


		    whr_rx_deskew 
			#(
				.DEVICE_WIDTH 							   (DEVICE_WIDTH							  ),
				.PCIE_IP_MODE                              (PCIE_IP_MODE_EPX8                         ),
				.NUM_CHAN                                  (8                            			  ),
				.AIB_WIDTH                                 (78                                        ),
				.DSK_WIDTH                                 (77                                        ),
				.DSK_MARKER_POS                            (69                                        ),
				.DSK_DATA_PAR_WIDTH                        (64                                        ),
				.PARITY_SEG_WIDTH                          (8                                         ),
				.DIS_MONITOR                               (0                                         )
			) u_wrpcie_deskew_0_8_port1 (
									.pld_clk(i_clk),
									.pld_rst_n(p1_reset),
									.cfg_force_dsk_done_i(1'b0),
									//.i_cfg_dsk_chan_sel(8'hFF),
									.cfg_k_device_width_i(2'b00),
									.cfg_dsk_clr_i(1'b0),
						.aib_data_i({
									{ch20_rx_ecc_data_out_dly[77:70], ch20_rx_ecc_data_out_dly[69:0]}, 
									{ch19_rx_ecc_data_out_dly[77:70], ch19_rx_ecc_data_out_dly[69:0]}, 
									{ch18_rx_ecc_data_out_dly[77:70], ch18_rx_ecc_data_out_dly[69:0]},
									{ch16_rx_ecc_data_out_dly[77:70], ch16_rx_ecc_data_out_dly[69:0]},
									{ch15_rx_ecc_data_out_dly[77:70], ch15_rx_ecc_data_out_dly[69:0]},
									{ch14_rx_ecc_data_out_dly[77:70], ch14_rx_ecc_data_out_dly[69:0]},
									{ch13_rx_ecc_data_out_dly[77:70], ch13_rx_ecc_data_out_dly[69:0]},
									{ch12_rx_ecc_data_out_dly[77:70], ch12_rx_ecc_data_out_dly[69:0]}				}),
                      .aib_data_deskewed_o({
											{ch20_rx_dsk_data_out[77:70], ch20_rx_dsk_data_out[68:0]}, 
											{ch19_rx_dsk_data_out[77:70], ch19_rx_dsk_data_out[68:0]}, 
											{ch18_rx_dsk_data_out[77:70], ch18_rx_dsk_data_out[68:0]},
											{ch16_rx_dsk_data_out[77:70], ch16_rx_dsk_data_out[68:0]},
											{ch15_rx_dsk_data_out[77:70], ch15_rx_dsk_data_out[68:0]},
											{ch14_rx_dsk_data_out[77:70], ch14_rx_dsk_data_out[68:0]},
											{ch13_rx_dsk_data_out[77:70], ch13_rx_dsk_data_out[68:0]},
											{ch12_rx_dsk_data_out[77:70], ch12_rx_dsk_data_out[68:0]}				}),
                      .cfg_dsk_active_chans_o(),
                      .cfg_dsk_monitor_err_o(),
                      .cfg_dsk_mon_err_status_o(),
                      .fsr_dsk_mon_err_status_o(o_rx_dsk_mon_err_status_port1),
                      .fsr_dsk_status_o(o_rx_dsk_status_port1),
                      .fsr_dsk_vld_o(o_rx_dsk_done_port1),
					  .fsr_dsk_eval_done_o(o_rx_dsk_eval_done_port1));		
		

`else 


		
		   whr_rx_deskew 
			#(
				.DEVICE_WIDTH 							   (DEVICE_WIDTH							  ),
				.PCIE_IP_MODE                              (PCIE_IP_MODE_EPX16                       ),
				.NUM_CHAN                                  (8                            			  ),
				.AIB_WIDTH                                 (78                                        ),
				.DSK_WIDTH                                 (77                                        ),
				.DSK_MARKER_POS                            (69                                        ),
				.DSK_DATA_PAR_WIDTH                        (64                                        ),
				.PARITY_SEG_WIDTH                          (8                                         ),
				.DIS_MONITOR                               (0                                         )
			) u_wrpcie_deskew_0_8_port0 (
									.pld_clk(i_clk),
									.pld_rst_n(p0_reset),
									.cfg_force_dsk_done_i(1'b0),
									//.cfg_k_device_width_i(8'hFF),
									.cfg_k_device_width_i(2'b00),
									.cfg_dsk_clr_i(1'b0),
						.aib_data_i({
									{ch9_rx_ecc_data_in[77:70], ch9_rx_ecc_data_out[69:0]},
									{ch8_rx_ecc_data_in[77:70], ch8_rx_ecc_data_out[69:0]}, 
									{ch7_rx_ecc_data_in[77:70], ch7_rx_ecc_data_out[69:0]},
									{ch6_rx_ecc_data_in[77:70], ch6_rx_ecc_data_out[69:0]},
									{ch5_rx_ecc_data_in[77:70], ch5_rx_ecc_data_out[69:0]},
									{ch4_rx_ecc_data_in[77:70], ch4_rx_ecc_data_out[69:0]},
									{ch3_rx_ecc_data_in[77:70], ch3_rx_ecc_data_out[69:0]},
									{ch2_rx_ecc_data_in[77:70], ch2_rx_ecc_data_out[69:0]}				}),
                      .aib_data_deskewed_o({
											{ch9_rx_dsk_data_out[77:70], ch9_rx_dsk_data_out[68:0]}, 
											{ch8_rx_dsk_data_out[77:70], ch8_rx_dsk_data_out[68:0]}, 
											{ch7_rx_dsk_data_out[77:70], ch7_rx_dsk_data_out[68:0]},
											{ch6_rx_dsk_data_out[77:70], ch6_rx_dsk_data_out[68:0]},
											{ch5_rx_dsk_data_out[77:70], ch5_rx_dsk_data_out[68:0]},
											{ch4_rx_dsk_data_out[77:70], ch4_rx_dsk_data_out[68:0]},
											{ch3_rx_dsk_data_out[77:70], ch3_rx_dsk_data_out[68:0]},
											{ch2_rx_dsk_data_out[77:70], ch2_rx_dsk_data_out[68:0]}				}),
                      .cfg_dsk_active_chans_o(),
                      .cfg_dsk_monitor_err_o(),
                      .cfg_dsk_mon_err_status_o(),
                      .fsr_dsk_mon_err_status_o(o_rx_dsk_mon_err_status_port0),
                      .fsr_dsk_status_o(o_rx_dsk_status_port0),
                      .fsr_dsk_vld_o(o_rx_dsk_done_port0),
					  .fsr_dsk_eval_done_o(o_rx_dsk_eval_done_port0));


		    whr_rx_deskew 
			#(
				.DEVICE_WIDTH 							   (DEVICE_WIDTH							  ),
				.PCIE_IP_MODE                              (PCIE_IP_MODE_EPX8                         ),
				.NUM_CHAN                                  (8                            			  ),
				.AIB_WIDTH                                 (78                                        ),
				.DSK_WIDTH                                 (77                                        ),
				.DSK_MARKER_POS                            (69                                        ),
				.DSK_DATA_PAR_WIDTH                        (64                                        ),
				.PARITY_SEG_WIDTH                          (8                                         ),
				.DIS_MONITOR                               (0                                         )
			) u_wrpcie_deskew_0_8_port1 (
									.pld_clk(i_clk),
									.pld_rst_n(p1_reset),
									.cfg_force_dsk_done_i(1'b0),
									//.i_cfg_dsk_chan_sel(8'hFF),
									.cfg_k_device_width_i(2'b00),
									.cfg_dsk_clr_i(1'b0),
						.aib_data_i({
									{ch20_rx_ecc_data_in[77:70], ch20_rx_ecc_data_out[69:0]}, 
									{ch19_rx_ecc_data_in[77:70], ch19_rx_ecc_data_out[69:0]}, 
									{ch18_rx_ecc_data_in[77:70], ch18_rx_ecc_data_out[69:0]},
									{ch16_rx_ecc_data_in[77:70], ch16_rx_ecc_data_out[69:0]},
									{ch15_rx_ecc_data_in[77:70], ch15_rx_ecc_data_out[69:0]},
									{ch14_rx_ecc_data_in[77:70], ch14_rx_ecc_data_out[69:0]},
									{ch13_rx_ecc_data_in[77:70], ch13_rx_ecc_data_out[69:0]},
									{ch12_rx_ecc_data_in[77:70], ch12_rx_ecc_data_out[69:0]}				}),
                      .aib_data_deskewed_o({
											{ch20_rx_dsk_data_out[77:70], ch20_rx_dsk_data_out[68:0]}, 
											{ch19_rx_dsk_data_out[77:70], ch19_rx_dsk_data_out[68:0]}, 
											{ch18_rx_dsk_data_out[77:70], ch18_rx_dsk_data_out[68:0]},
											{ch16_rx_dsk_data_out[77:70], ch16_rx_dsk_data_out[68:0]},
											{ch15_rx_dsk_data_out[77:70], ch15_rx_dsk_data_out[68:0]},
											{ch14_rx_dsk_data_out[77:70], ch14_rx_dsk_data_out[68:0]},
											{ch13_rx_dsk_data_out[77:70], ch13_rx_dsk_data_out[68:0]},
											{ch12_rx_dsk_data_out[77:70], ch12_rx_dsk_data_out[68:0]}				}),
                      .cfg_dsk_active_chans_o(),
                      .cfg_dsk_monitor_err_o(),
                      .cfg_dsk_mon_err_status_o(),
                      .fsr_dsk_mon_err_status_o(o_rx_dsk_mon_err_status_port1),
                      .fsr_dsk_status_o(o_rx_dsk_status_port1),
                      .fsr_dsk_vld_o(o_rx_dsk_done_port1),
					  .fsr_dsk_eval_done_o(o_rx_dsk_eval_done_port1));


`endif // SIM_MODE


			assign ch2_rx_dsk_data_out[69]		= 1'b0;
			assign ch3_rx_dsk_data_out[69]		= 1'b0;
			assign ch4_rx_dsk_data_out[69]		= 1'b0;
			assign ch5_rx_dsk_data_out[69]		= 1'b0;
			assign ch6_rx_dsk_data_out[69]		= 1'b0;
			assign ch7_rx_dsk_data_out[69]		= 1'b0;
			assign ch8_rx_dsk_data_out[69]		= 1'b0;
			assign ch9_rx_dsk_data_out[69]		= 1'b0;
			assign ch12_rx_dsk_data_out[69]		= 1'b0;
			assign ch13_rx_dsk_data_out[69]		= 1'b0;
			assign ch14_rx_dsk_data_out[69]		= 1'b0;
			assign ch15_rx_dsk_data_out[69]		= 1'b0;
			assign ch16_rx_dsk_data_out[69]		= 1'b0;
			assign ch18_rx_dsk_data_out[69]		= 1'b0;
			assign ch19_rx_dsk_data_out[69]		= 1'b0;
			assign ch20_rx_dsk_data_out[69]		= 1'b0;			
			
		
// Logic to generate Marker bit to be sent on the TX datapath
		whr_tx_deskew  #(
				.NUM_CHAN     ( 7 	)
								) u_tx_deskew_0_8_port0 (
			.pld_clk         (i_clk                          ),
			.pld_rst_n       (p0_reset                        ),

		    .rx_dsk_marker_o (tx_dsk_marker_port0[6:0]       ));

			whr_tx_deskew  #(
				.NUM_CHAN     ( 7 	)
								) u_tx_deskew_0_8_port1 (
			.pld_clk         (i_clk                          ),
			.pld_rst_n       (p1_reset                        ),

		    .rx_dsk_marker_o (tx_dsk_marker_port1[6:0]       ));
			
			assign tx_dsk_marker_port0[13:7] = 7'b1111111;
					  



							
			//assign ch2_rx_data_in[79] = s0_16_1__core_periphery__data_to_core[70];
			assign ch2_rx_data_in[77] = s0_16_1__core_periphery__data_to_core[100];
			assign ch2_rx_data_in[76] = s0_16_1__core_periphery__data_to_core[102];
			assign ch2_rx_data_in[75] = s0_16_1__core_periphery__data_to_core[72];
			assign ch2_rx_data_in[74] = s0_16_1__core_periphery__data_to_core[74];
			assign ch2_rx_data_in[73] = s0_16_1__core_periphery__data_to_core[75];
			assign ch2_rx_data_in[72] = s0_16_1__core_periphery__data_to_core[104];
			assign ch2_rx_data_in[71] = s0_16_1__core_periphery__data_to_core[105];
			assign ch2_rx_data_in[70] = s0_16_1__core_periphery__data_to_core[107];
			assign ch2_rx_data_in[69] = s0_16_1__core_periphery__data_to_core[77];
			assign ch2_rx_data_in[68] = s0_16_1__core_periphery__data_to_core[78];
			assign ch2_rx_data_in[67] = s0_16_1__core_periphery__data_to_core[79];
			assign ch2_rx_data_in[66] = s0_15_1__core_periphery__data_to_core[26];
			assign ch2_rx_data_in[65] = s0_15_1__core_periphery__data_to_core[24];
			assign ch2_rx_data_in[64] = s0_15_1__core_periphery__data_to_core[3];
			assign ch2_rx_data_in[63] = s0_15_1__core_periphery__data_to_core[2];
			assign ch2_rx_data_in[62] = s0_15_1__core_periphery__data_to_core[1];
			assign ch2_rx_data_in[61] = s0_15_1__core_periphery__data_to_core[31];
			assign ch2_rx_data_in[60] = s0_15_1__core_periphery__data_to_core[30];
			assign ch2_rx_data_in[59] = s0_15_1__core_periphery__data_to_core[28];
			assign ch2_rx_data_in[58] = s0_15_1__core_periphery__data_to_core[7];
			assign ch2_rx_data_in[57] = s0_15_1__core_periphery__data_to_core[5];
			assign ch2_rx_data_in[56] = s0_15_1__core_periphery__data_to_core[35];
			assign ch2_rx_data_in[55] = s0_15_1__core_periphery__data_to_core[33];
			assign ch2_rx_data_in[54] = s0_15_1__core_periphery__data_to_core[11];
			assign ch2_rx_data_in[53] = s0_15_1__core_periphery__data_to_core[10];
			assign ch2_rx_data_in[52] = s0_15_1__core_periphery__data_to_core[9];
			assign ch2_rx_data_in[51] = s0_15_1__core_periphery__data_to_core[8];
			assign ch2_rx_data_in[50] = s0_15_1__core_periphery__data_to_core[38];
			assign ch2_rx_data_in[49] = s0_15_1__core_periphery__data_to_core[36];
			assign ch2_rx_data_in[48] = s0_15_1__core_periphery__data_to_core[15];
			assign ch2_rx_data_in[47] = s0_15_1__core_periphery__data_to_core[14];
			assign ch2_rx_data_in[46] = s0_15_1__core_periphery__data_to_core[13];
			assign ch2_rx_data_in[45] = s0_15_1__core_periphery__data_to_core[43];
			assign ch2_rx_data_in[44] = s0_15_1__core_periphery__data_to_core[42];
			assign ch2_rx_data_in[43] = s0_15_1__core_periphery__data_to_core[40];
			assign ch2_rx_data_in[42] = s0_15_1__core_periphery__data_to_core[19];
			assign ch2_rx_data_in[41] = s0_15_1__core_periphery__data_to_core[17];
			assign ch2_rx_data_in[40] = s0_15_1__core_periphery__data_to_core[47];
			assign ch2_rx_data_in[39] = s0_15_1__core_periphery__data_to_core[45];
			//assign ch2_rx_data_in[39] = s0_15_1__core_periphery__data_to_core[23];
			assign ch2_rx_data_in[38] = s0_15_1__core_periphery__data_to_core[22];
			assign ch2_rx_data_in[37] = s0_15_1__core_periphery__data_to_core[20];
			assign ch2_rx_data_in[36] = s0_15_1__core_periphery__data_to_core[51];
			assign ch2_rx_data_in[35] = s0_15_1__core_periphery__data_to_core[49];
			assign ch2_rx_data_in[34] = s0_15_1__core_periphery__data_to_core[80];
			assign ch2_rx_data_in[33] = s0_15_1__core_periphery__data_to_core[82];
			assign ch2_rx_data_in[32] = s0_15_1__core_periphery__data_to_core[52];
			assign ch2_rx_data_in[31] = s0_15_1__core_periphery__data_to_core[54];
			assign ch2_rx_data_in[30] = s0_15_1__core_periphery__data_to_core[55];
			assign ch2_rx_data_in[29] = s0_15_1__core_periphery__data_to_core[84];
			assign ch2_rx_data_in[28] = s0_15_1__core_periphery__data_to_core[86];
			assign ch2_rx_data_in[27] = s0_15_1__core_periphery__data_to_core[87];
			assign ch2_rx_data_in[26] = s0_15_1__core_periphery__data_to_core[57];
			assign ch2_rx_data_in[25] = s0_15_1__core_periphery__data_to_core[58];
			assign ch2_rx_data_in[24] = s0_15_1__core_periphery__data_to_core[88];
			assign ch2_rx_data_in[23] = s0_15_1__core_periphery__data_to_core[90];
			assign ch2_rx_data_in[22] = s0_15_1__core_periphery__data_to_core[60];
			assign ch2_rx_data_in[21] = s0_15_1__core_periphery__data_to_core[62];
			assign ch2_rx_data_in[20] = s0_15_1__core_periphery__data_to_core[63];
			assign ch2_rx_data_in[19] = s0_15_1__core_periphery__data_to_core[92];
			assign ch2_rx_data_in[18] = s0_15_1__core_periphery__data_to_core[93];
			assign ch2_rx_data_in[17] = s0_15_1__core_periphery__data_to_core[95];
			assign ch2_rx_data_in[16] = s0_15_1__core_periphery__data_to_core[65];
			assign ch2_rx_data_in[15] = s0_15_1__core_periphery__data_to_core[66];
			assign ch2_rx_data_in[14] = s0_15_1__core_periphery__data_to_core[67];
			assign ch2_rx_data_in[13] = s0_15_1__core_periphery__data_to_core[96];
			assign ch2_rx_data_in[12] = s0_15_1__core_periphery__data_to_core[98];
			assign ch2_rx_data_in[11] = s0_15_1__core_periphery__data_to_core[99];
			assign ch2_rx_data_in[10] = s0_15_1__core_periphery__data_to_core[69];
			assign ch2_rx_data_in[9] = s0_15_1__core_periphery__data_to_core[70];
			assign ch2_rx_data_in[8] = s0_15_1__core_periphery__data_to_core[100];
			assign ch2_rx_data_in[7] = s0_15_1__core_periphery__data_to_core[102];
			assign ch2_rx_data_in[6] = s0_15_1__core_periphery__data_to_core[72];
			assign ch2_rx_data_in[5] = s0_15_1__core_periphery__data_to_core[74];
			assign ch2_rx_data_in[4] = s0_15_1__core_periphery__data_to_core[75];
			assign ch2_rx_data_in[3] = s0_15_1__core_periphery__data_to_core[104];
			assign ch2_rx_data_in[2] = s0_15_1__core_periphery__data_to_core[105];
			assign ch2_rx_data_in[1] = s0_15_1__core_periphery__data_to_core[107];
			assign ch2_rx_data_in[0] = s0_15_1__core_periphery__data_to_core[77];

			//channel 3

			//assign ch3_rx_data_in[79] = s0_23_1__core_periphery__data_to_core[70];
			assign ch3_rx_data_in[77] = s0_23_1__core_periphery__data_to_core[100];
			assign ch3_rx_data_in[76] = s0_23_1__core_periphery__data_to_core[102];
			assign ch3_rx_data_in[75] = s0_23_1__core_periphery__data_to_core[72];
			assign ch3_rx_data_in[74] = s0_23_1__core_periphery__data_to_core[74];
			assign ch3_rx_data_in[73] = s0_23_1__core_periphery__data_to_core[75];
			assign ch3_rx_data_in[72] = s0_23_1__core_periphery__data_to_core[104];
			assign ch3_rx_data_in[71] = s0_23_1__core_periphery__data_to_core[105];
			assign ch3_rx_data_in[70] = s0_23_1__core_periphery__data_to_core[107];
			assign ch3_rx_data_in[69] = s0_23_1__core_periphery__data_to_core[77];
			assign ch3_rx_data_in[68] = s0_23_1__core_periphery__data_to_core[78];
			assign ch3_rx_data_in[67] = s0_23_1__core_periphery__data_to_core[79];
			assign ch3_rx_data_in[66] = s0_22_1__core_periphery__data_to_core[26];
			assign ch3_rx_data_in[65] = s0_22_1__core_periphery__data_to_core[24];
			assign ch3_rx_data_in[64] = s0_22_1__core_periphery__data_to_core[3];
			assign ch3_rx_data_in[63] = s0_22_1__core_periphery__data_to_core[2];
			assign ch3_rx_data_in[62] = s0_22_1__core_periphery__data_to_core[1];
			assign ch3_rx_data_in[61] = s0_22_1__core_periphery__data_to_core[31];
			assign ch3_rx_data_in[60] = s0_22_1__core_periphery__data_to_core[30];
			assign ch3_rx_data_in[59] = s0_22_1__core_periphery__data_to_core[28];
			assign ch3_rx_data_in[58] = s0_22_1__core_periphery__data_to_core[7];
			assign ch3_rx_data_in[57] = s0_22_1__core_periphery__data_to_core[5];
			assign ch3_rx_data_in[56] = s0_22_1__core_periphery__data_to_core[35];
			assign ch3_rx_data_in[55] = s0_22_1__core_periphery__data_to_core[33];
			assign ch3_rx_data_in[54] = s0_22_1__core_periphery__data_to_core[11];
			assign ch3_rx_data_in[53] = s0_22_1__core_periphery__data_to_core[10];
			assign ch3_rx_data_in[52] = s0_22_1__core_periphery__data_to_core[9];
			assign ch3_rx_data_in[51] = s0_22_1__core_periphery__data_to_core[8];
			assign ch3_rx_data_in[50] = s0_22_1__core_periphery__data_to_core[38];
			assign ch3_rx_data_in[49] = s0_22_1__core_periphery__data_to_core[36];
			assign ch3_rx_data_in[48] = s0_22_1__core_periphery__data_to_core[15];
			assign ch3_rx_data_in[47] = s0_22_1__core_periphery__data_to_core[14];
			assign ch3_rx_data_in[46] = s0_22_1__core_periphery__data_to_core[13];
			assign ch3_rx_data_in[45] = s0_22_1__core_periphery__data_to_core[43];
			assign ch3_rx_data_in[44] = s0_22_1__core_periphery__data_to_core[42];
			assign ch3_rx_data_in[43] = s0_22_1__core_periphery__data_to_core[40];
			assign ch3_rx_data_in[42] = s0_22_1__core_periphery__data_to_core[19];
			assign ch3_rx_data_in[41] = s0_22_1__core_periphery__data_to_core[17];
			assign ch3_rx_data_in[40] = s0_22_1__core_periphery__data_to_core[47];
			assign ch3_rx_data_in[39] = s0_22_1__core_periphery__data_to_core[45];
			//assign ch3_rx_data_in[39] = s0_22_1__core_periphery__data_to_core[23];
			assign ch3_rx_data_in[38] = s0_22_1__core_periphery__data_to_core[22];
			assign ch3_rx_data_in[37] = s0_22_1__core_periphery__data_to_core[20];
			assign ch3_rx_data_in[36] = s0_22_1__core_periphery__data_to_core[51];
			assign ch3_rx_data_in[35] = s0_22_1__core_periphery__data_to_core[49];
			assign ch3_rx_data_in[34] = s0_22_1__core_periphery__data_to_core[80];
			assign ch3_rx_data_in[33] = s0_22_1__core_periphery__data_to_core[82];
			assign ch3_rx_data_in[32] = s0_22_1__core_periphery__data_to_core[52];
			assign ch3_rx_data_in[31] = s0_22_1__core_periphery__data_to_core[54];
			assign ch3_rx_data_in[30] = s0_22_1__core_periphery__data_to_core[55];
			assign ch3_rx_data_in[29] = s0_22_1__core_periphery__data_to_core[84];
			assign ch3_rx_data_in[28] = s0_22_1__core_periphery__data_to_core[86];
			assign ch3_rx_data_in[27] = s0_22_1__core_periphery__data_to_core[87];
			assign ch3_rx_data_in[26] = s0_22_1__core_periphery__data_to_core[57];
			assign ch3_rx_data_in[25] = s0_22_1__core_periphery__data_to_core[58];
			assign ch3_rx_data_in[24] = s0_22_1__core_periphery__data_to_core[88];
			assign ch3_rx_data_in[23] = s0_22_1__core_periphery__data_to_core[90];
			assign ch3_rx_data_in[22] = s0_22_1__core_periphery__data_to_core[60];
			assign ch3_rx_data_in[21] = s0_22_1__core_periphery__data_to_core[62];
			assign ch3_rx_data_in[20] = s0_22_1__core_periphery__data_to_core[63];
			assign ch3_rx_data_in[19] = s0_22_1__core_periphery__data_to_core[92];
			assign ch3_rx_data_in[18] = s0_22_1__core_periphery__data_to_core[93];
			assign ch3_rx_data_in[17] = s0_22_1__core_periphery__data_to_core[95];
			assign ch3_rx_data_in[16] = s0_22_1__core_periphery__data_to_core[65];
			assign ch3_rx_data_in[15] = s0_22_1__core_periphery__data_to_core[66];
			assign ch3_rx_data_in[14] = s0_22_1__core_periphery__data_to_core[67];
			assign ch3_rx_data_in[13] = s0_22_1__core_periphery__data_to_core[96];
			assign ch3_rx_data_in[12] = s0_22_1__core_periphery__data_to_core[98];
			assign ch3_rx_data_in[11] = s0_22_1__core_periphery__data_to_core[99];
			assign ch3_rx_data_in[10] = s0_22_1__core_periphery__data_to_core[69];
			assign ch3_rx_data_in[9] = s0_22_1__core_periphery__data_to_core[70];
			assign ch3_rx_data_in[8] = s0_22_1__core_periphery__data_to_core[100];
			assign ch3_rx_data_in[7] = s0_22_1__core_periphery__data_to_core[102];
			assign ch3_rx_data_in[6] = s0_22_1__core_periphery__data_to_core[72];
			assign ch3_rx_data_in[5] = s0_22_1__core_periphery__data_to_core[74];
			assign ch3_rx_data_in[4] = s0_22_1__core_periphery__data_to_core[75];
			assign ch3_rx_data_in[3] = s0_22_1__core_periphery__data_to_core[104];
			assign ch3_rx_data_in[2] = s0_22_1__core_periphery__data_to_core[105];
			assign ch3_rx_data_in[1] = s0_22_1__core_periphery__data_to_core[107];
			assign ch3_rx_data_in[0] = s0_22_1__core_periphery__data_to_core[77];

			//channel 4

			//assign ch4_rx_data_in[79] = s0_29_1__core_periphery__data_to_core[70];
			assign ch4_rx_data_in[77] = s0_29_1__core_periphery__data_to_core[100];
			assign ch4_rx_data_in[76] = s0_29_1__core_periphery__data_to_core[102];
			assign ch4_rx_data_in[75] = s0_29_1__core_periphery__data_to_core[72];
			assign ch4_rx_data_in[74] = s0_29_1__core_periphery__data_to_core[74];
			assign ch4_rx_data_in[73] = s0_29_1__core_periphery__data_to_core[75];
			assign ch4_rx_data_in[72] = s0_29_1__core_periphery__data_to_core[104];
			assign ch4_rx_data_in[71] = s0_29_1__core_periphery__data_to_core[105];
			assign ch4_rx_data_in[70] = s0_29_1__core_periphery__data_to_core[107];
			assign ch4_rx_data_in[69] = s0_29_1__core_periphery__data_to_core[77];
			assign ch4_rx_data_in[68] = s0_29_1__core_periphery__data_to_core[78];
			assign ch4_rx_data_in[67] = s0_29_1__core_periphery__data_to_core[79];
			assign ch4_rx_data_in[66] = s0_28_1__core_periphery__data_to_core[26];
			assign ch4_rx_data_in[65] = s0_28_1__core_periphery__data_to_core[24];
			assign ch4_rx_data_in[64] = s0_28_1__core_periphery__data_to_core[3];
			assign ch4_rx_data_in[63] = s0_28_1__core_periphery__data_to_core[2];
			assign ch4_rx_data_in[62] = s0_28_1__core_periphery__data_to_core[1];
			assign ch4_rx_data_in[61] = s0_28_1__core_periphery__data_to_core[31];
			assign ch4_rx_data_in[60] = s0_28_1__core_periphery__data_to_core[30];
			assign ch4_rx_data_in[59] = s0_28_1__core_periphery__data_to_core[28];
			assign ch4_rx_data_in[58] = s0_28_1__core_periphery__data_to_core[7];
			assign ch4_rx_data_in[57] = s0_28_1__core_periphery__data_to_core[5];
			assign ch4_rx_data_in[56] = s0_28_1__core_periphery__data_to_core[35];
			assign ch4_rx_data_in[55] = s0_28_1__core_periphery__data_to_core[33];
			assign ch4_rx_data_in[54] = s0_28_1__core_periphery__data_to_core[11];
			assign ch4_rx_data_in[53] = s0_28_1__core_periphery__data_to_core[10];
			assign ch4_rx_data_in[52] = s0_28_1__core_periphery__data_to_core[9];
			assign ch4_rx_data_in[51] = s0_28_1__core_periphery__data_to_core[8];
			assign ch4_rx_data_in[50] = s0_28_1__core_periphery__data_to_core[38];
			assign ch4_rx_data_in[49] = s0_28_1__core_periphery__data_to_core[36];
			assign ch4_rx_data_in[48] = s0_28_1__core_periphery__data_to_core[15];
			assign ch4_rx_data_in[47] = s0_28_1__core_periphery__data_to_core[14];
			assign ch4_rx_data_in[46] = s0_28_1__core_periphery__data_to_core[13];
			assign ch4_rx_data_in[45] = s0_28_1__core_periphery__data_to_core[43];
			assign ch4_rx_data_in[44] = s0_28_1__core_periphery__data_to_core[42];
			assign ch4_rx_data_in[43] = s0_28_1__core_periphery__data_to_core[40];
			assign ch4_rx_data_in[42] = s0_28_1__core_periphery__data_to_core[19];
			assign ch4_rx_data_in[41] = s0_28_1__core_periphery__data_to_core[17];
			assign ch4_rx_data_in[40] = s0_28_1__core_periphery__data_to_core[47];
			assign ch4_rx_data_in[39] = s0_28_1__core_periphery__data_to_core[45];
			//assign ch4_rx_data_in[39] = s0_28_1__core_periphery__data_to_core[23];
			assign ch4_rx_data_in[38] = s0_28_1__core_periphery__data_to_core[22];
			assign ch4_rx_data_in[37] = s0_28_1__core_periphery__data_to_core[20];
			assign ch4_rx_data_in[36] = s0_28_1__core_periphery__data_to_core[51];
			assign ch4_rx_data_in[35] = s0_28_1__core_periphery__data_to_core[49];
			assign ch4_rx_data_in[34] = s0_28_1__core_periphery__data_to_core[80];
			assign ch4_rx_data_in[33] = s0_28_1__core_periphery__data_to_core[82];
			assign ch4_rx_data_in[32] = s0_28_1__core_periphery__data_to_core[52];
			assign ch4_rx_data_in[31] = s0_28_1__core_periphery__data_to_core[54];
			assign ch4_rx_data_in[30] = s0_28_1__core_periphery__data_to_core[55];
			assign ch4_rx_data_in[29] = s0_28_1__core_periphery__data_to_core[84];
			assign ch4_rx_data_in[28] = s0_28_1__core_periphery__data_to_core[86];
			assign ch4_rx_data_in[27] = s0_28_1__core_periphery__data_to_core[87];
			assign ch4_rx_data_in[26] = s0_28_1__core_periphery__data_to_core[57];
			assign ch4_rx_data_in[25] = s0_28_1__core_periphery__data_to_core[58];
			assign ch4_rx_data_in[24] = s0_28_1__core_periphery__data_to_core[88];
			assign ch4_rx_data_in[23] = s0_28_1__core_periphery__data_to_core[90];
			assign ch4_rx_data_in[22] = s0_28_1__core_periphery__data_to_core[60];
			assign ch4_rx_data_in[21] = s0_28_1__core_periphery__data_to_core[62];
			assign ch4_rx_data_in[20] = s0_28_1__core_periphery__data_to_core[63];
			assign ch4_rx_data_in[19] = s0_28_1__core_periphery__data_to_core[92];
			assign ch4_rx_data_in[18] = s0_28_1__core_periphery__data_to_core[93];
			assign ch4_rx_data_in[17] = s0_28_1__core_periphery__data_to_core[95];
			assign ch4_rx_data_in[16] = s0_28_1__core_periphery__data_to_core[65];
			assign ch4_rx_data_in[15] = s0_28_1__core_periphery__data_to_core[66];
			assign ch4_rx_data_in[14] = s0_28_1__core_periphery__data_to_core[67];
			assign ch4_rx_data_in[13] = s0_28_1__core_periphery__data_to_core[96];
			assign ch4_rx_data_in[12] = s0_28_1__core_periphery__data_to_core[98];
			assign ch4_rx_data_in[11] = s0_28_1__core_periphery__data_to_core[99];
			assign ch4_rx_data_in[10] = s0_28_1__core_periphery__data_to_core[69];
			assign ch4_rx_data_in[9] = s0_28_1__core_periphery__data_to_core[70];
			assign ch4_rx_data_in[8] = s0_28_1__core_periphery__data_to_core[100];
			assign ch4_rx_data_in[7] = s0_28_1__core_periphery__data_to_core[102];
			assign ch4_rx_data_in[6] = s0_28_1__core_periphery__data_to_core[72];
			assign ch4_rx_data_in[5] = s0_28_1__core_periphery__data_to_core[74];
			assign ch4_rx_data_in[4] = s0_28_1__core_periphery__data_to_core[75];
			assign ch4_rx_data_in[3] = s0_28_1__core_periphery__data_to_core[104];
			assign ch4_rx_data_in[2] = s0_28_1__core_periphery__data_to_core[105];
			assign ch4_rx_data_in[1] = s0_28_1__core_periphery__data_to_core[107];
			assign ch4_rx_data_in[0] = s0_28_1__core_periphery__data_to_core[77];

			//channel 5

			//assign ch5_rx_data_in[79] = s0_35_1__core_periphery__data_to_core[70];
			assign ch5_rx_data_in[77] = s0_35_1__core_periphery__data_to_core[100];
			assign ch5_rx_data_in[76] = s0_35_1__core_periphery__data_to_core[102];
			assign ch5_rx_data_in[75] = s0_35_1__core_periphery__data_to_core[72];
			assign ch5_rx_data_in[74] = s0_35_1__core_periphery__data_to_core[74];
			assign ch5_rx_data_in[73] = s0_35_1__core_periphery__data_to_core[75];
			assign ch5_rx_data_in[72] = s0_35_1__core_periphery__data_to_core[104];
			assign ch5_rx_data_in[71] = s0_35_1__core_periphery__data_to_core[105];
			assign ch5_rx_data_in[70] = s0_35_1__core_periphery__data_to_core[107];
			assign ch5_rx_data_in[69] = s0_35_1__core_periphery__data_to_core[77];
			assign ch5_rx_data_in[68] = s0_35_1__core_periphery__data_to_core[78];
			assign ch5_rx_data_in[67] = s0_35_1__core_periphery__data_to_core[79];
			assign ch5_rx_data_in[66] = s0_34_1__core_periphery__data_to_core[26];
			assign ch5_rx_data_in[65] = s0_34_1__core_periphery__data_to_core[24];
			assign ch5_rx_data_in[64] = s0_34_1__core_periphery__data_to_core[3];
			assign ch5_rx_data_in[63] = s0_34_1__core_periphery__data_to_core[2];
			assign ch5_rx_data_in[62] = s0_34_1__core_periphery__data_to_core[1];
			assign ch5_rx_data_in[61] = s0_34_1__core_periphery__data_to_core[31];
			assign ch5_rx_data_in[60] = s0_34_1__core_periphery__data_to_core[30];
			assign ch5_rx_data_in[59] = s0_34_1__core_periphery__data_to_core[28];
			assign ch5_rx_data_in[58] = s0_34_1__core_periphery__data_to_core[7];
			assign ch5_rx_data_in[57] = s0_34_1__core_periphery__data_to_core[5];
			assign ch5_rx_data_in[56] = s0_34_1__core_periphery__data_to_core[35];
			assign ch5_rx_data_in[55] = s0_34_1__core_periphery__data_to_core[33];
			assign ch5_rx_data_in[54] = s0_34_1__core_periphery__data_to_core[11];
			assign ch5_rx_data_in[53] = s0_34_1__core_periphery__data_to_core[10];
			assign ch5_rx_data_in[52] = s0_34_1__core_periphery__data_to_core[9];
			assign ch5_rx_data_in[51] = s0_34_1__core_periphery__data_to_core[8];
			assign ch5_rx_data_in[50] = s0_34_1__core_periphery__data_to_core[38];
			assign ch5_rx_data_in[49] = s0_34_1__core_periphery__data_to_core[36];
			assign ch5_rx_data_in[48] = s0_34_1__core_periphery__data_to_core[15];
			assign ch5_rx_data_in[47] = s0_34_1__core_periphery__data_to_core[14];
			assign ch5_rx_data_in[46] = s0_34_1__core_periphery__data_to_core[13];
			assign ch5_rx_data_in[45] = s0_34_1__core_periphery__data_to_core[43];
			assign ch5_rx_data_in[44] = s0_34_1__core_periphery__data_to_core[42];
			assign ch5_rx_data_in[43] = s0_34_1__core_periphery__data_to_core[40];
			assign ch5_rx_data_in[42] = s0_34_1__core_periphery__data_to_core[19];
			assign ch5_rx_data_in[41] = s0_34_1__core_periphery__data_to_core[17];
			assign ch5_rx_data_in[40] = s0_34_1__core_periphery__data_to_core[47];
			assign ch5_rx_data_in[39] = s0_34_1__core_periphery__data_to_core[45];
			//assign ch5_rx_data_in[39] = s0_34_1__core_periphery__data_to_core[23];
			assign ch5_rx_data_in[38] = s0_34_1__core_periphery__data_to_core[22];
			assign ch5_rx_data_in[37] = s0_34_1__core_periphery__data_to_core[20];
			assign ch5_rx_data_in[36] = s0_34_1__core_periphery__data_to_core[51];
			assign ch5_rx_data_in[35] = s0_34_1__core_periphery__data_to_core[49];
			assign ch5_rx_data_in[34] = s0_34_1__core_periphery__data_to_core[80];
			assign ch5_rx_data_in[33] = s0_34_1__core_periphery__data_to_core[82];
			assign ch5_rx_data_in[32] = s0_34_1__core_periphery__data_to_core[52];
			assign ch5_rx_data_in[31] = s0_34_1__core_periphery__data_to_core[54];
			assign ch5_rx_data_in[30] = s0_34_1__core_periphery__data_to_core[55];
			assign ch5_rx_data_in[29] = s0_34_1__core_periphery__data_to_core[84];
			assign ch5_rx_data_in[28] = s0_34_1__core_periphery__data_to_core[86];
			assign ch5_rx_data_in[27] = s0_34_1__core_periphery__data_to_core[87];
			assign ch5_rx_data_in[26] = s0_34_1__core_periphery__data_to_core[57];
			assign ch5_rx_data_in[25] = s0_34_1__core_periphery__data_to_core[58];
			assign ch5_rx_data_in[24] = s0_34_1__core_periphery__data_to_core[88];
			assign ch5_rx_data_in[23] = s0_34_1__core_periphery__data_to_core[90];
			assign ch5_rx_data_in[22] = s0_34_1__core_periphery__data_to_core[60];
			assign ch5_rx_data_in[21] = s0_34_1__core_periphery__data_to_core[62];
			assign ch5_rx_data_in[20] = s0_34_1__core_periphery__data_to_core[63];
			assign ch5_rx_data_in[19] = s0_34_1__core_periphery__data_to_core[92];
			assign ch5_rx_data_in[18] = s0_34_1__core_periphery__data_to_core[93];
			assign ch5_rx_data_in[17] = s0_34_1__core_periphery__data_to_core[95];
			assign ch5_rx_data_in[16] = s0_34_1__core_periphery__data_to_core[65];
			assign ch5_rx_data_in[15] = s0_34_1__core_periphery__data_to_core[66];
			assign ch5_rx_data_in[14] = s0_34_1__core_periphery__data_to_core[67];
			assign ch5_rx_data_in[13] = s0_34_1__core_periphery__data_to_core[96];
			assign ch5_rx_data_in[12] = s0_34_1__core_periphery__data_to_core[98];
			assign ch5_rx_data_in[11] = s0_34_1__core_periphery__data_to_core[99];
			assign ch5_rx_data_in[10] = s0_34_1__core_periphery__data_to_core[69];
			assign ch5_rx_data_in[9] = s0_34_1__core_periphery__data_to_core[70];
			assign ch5_rx_data_in[8] = s0_34_1__core_periphery__data_to_core[100];
			assign ch5_rx_data_in[7] = s0_34_1__core_periphery__data_to_core[102];
			assign ch5_rx_data_in[6] = s0_34_1__core_periphery__data_to_core[72];
			assign ch5_rx_data_in[5] = s0_34_1__core_periphery__data_to_core[74];
			assign ch5_rx_data_in[4] = s0_34_1__core_periphery__data_to_core[75];
			assign ch5_rx_data_in[3] = s0_34_1__core_periphery__data_to_core[104];
			assign ch5_rx_data_in[2] = s0_34_1__core_periphery__data_to_core[105];
			assign ch5_rx_data_in[1] = s0_34_1__core_periphery__data_to_core[107];
			assign ch5_rx_data_in[0] = s0_34_1__core_periphery__data_to_core[77];


			//channel 6

			//assign ch6_rx_data_in[79] = s0_44_1__core_periphery__data_to_core[70];
			assign ch6_rx_data_in[77] = s0_44_1__core_periphery__data_to_core[100];
			assign ch6_rx_data_in[76] = s0_44_1__core_periphery__data_to_core[102];
			assign ch6_rx_data_in[75] = s0_44_1__core_periphery__data_to_core[72];
			assign ch6_rx_data_in[74] = s0_44_1__core_periphery__data_to_core[74];
			assign ch6_rx_data_in[73] = s0_44_1__core_periphery__data_to_core[75];
			assign ch6_rx_data_in[72] = s0_44_1__core_periphery__data_to_core[104];
			assign ch6_rx_data_in[71] = s0_44_1__core_periphery__data_to_core[105];
			assign ch6_rx_data_in[70] = s0_44_1__core_periphery__data_to_core[107];
			assign ch6_rx_data_in[69] = s0_44_1__core_periphery__data_to_core[77];
			assign ch6_rx_data_in[68] = s0_44_1__core_periphery__data_to_core[78];
			assign ch6_rx_data_in[67] = s0_44_1__core_periphery__data_to_core[79];
			assign ch6_rx_data_in[66] = s0_43_1__core_periphery__data_to_core[26];
			assign ch6_rx_data_in[65] = s0_43_1__core_periphery__data_to_core[24];
			assign ch6_rx_data_in[64] = s0_43_1__core_periphery__data_to_core[3];
			assign ch6_rx_data_in[63] = s0_43_1__core_periphery__data_to_core[2];
			assign ch6_rx_data_in[62] = s0_43_1__core_periphery__data_to_core[1];
			assign ch6_rx_data_in[61] = s0_43_1__core_periphery__data_to_core[31];
			assign ch6_rx_data_in[60] = s0_43_1__core_periphery__data_to_core[30];
			assign ch6_rx_data_in[59] = s0_43_1__core_periphery__data_to_core[28];
			assign ch6_rx_data_in[58] = s0_43_1__core_periphery__data_to_core[7];
			assign ch6_rx_data_in[57] = s0_43_1__core_periphery__data_to_core[5];
			assign ch6_rx_data_in[56] = s0_43_1__core_periphery__data_to_core[35];
			assign ch6_rx_data_in[55] = s0_43_1__core_periphery__data_to_core[33];
			assign ch6_rx_data_in[54] = s0_43_1__core_periphery__data_to_core[11];
			assign ch6_rx_data_in[53] = s0_43_1__core_periphery__data_to_core[10];
			assign ch6_rx_data_in[52] = s0_43_1__core_periphery__data_to_core[9];
			assign ch6_rx_data_in[51] = s0_43_1__core_periphery__data_to_core[8];
			assign ch6_rx_data_in[50] = s0_43_1__core_periphery__data_to_core[38];
			assign ch6_rx_data_in[49] = s0_43_1__core_periphery__data_to_core[36];
			assign ch6_rx_data_in[48] = s0_43_1__core_periphery__data_to_core[15];
			assign ch6_rx_data_in[47] = s0_43_1__core_periphery__data_to_core[14];
			assign ch6_rx_data_in[46] = s0_43_1__core_periphery__data_to_core[13];
			assign ch6_rx_data_in[45] = s0_43_1__core_periphery__data_to_core[43];
			assign ch6_rx_data_in[44] = s0_43_1__core_periphery__data_to_core[42];
			assign ch6_rx_data_in[43] = s0_43_1__core_periphery__data_to_core[40];
			assign ch6_rx_data_in[42] = s0_43_1__core_periphery__data_to_core[19];
			assign ch6_rx_data_in[41] = s0_43_1__core_periphery__data_to_core[17];
			assign ch6_rx_data_in[40] = s0_43_1__core_periphery__data_to_core[47];
			assign ch6_rx_data_in[39] = s0_43_1__core_periphery__data_to_core[45];
			//assign ch6_rx_data_in[39] = s0_43_1__core_periphery__data_to_core[23];
			assign ch6_rx_data_in[38] = s0_43_1__core_periphery__data_to_core[22];
			assign ch6_rx_data_in[37] = s0_43_1__core_periphery__data_to_core[20];
			assign ch6_rx_data_in[36] = s0_43_1__core_periphery__data_to_core[51];
			assign ch6_rx_data_in[35] = s0_43_1__core_periphery__data_to_core[49];
			assign ch6_rx_data_in[34] = s0_43_1__core_periphery__data_to_core[80];
			assign ch6_rx_data_in[33] = s0_43_1__core_periphery__data_to_core[82];
			assign ch6_rx_data_in[32] = s0_43_1__core_periphery__data_to_core[52];
			assign ch6_rx_data_in[31] = s0_43_1__core_periphery__data_to_core[54];
			assign ch6_rx_data_in[30] = s0_43_1__core_periphery__data_to_core[55];
			assign ch6_rx_data_in[29] = s0_43_1__core_periphery__data_to_core[84];
			assign ch6_rx_data_in[28] = s0_43_1__core_periphery__data_to_core[86];
			assign ch6_rx_data_in[27] = s0_43_1__core_periphery__data_to_core[87];
			assign ch6_rx_data_in[26] = s0_43_1__core_periphery__data_to_core[57];
			assign ch6_rx_data_in[25] = s0_43_1__core_periphery__data_to_core[58];
			assign ch6_rx_data_in[24] = s0_43_1__core_periphery__data_to_core[88];
			assign ch6_rx_data_in[23] = s0_43_1__core_periphery__data_to_core[90];
			assign ch6_rx_data_in[22] = s0_43_1__core_periphery__data_to_core[60];
			assign ch6_rx_data_in[21] = s0_43_1__core_periphery__data_to_core[62];
			assign ch6_rx_data_in[20] = s0_43_1__core_periphery__data_to_core[63];
			assign ch6_rx_data_in[19] = s0_43_1__core_periphery__data_to_core[92];
			assign ch6_rx_data_in[18] = s0_43_1__core_periphery__data_to_core[93];
			assign ch6_rx_data_in[17] = s0_43_1__core_periphery__data_to_core[95];
			assign ch6_rx_data_in[16] = s0_43_1__core_periphery__data_to_core[65];
			assign ch6_rx_data_in[15] = s0_43_1__core_periphery__data_to_core[66];
			assign ch6_rx_data_in[14] = s0_43_1__core_periphery__data_to_core[67];
			assign ch6_rx_data_in[13] = s0_43_1__core_periphery__data_to_core[96];
			assign ch6_rx_data_in[12] = s0_43_1__core_periphery__data_to_core[98];
			assign ch6_rx_data_in[11] = s0_43_1__core_periphery__data_to_core[99];
			assign ch6_rx_data_in[10] = s0_43_1__core_periphery__data_to_core[69];
			assign ch6_rx_data_in[9] = s0_43_1__core_periphery__data_to_core[70];
			assign ch6_rx_data_in[8] = s0_43_1__core_periphery__data_to_core[100];
			assign ch6_rx_data_in[7] = s0_43_1__core_periphery__data_to_core[102];
			assign ch6_rx_data_in[6] = s0_43_1__core_periphery__data_to_core[72];
			assign ch6_rx_data_in[5] = s0_43_1__core_periphery__data_to_core[74];
			assign ch6_rx_data_in[4] = s0_43_1__core_periphery__data_to_core[75];
			assign ch6_rx_data_in[3] = s0_43_1__core_periphery__data_to_core[104];
			assign ch6_rx_data_in[2] = s0_43_1__core_periphery__data_to_core[105];
			assign ch6_rx_data_in[1] = s0_43_1__core_periphery__data_to_core[107];
			assign ch6_rx_data_in[0] = s0_43_1__core_periphery__data_to_core[77];


			//channel 7

			//assign ch7_rx_data_in[79] = s0_50_1__core_periphery__data_to_core[70];
			assign ch7_rx_data_in[77] = s0_50_1__core_periphery__data_to_core[100];
			assign ch7_rx_data_in[76] = s0_50_1__core_periphery__data_to_core[102];
			assign ch7_rx_data_in[75] = s0_50_1__core_periphery__data_to_core[72];
			assign ch7_rx_data_in[74] = s0_50_1__core_periphery__data_to_core[74];
			assign ch7_rx_data_in[73] = s0_50_1__core_periphery__data_to_core[75];
			assign ch7_rx_data_in[72] = s0_50_1__core_periphery__data_to_core[104];
			assign ch7_rx_data_in[71] = s0_50_1__core_periphery__data_to_core[105];
			assign ch7_rx_data_in[70] = s0_50_1__core_periphery__data_to_core[107];
			assign ch7_rx_data_in[69] = s0_50_1__core_periphery__data_to_core[77];
			assign ch7_rx_data_in[68] = s0_50_1__core_periphery__data_to_core[78];
			assign ch7_rx_data_in[67] = s0_50_1__core_periphery__data_to_core[79];
			assign ch7_rx_data_in[66] = s0_49_1__core_periphery__data_to_core[26];
			assign ch7_rx_data_in[65] = s0_49_1__core_periphery__data_to_core[24];
			assign ch7_rx_data_in[64] = s0_49_1__core_periphery__data_to_core[3];
			assign ch7_rx_data_in[63] = s0_49_1__core_periphery__data_to_core[2];
			assign ch7_rx_data_in[62] = s0_49_1__core_periphery__data_to_core[1];
			assign ch7_rx_data_in[61] = s0_49_1__core_periphery__data_to_core[31];
			assign ch7_rx_data_in[60] = s0_49_1__core_periphery__data_to_core[30];
			assign ch7_rx_data_in[59] = s0_49_1__core_periphery__data_to_core[28];
			assign ch7_rx_data_in[58] = s0_49_1__core_periphery__data_to_core[7];
			assign ch7_rx_data_in[57] = s0_49_1__core_periphery__data_to_core[5];
			assign ch7_rx_data_in[56] = s0_49_1__core_periphery__data_to_core[35];
			assign ch7_rx_data_in[55] = s0_49_1__core_periphery__data_to_core[33];
			assign ch7_rx_data_in[54] = s0_49_1__core_periphery__data_to_core[11];
			assign ch7_rx_data_in[53] = s0_49_1__core_periphery__data_to_core[10];
			assign ch7_rx_data_in[52] = s0_49_1__core_periphery__data_to_core[9];
			assign ch7_rx_data_in[51] = s0_49_1__core_periphery__data_to_core[8];
			assign ch7_rx_data_in[50] = s0_49_1__core_periphery__data_to_core[38];
			assign ch7_rx_data_in[49] = s0_49_1__core_periphery__data_to_core[36];
			assign ch7_rx_data_in[48] = s0_49_1__core_periphery__data_to_core[15];
			assign ch7_rx_data_in[47] = s0_49_1__core_periphery__data_to_core[14];
			assign ch7_rx_data_in[46] = s0_49_1__core_periphery__data_to_core[13];
			assign ch7_rx_data_in[45] = s0_49_1__core_periphery__data_to_core[43];
			assign ch7_rx_data_in[44] = s0_49_1__core_periphery__data_to_core[42];
			assign ch7_rx_data_in[43] = s0_49_1__core_periphery__data_to_core[40];
			assign ch7_rx_data_in[42] = s0_49_1__core_periphery__data_to_core[19];
			assign ch7_rx_data_in[41] = s0_49_1__core_periphery__data_to_core[17];
			assign ch7_rx_data_in[40] = s0_49_1__core_periphery__data_to_core[47];
			assign ch7_rx_data_in[39] = s0_49_1__core_periphery__data_to_core[45];
			//assign ch7_rx_data_in[39] = s0_49_1__core_periphery__data_to_core[23];
			assign ch7_rx_data_in[38] = s0_49_1__core_periphery__data_to_core[22];
			assign ch7_rx_data_in[37] = s0_49_1__core_periphery__data_to_core[20];
			assign ch7_rx_data_in[36] = s0_49_1__core_periphery__data_to_core[51];
			assign ch7_rx_data_in[35] = s0_49_1__core_periphery__data_to_core[49];
			assign ch7_rx_data_in[34] = s0_49_1__core_periphery__data_to_core[80];
			assign ch7_rx_data_in[33] = s0_49_1__core_periphery__data_to_core[82];
			assign ch7_rx_data_in[32] = s0_49_1__core_periphery__data_to_core[52];
			assign ch7_rx_data_in[31] = s0_49_1__core_periphery__data_to_core[54];
			assign ch7_rx_data_in[30] = s0_49_1__core_periphery__data_to_core[55];
			assign ch7_rx_data_in[29] = s0_49_1__core_periphery__data_to_core[84];
			assign ch7_rx_data_in[28] = s0_49_1__core_periphery__data_to_core[86];
			assign ch7_rx_data_in[27] = s0_49_1__core_periphery__data_to_core[87];
			assign ch7_rx_data_in[26] = s0_49_1__core_periphery__data_to_core[57];
			assign ch7_rx_data_in[25] = s0_49_1__core_periphery__data_to_core[58];
			assign ch7_rx_data_in[24] = s0_49_1__core_periphery__data_to_core[88];
			assign ch7_rx_data_in[23] = s0_49_1__core_periphery__data_to_core[90];
			assign ch7_rx_data_in[22] = s0_49_1__core_periphery__data_to_core[60];
			assign ch7_rx_data_in[21] = s0_49_1__core_periphery__data_to_core[62];
			assign ch7_rx_data_in[20] = s0_49_1__core_periphery__data_to_core[63];
			assign ch7_rx_data_in[19] = s0_49_1__core_periphery__data_to_core[92];
			assign ch7_rx_data_in[18] = s0_49_1__core_periphery__data_to_core[93];
			assign ch7_rx_data_in[17] = s0_49_1__core_periphery__data_to_core[95];
			assign ch7_rx_data_in[16] = s0_49_1__core_periphery__data_to_core[65];
			assign ch7_rx_data_in[15] = s0_49_1__core_periphery__data_to_core[66];
			assign ch7_rx_data_in[14] = s0_49_1__core_periphery__data_to_core[67];
			assign ch7_rx_data_in[13] = s0_49_1__core_periphery__data_to_core[96];
			assign ch7_rx_data_in[12] = s0_49_1__core_periphery__data_to_core[98];
			assign ch7_rx_data_in[11] = s0_49_1__core_periphery__data_to_core[99];
			assign ch7_rx_data_in[10] = s0_49_1__core_periphery__data_to_core[69];
			assign ch7_rx_data_in[9] = s0_49_1__core_periphery__data_to_core[70];
			assign ch7_rx_data_in[8] = s0_49_1__core_periphery__data_to_core[100];
			assign ch7_rx_data_in[7] = s0_49_1__core_periphery__data_to_core[102];
			assign ch7_rx_data_in[6] = s0_49_1__core_periphery__data_to_core[72];
			assign ch7_rx_data_in[5] = s0_49_1__core_periphery__data_to_core[74];
			assign ch7_rx_data_in[4] = s0_49_1__core_periphery__data_to_core[75];
			assign ch7_rx_data_in[3] = s0_49_1__core_periphery__data_to_core[104];
			assign ch7_rx_data_in[2] = s0_49_1__core_periphery__data_to_core[105];
			assign ch7_rx_data_in[1] = s0_49_1__core_periphery__data_to_core[107];
			assign ch7_rx_data_in[0] = s0_49_1__core_periphery__data_to_core[77];

			//channel 8

			//assign ch8_rx_data_in[79] = s0_56_1__core_periphery__data_to_core[70];
			assign ch8_rx_data_in[77] = s0_56_1__core_periphery__data_to_core[100];
			assign ch8_rx_data_in[76] = s0_56_1__core_periphery__data_to_core[102];
			assign ch8_rx_data_in[75] = s0_56_1__core_periphery__data_to_core[72];
			assign ch8_rx_data_in[74] = s0_56_1__core_periphery__data_to_core[74];
			assign ch8_rx_data_in[73] = s0_56_1__core_periphery__data_to_core[75];
			assign ch8_rx_data_in[72] = s0_56_1__core_periphery__data_to_core[104];
			assign ch8_rx_data_in[71] = s0_56_1__core_periphery__data_to_core[105];
			assign ch8_rx_data_in[70] = s0_56_1__core_periphery__data_to_core[107];
			assign ch8_rx_data_in[69] = s0_56_1__core_periphery__data_to_core[77];
			assign ch8_rx_data_in[68] = s0_56_1__core_periphery__data_to_core[78];
			assign ch8_rx_data_in[67] = s0_56_1__core_periphery__data_to_core[79];
			assign ch8_rx_data_in[66] = s0_55_1__core_periphery__data_to_core[26];
			assign ch8_rx_data_in[65] = s0_55_1__core_periphery__data_to_core[24];
			assign ch8_rx_data_in[64] = s0_55_1__core_periphery__data_to_core[3];
			assign ch8_rx_data_in[63] = s0_55_1__core_periphery__data_to_core[2];
			assign ch8_rx_data_in[62] = s0_55_1__core_periphery__data_to_core[1];
			assign ch8_rx_data_in[61] = s0_55_1__core_periphery__data_to_core[31];
			assign ch8_rx_data_in[60] = s0_55_1__core_periphery__data_to_core[30];
			assign ch8_rx_data_in[59] = s0_55_1__core_periphery__data_to_core[28];
			assign ch8_rx_data_in[58] = s0_55_1__core_periphery__data_to_core[7];
			assign ch8_rx_data_in[57] = s0_55_1__core_periphery__data_to_core[5];
			assign ch8_rx_data_in[56] = s0_55_1__core_periphery__data_to_core[35];
			assign ch8_rx_data_in[55] = s0_55_1__core_periphery__data_to_core[33];
			assign ch8_rx_data_in[54] = s0_55_1__core_periphery__data_to_core[11];
			assign ch8_rx_data_in[53] = s0_55_1__core_periphery__data_to_core[10];
			assign ch8_rx_data_in[52] = s0_55_1__core_periphery__data_to_core[9];
			assign ch8_rx_data_in[51] = s0_55_1__core_periphery__data_to_core[8];
			assign ch8_rx_data_in[50] = s0_55_1__core_periphery__data_to_core[38];
			assign ch8_rx_data_in[49] = s0_55_1__core_periphery__data_to_core[36];
			assign ch8_rx_data_in[48] = s0_55_1__core_periphery__data_to_core[15];
			assign ch8_rx_data_in[47] = s0_55_1__core_periphery__data_to_core[14];
			assign ch8_rx_data_in[46] = s0_55_1__core_periphery__data_to_core[13];
			assign ch8_rx_data_in[45] = s0_55_1__core_periphery__data_to_core[43];
			assign ch8_rx_data_in[44] = s0_55_1__core_periphery__data_to_core[42];
			assign ch8_rx_data_in[43] = s0_55_1__core_periphery__data_to_core[40];
			assign ch8_rx_data_in[42] = s0_55_1__core_periphery__data_to_core[19];
			assign ch8_rx_data_in[41] = s0_55_1__core_periphery__data_to_core[17];
			assign ch8_rx_data_in[40] = s0_55_1__core_periphery__data_to_core[47];
			assign ch8_rx_data_in[39] = s0_55_1__core_periphery__data_to_core[45];
			//assign ch8_rx_data_in[39] = s0_55_1__core_periphery__data_to_core[23];
			assign ch8_rx_data_in[38] = s0_55_1__core_periphery__data_to_core[22];
			assign ch8_rx_data_in[37] = s0_55_1__core_periphery__data_to_core[20];
			assign ch8_rx_data_in[36] = s0_55_1__core_periphery__data_to_core[51];
			assign ch8_rx_data_in[35] = s0_55_1__core_periphery__data_to_core[49];
			assign ch8_rx_data_in[34] = s0_55_1__core_periphery__data_to_core[80];
			assign ch8_rx_data_in[33] = s0_55_1__core_periphery__data_to_core[82];
			assign ch8_rx_data_in[32] = s0_55_1__core_periphery__data_to_core[52];
			assign ch8_rx_data_in[31] = s0_55_1__core_periphery__data_to_core[54];
			assign ch8_rx_data_in[30] = s0_55_1__core_periphery__data_to_core[55];
			assign ch8_rx_data_in[29] = s0_55_1__core_periphery__data_to_core[84];
			assign ch8_rx_data_in[28] = s0_55_1__core_periphery__data_to_core[86];
			assign ch8_rx_data_in[27] = s0_55_1__core_periphery__data_to_core[87];
			assign ch8_rx_data_in[26] = s0_55_1__core_periphery__data_to_core[57];
			assign ch8_rx_data_in[25] = s0_55_1__core_periphery__data_to_core[58];
			assign ch8_rx_data_in[24] = s0_55_1__core_periphery__data_to_core[88];
			assign ch8_rx_data_in[23] = s0_55_1__core_periphery__data_to_core[90];
			assign ch8_rx_data_in[22] = s0_55_1__core_periphery__data_to_core[60];
			assign ch8_rx_data_in[21] = s0_55_1__core_periphery__data_to_core[62];
			assign ch8_rx_data_in[20] = s0_55_1__core_periphery__data_to_core[63];
			assign ch8_rx_data_in[19] = s0_55_1__core_periphery__data_to_core[92];
			assign ch8_rx_data_in[18] = s0_55_1__core_periphery__data_to_core[93];
			assign ch8_rx_data_in[17] = s0_55_1__core_periphery__data_to_core[95];
			assign ch8_rx_data_in[16] = s0_55_1__core_periphery__data_to_core[65];
			assign ch8_rx_data_in[15] = s0_55_1__core_periphery__data_to_core[66];
			assign ch8_rx_data_in[14] = s0_55_1__core_periphery__data_to_core[67];
			assign ch8_rx_data_in[13] = s0_55_1__core_periphery__data_to_core[96];
			assign ch8_rx_data_in[12] = s0_55_1__core_periphery__data_to_core[98];
			assign ch8_rx_data_in[11] = s0_55_1__core_periphery__data_to_core[99];
			assign ch8_rx_data_in[10] = s0_55_1__core_periphery__data_to_core[69];
			assign ch8_rx_data_in[9] = s0_55_1__core_periphery__data_to_core[70];
			assign ch8_rx_data_in[8] = s0_55_1__core_periphery__data_to_core[100];
			assign ch8_rx_data_in[7] = s0_55_1__core_periphery__data_to_core[102];
			assign ch8_rx_data_in[6] = s0_55_1__core_periphery__data_to_core[72];
			assign ch8_rx_data_in[5] = s0_55_1__core_periphery__data_to_core[74];
			assign ch8_rx_data_in[4] = s0_55_1__core_periphery__data_to_core[75];
			assign ch8_rx_data_in[3] = s0_55_1__core_periphery__data_to_core[104];
			assign ch8_rx_data_in[2] = s0_55_1__core_periphery__data_to_core[105];
			assign ch8_rx_data_in[1] = s0_55_1__core_periphery__data_to_core[107];
			assign ch8_rx_data_in[0] = s0_55_1__core_periphery__data_to_core[77];


			//channel 9

			//assign ch9_rx_data_in[79] = s0_63_1__core_periphery__data_to_core[70];
			assign ch9_rx_data_in[77] = s0_63_1__core_periphery__data_to_core[100];
			assign ch9_rx_data_in[76] = s0_63_1__core_periphery__data_to_core[102];
			assign ch9_rx_data_in[75] = s0_63_1__core_periphery__data_to_core[72];
			assign ch9_rx_data_in[74] = s0_63_1__core_periphery__data_to_core[74];
			assign ch9_rx_data_in[73] = s0_63_1__core_periphery__data_to_core[75];
			assign ch9_rx_data_in[72] = s0_63_1__core_periphery__data_to_core[104];
			assign ch9_rx_data_in[71] = s0_63_1__core_periphery__data_to_core[105];
			assign ch9_rx_data_in[70] = s0_63_1__core_periphery__data_to_core[107];
			assign ch9_rx_data_in[69] = s0_63_1__core_periphery__data_to_core[77];
			assign ch9_rx_data_in[68] = s0_63_1__core_periphery__data_to_core[78];
			assign ch9_rx_data_in[67] = s0_63_1__core_periphery__data_to_core[79];
			assign ch9_rx_data_in[66] = s0_62_1__core_periphery__data_to_core[26];
			assign ch9_rx_data_in[65] = s0_62_1__core_periphery__data_to_core[24];
			assign ch9_rx_data_in[64] = s0_62_1__core_periphery__data_to_core[3];
			assign ch9_rx_data_in[63] = s0_62_1__core_periphery__data_to_core[2];
			assign ch9_rx_data_in[62] = s0_62_1__core_periphery__data_to_core[1];
			assign ch9_rx_data_in[61] = s0_62_1__core_periphery__data_to_core[31];
			assign ch9_rx_data_in[60] = s0_62_1__core_periphery__data_to_core[30];
			assign ch9_rx_data_in[59] = s0_62_1__core_periphery__data_to_core[28];
			assign ch9_rx_data_in[58] = s0_62_1__core_periphery__data_to_core[7];
			assign ch9_rx_data_in[57] = s0_62_1__core_periphery__data_to_core[5];
			assign ch9_rx_data_in[56] = s0_62_1__core_periphery__data_to_core[35];
			assign ch9_rx_data_in[55] = s0_62_1__core_periphery__data_to_core[33];
			assign ch9_rx_data_in[54] = s0_62_1__core_periphery__data_to_core[11];
			assign ch9_rx_data_in[53] = s0_62_1__core_periphery__data_to_core[10];
			assign ch9_rx_data_in[52] = s0_62_1__core_periphery__data_to_core[9];
			assign ch9_rx_data_in[51] = s0_62_1__core_periphery__data_to_core[8];
			assign ch9_rx_data_in[50] = s0_62_1__core_periphery__data_to_core[38];
			assign ch9_rx_data_in[49] = s0_62_1__core_periphery__data_to_core[36];
			assign ch9_rx_data_in[48] = s0_62_1__core_periphery__data_to_core[15];
			assign ch9_rx_data_in[47] = s0_62_1__core_periphery__data_to_core[14];
			assign ch9_rx_data_in[46] = s0_62_1__core_periphery__data_to_core[13];
			assign ch9_rx_data_in[45] = s0_62_1__core_periphery__data_to_core[43];
			assign ch9_rx_data_in[44] = s0_62_1__core_periphery__data_to_core[42];
			assign ch9_rx_data_in[43] = s0_62_1__core_periphery__data_to_core[40];
			assign ch9_rx_data_in[42] = s0_62_1__core_periphery__data_to_core[19];
			assign ch9_rx_data_in[41] = s0_62_1__core_periphery__data_to_core[17];
			assign ch9_rx_data_in[40] = s0_62_1__core_periphery__data_to_core[47];
			assign ch9_rx_data_in[39] = s0_62_1__core_periphery__data_to_core[45];
			//assign ch9_rx_data_in[39] = s0_62_1__core_periphery__data_to_core[23];
			assign ch9_rx_data_in[38] = s0_62_1__core_periphery__data_to_core[22];
			assign ch9_rx_data_in[37] = s0_62_1__core_periphery__data_to_core[20];
			assign ch9_rx_data_in[36] = s0_62_1__core_periphery__data_to_core[51];
			assign ch9_rx_data_in[35] = s0_62_1__core_periphery__data_to_core[49];
			assign ch9_rx_data_in[34] = s0_62_1__core_periphery__data_to_core[80];
			assign ch9_rx_data_in[33] = s0_62_1__core_periphery__data_to_core[82];
			assign ch9_rx_data_in[32] = s0_62_1__core_periphery__data_to_core[52];
			assign ch9_rx_data_in[31] = s0_62_1__core_periphery__data_to_core[54];
			assign ch9_rx_data_in[30] = s0_62_1__core_periphery__data_to_core[55];
			assign ch9_rx_data_in[29] = s0_62_1__core_periphery__data_to_core[84];
			assign ch9_rx_data_in[28] = s0_62_1__core_periphery__data_to_core[86];
			assign ch9_rx_data_in[27] = s0_62_1__core_periphery__data_to_core[87];
			assign ch9_rx_data_in[26] = s0_62_1__core_periphery__data_to_core[57];
			assign ch9_rx_data_in[25] = s0_62_1__core_periphery__data_to_core[58];
			assign ch9_rx_data_in[24] = s0_62_1__core_periphery__data_to_core[88];
			assign ch9_rx_data_in[23] = s0_62_1__core_periphery__data_to_core[90];
			assign ch9_rx_data_in[22] = s0_62_1__core_periphery__data_to_core[60];
			assign ch9_rx_data_in[21] = s0_62_1__core_periphery__data_to_core[62];
			assign ch9_rx_data_in[20] = s0_62_1__core_periphery__data_to_core[63];
			assign ch9_rx_data_in[19] = s0_62_1__core_periphery__data_to_core[92];
			assign ch9_rx_data_in[18] = s0_62_1__core_periphery__data_to_core[93];
			assign ch9_rx_data_in[17] = s0_62_1__core_periphery__data_to_core[95];
			assign ch9_rx_data_in[16] = s0_62_1__core_periphery__data_to_core[65];
			assign ch9_rx_data_in[15] = s0_62_1__core_periphery__data_to_core[66];
			assign ch9_rx_data_in[14] = s0_62_1__core_periphery__data_to_core[67];
			assign ch9_rx_data_in[13] = s0_62_1__core_periphery__data_to_core[96];
			assign ch9_rx_data_in[12] = s0_62_1__core_periphery__data_to_core[98];
			assign ch9_rx_data_in[11] = s0_62_1__core_periphery__data_to_core[99];
			assign ch9_rx_data_in[10] = s0_62_1__core_periphery__data_to_core[69];
			assign ch9_rx_data_in[9] = s0_62_1__core_periphery__data_to_core[70];
			assign ch9_rx_data_in[8] = s0_62_1__core_periphery__data_to_core[100];
			assign ch9_rx_data_in[7] = s0_62_1__core_periphery__data_to_core[102];
			assign ch9_rx_data_in[6] = s0_62_1__core_periphery__data_to_core[72];
			assign ch9_rx_data_in[5] = s0_62_1__core_periphery__data_to_core[74];
			assign ch9_rx_data_in[4] = s0_62_1__core_periphery__data_to_core[75];
			assign ch9_rx_data_in[3] = s0_62_1__core_periphery__data_to_core[104];
			assign ch9_rx_data_in[2] = s0_62_1__core_periphery__data_to_core[105];
			assign ch9_rx_data_in[1] = s0_62_1__core_periphery__data_to_core[107];
			assign ch9_rx_data_in[0] = s0_62_1__core_periphery__data_to_core[77];

			//assign ch12_rx_data_in[79] = s0_84_1__core_periphery__data_to_core[70];
			assign ch12_rx_data_in[77] = s0_84_1__core_periphery__data_to_core[100];
			assign ch12_rx_data_in[76] = s0_84_1__core_periphery__data_to_core[102];
			assign ch12_rx_data_in[75] = s0_84_1__core_periphery__data_to_core[72];
			assign ch12_rx_data_in[74] = s0_84_1__core_periphery__data_to_core[74];
			assign ch12_rx_data_in[73] = s0_84_1__core_periphery__data_to_core[75];
			assign ch12_rx_data_in[72] = s0_84_1__core_periphery__data_to_core[104];
			assign ch12_rx_data_in[71] = s0_84_1__core_periphery__data_to_core[105];
			assign ch12_rx_data_in[70] = s0_84_1__core_periphery__data_to_core[107];
			assign ch12_rx_data_in[69] = s0_84_1__core_periphery__data_to_core[77];
			assign ch12_rx_data_in[68] = s0_84_1__core_periphery__data_to_core[78];
			assign ch12_rx_data_in[67] = s0_84_1__core_periphery__data_to_core[79];
			assign ch12_rx_data_in[66] = s0_83_1__core_periphery__data_to_core[26];
			assign ch12_rx_data_in[65] = s0_83_1__core_periphery__data_to_core[24];
			assign ch12_rx_data_in[64] = s0_83_1__core_periphery__data_to_core[3];
			assign ch12_rx_data_in[63] = s0_83_1__core_periphery__data_to_core[2];
			assign ch12_rx_data_in[62] = s0_83_1__core_periphery__data_to_core[1];
			assign ch12_rx_data_in[61] = s0_83_1__core_periphery__data_to_core[31];
			assign ch12_rx_data_in[60] = s0_83_1__core_periphery__data_to_core[30];
			assign ch12_rx_data_in[59] = s0_83_1__core_periphery__data_to_core[28];
			assign ch12_rx_data_in[58] = s0_83_1__core_periphery__data_to_core[7];
			assign ch12_rx_data_in[57] = s0_83_1__core_periphery__data_to_core[5];
			assign ch12_rx_data_in[56] = s0_83_1__core_periphery__data_to_core[35];
			assign ch12_rx_data_in[55] = s0_83_1__core_periphery__data_to_core[33];
			assign ch12_rx_data_in[54] = s0_83_1__core_periphery__data_to_core[11];
			assign ch12_rx_data_in[53] = s0_83_1__core_periphery__data_to_core[10];
			assign ch12_rx_data_in[52] = s0_83_1__core_periphery__data_to_core[9];
			assign ch12_rx_data_in[51] = s0_83_1__core_periphery__data_to_core[8];
			assign ch12_rx_data_in[50] = s0_83_1__core_periphery__data_to_core[38];
			assign ch12_rx_data_in[49] = s0_83_1__core_periphery__data_to_core[36];
			assign ch12_rx_data_in[48] = s0_83_1__core_periphery__data_to_core[15];
			assign ch12_rx_data_in[47] = s0_83_1__core_periphery__data_to_core[14];
			assign ch12_rx_data_in[46] = s0_83_1__core_periphery__data_to_core[13];
			assign ch12_rx_data_in[45] = s0_83_1__core_periphery__data_to_core[43];
			assign ch12_rx_data_in[44] = s0_83_1__core_periphery__data_to_core[42];
			assign ch12_rx_data_in[43] = s0_83_1__core_periphery__data_to_core[40];
			assign ch12_rx_data_in[42] = s0_83_1__core_periphery__data_to_core[19];
			assign ch12_rx_data_in[41] = s0_83_1__core_periphery__data_to_core[17];
			assign ch12_rx_data_in[40] = s0_83_1__core_periphery__data_to_core[47];
			assign ch12_rx_data_in[39] = s0_83_1__core_periphery__data_to_core[45];
			//assign ch12_rx_data_in[39] = s0_83_1__core_periphery__data_to_core[23];
			assign ch12_rx_data_in[38] = s0_83_1__core_periphery__data_to_core[22];
			assign ch12_rx_data_in[37] = s0_83_1__core_periphery__data_to_core[20];
			assign ch12_rx_data_in[36] = s0_83_1__core_periphery__data_to_core[51];
			assign ch12_rx_data_in[35] = s0_83_1__core_periphery__data_to_core[49];
			assign ch12_rx_data_in[34] = s0_83_1__core_periphery__data_to_core[80];
			assign ch12_rx_data_in[33] = s0_83_1__core_periphery__data_to_core[82];
			assign ch12_rx_data_in[32] = s0_83_1__core_periphery__data_to_core[52];
			assign ch12_rx_data_in[31] = s0_83_1__core_periphery__data_to_core[54];
			assign ch12_rx_data_in[30] = s0_83_1__core_periphery__data_to_core[55];
			assign ch12_rx_data_in[29] = s0_83_1__core_periphery__data_to_core[84];
			assign ch12_rx_data_in[28] = s0_83_1__core_periphery__data_to_core[86];
			assign ch12_rx_data_in[27] = s0_83_1__core_periphery__data_to_core[87];
			assign ch12_rx_data_in[26] = s0_83_1__core_periphery__data_to_core[57];
			assign ch12_rx_data_in[25] = s0_83_1__core_periphery__data_to_core[58];
			assign ch12_rx_data_in[24] = s0_83_1__core_periphery__data_to_core[88];
			assign ch12_rx_data_in[23] = s0_83_1__core_periphery__data_to_core[90];
			assign ch12_rx_data_in[22] = s0_83_1__core_periphery__data_to_core[60];
			assign ch12_rx_data_in[21] = s0_83_1__core_periphery__data_to_core[62];
			assign ch12_rx_data_in[20] = s0_83_1__core_periphery__data_to_core[63];
			assign ch12_rx_data_in[19] = s0_83_1__core_periphery__data_to_core[92];
			assign ch12_rx_data_in[18] = s0_83_1__core_periphery__data_to_core[93];
			assign ch12_rx_data_in[17] = s0_83_1__core_periphery__data_to_core[95];
			assign ch12_rx_data_in[16] = s0_83_1__core_periphery__data_to_core[65];
			assign ch12_rx_data_in[15] = s0_83_1__core_periphery__data_to_core[66];
			assign ch12_rx_data_in[14] = s0_83_1__core_periphery__data_to_core[67];
			assign ch12_rx_data_in[13] = s0_83_1__core_periphery__data_to_core[96];
			assign ch12_rx_data_in[12] = s0_83_1__core_periphery__data_to_core[98];
			assign ch12_rx_data_in[11] = s0_83_1__core_periphery__data_to_core[99];
			assign ch12_rx_data_in[10] = s0_83_1__core_periphery__data_to_core[69];
			assign ch12_rx_data_in[9] = s0_83_1__core_periphery__data_to_core[70];
			assign ch12_rx_data_in[8] = s0_83_1__core_periphery__data_to_core[100];
			assign ch12_rx_data_in[7] = s0_83_1__core_periphery__data_to_core[102];
			assign ch12_rx_data_in[6] = s0_83_1__core_periphery__data_to_core[72];
			assign ch12_rx_data_in[5] = s0_83_1__core_periphery__data_to_core[74];
			assign ch12_rx_data_in[4] = s0_83_1__core_periphery__data_to_core[75];
			assign ch12_rx_data_in[3] = s0_83_1__core_periphery__data_to_core[104];
			assign ch12_rx_data_in[2] = s0_83_1__core_periphery__data_to_core[105];
			assign ch12_rx_data_in[1] = s0_83_1__core_periphery__data_to_core[107];
			assign ch12_rx_data_in[0] = s0_83_1__core_periphery__data_to_core[77];



			//channel 13

			//assign ch13_rx_data_in[79] = s0_90_1__core_periphery__data_to_core[70];
			assign ch13_rx_data_in[77] = s0_90_1__core_periphery__data_to_core[100];
			assign ch13_rx_data_in[76] = s0_90_1__core_periphery__data_to_core[102];
			assign ch13_rx_data_in[75] = s0_90_1__core_periphery__data_to_core[72];
			assign ch13_rx_data_in[74] = s0_90_1__core_periphery__data_to_core[74];
			assign ch13_rx_data_in[73] = s0_90_1__core_periphery__data_to_core[75];
			assign ch13_rx_data_in[72] = s0_90_1__core_periphery__data_to_core[104];
			assign ch13_rx_data_in[71] = s0_90_1__core_periphery__data_to_core[105];
			assign ch13_rx_data_in[70] = s0_90_1__core_periphery__data_to_core[107];
			assign ch13_rx_data_in[69] = s0_90_1__core_periphery__data_to_core[77];
			assign ch13_rx_data_in[68] = s0_90_1__core_periphery__data_to_core[78];
			assign ch13_rx_data_in[67] = s0_90_1__core_periphery__data_to_core[79];
			assign ch13_rx_data_in[66] = s0_89_1__core_periphery__data_to_core[26];
			assign ch13_rx_data_in[65] = s0_89_1__core_periphery__data_to_core[24];
			assign ch13_rx_data_in[64] = s0_89_1__core_periphery__data_to_core[3];
			assign ch13_rx_data_in[63] = s0_89_1__core_periphery__data_to_core[2];
			assign ch13_rx_data_in[62] = s0_89_1__core_periphery__data_to_core[1];
			assign ch13_rx_data_in[61] = s0_89_1__core_periphery__data_to_core[31];
			assign ch13_rx_data_in[60] = s0_89_1__core_periphery__data_to_core[30];
			assign ch13_rx_data_in[59] = s0_89_1__core_periphery__data_to_core[28];
			assign ch13_rx_data_in[58] = s0_89_1__core_periphery__data_to_core[7];
			assign ch13_rx_data_in[57] = s0_89_1__core_periphery__data_to_core[5];
			assign ch13_rx_data_in[56] = s0_89_1__core_periphery__data_to_core[35];
			assign ch13_rx_data_in[55] = s0_89_1__core_periphery__data_to_core[33];
			assign ch13_rx_data_in[54] = s0_89_1__core_periphery__data_to_core[11];
			assign ch13_rx_data_in[53] = s0_89_1__core_periphery__data_to_core[10];
			assign ch13_rx_data_in[52] = s0_89_1__core_periphery__data_to_core[9];
			assign ch13_rx_data_in[51] = s0_89_1__core_periphery__data_to_core[8];
			assign ch13_rx_data_in[50] = s0_89_1__core_periphery__data_to_core[38];
			assign ch13_rx_data_in[49] = s0_89_1__core_periphery__data_to_core[36];
			assign ch13_rx_data_in[48] = s0_89_1__core_periphery__data_to_core[15];
			assign ch13_rx_data_in[47] = s0_89_1__core_periphery__data_to_core[14];
			assign ch13_rx_data_in[46] = s0_89_1__core_periphery__data_to_core[13];
			assign ch13_rx_data_in[45] = s0_89_1__core_periphery__data_to_core[43];
			assign ch13_rx_data_in[44] = s0_89_1__core_periphery__data_to_core[42];
			assign ch13_rx_data_in[43] = s0_89_1__core_periphery__data_to_core[40];
			assign ch13_rx_data_in[42] = s0_89_1__core_periphery__data_to_core[19];
			assign ch13_rx_data_in[41] = s0_89_1__core_periphery__data_to_core[17];
			assign ch13_rx_data_in[40] = s0_89_1__core_periphery__data_to_core[47];
			assign ch13_rx_data_in[39] = s0_89_1__core_periphery__data_to_core[45];
			//assign ch13_rx_data_in[39] = s0_89_1__core_periphery__data_to_core[23];
			assign ch13_rx_data_in[38] = s0_89_1__core_periphery__data_to_core[22];
			assign ch13_rx_data_in[37] = s0_89_1__core_periphery__data_to_core[20];
			assign ch13_rx_data_in[36] = s0_89_1__core_periphery__data_to_core[51];
			assign ch13_rx_data_in[35] = s0_89_1__core_periphery__data_to_core[49];
			assign ch13_rx_data_in[34] = s0_89_1__core_periphery__data_to_core[80];
			assign ch13_rx_data_in[33] = s0_89_1__core_periphery__data_to_core[82];
			assign ch13_rx_data_in[32] = s0_89_1__core_periphery__data_to_core[52];
			assign ch13_rx_data_in[31] = s0_89_1__core_periphery__data_to_core[54];
			assign ch13_rx_data_in[30] = s0_89_1__core_periphery__data_to_core[55];
			assign ch13_rx_data_in[29] = s0_89_1__core_periphery__data_to_core[84];
			assign ch13_rx_data_in[28] = s0_89_1__core_periphery__data_to_core[86];
			assign ch13_rx_data_in[27] = s0_89_1__core_periphery__data_to_core[87];
			assign ch13_rx_data_in[26] = s0_89_1__core_periphery__data_to_core[57];
			assign ch13_rx_data_in[25] = s0_89_1__core_periphery__data_to_core[58];
			assign ch13_rx_data_in[24] = s0_89_1__core_periphery__data_to_core[88];
			assign ch13_rx_data_in[23] = s0_89_1__core_periphery__data_to_core[90];
			assign ch13_rx_data_in[22] = s0_89_1__core_periphery__data_to_core[60];
			assign ch13_rx_data_in[21] = s0_89_1__core_periphery__data_to_core[62];
			assign ch13_rx_data_in[20] = s0_89_1__core_periphery__data_to_core[63];
			assign ch13_rx_data_in[19] = s0_89_1__core_periphery__data_to_core[92];
			assign ch13_rx_data_in[18] = s0_89_1__core_periphery__data_to_core[93];
			assign ch13_rx_data_in[17] = s0_89_1__core_periphery__data_to_core[95];
			assign ch13_rx_data_in[16] = s0_89_1__core_periphery__data_to_core[65];
			assign ch13_rx_data_in[15] = s0_89_1__core_periphery__data_to_core[66];
			assign ch13_rx_data_in[14] = s0_89_1__core_periphery__data_to_core[67];
			assign ch13_rx_data_in[13] = s0_89_1__core_periphery__data_to_core[96];
			assign ch13_rx_data_in[12] = s0_89_1__core_periphery__data_to_core[98];
			assign ch13_rx_data_in[11] = s0_89_1__core_periphery__data_to_core[99];
			assign ch13_rx_data_in[10] = s0_89_1__core_periphery__data_to_core[69];
			assign ch13_rx_data_in[9] = s0_89_1__core_periphery__data_to_core[70];
			assign ch13_rx_data_in[8] = s0_89_1__core_periphery__data_to_core[100];
			assign ch13_rx_data_in[7] = s0_89_1__core_periphery__data_to_core[102];
			assign ch13_rx_data_in[6] = s0_89_1__core_periphery__data_to_core[72];
			assign ch13_rx_data_in[5] = s0_89_1__core_periphery__data_to_core[74];
			assign ch13_rx_data_in[4] = s0_89_1__core_periphery__data_to_core[75];
			assign ch13_rx_data_in[3] = s0_89_1__core_periphery__data_to_core[104];
			assign ch13_rx_data_in[2] = s0_89_1__core_periphery__data_to_core[105];
			assign ch13_rx_data_in[1] = s0_89_1__core_periphery__data_to_core[107];
			assign ch13_rx_data_in[0] = s0_89_1__core_periphery__data_to_core[77];


			//channel 14

			//assign ch14_rx_data_in[79] = s0_96_1__core_periphery__data_to_core[70];
			assign ch14_rx_data_in[77] = s0_96_1__core_periphery__data_to_core[100];
			assign ch14_rx_data_in[76] = s0_96_1__core_periphery__data_to_core[102];
			assign ch14_rx_data_in[75] = s0_96_1__core_periphery__data_to_core[72];
			assign ch14_rx_data_in[74] = s0_96_1__core_periphery__data_to_core[74];
			assign ch14_rx_data_in[73] = s0_96_1__core_periphery__data_to_core[75];
			assign ch14_rx_data_in[72] = s0_96_1__core_periphery__data_to_core[104];
			assign ch14_rx_data_in[71] = s0_96_1__core_periphery__data_to_core[105];
			assign ch14_rx_data_in[70] = s0_96_1__core_periphery__data_to_core[107];
			assign ch14_rx_data_in[69] = s0_96_1__core_periphery__data_to_core[77];
			assign ch14_rx_data_in[68] = s0_96_1__core_periphery__data_to_core[78];
			assign ch14_rx_data_in[67] = s0_96_1__core_periphery__data_to_core[79];
			assign ch14_rx_data_in[66] = s0_95_1__core_periphery__data_to_core[26];
			assign ch14_rx_data_in[65] = s0_95_1__core_periphery__data_to_core[24];
			assign ch14_rx_data_in[64] = s0_95_1__core_periphery__data_to_core[3];
			assign ch14_rx_data_in[63] = s0_95_1__core_periphery__data_to_core[2];
			assign ch14_rx_data_in[62] = s0_95_1__core_periphery__data_to_core[1];
			assign ch14_rx_data_in[61] = s0_95_1__core_periphery__data_to_core[31];
			assign ch14_rx_data_in[60] = s0_95_1__core_periphery__data_to_core[30];
			assign ch14_rx_data_in[59] = s0_95_1__core_periphery__data_to_core[28];
			assign ch14_rx_data_in[58] = s0_95_1__core_periphery__data_to_core[7];
			assign ch14_rx_data_in[57] = s0_95_1__core_periphery__data_to_core[5];
			assign ch14_rx_data_in[56] = s0_95_1__core_periphery__data_to_core[35];
			assign ch14_rx_data_in[55] = s0_95_1__core_periphery__data_to_core[33];
			assign ch14_rx_data_in[54] = s0_95_1__core_periphery__data_to_core[11];
			assign ch14_rx_data_in[53] = s0_95_1__core_periphery__data_to_core[10];
			assign ch14_rx_data_in[52] = s0_95_1__core_periphery__data_to_core[9];
			assign ch14_rx_data_in[51] = s0_95_1__core_periphery__data_to_core[8];
			assign ch14_rx_data_in[50] = s0_95_1__core_periphery__data_to_core[38];
			assign ch14_rx_data_in[49] = s0_95_1__core_periphery__data_to_core[36];
			assign ch14_rx_data_in[48] = s0_95_1__core_periphery__data_to_core[15];
			assign ch14_rx_data_in[47] = s0_95_1__core_periphery__data_to_core[14];
			assign ch14_rx_data_in[46] = s0_95_1__core_periphery__data_to_core[13];
			assign ch14_rx_data_in[45] = s0_95_1__core_periphery__data_to_core[43];
			assign ch14_rx_data_in[44] = s0_95_1__core_periphery__data_to_core[42];
			assign ch14_rx_data_in[43] = s0_95_1__core_periphery__data_to_core[40];
			assign ch14_rx_data_in[42] = s0_95_1__core_periphery__data_to_core[19];
			assign ch14_rx_data_in[41] = s0_95_1__core_periphery__data_to_core[17];
			assign ch14_rx_data_in[40] = s0_95_1__core_periphery__data_to_core[47];
			assign ch14_rx_data_in[39] = s0_95_1__core_periphery__data_to_core[45];
			//assign ch14_rx_data_in[39] = s0_95_1__core_periphery__data_to_core[23];
			assign ch14_rx_data_in[38] = s0_95_1__core_periphery__data_to_core[22];
			assign ch14_rx_data_in[37] = s0_95_1__core_periphery__data_to_core[20];
			assign ch14_rx_data_in[36] = s0_95_1__core_periphery__data_to_core[51];
			assign ch14_rx_data_in[35] = s0_95_1__core_periphery__data_to_core[49];
			assign ch14_rx_data_in[34] = s0_95_1__core_periphery__data_to_core[80];
			assign ch14_rx_data_in[33] = s0_95_1__core_periphery__data_to_core[82];
			assign ch14_rx_data_in[32] = s0_95_1__core_periphery__data_to_core[52];
			assign ch14_rx_data_in[31] = s0_95_1__core_periphery__data_to_core[54];
			assign ch14_rx_data_in[30] = s0_95_1__core_periphery__data_to_core[55];
			assign ch14_rx_data_in[29] = s0_95_1__core_periphery__data_to_core[84];
			assign ch14_rx_data_in[28] = s0_95_1__core_periphery__data_to_core[86];
			assign ch14_rx_data_in[27] = s0_95_1__core_periphery__data_to_core[87];
			assign ch14_rx_data_in[26] = s0_95_1__core_periphery__data_to_core[57];
			assign ch14_rx_data_in[25] = s0_95_1__core_periphery__data_to_core[58];
			assign ch14_rx_data_in[24] = s0_95_1__core_periphery__data_to_core[88];
			assign ch14_rx_data_in[23] = s0_95_1__core_periphery__data_to_core[90];
			assign ch14_rx_data_in[22] = s0_95_1__core_periphery__data_to_core[60];
			assign ch14_rx_data_in[21] = s0_95_1__core_periphery__data_to_core[62];
			assign ch14_rx_data_in[20] = s0_95_1__core_periphery__data_to_core[63];
			assign ch14_rx_data_in[19] = s0_95_1__core_periphery__data_to_core[92];
			assign ch14_rx_data_in[18] = s0_95_1__core_periphery__data_to_core[93];
			assign ch14_rx_data_in[17] = s0_95_1__core_periphery__data_to_core[95];
			assign ch14_rx_data_in[16] = s0_95_1__core_periphery__data_to_core[65];
			assign ch14_rx_data_in[15] = s0_95_1__core_periphery__data_to_core[66];
			assign ch14_rx_data_in[14] = s0_95_1__core_periphery__data_to_core[67];
			assign ch14_rx_data_in[13] = s0_95_1__core_periphery__data_to_core[96];
			assign ch14_rx_data_in[12] = s0_95_1__core_periphery__data_to_core[98];
			assign ch14_rx_data_in[11] = s0_95_1__core_periphery__data_to_core[99];
			assign ch14_rx_data_in[10] = s0_95_1__core_periphery__data_to_core[69];
			assign ch14_rx_data_in[9] = s0_95_1__core_periphery__data_to_core[70];
			assign ch14_rx_data_in[8] = s0_95_1__core_periphery__data_to_core[100];
			assign ch14_rx_data_in[7] = s0_95_1__core_periphery__data_to_core[102];
			assign ch14_rx_data_in[6] = s0_95_1__core_periphery__data_to_core[72];
			assign ch14_rx_data_in[5] = s0_95_1__core_periphery__data_to_core[74];
			assign ch14_rx_data_in[4] = s0_95_1__core_periphery__data_to_core[75];
			assign ch14_rx_data_in[3] = s0_95_1__core_periphery__data_to_core[104];
			assign ch14_rx_data_in[2] = s0_95_1__core_periphery__data_to_core[105];
			assign ch14_rx_data_in[1] = s0_95_1__core_periphery__data_to_core[107];
			assign ch14_rx_data_in[0] = s0_95_1__core_periphery__data_to_core[77];


			//channel 15

			//assign ch15_rx_data_in[79] = s0_103_1__core_periphery__data_to_core[70];
			assign ch15_rx_data_in[77] = s0_103_1__core_periphery__data_to_core[100];
			assign ch15_rx_data_in[76] = s0_103_1__core_periphery__data_to_core[102];
			assign ch15_rx_data_in[75] = s0_103_1__core_periphery__data_to_core[72];
			assign ch15_rx_data_in[74] = s0_103_1__core_periphery__data_to_core[74];
			assign ch15_rx_data_in[73] = s0_103_1__core_periphery__data_to_core[75];
			assign ch15_rx_data_in[72] = s0_103_1__core_periphery__data_to_core[104];
			assign ch15_rx_data_in[71] = s0_103_1__core_periphery__data_to_core[105];
			assign ch15_rx_data_in[70] = s0_103_1__core_periphery__data_to_core[107];
			assign ch15_rx_data_in[69] = s0_103_1__core_periphery__data_to_core[77];
			assign ch15_rx_data_in[68] = s0_103_1__core_periphery__data_to_core[78];
			assign ch15_rx_data_in[67] = s0_103_1__core_periphery__data_to_core[79];
			assign ch15_rx_data_in[66] = s0_102_1__core_periphery__data_to_core[26];
			assign ch15_rx_data_in[65] = s0_102_1__core_periphery__data_to_core[24];
			assign ch15_rx_data_in[64] = s0_102_1__core_periphery__data_to_core[3];
			assign ch15_rx_data_in[63] = s0_102_1__core_periphery__data_to_core[2];
			assign ch15_rx_data_in[62] = s0_102_1__core_periphery__data_to_core[1];
			assign ch15_rx_data_in[61] = s0_102_1__core_periphery__data_to_core[31];
			assign ch15_rx_data_in[60] = s0_102_1__core_periphery__data_to_core[30];
			assign ch15_rx_data_in[59] = s0_102_1__core_periphery__data_to_core[28];
			assign ch15_rx_data_in[58] = s0_102_1__core_periphery__data_to_core[7];
			assign ch15_rx_data_in[57] = s0_102_1__core_periphery__data_to_core[5];
			assign ch15_rx_data_in[56] = s0_102_1__core_periphery__data_to_core[35];
			assign ch15_rx_data_in[55] = s0_102_1__core_periphery__data_to_core[33];
			assign ch15_rx_data_in[54] = s0_102_1__core_periphery__data_to_core[11];
			assign ch15_rx_data_in[53] = s0_102_1__core_periphery__data_to_core[10];
			assign ch15_rx_data_in[52] = s0_102_1__core_periphery__data_to_core[9];
			assign ch15_rx_data_in[51] = s0_102_1__core_periphery__data_to_core[8];
			assign ch15_rx_data_in[50] = s0_102_1__core_periphery__data_to_core[38];
			assign ch15_rx_data_in[49] = s0_102_1__core_periphery__data_to_core[36];
			assign ch15_rx_data_in[48] = s0_102_1__core_periphery__data_to_core[15];
			assign ch15_rx_data_in[47] = s0_102_1__core_periphery__data_to_core[14];
			assign ch15_rx_data_in[46] = s0_102_1__core_periphery__data_to_core[13];
			assign ch15_rx_data_in[45] = s0_102_1__core_periphery__data_to_core[43];
			assign ch15_rx_data_in[44] = s0_102_1__core_periphery__data_to_core[42];
			assign ch15_rx_data_in[43] = s0_102_1__core_periphery__data_to_core[40];
			assign ch15_rx_data_in[42] = s0_102_1__core_periphery__data_to_core[19];
			assign ch15_rx_data_in[41] = s0_102_1__core_periphery__data_to_core[17];
			assign ch15_rx_data_in[40] = s0_102_1__core_periphery__data_to_core[47];
			assign ch15_rx_data_in[39] = s0_102_1__core_periphery__data_to_core[45];
			//assign ch15_rx_data_in[39] = s0_102_1__core_periphery__data_to_core[23];
			assign ch15_rx_data_in[38] = s0_102_1__core_periphery__data_to_core[22];
			assign ch15_rx_data_in[37] = s0_102_1__core_periphery__data_to_core[20];
			assign ch15_rx_data_in[36] = s0_102_1__core_periphery__data_to_core[51];
			assign ch15_rx_data_in[35] = s0_102_1__core_periphery__data_to_core[49];
			assign ch15_rx_data_in[34] = s0_102_1__core_periphery__data_to_core[80];
			assign ch15_rx_data_in[33] = s0_102_1__core_periphery__data_to_core[82];
			assign ch15_rx_data_in[32] = s0_102_1__core_periphery__data_to_core[52];
			assign ch15_rx_data_in[31] = s0_102_1__core_periphery__data_to_core[54];
			assign ch15_rx_data_in[30] = s0_102_1__core_periphery__data_to_core[55];
			assign ch15_rx_data_in[29] = s0_102_1__core_periphery__data_to_core[84];
			assign ch15_rx_data_in[28] = s0_102_1__core_periphery__data_to_core[86];
			assign ch15_rx_data_in[27] = s0_102_1__core_periphery__data_to_core[87];
			assign ch15_rx_data_in[26] = s0_102_1__core_periphery__data_to_core[57];
			assign ch15_rx_data_in[25] = s0_102_1__core_periphery__data_to_core[58];
			assign ch15_rx_data_in[24] = s0_102_1__core_periphery__data_to_core[88];
			assign ch15_rx_data_in[23] = s0_102_1__core_periphery__data_to_core[90];
			assign ch15_rx_data_in[22] = s0_102_1__core_periphery__data_to_core[60];
			assign ch15_rx_data_in[21] = s0_102_1__core_periphery__data_to_core[62];
			assign ch15_rx_data_in[20] = s0_102_1__core_periphery__data_to_core[63];
			assign ch15_rx_data_in[19] = s0_102_1__core_periphery__data_to_core[92];
			assign ch15_rx_data_in[18] = s0_102_1__core_periphery__data_to_core[93];
			assign ch15_rx_data_in[17] = s0_102_1__core_periphery__data_to_core[95];
			assign ch15_rx_data_in[16] = s0_102_1__core_periphery__data_to_core[65];
			assign ch15_rx_data_in[15] = s0_102_1__core_periphery__data_to_core[66];
			assign ch15_rx_data_in[14] = s0_102_1__core_periphery__data_to_core[67];
			assign ch15_rx_data_in[13] = s0_102_1__core_periphery__data_to_core[96];
			assign ch15_rx_data_in[12] = s0_102_1__core_periphery__data_to_core[98];
			assign ch15_rx_data_in[11] = s0_102_1__core_periphery__data_to_core[99];
			assign ch15_rx_data_in[10] = s0_102_1__core_periphery__data_to_core[69];
			assign ch15_rx_data_in[9] = s0_102_1__core_periphery__data_to_core[70];
			assign ch15_rx_data_in[8] = s0_102_1__core_periphery__data_to_core[100];
			assign ch15_rx_data_in[7] = s0_102_1__core_periphery__data_to_core[102];
			assign ch15_rx_data_in[6] = s0_102_1__core_periphery__data_to_core[72];
			assign ch15_rx_data_in[5] = s0_102_1__core_periphery__data_to_core[74];
			assign ch15_rx_data_in[4] = s0_102_1__core_periphery__data_to_core[75];
			assign ch15_rx_data_in[3] = s0_102_1__core_periphery__data_to_core[104];
			assign ch15_rx_data_in[2] = s0_102_1__core_periphery__data_to_core[105];
			assign ch15_rx_data_in[1] = s0_102_1__core_periphery__data_to_core[107];
			assign ch15_rx_data_in[0] = s0_102_1__core_periphery__data_to_core[77];


			//channel 16

			//assign ch16_rx_data_in[79] = s0_109_1__core_periphery__data_to_core[70];
			assign ch16_rx_data_in[77] = s0_109_1__core_periphery__data_to_core[100];
			assign ch16_rx_data_in[76] = s0_109_1__core_periphery__data_to_core[102];
			assign ch16_rx_data_in[75] = s0_109_1__core_periphery__data_to_core[72];
			assign ch16_rx_data_in[74] = s0_109_1__core_periphery__data_to_core[74];
			assign ch16_rx_data_in[73] = s0_109_1__core_periphery__data_to_core[75];
			assign ch16_rx_data_in[72] = s0_109_1__core_periphery__data_to_core[104];
			assign ch16_rx_data_in[71] = s0_109_1__core_periphery__data_to_core[105];
			assign ch16_rx_data_in[70] = s0_109_1__core_periphery__data_to_core[107];
			assign ch16_rx_data_in[69] = s0_109_1__core_periphery__data_to_core[77];
			assign ch16_rx_data_in[68] = s0_109_1__core_periphery__data_to_core[78];
			assign ch16_rx_data_in[67] = s0_109_1__core_periphery__data_to_core[79];
			assign ch16_rx_data_in[66] = s0_108_1__core_periphery__data_to_core[26];
			assign ch16_rx_data_in[65] = s0_108_1__core_periphery__data_to_core[24];
			assign ch16_rx_data_in[64] = s0_108_1__core_periphery__data_to_core[3];
			assign ch16_rx_data_in[63] = s0_108_1__core_periphery__data_to_core[2];
			assign ch16_rx_data_in[62] = s0_108_1__core_periphery__data_to_core[1];
			assign ch16_rx_data_in[61] = s0_108_1__core_periphery__data_to_core[31];
			assign ch16_rx_data_in[60] = s0_108_1__core_periphery__data_to_core[30];
			assign ch16_rx_data_in[59] = s0_108_1__core_periphery__data_to_core[28];
			assign ch16_rx_data_in[58] = s0_108_1__core_periphery__data_to_core[7];
			assign ch16_rx_data_in[57] = s0_108_1__core_periphery__data_to_core[5];
			assign ch16_rx_data_in[56] = s0_108_1__core_periphery__data_to_core[35];
			assign ch16_rx_data_in[55] = s0_108_1__core_periphery__data_to_core[33];
			assign ch16_rx_data_in[54] = s0_108_1__core_periphery__data_to_core[11];
			assign ch16_rx_data_in[53] = s0_108_1__core_periphery__data_to_core[10];
			assign ch16_rx_data_in[52] = s0_108_1__core_periphery__data_to_core[9];
			assign ch16_rx_data_in[51] = s0_108_1__core_periphery__data_to_core[8];
			assign ch16_rx_data_in[50] = s0_108_1__core_periphery__data_to_core[38];
			assign ch16_rx_data_in[49] = s0_108_1__core_periphery__data_to_core[36];
			assign ch16_rx_data_in[48] = s0_108_1__core_periphery__data_to_core[15];
			assign ch16_rx_data_in[47] = s0_108_1__core_periphery__data_to_core[14];
			assign ch16_rx_data_in[46] = s0_108_1__core_periphery__data_to_core[13];
			assign ch16_rx_data_in[45] = s0_108_1__core_periphery__data_to_core[43];
			assign ch16_rx_data_in[44] = s0_108_1__core_periphery__data_to_core[42];
			assign ch16_rx_data_in[43] = s0_108_1__core_periphery__data_to_core[40];
			assign ch16_rx_data_in[42] = s0_108_1__core_periphery__data_to_core[19];
			assign ch16_rx_data_in[41] = s0_108_1__core_periphery__data_to_core[17];
			assign ch16_rx_data_in[40] = s0_108_1__core_periphery__data_to_core[47];
			assign ch16_rx_data_in[39] = s0_108_1__core_periphery__data_to_core[45];
			//assign ch16_rx_data_in[39] = s0_108_1__core_periphery__data_to_core[23];
			assign ch16_rx_data_in[38] = s0_108_1__core_periphery__data_to_core[22];
			assign ch16_rx_data_in[37] = s0_108_1__core_periphery__data_to_core[20];
			assign ch16_rx_data_in[36] = s0_108_1__core_periphery__data_to_core[51];
			assign ch16_rx_data_in[35] = s0_108_1__core_periphery__data_to_core[49];
			assign ch16_rx_data_in[34] = s0_108_1__core_periphery__data_to_core[80];
			assign ch16_rx_data_in[33] = s0_108_1__core_periphery__data_to_core[82];
			assign ch16_rx_data_in[32] = s0_108_1__core_periphery__data_to_core[52];
			assign ch16_rx_data_in[31] = s0_108_1__core_periphery__data_to_core[54];
			assign ch16_rx_data_in[30] = s0_108_1__core_periphery__data_to_core[55];
			assign ch16_rx_data_in[29] = s0_108_1__core_periphery__data_to_core[84];
			assign ch16_rx_data_in[28] = s0_108_1__core_periphery__data_to_core[86];
			assign ch16_rx_data_in[27] = s0_108_1__core_periphery__data_to_core[87];
			assign ch16_rx_data_in[26] = s0_108_1__core_periphery__data_to_core[57];
			assign ch16_rx_data_in[25] = s0_108_1__core_periphery__data_to_core[58];
			assign ch16_rx_data_in[24] = s0_108_1__core_periphery__data_to_core[88];
			assign ch16_rx_data_in[23] = s0_108_1__core_periphery__data_to_core[90];
			assign ch16_rx_data_in[22] = s0_108_1__core_periphery__data_to_core[60];
			assign ch16_rx_data_in[21] = s0_108_1__core_periphery__data_to_core[62];
			assign ch16_rx_data_in[20] = s0_108_1__core_periphery__data_to_core[63];
			assign ch16_rx_data_in[19] = s0_108_1__core_periphery__data_to_core[92];
			assign ch16_rx_data_in[18] = s0_108_1__core_periphery__data_to_core[93];
			assign ch16_rx_data_in[17] = s0_108_1__core_periphery__data_to_core[95];
			assign ch16_rx_data_in[16] = s0_108_1__core_periphery__data_to_core[65];
			assign ch16_rx_data_in[15] = s0_108_1__core_periphery__data_to_core[66];
			assign ch16_rx_data_in[14] = s0_108_1__core_periphery__data_to_core[67];
			assign ch16_rx_data_in[13] = s0_108_1__core_periphery__data_to_core[96];
			assign ch16_rx_data_in[12] = s0_108_1__core_periphery__data_to_core[98];
			assign ch16_rx_data_in[11] = s0_108_1__core_periphery__data_to_core[99];
			assign ch16_rx_data_in[10] = s0_108_1__core_periphery__data_to_core[69];
			assign ch16_rx_data_in[9] = s0_108_1__core_periphery__data_to_core[70];
			assign ch16_rx_data_in[8] = s0_108_1__core_periphery__data_to_core[100];
			assign ch16_rx_data_in[7] = s0_108_1__core_periphery__data_to_core[102];
			assign ch16_rx_data_in[6] = s0_108_1__core_periphery__data_to_core[72];
			assign ch16_rx_data_in[5] = s0_108_1__core_periphery__data_to_core[74];
			assign ch16_rx_data_in[4] = s0_108_1__core_periphery__data_to_core[75];
			assign ch16_rx_data_in[3] = s0_108_1__core_periphery__data_to_core[104];
			assign ch16_rx_data_in[2] = s0_108_1__core_periphery__data_to_core[105];
			assign ch16_rx_data_in[1] = s0_108_1__core_periphery__data_to_core[107];
			assign ch16_rx_data_in[0] = s0_108_1__core_periphery__data_to_core[77];


			//assign ch18_rx_data_in[79] = s0_124_1__core_periphery__data_to_core[70];
			assign ch18_rx_data_in[77] = s0_124_1__core_periphery__data_to_core[100];
			assign ch18_rx_data_in[76] = s0_124_1__core_periphery__data_to_core[102];
			assign ch18_rx_data_in[75] = s0_124_1__core_periphery__data_to_core[72];
			assign ch18_rx_data_in[74] = s0_124_1__core_periphery__data_to_core[74];
			assign ch18_rx_data_in[73] = s0_124_1__core_periphery__data_to_core[75];
			assign ch18_rx_data_in[72] = s0_124_1__core_periphery__data_to_core[104];
			assign ch18_rx_data_in[71] = s0_124_1__core_periphery__data_to_core[105];
			assign ch18_rx_data_in[70] = s0_124_1__core_periphery__data_to_core[107];
			assign ch18_rx_data_in[69] = s0_124_1__core_periphery__data_to_core[77];
			assign ch18_rx_data_in[68] = s0_124_1__core_periphery__data_to_core[78];
			assign ch18_rx_data_in[67] = s0_124_1__core_periphery__data_to_core[79];
			assign ch18_rx_data_in[66] = s0_123_1__core_periphery__data_to_core[26];
			assign ch18_rx_data_in[65] = s0_123_1__core_periphery__data_to_core[24];
			assign ch18_rx_data_in[64] = s0_123_1__core_periphery__data_to_core[3];
			assign ch18_rx_data_in[63] = s0_123_1__core_periphery__data_to_core[2];
			assign ch18_rx_data_in[62] = s0_123_1__core_periphery__data_to_core[1];
			assign ch18_rx_data_in[61] = s0_123_1__core_periphery__data_to_core[31];
			assign ch18_rx_data_in[60] = s0_123_1__core_periphery__data_to_core[30];
			assign ch18_rx_data_in[59] = s0_123_1__core_periphery__data_to_core[28];
			assign ch18_rx_data_in[58] = s0_123_1__core_periphery__data_to_core[7];
			assign ch18_rx_data_in[57] = s0_123_1__core_periphery__data_to_core[5];
			assign ch18_rx_data_in[56] = s0_123_1__core_periphery__data_to_core[35];
			assign ch18_rx_data_in[55] = s0_123_1__core_periphery__data_to_core[33];
			assign ch18_rx_data_in[54] = s0_123_1__core_periphery__data_to_core[11];
			assign ch18_rx_data_in[53] = s0_123_1__core_periphery__data_to_core[10];
			assign ch18_rx_data_in[52] = s0_123_1__core_periphery__data_to_core[9];
			assign ch18_rx_data_in[51] = s0_123_1__core_periphery__data_to_core[8];
			assign ch18_rx_data_in[50] = s0_123_1__core_periphery__data_to_core[38];
			assign ch18_rx_data_in[49] = s0_123_1__core_periphery__data_to_core[36];
			assign ch18_rx_data_in[48] = s0_123_1__core_periphery__data_to_core[15];
			assign ch18_rx_data_in[47] = s0_123_1__core_periphery__data_to_core[14];
			assign ch18_rx_data_in[46] = s0_123_1__core_periphery__data_to_core[13];
			assign ch18_rx_data_in[45] = s0_123_1__core_periphery__data_to_core[43];
			assign ch18_rx_data_in[44] = s0_123_1__core_periphery__data_to_core[42];
			assign ch18_rx_data_in[43] = s0_123_1__core_periphery__data_to_core[40];
			assign ch18_rx_data_in[42] = s0_123_1__core_periphery__data_to_core[19];
			assign ch18_rx_data_in[41] = s0_123_1__core_periphery__data_to_core[17];
			assign ch18_rx_data_in[40] = s0_123_1__core_periphery__data_to_core[47];
			assign ch18_rx_data_in[39] = s0_123_1__core_periphery__data_to_core[45];
			//assign ch18_rx_data_in[39] = s0_123_1__core_periphery__data_to_core[23];
			assign ch18_rx_data_in[38] = s0_123_1__core_periphery__data_to_core[22];
			assign ch18_rx_data_in[37] = s0_123_1__core_periphery__data_to_core[20];
			assign ch18_rx_data_in[36] = s0_123_1__core_periphery__data_to_core[51];
			assign ch18_rx_data_in[35] = s0_123_1__core_periphery__data_to_core[49];
			assign ch18_rx_data_in[34] = s0_123_1__core_periphery__data_to_core[80];
			assign ch18_rx_data_in[33] = s0_123_1__core_periphery__data_to_core[82];
			assign ch18_rx_data_in[32] = s0_123_1__core_periphery__data_to_core[52];
			assign ch18_rx_data_in[31] = s0_123_1__core_periphery__data_to_core[54];
			assign ch18_rx_data_in[30] = s0_123_1__core_periphery__data_to_core[55];
			assign ch18_rx_data_in[29] = s0_123_1__core_periphery__data_to_core[84];
			assign ch18_rx_data_in[28] = s0_123_1__core_periphery__data_to_core[86];
			assign ch18_rx_data_in[27] = s0_123_1__core_periphery__data_to_core[87];
			assign ch18_rx_data_in[26] = s0_123_1__core_periphery__data_to_core[57];
			assign ch18_rx_data_in[25] = s0_123_1__core_periphery__data_to_core[58];
			assign ch18_rx_data_in[24] = s0_123_1__core_periphery__data_to_core[88];
			assign ch18_rx_data_in[23] = s0_123_1__core_periphery__data_to_core[90];
			assign ch18_rx_data_in[22] = s0_123_1__core_periphery__data_to_core[60];
			assign ch18_rx_data_in[21] = s0_123_1__core_periphery__data_to_core[62];
			assign ch18_rx_data_in[20] = s0_123_1__core_periphery__data_to_core[63];
			assign ch18_rx_data_in[19] = s0_123_1__core_periphery__data_to_core[92];
			assign ch18_rx_data_in[18] = s0_123_1__core_periphery__data_to_core[93];
			assign ch18_rx_data_in[17] = s0_123_1__core_periphery__data_to_core[95];
			assign ch18_rx_data_in[16] = s0_123_1__core_periphery__data_to_core[65];
			assign ch18_rx_data_in[15] = s0_123_1__core_periphery__data_to_core[66];
			assign ch18_rx_data_in[14] = s0_123_1__core_periphery__data_to_core[67];
			assign ch18_rx_data_in[13] = s0_123_1__core_periphery__data_to_core[96];
			assign ch18_rx_data_in[12] = s0_123_1__core_periphery__data_to_core[98];
			assign ch18_rx_data_in[11] = s0_123_1__core_periphery__data_to_core[99];
			assign ch18_rx_data_in[10] = s0_123_1__core_periphery__data_to_core[69];
			assign ch18_rx_data_in[9] = s0_123_1__core_periphery__data_to_core[70];
			assign ch18_rx_data_in[8] = s0_123_1__core_periphery__data_to_core[100];
			assign ch18_rx_data_in[7] = s0_123_1__core_periphery__data_to_core[102];
			assign ch18_rx_data_in[6] = s0_123_1__core_periphery__data_to_core[72];
			assign ch18_rx_data_in[5] = s0_123_1__core_periphery__data_to_core[74];
			assign ch18_rx_data_in[4] = s0_123_1__core_periphery__data_to_core[75];
			assign ch18_rx_data_in[3] = s0_123_1__core_periphery__data_to_core[104];
			assign ch18_rx_data_in[2] = s0_123_1__core_periphery__data_to_core[105];
			assign ch18_rx_data_in[1] = s0_123_1__core_periphery__data_to_core[107];
			assign ch18_rx_data_in[0] = s0_123_1__core_periphery__data_to_core[77];


			//channel 19


			//assign ch19_rx_data_in[79] = s0_130_1__core_periphery__data_to_core[70];
			assign ch19_rx_data_in[77] = s0_130_1__core_periphery__data_to_core[100];
			assign ch19_rx_data_in[76] = s0_130_1__core_periphery__data_to_core[102];
			assign ch19_rx_data_in[75] = s0_130_1__core_periphery__data_to_core[72];
			assign ch19_rx_data_in[74] = s0_130_1__core_periphery__data_to_core[74];
			assign ch19_rx_data_in[73] = s0_130_1__core_periphery__data_to_core[75];
			assign ch19_rx_data_in[72] = s0_130_1__core_periphery__data_to_core[104];
			assign ch19_rx_data_in[71] = s0_130_1__core_periphery__data_to_core[105];
			assign ch19_rx_data_in[70] = s0_130_1__core_periphery__data_to_core[107];
			assign ch19_rx_data_in[69] = s0_130_1__core_periphery__data_to_core[77];
			assign ch19_rx_data_in[68] = s0_130_1__core_periphery__data_to_core[78];
			assign ch19_rx_data_in[67] = s0_130_1__core_periphery__data_to_core[79];
			assign ch19_rx_data_in[66] = s0_129_1__core_periphery__data_to_core[26];
			assign ch19_rx_data_in[65] = s0_129_1__core_periphery__data_to_core[24];
			assign ch19_rx_data_in[64] = s0_129_1__core_periphery__data_to_core[3];
			assign ch19_rx_data_in[63] = s0_129_1__core_periphery__data_to_core[2];
			assign ch19_rx_data_in[62] = s0_129_1__core_periphery__data_to_core[1];
			assign ch19_rx_data_in[61] = s0_129_1__core_periphery__data_to_core[31];
			assign ch19_rx_data_in[60] = s0_129_1__core_periphery__data_to_core[30];
			assign ch19_rx_data_in[59] = s0_129_1__core_periphery__data_to_core[28];
			assign ch19_rx_data_in[58] = s0_129_1__core_periphery__data_to_core[7];
			assign ch19_rx_data_in[57] = s0_129_1__core_periphery__data_to_core[5];
			assign ch19_rx_data_in[56] = s0_129_1__core_periphery__data_to_core[35];
			assign ch19_rx_data_in[55] = s0_129_1__core_periphery__data_to_core[33];
			assign ch19_rx_data_in[54] = s0_129_1__core_periphery__data_to_core[11];
			assign ch19_rx_data_in[53] = s0_129_1__core_periphery__data_to_core[10];
			assign ch19_rx_data_in[52] = s0_129_1__core_periphery__data_to_core[9];
			assign ch19_rx_data_in[51] = s0_129_1__core_periphery__data_to_core[8];
			assign ch19_rx_data_in[50] = s0_129_1__core_periphery__data_to_core[38];
			assign ch19_rx_data_in[49] = s0_129_1__core_periphery__data_to_core[36];
			assign ch19_rx_data_in[48] = s0_129_1__core_periphery__data_to_core[15];
			assign ch19_rx_data_in[47] = s0_129_1__core_periphery__data_to_core[14];
			assign ch19_rx_data_in[46] = s0_129_1__core_periphery__data_to_core[13];
			assign ch19_rx_data_in[45] = s0_129_1__core_periphery__data_to_core[43];
			assign ch19_rx_data_in[44] = s0_129_1__core_periphery__data_to_core[42];
			assign ch19_rx_data_in[43] = s0_129_1__core_periphery__data_to_core[40];
			assign ch19_rx_data_in[42] = s0_129_1__core_periphery__data_to_core[19];
			assign ch19_rx_data_in[41] = s0_129_1__core_periphery__data_to_core[17];
			assign ch19_rx_data_in[40] = s0_129_1__core_periphery__data_to_core[47];
			assign ch19_rx_data_in[39] = s0_129_1__core_periphery__data_to_core[45];
			//assign ch19_rx_data_in[39] = s0_129_1__core_periphery__data_to_core[23];
			assign ch19_rx_data_in[38] = s0_129_1__core_periphery__data_to_core[22];
			assign ch19_rx_data_in[37] = s0_129_1__core_periphery__data_to_core[20];
			assign ch19_rx_data_in[36] = s0_129_1__core_periphery__data_to_core[51];
			assign ch19_rx_data_in[35] = s0_129_1__core_periphery__data_to_core[49];
			assign ch19_rx_data_in[34] = s0_129_1__core_periphery__data_to_core[80];
			assign ch19_rx_data_in[33] = s0_129_1__core_periphery__data_to_core[82];
			assign ch19_rx_data_in[32] = s0_129_1__core_periphery__data_to_core[52];
			assign ch19_rx_data_in[31] = s0_129_1__core_periphery__data_to_core[54];
			assign ch19_rx_data_in[30] = s0_129_1__core_periphery__data_to_core[55];
			assign ch19_rx_data_in[29] = s0_129_1__core_periphery__data_to_core[84];
			assign ch19_rx_data_in[28] = s0_129_1__core_periphery__data_to_core[86];
			assign ch19_rx_data_in[27] = s0_129_1__core_periphery__data_to_core[87];
			assign ch19_rx_data_in[26] = s0_129_1__core_periphery__data_to_core[57];
			assign ch19_rx_data_in[25] = s0_129_1__core_periphery__data_to_core[58];
			assign ch19_rx_data_in[24] = s0_129_1__core_periphery__data_to_core[88];
			assign ch19_rx_data_in[23] = s0_129_1__core_periphery__data_to_core[90];
			assign ch19_rx_data_in[22] = s0_129_1__core_periphery__data_to_core[60];
			assign ch19_rx_data_in[21] = s0_129_1__core_periphery__data_to_core[62];
			assign ch19_rx_data_in[20] = s0_129_1__core_periphery__data_to_core[63];
			assign ch19_rx_data_in[19] = s0_129_1__core_periphery__data_to_core[92];
			assign ch19_rx_data_in[18] = s0_129_1__core_periphery__data_to_core[93];
			assign ch19_rx_data_in[17] = s0_129_1__core_periphery__data_to_core[95];
			assign ch19_rx_data_in[16] = s0_129_1__core_periphery__data_to_core[65];
			assign ch19_rx_data_in[15] = s0_129_1__core_periphery__data_to_core[66];
			assign ch19_rx_data_in[14] = s0_129_1__core_periphery__data_to_core[67];
			assign ch19_rx_data_in[13] = s0_129_1__core_periphery__data_to_core[96];
			assign ch19_rx_data_in[12] = s0_129_1__core_periphery__data_to_core[98];
			assign ch19_rx_data_in[11] = s0_129_1__core_periphery__data_to_core[99];
			assign ch19_rx_data_in[10] = s0_129_1__core_periphery__data_to_core[69];
			assign ch19_rx_data_in[9] = s0_129_1__core_periphery__data_to_core[70];
			assign ch19_rx_data_in[8] = s0_129_1__core_periphery__data_to_core[100];
			assign ch19_rx_data_in[7] = s0_129_1__core_periphery__data_to_core[102];
			assign ch19_rx_data_in[6] = s0_129_1__core_periphery__data_to_core[72];
			assign ch19_rx_data_in[5] = s0_129_1__core_periphery__data_to_core[74];
			assign ch19_rx_data_in[4] = s0_129_1__core_periphery__data_to_core[75];
			assign ch19_rx_data_in[3] = s0_129_1__core_periphery__data_to_core[104];
			assign ch19_rx_data_in[2] = s0_129_1__core_periphery__data_to_core[105];
			assign ch19_rx_data_in[1] = s0_129_1__core_periphery__data_to_core[107];
			assign ch19_rx_data_in[0] = s0_129_1__core_periphery__data_to_core[77];


			//channel 20

			//assign ch20_rx_data_in[79] = s0_136_1__core_periphery__data_to_core[70];
			assign ch20_rx_data_in[77] = s0_136_1__core_periphery__data_to_core[100];
			assign ch20_rx_data_in[76] = s0_136_1__core_periphery__data_to_core[102];
			assign ch20_rx_data_in[75] = s0_136_1__core_periphery__data_to_core[72];
			assign ch20_rx_data_in[74] = s0_136_1__core_periphery__data_to_core[74];
			assign ch20_rx_data_in[73] = s0_136_1__core_periphery__data_to_core[75];
			assign ch20_rx_data_in[72] = s0_136_1__core_periphery__data_to_core[104];
			assign ch20_rx_data_in[71] = s0_136_1__core_periphery__data_to_core[105];
			assign ch20_rx_data_in[70] = s0_136_1__core_periphery__data_to_core[107];
			assign ch20_rx_data_in[69] = s0_136_1__core_periphery__data_to_core[77];
			assign ch20_rx_data_in[68] = s0_136_1__core_periphery__data_to_core[78];
			assign ch20_rx_data_in[67] = s0_136_1__core_periphery__data_to_core[79];
			assign ch20_rx_data_in[66] = s0_135_1__core_periphery__data_to_core[26];
			assign ch20_rx_data_in[65] = s0_135_1__core_periphery__data_to_core[24];
			assign ch20_rx_data_in[64] = s0_135_1__core_periphery__data_to_core[3];
			assign ch20_rx_data_in[63] = s0_135_1__core_periphery__data_to_core[2];
			assign ch20_rx_data_in[62] = s0_135_1__core_periphery__data_to_core[1];
			assign ch20_rx_data_in[61] = s0_135_1__core_periphery__data_to_core[31];
			assign ch20_rx_data_in[60] = s0_135_1__core_periphery__data_to_core[30];
			assign ch20_rx_data_in[59] = s0_135_1__core_periphery__data_to_core[28];
			assign ch20_rx_data_in[58] = s0_135_1__core_periphery__data_to_core[7];
			assign ch20_rx_data_in[57] = s0_135_1__core_periphery__data_to_core[5];
			assign ch20_rx_data_in[56] = s0_135_1__core_periphery__data_to_core[35];
			assign ch20_rx_data_in[55] = s0_135_1__core_periphery__data_to_core[33];
			assign ch20_rx_data_in[54] = s0_135_1__core_periphery__data_to_core[11];
			assign ch20_rx_data_in[53] = s0_135_1__core_periphery__data_to_core[10];
			assign ch20_rx_data_in[52] = s0_135_1__core_periphery__data_to_core[9];
			assign ch20_rx_data_in[51] = s0_135_1__core_periphery__data_to_core[8];
			assign ch20_rx_data_in[50] = s0_135_1__core_periphery__data_to_core[38];
			assign ch20_rx_data_in[49] = s0_135_1__core_periphery__data_to_core[36];
			assign ch20_rx_data_in[48] = s0_135_1__core_periphery__data_to_core[15];
			assign ch20_rx_data_in[47] = s0_135_1__core_periphery__data_to_core[14];
			assign ch20_rx_data_in[46] = s0_135_1__core_periphery__data_to_core[13];
			assign ch20_rx_data_in[45] = s0_135_1__core_periphery__data_to_core[43];
			assign ch20_rx_data_in[44] = s0_135_1__core_periphery__data_to_core[42];
			assign ch20_rx_data_in[43] = s0_135_1__core_periphery__data_to_core[40];
			assign ch20_rx_data_in[42] = s0_135_1__core_periphery__data_to_core[19];
			assign ch20_rx_data_in[41] = s0_135_1__core_periphery__data_to_core[17];
			assign ch20_rx_data_in[40] = s0_135_1__core_periphery__data_to_core[47];
			assign ch20_rx_data_in[39] = s0_135_1__core_periphery__data_to_core[45];
			//assign ch20_rx_data_in[39] = s0_135_1__core_periphery__data_to_core[23];
			assign ch20_rx_data_in[38] = s0_135_1__core_periphery__data_to_core[22];
			assign ch20_rx_data_in[37] = s0_135_1__core_periphery__data_to_core[20];
			assign ch20_rx_data_in[36] = s0_135_1__core_periphery__data_to_core[51];
			assign ch20_rx_data_in[35] = s0_135_1__core_periphery__data_to_core[49];
			assign ch20_rx_data_in[34] = s0_135_1__core_periphery__data_to_core[80];
			assign ch20_rx_data_in[33] = s0_135_1__core_periphery__data_to_core[82];
			assign ch20_rx_data_in[32] = s0_135_1__core_periphery__data_to_core[52];
			assign ch20_rx_data_in[31] = s0_135_1__core_periphery__data_to_core[54];
			assign ch20_rx_data_in[30] = s0_135_1__core_periphery__data_to_core[55];
			assign ch20_rx_data_in[29] = s0_135_1__core_periphery__data_to_core[84];
			assign ch20_rx_data_in[28] = s0_135_1__core_periphery__data_to_core[86];
			assign ch20_rx_data_in[27] = s0_135_1__core_periphery__data_to_core[87];
			assign ch20_rx_data_in[26] = s0_135_1__core_periphery__data_to_core[57];
			assign ch20_rx_data_in[25] = s0_135_1__core_periphery__data_to_core[58];
			assign ch20_rx_data_in[24] = s0_135_1__core_periphery__data_to_core[88];
			assign ch20_rx_data_in[23] = s0_135_1__core_periphery__data_to_core[90];
			assign ch20_rx_data_in[22] = s0_135_1__core_periphery__data_to_core[60];
			assign ch20_rx_data_in[21] = s0_135_1__core_periphery__data_to_core[62];
			assign ch20_rx_data_in[20] = s0_135_1__core_periphery__data_to_core[63];
			assign ch20_rx_data_in[19] = s0_135_1__core_periphery__data_to_core[92];
			assign ch20_rx_data_in[18] = s0_135_1__core_periphery__data_to_core[93];
			assign ch20_rx_data_in[17] = s0_135_1__core_periphery__data_to_core[95];
			assign ch20_rx_data_in[16] = s0_135_1__core_periphery__data_to_core[65];
			assign ch20_rx_data_in[15] = s0_135_1__core_periphery__data_to_core[66];
			assign ch20_rx_data_in[14] = s0_135_1__core_periphery__data_to_core[67];
			assign ch20_rx_data_in[13] = s0_135_1__core_periphery__data_to_core[96];
			assign ch20_rx_data_in[12] = s0_135_1__core_periphery__data_to_core[98];
			assign ch20_rx_data_in[11] = s0_135_1__core_periphery__data_to_core[99];
			assign ch20_rx_data_in[10] = s0_135_1__core_periphery__data_to_core[69];
			assign ch20_rx_data_in[9] = s0_135_1__core_periphery__data_to_core[70];
			assign ch20_rx_data_in[8] = s0_135_1__core_periphery__data_to_core[100];
			assign ch20_rx_data_in[7] = s0_135_1__core_periphery__data_to_core[102];
			assign ch20_rx_data_in[6] = s0_135_1__core_periphery__data_to_core[72];
			assign ch20_rx_data_in[5] = s0_135_1__core_periphery__data_to_core[74];
			assign ch20_rx_data_in[4] = s0_135_1__core_periphery__data_to_core[75];
			assign ch20_rx_data_in[3] = s0_135_1__core_periphery__data_to_core[104];
			assign ch20_rx_data_in[2] = s0_135_1__core_periphery__data_to_core[105];
			assign ch20_rx_data_in[1] = s0_135_1__core_periphery__data_to_core[107];
			assign ch20_rx_data_in[0] = s0_135_1__core_periphery__data_to_core[77];

		end
	endgenerate 
	
	generate if (DEVICE_WIDTH == "pcie_x4x4x4x4")   begin 
	
always @(posedge i_clk)
begin 
	if(p2_reset == 0)
	begin 
	
		ch0_rx_data_in_r <= 0;
		ch1_rx_data_in_r <= 0;
		ch2_rx_data_in_r <= 0;
		ch3_rx_data_in_r <= 0;
		ch4_rx_data_in_r <= 0;

	
	end 
	
	else 
	begin 
		ch0_rx_data_in_r <= ch0_rx_data_in;
		ch1_rx_data_in_r <= ch1_rx_data_in;
		ch2_rx_data_in_r <= ch2_rx_data_in;
		ch3_rx_data_in_r <= ch3_rx_data_in;
		ch4_rx_data_in_r <= ch4_rx_data_in;


	end 
end

always @(posedge i_clk)
begin 
	if(p0_reset == 0)
	begin 
	

		ch5_rx_data_in_r <= 0;
		ch6_rx_data_in_r <= 0;
		ch7_rx_data_in_r <= 0;
		ch8_rx_data_in_r <= 0;
		ch9_rx_data_in_r <= 0;

	
	end 
	
	else 
	begin 

		ch5_rx_data_in_r <= ch5_rx_data_in;
		ch6_rx_data_in_r <= ch6_rx_data_in;
		ch7_rx_data_in_r <= ch7_rx_data_in;
		ch8_rx_data_in_r <= ch8_rx_data_in;
		ch9_rx_data_in_r <= ch9_rx_data_in;


	end 
end

always @(posedge i_clk)
begin 
	if(p1_reset == 0)
	begin 
	

		ch12_rx_data_in_r <= 0;
		ch13_rx_data_in_r <= 0;
		ch14_rx_data_in_r <= 0;
		ch15_rx_data_in_r <= 0;
		ch16_rx_data_in_r <= 0;

	
	end 
	
	else 
	begin 

		ch12_rx_data_in_r <= ch12_rx_data_in;
		ch13_rx_data_in_r <= ch13_rx_data_in;
		ch14_rx_data_in_r <= ch14_rx_data_in;
		ch15_rx_data_in_r <= ch15_rx_data_in;
		ch16_rx_data_in_r <= ch16_rx_data_in;


	end 
end

always @(posedge i_clk)
begin 
	if(p3_reset == 0)
	begin 
	

		ch17_rx_data_in_r <= 0;
		ch18_rx_data_in_r <= 0;
		ch19_rx_data_in_r <= 0;
		ch20_rx_data_in_r <= 0;
		ch21_rx_data_in_r <= 0;
	
	end 
	
	else 
	begin 

		ch17_rx_data_in_r <= ch17_rx_data_in;
		ch18_rx_data_in_r <= ch18_rx_data_in;
		ch19_rx_data_in_r <= ch19_rx_data_in;
		ch20_rx_data_in_r <= ch20_rx_data_in;
		ch21_rx_data_in_r <= ch21_rx_data_in;

	end 
end

localparam AIB_WIDTH = 78;
localparam NUM_CHAN = 20; 
localparam ECC_OUT_WIDTH = 70;
genvar ww;

logic [NUM_CHAN * AIB_WIDTH-1:0] i_rx_ecc_data;
logic [NUM_CHAN * ECC_OUT_WIDTH-1:0] o_rx_ecc_data;
logic [NUM_CHAN-1:0] [AIB_WIDTH-1:0] data_in;
logic [NUM_CHAN-1:0] [ECC_OUT_WIDTH-1:0] data_out;
logic [NUM_CHAN-1:0] o_int_sec;
logic [NUM_CHAN-1:0] o_int_ded;
logic [NUM_CHAN-1:0] o_syndrome;

assign i_rx_ecc_data	 =  (	
							{{ch21_rx_ecc_data_in},
							{ch20_rx_ecc_data_in},
							{ch19_rx_ecc_data_in},
							{ch18_rx_ecc_data_in}, 
							{ch17_rx_ecc_data_in}, 
							{ch16_rx_ecc_data_in},
							{ch15_rx_ecc_data_in}, 
							{ch14_rx_ecc_data_in}, 
							{ch13_rx_ecc_data_in},
							{ch12_rx_ecc_data_in},  
							{ch9_rx_ecc_data_in}, 
							{ch8_rx_ecc_data_in},
							{ch7_rx_ecc_data_in},
							{ch6_rx_ecc_data_in}, 
							{ch5_rx_ecc_data_in},
							{ch4_rx_ecc_data_in}, 
							{ch3_rx_ecc_data_in}, 
							{ch2_rx_ecc_data_in},
							{ch1_rx_ecc_data_in},
							{ch0_rx_ecc_data_in}							}   
						);


//ecc module instantaition
for(ww=0; ww<NUM_CHAN; ww++) begin:ecc_module_instantiation
				
		assign  data_in[ww] = i_rx_ecc_data[ww*AIB_WIDTH+:AIB_WIDTH]	;	
		
				wrlib_ecc_dec_c78_d70 inst_rx_ecc (

				   .o_int_sec 		(o_int_sec[ww]),
				   .o_int_ded		(o_int_ded[ww]),
				   .o_syndrome		(o_syndrome[ww]),
				   .i_code			(data_in[ww]),
				   .o_data			(data_out[ww])

				);
			
		assign o_rx_ecc_data[ww*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] = data_out[ww];
		
end:ecc_module_instantiation 

assign  ch0_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch0_rx_data_in_r[77:70],70'd0} :	ch0_rx_data_in_r[77:0] ;
assign  ch1_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch1_rx_data_in_r[77:70],70'd0} :	ch1_rx_data_in_r[77:0] ;
assign  ch2_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch2_rx_data_in_r[77:70],70'd0} :	ch2_rx_data_in_r[77:0] ;						
assign  ch3_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch3_rx_data_in_r[77:70],70'd0} : 	ch3_rx_data_in_r[77:0] ;	
assign  ch4_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch4_rx_data_in_r[77:70],70'd0} : 	ch4_rx_data_in_r[77:0] ;	
assign  ch5_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch5_rx_data_in_r[77:70],70'd0} : 	ch5_rx_data_in_r[77:0] ;
assign  ch6_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch6_rx_data_in_r[77:70],70'd0} : 	ch6_rx_data_in_r[77:0] ;
assign  ch7_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch7_rx_data_in_r[77:70],70'd0} : 	ch7_rx_data_in_r[77:0] ;	
assign  ch8_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch8_rx_data_in_r[77:70],70'd0} : 	ch8_rx_data_in_r[77:0] ;
assign  ch9_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch9_rx_data_in_r[77:70],70'd0} : 	ch9_rx_data_in_r[77:0] ;	
assign  ch12_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch12_rx_data_in_r[77:70],70'd0} :    ch12_rx_data_in_r[77:0] ;	
assign  ch13_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch13_rx_data_in_r[77:70],70'd0} :    ch13_rx_data_in_r[77:0] ;
assign  ch14_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch14_rx_data_in_r[77:70],70'd0} :    ch14_rx_data_in_r[77:0] ;
assign  ch15_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch15_rx_data_in_r[77:70],70'd0} :    ch15_rx_data_in_r[77:0] ;
assign  ch16_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch16_rx_data_in_r[77:70],70'd0} :    ch16_rx_data_in_r[77:0] ;	
assign  ch17_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch17_rx_data_in_r[77:70],70'd0} :    ch17_rx_data_in_r[77:0] ;
assign  ch18_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch18_rx_data_in_r[77:70],70'd0} :    ch18_rx_data_in_r[77:0] ; 
assign  ch19_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch19_rx_data_in_r[77:70],70'd0} :    ch19_rx_data_in_r[77:0] ; 
assign  ch20_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch20_rx_data_in_r[77:70],70'd0} :    ch20_rx_data_in_r[77:0] ; 
assign  ch21_rx_ecc_data_in 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? {ch21_rx_data_in_r[77:70],70'd0} :    ch21_rx_data_in_r[77:0] ;


// mux to enable or disable ECC
assign  ch0_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 	ch0_rx_data_in_r[69:0]    :   o_rx_ecc_data[0*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //  ch0_rx_ecc0_data_out;
assign  ch1_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 	ch1_rx_data_in_r[69:0]    :   o_rx_ecc_data[1*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //  ch1_rx_ecc0_data_out;
assign  ch2_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 	ch2_rx_data_in_r[69:0]    :   o_rx_ecc_data[2*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //  ch2_rx_ecc0_data_out;						
assign  ch3_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 	ch3_rx_data_in_r[69:0]    :   o_rx_ecc_data[3*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch3_rx_ecc0_data_out;	
assign  ch4_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 	ch4_rx_data_in_r[69:0]    :   o_rx_ecc_data[4*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch4_rx_ecc0_data_out;	
assign  ch5_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 	ch5_rx_data_in_r[69:0]    :   o_rx_ecc_data[5*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch5_rx_ecc0_data_out;
assign  ch6_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 	ch6_rx_data_in_r[69:0]    :   o_rx_ecc_data[6*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch6_rx_ecc0_data_out;
assign  ch7_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 	ch7_rx_data_in_r[69:0]    :   o_rx_ecc_data[7*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch7_rx_ecc0_data_out;	
assign  ch8_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 	ch8_rx_data_in_r[69:0]    :   o_rx_ecc_data[8*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch8_rx_ecc0_data_out;
assign  ch9_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ? 	ch9_rx_data_in_r[69:0]    :   o_rx_ecc_data[9*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch9_rx_ecc0_data_out;	
assign  ch12_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ?    ch12_rx_data_in_r[69:0]   :   o_rx_ecc_data[10*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch12_rx_ecc0_data_out;	
assign  ch13_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ?    ch13_rx_data_in_r[69:0]   :   o_rx_ecc_data[11*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch13_rx_ecc0_data_out;
assign  ch14_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ?    ch14_rx_data_in_r[69:0]   :   o_rx_ecc_data[12*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch14_rx_ecc0_data_out;
assign  ch15_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ?    ch15_rx_data_in_r[69:0]   :   o_rx_ecc_data[13*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch15_rx_ecc0_data_out;
assign  ch16_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ?    ch16_rx_data_in_r[69:0]   :   o_rx_ecc_data[14*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch16_rx_ecc0_data_out;	
assign  ch17_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ?    ch17_rx_data_in_r[69:0]   :   o_rx_ecc_data[15*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch17_rx_ecc0_data_out;
assign  ch18_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ?    ch18_rx_data_in_r[69:0]   :   o_rx_ecc_data[16*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch18_rx_ecc0_data_out;
assign  ch19_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ?    ch19_rx_data_in_r[69:0]   :   o_rx_ecc_data[17*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch19_rx_ecc0_data_out;
assign  ch20_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ?    ch20_rx_data_in_r[69:0]   :   o_rx_ecc_data[18*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch20_rx_ecc0_data_out;
assign  ch21_rx_ecc_data_out 	= (core4_0_enable_ecc_hwtcl ==1'b0) ?    ch21_rx_data_in_r[69:0]   :   o_rx_ecc_data[19*ECC_OUT_WIDTH+:ECC_OUT_WIDTH] ; //ch21_rx_ecc0_data_out;




//mux to enable/disable deskew module
//localparam deskew_enable = 1'b0;
assign ch0_rx_data_out  =  (deskew_enable ==1'b1) ?  ch0_rx_dsk_data_out : {ch0_rx_ecc_data_in[77:70], ch0_rx_ecc_data_out[69:0]};
assign ch1_rx_data_out  =  (deskew_enable ==1'b1) ?  ch1_rx_dsk_data_out : {ch1_rx_ecc_data_in[77:70], ch1_rx_ecc_data_out[69:0]};
assign ch2_rx_data_out  =  (deskew_enable ==1'b1) ?  ch2_rx_dsk_data_out : {ch2_rx_ecc_data_in[77:70], ch2_rx_ecc_data_out[69:0]};
assign ch3_rx_data_out  =  (deskew_enable ==1'b1) ?  ch3_rx_dsk_data_out : {ch3_rx_ecc_data_in[77:70], ch3_rx_ecc_data_out[69:0]};
assign ch4_rx_data_out  =  (deskew_enable ==1'b1) ?  ch4_rx_dsk_data_out : {ch4_rx_ecc_data_in[77:70], ch4_rx_ecc_data_out[69:0]};
assign ch5_rx_data_out  =  (deskew_enable ==1'b1) ?  ch5_rx_dsk_data_out : {ch5_rx_ecc_data_in[77:70], ch5_rx_ecc_data_out[69:0]};
assign ch6_rx_data_out  =  (deskew_enable ==1'b1) ?  ch6_rx_dsk_data_out : {ch6_rx_ecc_data_in[77:70], ch6_rx_ecc_data_out[69:0]};
assign ch7_rx_data_out  =  (deskew_enable ==1'b1) ?  ch7_rx_dsk_data_out : {ch7_rx_ecc_data_in[77:70], ch7_rx_ecc_data_out[69:0]};
assign ch8_rx_data_out  =  (deskew_enable ==1'b1) ?  ch8_rx_dsk_data_out : {ch8_rx_ecc_data_in[77:70], ch8_rx_ecc_data_out[69:0]};
assign ch9_rx_data_out  =  (deskew_enable ==1'b1) ?  ch9_rx_dsk_data_out : {ch9_rx_ecc_data_in[77:70], ch9_rx_ecc_data_out[69:0]};
assign ch12_rx_data_out  =  (deskew_enable ==1'b1) ?  ch12_rx_dsk_data_out : {ch12_rx_ecc_data_in[77:70], ch12_rx_ecc_data_out[69:0]};
assign ch13_rx_data_out  =  (deskew_enable ==1'b1) ?  ch13_rx_dsk_data_out : {ch13_rx_ecc_data_in[77:70], ch13_rx_ecc_data_out[69:0]};
assign ch14_rx_data_out  =  (deskew_enable ==1'b1) ?  ch14_rx_dsk_data_out : {ch14_rx_ecc_data_in[77:70], ch14_rx_ecc_data_out[69:0]};
assign ch15_rx_data_out  =  (deskew_enable ==1'b1) ?  ch15_rx_dsk_data_out : {ch15_rx_ecc_data_in[77:70], ch15_rx_ecc_data_out[69:0]};
assign ch16_rx_data_out  =  (deskew_enable ==1'b1) ?  ch16_rx_dsk_data_out : {ch16_rx_ecc_data_in[77:70], ch16_rx_ecc_data_out[69:0]};
assign ch17_rx_data_out  =  (deskew_enable ==1'b1) ?  ch17_rx_dsk_data_out : {ch17_rx_ecc_data_in[77:70], ch17_rx_ecc_data_out[69:0]};
assign ch18_rx_data_out  =  (deskew_enable ==1'b1) ?  ch18_rx_dsk_data_out : {ch18_rx_ecc_data_in[77:70], ch18_rx_ecc_data_out[69:0]};
assign ch19_rx_data_out  =  (deskew_enable ==1'b1) ?  ch19_rx_dsk_data_out : {ch19_rx_ecc_data_in[77:70], ch19_rx_ecc_data_out[69:0]};
assign ch20_rx_data_out  =  (deskew_enable ==1'b1) ?  ch20_rx_dsk_data_out : {ch20_rx_ecc_data_in[77:70], ch20_rx_ecc_data_out[69:0]};
assign ch21_rx_data_out  =  (deskew_enable ==1'b1) ?  ch21_rx_dsk_data_out : {ch21_rx_ecc_data_in[77:70], ch21_rx_ecc_data_out[69:0]};



 


`ifdef SIM_MODE

 
logic [NUM_CHAN-1:0][7:0] delay;
wire [77:0] ch0_rx_ecc_data_in_dly;
wire [77:0] ch1_rx_ecc_data_in_dly;
wire [77:0] ch2_rx_ecc_data_in_dly;
wire [77:0] ch3_rx_ecc_data_in_dly;
wire [77:0] ch4_rx_ecc_data_in_dly;
wire [77:0] ch5_rx_ecc_data_in_dly;
wire [77:0] ch6_rx_ecc_data_in_dly;
wire [77:0] ch7_rx_ecc_data_in_dly;
wire [77:0] ch8_rx_ecc_data_in_dly;
wire [77:0] ch9_rx_ecc_data_in_dly;
wire [77:0] ch12_rx_ecc_data_in_dly;
wire [77:0] ch13_rx_ecc_data_in_dly;
wire [77:0] ch14_rx_ecc_data_in_dly;
wire [77:0] ch15_rx_ecc_data_in_dly;
wire [77:0] ch16_rx_ecc_data_in_dly;
wire [77:0] ch17_rx_ecc_data_in_dly;
wire [77:0] ch18_rx_ecc_data_in_dly;
wire [77:0] ch19_rx_ecc_data_in_dly;
wire [77:0] ch20_rx_ecc_data_in_dly;
wire [77:0] ch21_rx_ecc_data_in_dly;

wire [77:0] ch0_rx_ecc_data_out_dly;
wire [77:0] ch1_rx_ecc_data_out_dly;
wire [77:0] ch2_rx_ecc_data_out_dly;
wire [77:0] ch3_rx_ecc_data_out_dly;
wire [77:0] ch4_rx_ecc_data_out_dly;
wire [77:0] ch5_rx_ecc_data_out_dly;
wire [77:0] ch6_rx_ecc_data_out_dly;
wire [77:0] ch7_rx_ecc_data_out_dly;
wire [77:0] ch8_rx_ecc_data_out_dly;
wire [77:0] ch9_rx_ecc_data_out_dly;
wire [77:0] ch12_rx_ecc_data_out_dly;
wire [77:0] ch13_rx_ecc_data_out_dly;
wire [77:0] ch14_rx_ecc_data_out_dly;
wire [77:0] ch15_rx_ecc_data_out_dly;
wire [77:0] ch16_rx_ecc_data_out_dly;
wire [77:0] ch17_rx_ecc_data_out_dly;
wire [77:0] ch18_rx_ecc_data_out_dly;
wire [77:0] ch19_rx_ecc_data_out_dly;
wire [77:0] ch20_rx_ecc_data_out_dly;
wire [77:0] ch21_rx_ecc_data_out_dly;

logic [NUM_CHAN*AIB_WIDTH-1:0] aib_data;
logic [NUM_CHAN*AIB_WIDTH-1:0] o_aib_data;
logic [NUM_CHAN-1:0] [AIB_WIDTH-1:0] data;
logic [NUM_CHAN-1:0] [AIB_WIDTH-1:0] q;



// Logic to generate SKEW. MAX_AIB_SKEW -- adds 5 skews in each channel. RANDOM_AIB_SKEW -- adds random skew ranging from 1,5 in each channel
always_comb begin : loop_for_number_of_aib_channels
		for(i = 0; i<NUM_CHAN; i=i+1) begin // loop for number of aib channels
		`ifdef MAX_AIB_SKEW
					  delay[i][7:0] = 5; // Whatever is max delay supported on rx path.
		`elsif RANDOM_AIB_SKEW
					  delay[i][7:0] = $urandom_range(1,5);
		`else 
					  delay[i][7:0] = 0;                                                                     
		`endif
		end
		end :loop_for_number_of_aib_channels
		
		



assign aib_data	 =  (	
							{//ch18_pld_rx_fabric_data_out[78:40],ch18_pld_rx_fabric_data_out[38:0], 
							{ch21_rx_ecc_data_in[77:70], ch21_rx_ecc_data_out[69:0]},
							{ch20_rx_ecc_data_in[77:70], ch20_rx_ecc_data_out[69:0]},
							{ch19_rx_ecc_data_in[77:70], ch19_rx_ecc_data_out[69:0]}, 
							{ch18_rx_ecc_data_in[77:70], ch18_rx_ecc_data_out[69:0]}, 
							{ch17_rx_ecc_data_in[77:70], ch17_rx_ecc_data_out[69:0]},
							{ch16_rx_ecc_data_in[77:70], ch16_rx_ecc_data_out[69:0]},
							{ch15_rx_ecc_data_in[77:70], ch15_rx_ecc_data_out[69:0]}, 
							{ch14_rx_ecc_data_in[77:70], ch14_rx_ecc_data_out[69:0]}, 
							{ch13_rx_ecc_data_in[77:70], ch13_rx_ecc_data_out[69:0]},
							{ch12_rx_ecc_data_in[77:70], ch12_rx_ecc_data_out[69:0]}, 
							//  ch10_pld_rx_fabric_data_out[78:40],ch10_pld_rx_fabric_data_out[38:0], 
							{ch9_rx_ecc_data_in[77:70], ch9_rx_ecc_data_out[69:0]}, 
							{ch8_rx_ecc_data_in[77:70], ch8_rx_ecc_data_out[69:0]},
							{ch7_rx_ecc_data_in[77:70], ch7_rx_ecc_data_out[69:0]},
							{ch6_rx_ecc_data_in[77:70], ch6_rx_ecc_data_out[69:0]}, 
							{ch5_rx_ecc_data_in[77:70], ch5_rx_ecc_data_out[69:0]},
							{ch4_rx_ecc_data_in[77:70], ch4_rx_ecc_data_out[69:0]}, 
							{ch3_rx_ecc_data_in[77:70], ch3_rx_ecc_data_out[69:0]}, 
							{ch2_rx_ecc_data_in[77:70], ch2_rx_ecc_data_out[69:0]},
							{ch1_rx_ecc_data_in[77:70], ch1_rx_ecc_data_out[69:0]},
							{ch0_rx_ecc_data_in[77:70], ch0_rx_ecc_data_out[69:0]} 							}    
						);





//delay logic to add skew to the data path 
for(ww=0; ww<5; ww++) begin:delay_module_1
				
		assign  data[ww] = aib_data[ww*AIB_WIDTH+:AIB_WIDTH]	;	
		
				hip_aib_adaptor
				# (
					.DWIDTH (78)
				) inst_hip_aib_adaptor (

				   .delay 		(delay[ww]),
				   .clk			(i_clk),
				   .rst_n		(p2_reset),
				   .d			(data[ww]),
				   .q			(q[ww])

				);
			
		assign o_aib_data[ww*AIB_WIDTH+:AIB_WIDTH] = q[ww];
		
end:delay_module_1

for(ww=5; ww<10; ww++) begin:delay_module_2
				
		assign  data[ww] = aib_data[ww*AIB_WIDTH+:AIB_WIDTH]	;	
		
				hip_aib_adaptor
				# (
					.DWIDTH (78)
				) inst_hip_aib_adaptor (

				   .delay 		(delay[ww]),
				   .clk			(i_clk),
				   .rst_n		(p0_reset),
				   .d			(data[ww]),
				   .q			(q[ww])

				);
			
		assign o_aib_data[ww*AIB_WIDTH+:AIB_WIDTH] = q[ww];
		
end:delay_module_2

for(ww=10; ww<15; ww++) begin:delay_module_3
				
		assign  data[ww] = aib_data[ww*AIB_WIDTH+:AIB_WIDTH]	;	
		
				hip_aib_adaptor
				# (
					.DWIDTH (78)
				) inst_hip_aib_adaptor (

				   .delay 		(delay[ww]),
				   .clk			(i_clk),
				   .rst_n		(p1_reset),
				   .d			(data[ww]),
				   .q			(q[ww])

				);
			
		assign o_aib_data[ww*AIB_WIDTH+:AIB_WIDTH] = q[ww];
		
end:delay_module_3

for(ww=15; ww<20; ww++) begin:delay_module_4
				
		assign  data[ww] = aib_data[ww*AIB_WIDTH+:AIB_WIDTH]	;	
		
				hip_aib_adaptor
				# (
					.DWIDTH (78)
				) inst_hip_aib_adaptor (

				   .delay 		(delay[ww]),
				   .clk			(i_clk),
				   .rst_n		(p3_reset),
				   .d			(data[ww]),
				   .q			(q[ww])

				);
			
		assign o_aib_data[ww*AIB_WIDTH+:AIB_WIDTH] = q[ww];
		
end:delay_module_4
//endgenerate 



assign {	
		{//ch18_pld_rx_fabric_data_out[78:40],ch18_pld_rx_fabric_data_out[38:0], 
		{ch21_rx_ecc_data_out_dly[77:70], ch21_rx_ecc_data_out_dly[69:0]},
		{ch20_rx_ecc_data_out_dly[77:70], ch20_rx_ecc_data_out_dly[69:0]},
		{ch19_rx_ecc_data_out_dly[77:70], ch19_rx_ecc_data_out_dly[69:0]}, 
		{ch18_rx_ecc_data_out_dly[77:70], ch18_rx_ecc_data_out_dly[69:0]}, 
		{ch17_rx_ecc_data_out_dly[77:70], ch17_rx_ecc_data_out_dly[69:0]},
		{ch16_rx_ecc_data_out_dly[77:70], ch16_rx_ecc_data_out_dly[69:0]},
		{ch15_rx_ecc_data_out_dly[77:70], ch15_rx_ecc_data_out_dly[69:0]}, 
		{ch14_rx_ecc_data_out_dly[77:70], ch14_rx_ecc_data_out_dly[69:0]}, 
		{ch13_rx_ecc_data_out_dly[77:70], ch13_rx_ecc_data_out_dly[69:0]},
		{ch12_rx_ecc_data_out_dly[77:70], ch12_rx_ecc_data_out_dly[69:0]}, 
		//  ch10_pld_rx_fabric_data_out[78:40],ch10_pld_rx_fabric_data_out[38:0], 
		{ch9_rx_ecc_data_out_dly[77:70], ch9_rx_ecc_data_out_dly[69:0]}, 
		{ch8_rx_ecc_data_out_dly[77:70], ch8_rx_ecc_data_out_dly[69:0]},
		{ch7_rx_ecc_data_out_dly[77:70], ch7_rx_ecc_data_out_dly[69:0]},
		{ch6_rx_ecc_data_out_dly[77:70], ch6_rx_ecc_data_out_dly[69:0]}, 
		{ch5_rx_ecc_data_out_dly[77:70], ch5_rx_ecc_data_out_dly[69:0]},
		{ch4_rx_ecc_data_out_dly[77:70], ch4_rx_ecc_data_out_dly[69:0]}, 
		{ch3_rx_ecc_data_out_dly[77:70], ch3_rx_ecc_data_out_dly[69:0]}, 
		{ch2_rx_ecc_data_out_dly[77:70], ch2_rx_ecc_data_out_dly[69:0]},
		{ch1_rx_ecc_data_out_dly[77:70], ch1_rx_ecc_data_out_dly[69:0]},
		{ch0_rx_ecc_data_out_dly[77:70], ch0_rx_ecc_data_out_dly[69:0]}}    
		}   														=   o_aib_data;
		



			 whr_rx_deskew #(
				.DEVICE_WIDTH 							   (DEVICE_WIDTH							  ),
				.PCIE_IP_MODE                              (PCIE_IP_MODE_RPX4                         ),
				.NUM_CHAN                                  (5                            			  ),
				.AIB_WIDTH                                 (78                                        ),
				.DSK_WIDTH                                 (77                                        ),
				.DSK_MARKER_POS                            (69                                        ),
			   .DSK_DATA_PAR_WIDTH                         (64                                        ),
				.PARITY_SEG_WIDTH                          (8                                         ),
				.DIS_MONITOR                               (0                                         )
			  ) u_wrpcie_deskew_0_5_port2 (.pld_clk(i_clk),
								  .pld_rst_n(p2_reset),
								  .cfg_force_dsk_done_i(1'b0),
								  //.i_cfg_dsk_chan_sel(5'h1F),
								  .cfg_k_device_width_i(2'b00),
								  .cfg_dsk_clr_i(1'b0),
								  .aib_data_i({
												{ch4_rx_ecc_data_out_dly[77:70], ch4_rx_ecc_data_out_dly[69:0]},
												{ch3_rx_ecc_data_out_dly[77:70], ch3_rx_ecc_data_out_dly[69:0]}, 
												{ch2_rx_ecc_data_out_dly[77:70], ch2_rx_ecc_data_out_dly[69:0]},
												{ch1_rx_ecc_data_out_dly[77:70], ch1_rx_ecc_data_out_dly[69:0]},
												{ch0_rx_ecc_data_out_dly[77:70], ch0_rx_ecc_data_out_dly[69:0]}			}),
								  .aib_data_deskewed_o({
														{ch4_rx_dsk_data_out[77:70], ch4_rx_dsk_data_out[68:0]},
														{ch3_rx_dsk_data_out[77:70], ch3_rx_dsk_data_out[68:0]},
														{ch2_rx_dsk_data_out[77:70], ch2_rx_dsk_data_out[68:0]},
														{ch1_rx_dsk_data_out[77:70], ch1_rx_dsk_data_out[68:0]},
														{ch0_rx_dsk_data_out[77:70], ch0_rx_dsk_data_out[68:0]}			}),
								  .cfg_dsk_active_chans_o(),
								  .cfg_dsk_monitor_err_o(),
								  .cfg_dsk_mon_err_status_o(),
								  .fsr_dsk_mon_err_status_o(o_rx_dsk_mon_err_status_port2),
								  .fsr_dsk_status_o(o_rx_dsk_status_port2),
								  .fsr_dsk_vld_o(o_rx_dsk_done_port2),
								  .fsr_dsk_eval_done_o(o_rx_dsk_eval_done_port2));


			 whr_rx_deskew #(
				.DEVICE_WIDTH 							   (DEVICE_WIDTH							  ),
				.PCIE_IP_MODE                              (PCIE_IP_MODE_EPX16                        ),
				.NUM_CHAN                                  (5                                         ),
				.AIB_WIDTH                                 (78                                        ),
				.DSK_WIDTH                                 (77                                        ),
				.DSK_MARKER_POS                            (69                                        ),
			   .DSK_DATA_PAR_WIDTH                         (64                                        ),
				.PARITY_SEG_WIDTH                          (8                                         ),
				.DIS_MONITOR                               (0                                         )
			  ) u_wrpcie_deskew_0_5_port0 (.pld_clk(i_clk),
								  .pld_rst_n(p0_reset),
								  .cfg_force_dsk_done_i(1'b0),
								  //.i_cfg_dsk_chan_sel(5'h1F),
								  .cfg_k_device_width_i(2'b00),
								  .cfg_dsk_clr_i(1'b0),
								  .aib_data_i({
												{ch9_rx_ecc_data_out_dly[77:70], ch9_rx_ecc_data_out_dly[69:0]},
												{ch8_rx_ecc_data_out_dly[77:70], ch8_rx_ecc_data_out_dly[69:0]}, 
												{ch7_rx_ecc_data_out_dly[77:70], ch7_rx_ecc_data_out_dly[69:0]},
												{ch6_rx_ecc_data_out_dly[77:70], ch6_rx_ecc_data_out_dly[69:0]},
												{ch5_rx_ecc_data_out_dly[77:70], ch5_rx_ecc_data_out_dly[69:0]}			}),
								  .aib_data_deskewed_o({
														{ch9_rx_dsk_data_out[77:70], ch9_rx_dsk_data_out[68:0]},
														{ch8_rx_dsk_data_out[77:70], ch8_rx_dsk_data_out[68:0]},
														{ch7_rx_dsk_data_out[77:70], ch7_rx_dsk_data_out[68:0]},
														{ch6_rx_dsk_data_out[77:70], ch6_rx_dsk_data_out[68:0]},
														{ch5_rx_dsk_data_out[77:70], ch5_rx_dsk_data_out[68:0]}			}),
								  .cfg_dsk_active_chans_o(),
								  .cfg_dsk_monitor_err_o(),
								  .cfg_dsk_mon_err_status_o(),
								  .fsr_dsk_mon_err_status_o(o_rx_dsk_mon_err_status_port0),
								  .fsr_dsk_status_o(o_rx_dsk_status_port0),
								  .fsr_dsk_vld_o(o_rx_dsk_done_port0),
								  .fsr_dsk_eval_done_o(o_rx_dsk_eval_done_port0));
  
			 whr_rx_deskew #(
				.DEVICE_WIDTH 							   (DEVICE_WIDTH							  ),
				.PCIE_IP_MODE                              (PCIE_IP_MODE_EPX8                         ),
				.NUM_CHAN                                  (5                               		  ),
				.AIB_WIDTH                                 (78                                        ),
				.DSK_WIDTH                                 (77                                        ),
				.DSK_MARKER_POS                            (69                                        ),
			   .DSK_DATA_PAR_WIDTH                         (64                                        ),
				.PARITY_SEG_WIDTH                          (8                                         ),
				.DIS_MONITOR                               (0                                         )
			  ) u_wrpcie_deskew_0_5_port1 (.pld_clk(i_clk),
								  .pld_rst_n(p1_reset),
								  .cfg_force_dsk_done_i(1'b0),
								  //.i_cfg_dsk_chan_sel(5'h1F),
								  .cfg_k_device_width_i(2'b00),
								  .cfg_dsk_clr_i(1'b0),
								  .aib_data_i({
												{ch16_rx_ecc_data_out_dly[77:70], ch16_rx_ecc_data_out_dly[69:0]},
												{ch15_rx_ecc_data_out_dly[77:70], ch15_rx_ecc_data_out_dly[69:0]}, 
												{ch14_rx_ecc_data_out_dly[77:70], ch14_rx_ecc_data_out_dly[69:0]},
												{ch13_rx_ecc_data_out_dly[77:70], ch13_rx_ecc_data_out_dly[69:0]},
												{ch12_rx_ecc_data_out_dly[77:70], ch12_rx_ecc_data_out_dly[69:0]}			}),
								  .aib_data_deskewed_o({
														{ch16_rx_dsk_data_out[77:70], ch16_rx_dsk_data_out[68:0]},
														{ch15_rx_dsk_data_out[77:70], ch15_rx_dsk_data_out[68:0]},
														{ch14_rx_dsk_data_out[77:70], ch14_rx_dsk_data_out[68:0]},
														{ch13_rx_dsk_data_out[77:70], ch13_rx_dsk_data_out[68:0]},
														{ch12_rx_dsk_data_out[77:70], ch12_rx_dsk_data_out[68:0]}			}),
								  .cfg_dsk_active_chans_o(),
								  .cfg_dsk_monitor_err_o(),
								  .cfg_dsk_mon_err_status_o(),
								  .fsr_dsk_mon_err_status_o(o_rx_dsk_mon_err_status_port1),
								  .fsr_dsk_status_o(o_rx_dsk_status_port1),
								  .fsr_dsk_vld_o(o_rx_dsk_done_port1),
								  .fsr_dsk_eval_done_o(o_rx_dsk_eval_done_port1)); 

								  
			 whr_rx_deskew #(
				.DEVICE_WIDTH 							   (DEVICE_WIDTH							  ),
				.PCIE_IP_MODE                              (PCIE_IP_MODE_RPX4                         ),
				.NUM_CHAN                                  (5                            			  ),
				.AIB_WIDTH                                 (78                                        ),
				.DSK_WIDTH                                 (77                                        ),
				.DSK_MARKER_POS                            (69                                        ),
			   .DSK_DATA_PAR_WIDTH                         (64                                         ),
				.PARITY_SEG_WIDTH                          (8                                         ),
				.DIS_MONITOR                               (0                                         )
			  ) u_wrpcie_deskew_0_5_port3 (.pld_clk(i_clk),
								  .pld_rst_n(p3_reset),
								  .cfg_force_dsk_done_i(1'b0),
								  //.i_cfg_dsk_chan_sel(5'h1F),
								  .cfg_k_device_width_i(2'b00),
								  .cfg_dsk_clr_i(1'b0),
								  .aib_data_i({
												{ch21_rx_ecc_data_out_dly[77:70], ch21_rx_ecc_data_out_dly[69:0]},
												{ch20_rx_ecc_data_out_dly[77:70], ch20_rx_ecc_data_out_dly[69:0]}, 
												{ch19_rx_ecc_data_out_dly[77:70], ch19_rx_ecc_data_out_dly[69:0]},
												{ch18_rx_ecc_data_out_dly[77:70], ch18_rx_ecc_data_out_dly[69:0]},
												{ch17_rx_ecc_data_out_dly[77:70], ch17_rx_ecc_data_out_dly[69:0]}			}),
								  .aib_data_deskewed_o({
														{ch21_rx_dsk_data_out[77:70], ch21_rx_dsk_data_out[68:0]},
														{ch20_rx_dsk_data_out[77:70], ch20_rx_dsk_data_out[68:0]},
														{ch19_rx_dsk_data_out[77:70], ch19_rx_dsk_data_out[68:0]},
														{ch18_rx_dsk_data_out[77:70], ch18_rx_dsk_data_out[68:0]},
														{ch17_rx_dsk_data_out[77:70], ch17_rx_dsk_data_out[68:0]}			}),
								  .cfg_dsk_active_chans_o(),
								  .cfg_dsk_monitor_err_o(),
								  .cfg_dsk_mon_err_status_o(),
								  .fsr_dsk_mon_err_status_o(o_rx_dsk_mon_err_status_port3),
								  .fsr_dsk_status_o(o_rx_dsk_status_port3),
								  .fsr_dsk_vld_o(o_rx_dsk_done_port3),
								  .fsr_dsk_eval_done_o(o_rx_dsk_eval_done_port3)); 
								  
`else

	
	
			 whr_rx_deskew #(
				.DEVICE_WIDTH 							   (DEVICE_WIDTH							  ),
				.PCIE_IP_MODE                              (PCIE_IP_MODE_RPX4                         ),
				.NUM_CHAN                                  (5                            			  ),
				.AIB_WIDTH                                 (78                                        ),
				.DSK_WIDTH                                 (77                                        ),
				.DSK_MARKER_POS                            (69                                        ),
			   .DSK_DATA_PAR_WIDTH                         (64                                        ),
				.PARITY_SEG_WIDTH                          (8                                         ),
				.DIS_MONITOR                               (0                                         )
			  ) u_wrpcie_deskew_0_5_port2 (.pld_clk(i_clk),
								  .pld_rst_n(p2_reset),
								  .cfg_force_dsk_done_i(1'b0),
								  //.i_cfg_dsk_chan_sel(5'h1F),
								  .cfg_k_device_width_i(2'b00),
								  .cfg_dsk_clr_i(1'b0),
								  .aib_data_i({
												{ch4_rx_ecc_data_in[77:70], ch4_rx_ecc_data_out[69:0]},
												{ch3_rx_ecc_data_in[77:70], ch3_rx_ecc_data_out[69:0]}, 
												{ch2_rx_ecc_data_in[77:70], ch2_rx_ecc_data_out[69:0]},
												{ch1_rx_ecc_data_in[77:70], ch1_rx_ecc_data_out[69:0]},
												{ch0_rx_ecc_data_in[77:70], ch0_rx_ecc_data_out[69:0]}			}),
								  .aib_data_deskewed_o({
														{ch4_rx_dsk_data_out[77:70], ch4_rx_dsk_data_out[68:0]},
														{ch3_rx_dsk_data_out[77:70], ch3_rx_dsk_data_out[68:0]},
														{ch2_rx_dsk_data_out[77:70], ch2_rx_dsk_data_out[68:0]},
														{ch1_rx_dsk_data_out[77:70], ch1_rx_dsk_data_out[68:0]},
														{ch0_rx_dsk_data_out[77:70], ch0_rx_dsk_data_out[68:0]}			}),
								  .cfg_dsk_active_chans_o(),
								  .cfg_dsk_monitor_err_o(),
								  .cfg_dsk_mon_err_status_o(),
								  .fsr_dsk_mon_err_status_o(o_rx_dsk_mon_err_status_port2),
								  .fsr_dsk_status_o(o_rx_dsk_status_port2),
								  .fsr_dsk_vld_o(o_rx_dsk_done_port2),
								  .fsr_dsk_eval_done_o(o_rx_dsk_eval_done_port2));


			 whr_rx_deskew #(
				.DEVICE_WIDTH 							   (DEVICE_WIDTH							  ),
				.PCIE_IP_MODE                              (PCIE_IP_MODE_EPX16                        ),
				.NUM_CHAN                                  (5                                         ),
				.AIB_WIDTH                                 (78                                        ),
				.DSK_WIDTH                                 (77                                        ),
				.DSK_MARKER_POS                            (69                                        ),
			   .DSK_DATA_PAR_WIDTH                         (64                                        ),
				.PARITY_SEG_WIDTH                          (8                                         ),
				.DIS_MONITOR                               (0                                         )
			  ) u_wrpcie_deskew_0_5_port0 (.pld_clk(i_clk),
								  .pld_rst_n(p0_reset),
								  .cfg_force_dsk_done_i(1'b0),
								  //.i_cfg_dsk_chan_sel(5'h1F),
								  .cfg_k_device_width_i(2'b00),
								  .cfg_dsk_clr_i(1'b0),
								  .aib_data_i({
												{ch9_rx_ecc_data_in[77:70], ch9_rx_ecc_data_out[69:0]},
												{ch8_rx_ecc_data_in[77:70], ch8_rx_ecc_data_out[69:0]}, 
												{ch7_rx_ecc_data_in[77:70], ch7_rx_ecc_data_out[69:0]},
												{ch6_rx_ecc_data_in[77:70], ch6_rx_ecc_data_out[69:0]},
												{ch5_rx_ecc_data_in[77:70], ch5_rx_ecc_data_out[69:0]}			}),
								  .aib_data_deskewed_o({
														{ch9_rx_dsk_data_out[77:70], ch9_rx_dsk_data_out[68:0]},
														{ch8_rx_dsk_data_out[77:70], ch8_rx_dsk_data_out[68:0]},
														{ch7_rx_dsk_data_out[77:70], ch7_rx_dsk_data_out[68:0]},
														{ch6_rx_dsk_data_out[77:70], ch6_rx_dsk_data_out[68:0]},
														{ch5_rx_dsk_data_out[77:70], ch5_rx_dsk_data_out[68:0]}			}),
								  .cfg_dsk_active_chans_o(),
								  .cfg_dsk_monitor_err_o(),
								  .cfg_dsk_mon_err_status_o(),
								  .fsr_dsk_mon_err_status_o(o_rx_dsk_mon_err_status_port0),
								  .fsr_dsk_status_o(o_rx_dsk_status_port0),
								  .fsr_dsk_vld_o(o_rx_dsk_done_port0),
								  .fsr_dsk_eval_done_o(o_rx_dsk_eval_done_port0));
  
			 whr_rx_deskew #(
				.DEVICE_WIDTH 							   (DEVICE_WIDTH							  ),
				.PCIE_IP_MODE                              (PCIE_IP_MODE_EPX8                         ),
				.NUM_CHAN                                  (5                               		  ),
				.AIB_WIDTH                                 (78                                        ),
				.DSK_WIDTH                                 (77                                        ),
				.DSK_MARKER_POS                            (69                                        ),
			   .DSK_DATA_PAR_WIDTH                         (64                                        ),
				.PARITY_SEG_WIDTH                          (8                                         ),
				.DIS_MONITOR                               (0                                         )
			  ) u_wrpcie_deskew_0_5_port1 (.pld_clk(i_clk),
								  .pld_rst_n(p1_reset),
								  .cfg_force_dsk_done_i(1'b0),
								  //.i_cfg_dsk_chan_sel(5'h1F),
								  .cfg_k_device_width_i(2'b00),
								  .cfg_dsk_clr_i(1'b0),
								  .aib_data_i({
												{ch16_rx_ecc_data_in[77:70], ch16_rx_ecc_data_out[69:0]},
												{ch15_rx_ecc_data_in[77:70], ch15_rx_ecc_data_out[69:0]}, 
												{ch14_rx_ecc_data_in[77:70], ch14_rx_ecc_data_out[69:0]},
												{ch13_rx_ecc_data_in[77:70], ch13_rx_ecc_data_out[69:0]},
												{ch12_rx_ecc_data_in[77:70], ch12_rx_ecc_data_out[69:0]}			}),
								  .aib_data_deskewed_o({
														{ch16_rx_dsk_data_out[77:70], ch16_rx_dsk_data_out[68:0]},
														{ch15_rx_dsk_data_out[77:70], ch15_rx_dsk_data_out[68:0]},
														{ch14_rx_dsk_data_out[77:70], ch14_rx_dsk_data_out[68:0]},
														{ch13_rx_dsk_data_out[77:70], ch13_rx_dsk_data_out[68:0]},
														{ch12_rx_dsk_data_out[77:70], ch12_rx_dsk_data_out[68:0]}			}),
								  .cfg_dsk_active_chans_o(),
								  .cfg_dsk_monitor_err_o(),
								  .cfg_dsk_mon_err_status_o(),
								  .fsr_dsk_mon_err_status_o(o_rx_dsk_mon_err_status_port1),
								  .fsr_dsk_status_o(o_rx_dsk_status_port1),
								  .fsr_dsk_vld_o(o_rx_dsk_done_port1),
								  .fsr_dsk_eval_done_o(o_rx_dsk_eval_done_port1)); 

								  
			 whr_rx_deskew #(
				.DEVICE_WIDTH 							   (DEVICE_WIDTH							  ),
				.PCIE_IP_MODE                              (PCIE_IP_MODE_RPX4                         ),
				.NUM_CHAN                                  (5                            			  ),
				.AIB_WIDTH                                 (78                                        ),
				.DSK_WIDTH                                 (77                                        ),
				.DSK_MARKER_POS                            (69                                        ),
			   .DSK_DATA_PAR_WIDTH                         (64                                         ),
				.PARITY_SEG_WIDTH                          (8                                         ),
				.DIS_MONITOR                               (0                                         )
			  ) u_wrpcie_deskew_0_5_port3 (.pld_clk(i_clk),
								  .pld_rst_n(p3_reset),
								  .cfg_force_dsk_done_i(1'b0),
								  //.i_cfg_dsk_chan_sel(5'h1F),
								  .cfg_k_device_width_i(2'b00),
								  .cfg_dsk_clr_i(1'b0),
								  .aib_data_i({
												{ch21_rx_ecc_data_in[77:70], ch21_rx_ecc_data_out[69:0]},
												{ch20_rx_ecc_data_in[77:70], ch20_rx_ecc_data_out[69:0]}, 
												{ch19_rx_ecc_data_in[77:70], ch19_rx_ecc_data_out[69:0]},
												{ch18_rx_ecc_data_in[77:70], ch18_rx_ecc_data_out[69:0]},
												{ch17_rx_ecc_data_in[77:70], ch17_rx_ecc_data_out[69:0]}			}),
								  .aib_data_deskewed_o({
														{ch21_rx_dsk_data_out[77:70], ch21_rx_dsk_data_out[68:0]},
														{ch20_rx_dsk_data_out[77:70], ch20_rx_dsk_data_out[68:0]},
														{ch19_rx_dsk_data_out[77:70], ch19_rx_dsk_data_out[68:0]},
														{ch18_rx_dsk_data_out[77:70], ch18_rx_dsk_data_out[68:0]},
														{ch17_rx_dsk_data_out[77:70], ch17_rx_dsk_data_out[68:0]}			}),
								  .cfg_dsk_active_chans_o(),
								  .cfg_dsk_monitor_err_o(),
								  .cfg_dsk_mon_err_status_o(),
								  .fsr_dsk_mon_err_status_o(o_rx_dsk_mon_err_status_port3),
								  .fsr_dsk_status_o(o_rx_dsk_status_port3),
								  .fsr_dsk_vld_o(o_rx_dsk_done_port3),
								  .fsr_dsk_eval_done_o(o_rx_dsk_eval_done_port3)); 


`endif // SIM_MODE
								  
			assign ch0_rx_dsk_data_out[69]		= 1'b0;
			assign ch1_rx_dsk_data_out[69]		= 1'b0;
			assign ch2_rx_dsk_data_out[69]		= 1'b0;
			assign ch3_rx_dsk_data_out[69]		= 1'b0;
			assign ch4_rx_dsk_data_out[69]		= 1'b0;
			assign ch5_rx_dsk_data_out[69]		= 1'b0;
			assign ch6_rx_dsk_data_out[69]		= 1'b0;
			assign ch7_rx_dsk_data_out[69]		= 1'b0;
			assign ch8_rx_dsk_data_out[69]		= 1'b0;
			assign ch9_rx_dsk_data_out[69]		= 1'b0;
			assign ch12_rx_dsk_data_out[69]		= 1'b0;
			assign ch13_rx_dsk_data_out[69]		= 1'b0;
			assign ch14_rx_dsk_data_out[69]		= 1'b0;
			assign ch15_rx_dsk_data_out[69]		= 1'b0;
			assign ch16_rx_dsk_data_out[69]		= 1'b0;
			assign ch17_rx_dsk_data_out[69]		= 1'b0;	
			assign ch18_rx_dsk_data_out[69]		= 1'b0;	
			assign ch19_rx_dsk_data_out[69]		= 1'b0;	
			assign ch20_rx_dsk_data_out[69]		= 1'b0;	
			assign ch21_rx_dsk_data_out[69]		= 1'b0;	

// Logic to generate Marker bit to be sent on the TX datapath
			whr_tx_deskew  #(
				.NUM_CHAN     ( 5 	)
								) u_tx_deskew_0_5_port0 (
			.pld_clk         (i_clk                      ),
			.pld_rst_n       (p0_reset                    ),

		    .rx_dsk_marker_o (tx_dsk_marker_port0[6:2]   ));

			whr_tx_deskew  #(
				.NUM_CHAN     ( 5 	)
								) u_tx_deskew_0_5_port1 (
			.pld_clk         (i_clk                      ),
			.pld_rst_n       (p1_reset                    ),

		    .rx_dsk_marker_o (tx_dsk_marker_port1[4:0]  ));

			whr_tx_deskew  #(
				.NUM_CHAN     ( 5 	)
								) u_tx_deskew_0_5_port2 (
			.pld_clk         (i_clk                      ),
			.pld_rst_n       (p2_reset                    ),

		    .rx_dsk_marker_o (tx_dsk_marker_port2[4:0]  ));

			whr_tx_deskew  #(
				.NUM_CHAN     ( 5 	)
								) u_tx_deskew_0_5_port3 (
			.pld_clk         (i_clk                      ),
			.pld_rst_n       (p3_reset                    ),

		    .rx_dsk_marker_o (tx_dsk_marker_port3[4:0]   ));
								  
			assign {tx_dsk_marker_port0[13:7], tx_dsk_marker_port0[1:0]} = 9'h1ff;
			assign tx_dsk_marker_port1[6:5] = 2'b11;


		

			assign ch0_rx_data_in[77] = s0_4_1__core_periphery__data_to_core[100];
			assign ch0_rx_data_in[76] = s0_4_1__core_periphery__data_to_core[102];
			assign ch0_rx_data_in[75] = s0_4_1__core_periphery__data_to_core[72];
			assign ch0_rx_data_in[74] = s0_4_1__core_periphery__data_to_core[74];
			assign ch0_rx_data_in[73] = s0_4_1__core_periphery__data_to_core[75];
			assign ch0_rx_data_in[72] = s0_4_1__core_periphery__data_to_core[104];
			assign ch0_rx_data_in[71] = s0_4_1__core_periphery__data_to_core[105];
			assign ch0_rx_data_in[70] = s0_4_1__core_periphery__data_to_core[107];
			assign ch0_rx_data_in[69] = s0_4_1__core_periphery__data_to_core[77];
			assign ch0_rx_data_in[68] = s0_4_1__core_periphery__data_to_core[78];
			assign ch0_rx_data_in[67] = s0_4_1__core_periphery__data_to_core[79];
			assign ch0_rx_data_in[66] = s0_3_1__core_periphery__data_to_core[26];
			assign ch0_rx_data_in[65] = s0_3_1__core_periphery__data_to_core[24];
			assign ch0_rx_data_in[64] = s0_3_1__core_periphery__data_to_core[3];
			assign ch0_rx_data_in[63] = s0_3_1__core_periphery__data_to_core[2];
			assign ch0_rx_data_in[62] = s0_3_1__core_periphery__data_to_core[1];
			assign ch0_rx_data_in[61] = s0_3_1__core_periphery__data_to_core[31];
			assign ch0_rx_data_in[60] = s0_3_1__core_periphery__data_to_core[30];
			assign ch0_rx_data_in[59] = s0_3_1__core_periphery__data_to_core[28];
			assign ch0_rx_data_in[58] = s0_3_1__core_periphery__data_to_core[7];
			assign ch0_rx_data_in[57] = s0_3_1__core_periphery__data_to_core[5];
			assign ch0_rx_data_in[56] = s0_3_1__core_periphery__data_to_core[35];
			assign ch0_rx_data_in[55] = s0_3_1__core_periphery__data_to_core[33];
			assign ch0_rx_data_in[54] = s0_3_1__core_periphery__data_to_core[11];
			assign ch0_rx_data_in[53] = s0_3_1__core_periphery__data_to_core[10];
			assign ch0_rx_data_in[52] = s0_3_1__core_periphery__data_to_core[9];
			assign ch0_rx_data_in[51] = s0_3_1__core_periphery__data_to_core[8];
			assign ch0_rx_data_in[50] = s0_3_1__core_periphery__data_to_core[38];
			assign ch0_rx_data_in[49] = s0_3_1__core_periphery__data_to_core[36];
			assign ch0_rx_data_in[48] = s0_3_1__core_periphery__data_to_core[15];
			assign ch0_rx_data_in[47] = s0_3_1__core_periphery__data_to_core[14];
			assign ch0_rx_data_in[46] = s0_3_1__core_periphery__data_to_core[13];
			assign ch0_rx_data_in[45] = s0_3_1__core_periphery__data_to_core[43];
			assign ch0_rx_data_in[44] = s0_3_1__core_periphery__data_to_core[42];
			assign ch0_rx_data_in[43] = s0_3_1__core_periphery__data_to_core[40];
			assign ch0_rx_data_in[42] = s0_3_1__core_periphery__data_to_core[19];
			assign ch0_rx_data_in[41] = s0_3_1__core_periphery__data_to_core[17];
			assign ch0_rx_data_in[40] = s0_3_1__core_periphery__data_to_core[47];
			assign ch0_rx_data_in[39] = s0_3_1__core_periphery__data_to_core[45];
			//assign ch0_rx_data_in[39] = s0_3_1__core_periphery__data_to_core[23];
			assign ch0_rx_data_in[38] = s0_3_1__core_periphery__data_to_core[22];
			assign ch0_rx_data_in[37] = s0_3_1__core_periphery__data_to_core[20];
			assign ch0_rx_data_in[36] = s0_3_1__core_periphery__data_to_core[51];
			assign ch0_rx_data_in[35] = s0_3_1__core_periphery__data_to_core[49];
			assign ch0_rx_data_in[34] = s0_3_1__core_periphery__data_to_core[80];
			assign ch0_rx_data_in[33] = s0_3_1__core_periphery__data_to_core[82];
			assign ch0_rx_data_in[32] = s0_3_1__core_periphery__data_to_core[52];
			assign ch0_rx_data_in[31] = s0_3_1__core_periphery__data_to_core[54];
			assign ch0_rx_data_in[30] = s0_3_1__core_periphery__data_to_core[55];
			assign ch0_rx_data_in[29] = s0_3_1__core_periphery__data_to_core[84];
			assign ch0_rx_data_in[28] = s0_3_1__core_periphery__data_to_core[86];
			assign ch0_rx_data_in[27] = s0_3_1__core_periphery__data_to_core[87];
			assign ch0_rx_data_in[26] = s0_3_1__core_periphery__data_to_core[57];
			assign ch0_rx_data_in[25] = s0_3_1__core_periphery__data_to_core[58];
			assign ch0_rx_data_in[24] = s0_3_1__core_periphery__data_to_core[88];
			assign ch0_rx_data_in[23] = s0_3_1__core_periphery__data_to_core[90];
			assign ch0_rx_data_in[22] = s0_3_1__core_periphery__data_to_core[60];
			assign ch0_rx_data_in[21] = s0_3_1__core_periphery__data_to_core[62];
			assign ch0_rx_data_in[20] = s0_3_1__core_periphery__data_to_core[63];
			assign ch0_rx_data_in[19] = s0_3_1__core_periphery__data_to_core[92];
			assign ch0_rx_data_in[18] = s0_3_1__core_periphery__data_to_core[93];
			assign ch0_rx_data_in[17] = s0_3_1__core_periphery__data_to_core[95];
			assign ch0_rx_data_in[16] = s0_3_1__core_periphery__data_to_core[65];
			assign ch0_rx_data_in[15] = s0_3_1__core_periphery__data_to_core[66];
			assign ch0_rx_data_in[14] = s0_3_1__core_periphery__data_to_core[67];
			assign ch0_rx_data_in[13] = s0_3_1__core_periphery__data_to_core[96];
			assign ch0_rx_data_in[12] = s0_3_1__core_periphery__data_to_core[98];
			assign ch0_rx_data_in[11] = s0_3_1__core_periphery__data_to_core[99];
			assign ch0_rx_data_in[10] = s0_3_1__core_periphery__data_to_core[69];
			assign ch0_rx_data_in[9] = s0_3_1__core_periphery__data_to_core[70];
			assign ch0_rx_data_in[8] = s0_3_1__core_periphery__data_to_core[100];
			assign ch0_rx_data_in[7] = s0_3_1__core_periphery__data_to_core[102];
			assign ch0_rx_data_in[6] = s0_3_1__core_periphery__data_to_core[72];
			assign ch0_rx_data_in[5] = s0_3_1__core_periphery__data_to_core[74];
			assign ch0_rx_data_in[4] = s0_3_1__core_periphery__data_to_core[75];
			assign ch0_rx_data_in[3] = s0_3_1__core_periphery__data_to_core[104];
			assign ch0_rx_data_in[2] = s0_3_1__core_periphery__data_to_core[105];
			assign ch0_rx_data_in[1] = s0_3_1__core_periphery__data_to_core[107];
			assign ch0_rx_data_in[0] = s0_3_1__core_periphery__data_to_core[77];


			//assign ch1_rx_data_in[79] = s0_10_1__core_periphery__data_to_core[70];
			assign ch1_rx_data_in[77] = s0_10_1__core_periphery__data_to_core[100];
			assign ch1_rx_data_in[76] = s0_10_1__core_periphery__data_to_core[102];
			assign ch1_rx_data_in[75] = s0_10_1__core_periphery__data_to_core[72];
			assign ch1_rx_data_in[74] = s0_10_1__core_periphery__data_to_core[74];
			assign ch1_rx_data_in[73] = s0_10_1__core_periphery__data_to_core[75];
			assign ch1_rx_data_in[72] = s0_10_1__core_periphery__data_to_core[104];
			assign ch1_rx_data_in[71] = s0_10_1__core_periphery__data_to_core[105];
			assign ch1_rx_data_in[70] = s0_10_1__core_periphery__data_to_core[107];
			assign ch1_rx_data_in[69] = s0_10_1__core_periphery__data_to_core[77];
			assign ch1_rx_data_in[68] = s0_10_1__core_periphery__data_to_core[78];
			assign ch1_rx_data_in[67] = s0_10_1__core_periphery__data_to_core[79];
			assign ch1_rx_data_in[66] = s0_9_1__core_periphery__data_to_core[26];
			assign ch1_rx_data_in[65] = s0_9_1__core_periphery__data_to_core[24];
			assign ch1_rx_data_in[64] = s0_9_1__core_periphery__data_to_core[3];
			assign ch1_rx_data_in[63] = s0_9_1__core_periphery__data_to_core[2];
			assign ch1_rx_data_in[62] = s0_9_1__core_periphery__data_to_core[1];
			assign ch1_rx_data_in[61] = s0_9_1__core_periphery__data_to_core[31];
			assign ch1_rx_data_in[60] = s0_9_1__core_periphery__data_to_core[30];
			assign ch1_rx_data_in[59] = s0_9_1__core_periphery__data_to_core[28];
			assign ch1_rx_data_in[58] = s0_9_1__core_periphery__data_to_core[7];
			assign ch1_rx_data_in[57] = s0_9_1__core_periphery__data_to_core[5];
			assign ch1_rx_data_in[56] = s0_9_1__core_periphery__data_to_core[35];
			assign ch1_rx_data_in[55] = s0_9_1__core_periphery__data_to_core[33];
			assign ch1_rx_data_in[54] = s0_9_1__core_periphery__data_to_core[11];
			assign ch1_rx_data_in[53] = s0_9_1__core_periphery__data_to_core[10];
			assign ch1_rx_data_in[52] = s0_9_1__core_periphery__data_to_core[9];
			assign ch1_rx_data_in[51] = s0_9_1__core_periphery__data_to_core[8];
			assign ch1_rx_data_in[50] = s0_9_1__core_periphery__data_to_core[38];
			assign ch1_rx_data_in[49] = s0_9_1__core_periphery__data_to_core[36];
			assign ch1_rx_data_in[48] = s0_9_1__core_periphery__data_to_core[15];
			assign ch1_rx_data_in[47] = s0_9_1__core_periphery__data_to_core[14];
			assign ch1_rx_data_in[46] = s0_9_1__core_periphery__data_to_core[13];
			assign ch1_rx_data_in[45] = s0_9_1__core_periphery__data_to_core[43];
			assign ch1_rx_data_in[44] = s0_9_1__core_periphery__data_to_core[42];
			assign ch1_rx_data_in[43] = s0_9_1__core_periphery__data_to_core[40];
			assign ch1_rx_data_in[42] = s0_9_1__core_periphery__data_to_core[19];
			assign ch1_rx_data_in[41] = s0_9_1__core_periphery__data_to_core[17];
			assign ch1_rx_data_in[40] = s0_9_1__core_periphery__data_to_core[47];
			assign ch1_rx_data_in[39] = s0_9_1__core_periphery__data_to_core[45];
			//assign ch1_rx_data_in[39] = s0_9_1__core_periphery__data_to_core[23];
			assign ch1_rx_data_in[38] = s0_9_1__core_periphery__data_to_core[22];
			assign ch1_rx_data_in[37] = s0_9_1__core_periphery__data_to_core[20];
			assign ch1_rx_data_in[36] = s0_9_1__core_periphery__data_to_core[51];
			assign ch1_rx_data_in[35] = s0_9_1__core_periphery__data_to_core[49];
			assign ch1_rx_data_in[34] = s0_9_1__core_periphery__data_to_core[80];
			assign ch1_rx_data_in[33] = s0_9_1__core_periphery__data_to_core[82];
			assign ch1_rx_data_in[32] = s0_9_1__core_periphery__data_to_core[52];
			assign ch1_rx_data_in[31] = s0_9_1__core_periphery__data_to_core[54];
			assign ch1_rx_data_in[30] = s0_9_1__core_periphery__data_to_core[55];
			assign ch1_rx_data_in[29] = s0_9_1__core_periphery__data_to_core[84];
			assign ch1_rx_data_in[28] = s0_9_1__core_periphery__data_to_core[86];
			assign ch1_rx_data_in[27] = s0_9_1__core_periphery__data_to_core[87];
			assign ch1_rx_data_in[26] = s0_9_1__core_periphery__data_to_core[57];
			assign ch1_rx_data_in[25] = s0_9_1__core_periphery__data_to_core[58];
			assign ch1_rx_data_in[24] = s0_9_1__core_periphery__data_to_core[88];
			assign ch1_rx_data_in[23] = s0_9_1__core_periphery__data_to_core[90];
			assign ch1_rx_data_in[22] = s0_9_1__core_periphery__data_to_core[60];
			assign ch1_rx_data_in[21] = s0_9_1__core_periphery__data_to_core[62];
			assign ch1_rx_data_in[20] = s0_9_1__core_periphery__data_to_core[63];
			assign ch1_rx_data_in[19] = s0_9_1__core_periphery__data_to_core[92];
			assign ch1_rx_data_in[18] = s0_9_1__core_periphery__data_to_core[93];
			assign ch1_rx_data_in[17] = s0_9_1__core_periphery__data_to_core[95];
			assign ch1_rx_data_in[16] = s0_9_1__core_periphery__data_to_core[65];
			assign ch1_rx_data_in[15] = s0_9_1__core_periphery__data_to_core[66];
			assign ch1_rx_data_in[14] = s0_9_1__core_periphery__data_to_core[67];
			assign ch1_rx_data_in[13] = s0_9_1__core_periphery__data_to_core[96];
			assign ch1_rx_data_in[12] = s0_9_1__core_periphery__data_to_core[98];
			assign ch1_rx_data_in[11] = s0_9_1__core_periphery__data_to_core[99];
			assign ch1_rx_data_in[10] = s0_9_1__core_periphery__data_to_core[69];
			assign ch1_rx_data_in[9] = s0_9_1__core_periphery__data_to_core[70];
			assign ch1_rx_data_in[8] = s0_9_1__core_periphery__data_to_core[100];
			assign ch1_rx_data_in[7] = s0_9_1__core_periphery__data_to_core[102];
			assign ch1_rx_data_in[6] = s0_9_1__core_periphery__data_to_core[72];
			assign ch1_rx_data_in[5] = s0_9_1__core_periphery__data_to_core[74];
			assign ch1_rx_data_in[4] = s0_9_1__core_periphery__data_to_core[75];
			assign ch1_rx_data_in[3] = s0_9_1__core_periphery__data_to_core[104];
			assign ch1_rx_data_in[2] = s0_9_1__core_periphery__data_to_core[105];
			assign ch1_rx_data_in[1] = s0_9_1__core_periphery__data_to_core[107];
			assign ch1_rx_data_in[0] = s0_9_1__core_periphery__data_to_core[77];


			//assign ch2_rx_data_in[79] = s0_16_1__core_periphery__data_to_core[70];
			assign ch2_rx_data_in[77] = s0_16_1__core_periphery__data_to_core[100];
			assign ch2_rx_data_in[76] = s0_16_1__core_periphery__data_to_core[102];
			assign ch2_rx_data_in[75] = s0_16_1__core_periphery__data_to_core[72];
			assign ch2_rx_data_in[74] = s0_16_1__core_periphery__data_to_core[74];
			assign ch2_rx_data_in[73] = s0_16_1__core_periphery__data_to_core[75];
			assign ch2_rx_data_in[72] = s0_16_1__core_periphery__data_to_core[104];
			assign ch2_rx_data_in[71] = s0_16_1__core_periphery__data_to_core[105];
			assign ch2_rx_data_in[70] = s0_16_1__core_periphery__data_to_core[107];
			assign ch2_rx_data_in[69] = s0_16_1__core_periphery__data_to_core[77];
			assign ch2_rx_data_in[68] = s0_16_1__core_periphery__data_to_core[78];
			assign ch2_rx_data_in[67] = s0_16_1__core_periphery__data_to_core[79];
			assign ch2_rx_data_in[66] = s0_15_1__core_periphery__data_to_core[26];
			assign ch2_rx_data_in[65] = s0_15_1__core_periphery__data_to_core[24];
			assign ch2_rx_data_in[64] = s0_15_1__core_periphery__data_to_core[3];
			assign ch2_rx_data_in[63] = s0_15_1__core_periphery__data_to_core[2];
			assign ch2_rx_data_in[62] = s0_15_1__core_periphery__data_to_core[1];
			assign ch2_rx_data_in[61] = s0_15_1__core_periphery__data_to_core[31];
			assign ch2_rx_data_in[60] = s0_15_1__core_periphery__data_to_core[30];
			assign ch2_rx_data_in[59] = s0_15_1__core_periphery__data_to_core[28];
			assign ch2_rx_data_in[58] = s0_15_1__core_periphery__data_to_core[7];
			assign ch2_rx_data_in[57] = s0_15_1__core_periphery__data_to_core[5];
			assign ch2_rx_data_in[56] = s0_15_1__core_periphery__data_to_core[35];
			assign ch2_rx_data_in[55] = s0_15_1__core_periphery__data_to_core[33];
			assign ch2_rx_data_in[54] = s0_15_1__core_periphery__data_to_core[11];
			assign ch2_rx_data_in[53] = s0_15_1__core_periphery__data_to_core[10];
			assign ch2_rx_data_in[52] = s0_15_1__core_periphery__data_to_core[9];
			assign ch2_rx_data_in[51] = s0_15_1__core_periphery__data_to_core[8];
			assign ch2_rx_data_in[50] = s0_15_1__core_periphery__data_to_core[38];
			assign ch2_rx_data_in[49] = s0_15_1__core_periphery__data_to_core[36];
			assign ch2_rx_data_in[48] = s0_15_1__core_periphery__data_to_core[15];
			assign ch2_rx_data_in[47] = s0_15_1__core_periphery__data_to_core[14];
			assign ch2_rx_data_in[46] = s0_15_1__core_periphery__data_to_core[13];
			assign ch2_rx_data_in[45] = s0_15_1__core_periphery__data_to_core[43];
			assign ch2_rx_data_in[44] = s0_15_1__core_periphery__data_to_core[42];
			assign ch2_rx_data_in[43] = s0_15_1__core_periphery__data_to_core[40];
			assign ch2_rx_data_in[42] = s0_15_1__core_periphery__data_to_core[19];
			assign ch2_rx_data_in[41] = s0_15_1__core_periphery__data_to_core[17];
			assign ch2_rx_data_in[40] = s0_15_1__core_periphery__data_to_core[47];
			assign ch2_rx_data_in[39] = s0_15_1__core_periphery__data_to_core[45];
			//assign ch2_rx_data_in[39] = s0_15_1__core_periphery__data_to_core[23];
			assign ch2_rx_data_in[38] = s0_15_1__core_periphery__data_to_core[22];
			assign ch2_rx_data_in[37] = s0_15_1__core_periphery__data_to_core[20];
			assign ch2_rx_data_in[36] = s0_15_1__core_periphery__data_to_core[51];
			assign ch2_rx_data_in[35] = s0_15_1__core_periphery__data_to_core[49];
			assign ch2_rx_data_in[34] = s0_15_1__core_periphery__data_to_core[80];
			assign ch2_rx_data_in[33] = s0_15_1__core_periphery__data_to_core[82];
			assign ch2_rx_data_in[32] = s0_15_1__core_periphery__data_to_core[52];
			assign ch2_rx_data_in[31] = s0_15_1__core_periphery__data_to_core[54];
			assign ch2_rx_data_in[30] = s0_15_1__core_periphery__data_to_core[55];
			assign ch2_rx_data_in[29] = s0_15_1__core_periphery__data_to_core[84];
			assign ch2_rx_data_in[28] = s0_15_1__core_periphery__data_to_core[86];
			assign ch2_rx_data_in[27] = s0_15_1__core_periphery__data_to_core[87];
			assign ch2_rx_data_in[26] = s0_15_1__core_periphery__data_to_core[57];
			assign ch2_rx_data_in[25] = s0_15_1__core_periphery__data_to_core[58];
			assign ch2_rx_data_in[24] = s0_15_1__core_periphery__data_to_core[88];
			assign ch2_rx_data_in[23] = s0_15_1__core_periphery__data_to_core[90];
			assign ch2_rx_data_in[22] = s0_15_1__core_periphery__data_to_core[60];
			assign ch2_rx_data_in[21] = s0_15_1__core_periphery__data_to_core[62];
			assign ch2_rx_data_in[20] = s0_15_1__core_periphery__data_to_core[63];
			assign ch2_rx_data_in[19] = s0_15_1__core_periphery__data_to_core[92];
			assign ch2_rx_data_in[18] = s0_15_1__core_periphery__data_to_core[93];
			assign ch2_rx_data_in[17] = s0_15_1__core_periphery__data_to_core[95];
			assign ch2_rx_data_in[16] = s0_15_1__core_periphery__data_to_core[65];
			assign ch2_rx_data_in[15] = s0_15_1__core_periphery__data_to_core[66];
			assign ch2_rx_data_in[14] = s0_15_1__core_periphery__data_to_core[67];
			assign ch2_rx_data_in[13] = s0_15_1__core_periphery__data_to_core[96];
			assign ch2_rx_data_in[12] = s0_15_1__core_periphery__data_to_core[98];
			assign ch2_rx_data_in[11] = s0_15_1__core_periphery__data_to_core[99];
			assign ch2_rx_data_in[10] = s0_15_1__core_periphery__data_to_core[69];
			assign ch2_rx_data_in[9] = s0_15_1__core_periphery__data_to_core[70];
			assign ch2_rx_data_in[8] = s0_15_1__core_periphery__data_to_core[100];
			assign ch2_rx_data_in[7] = s0_15_1__core_periphery__data_to_core[102];
			assign ch2_rx_data_in[6] = s0_15_1__core_periphery__data_to_core[72];
			assign ch2_rx_data_in[5] = s0_15_1__core_periphery__data_to_core[74];
			assign ch2_rx_data_in[4] = s0_15_1__core_periphery__data_to_core[75];
			assign ch2_rx_data_in[3] = s0_15_1__core_periphery__data_to_core[104];
			assign ch2_rx_data_in[2] = s0_15_1__core_periphery__data_to_core[105];
			assign ch2_rx_data_in[1] = s0_15_1__core_periphery__data_to_core[107];
			assign ch2_rx_data_in[0] = s0_15_1__core_periphery__data_to_core[77];

			//assign ch3_rx_data_in[79] = s0_23_1__core_periphery__data_to_core[70];
			assign ch3_rx_data_in[77] = s0_23_1__core_periphery__data_to_core[100];
			assign ch3_rx_data_in[76] = s0_23_1__core_periphery__data_to_core[102];
			assign ch3_rx_data_in[75] = s0_23_1__core_periphery__data_to_core[72];
			assign ch3_rx_data_in[74] = s0_23_1__core_periphery__data_to_core[74];
			assign ch3_rx_data_in[73] = s0_23_1__core_periphery__data_to_core[75];
			assign ch3_rx_data_in[72] = s0_23_1__core_periphery__data_to_core[104];
			assign ch3_rx_data_in[71] = s0_23_1__core_periphery__data_to_core[105];
			assign ch3_rx_data_in[70] = s0_23_1__core_periphery__data_to_core[107];
			assign ch3_rx_data_in[69] = s0_23_1__core_periphery__data_to_core[77];
			assign ch3_rx_data_in[68] = s0_23_1__core_periphery__data_to_core[78];
			assign ch3_rx_data_in[67] = s0_23_1__core_periphery__data_to_core[79];
			assign ch3_rx_data_in[66] = s0_22_1__core_periphery__data_to_core[26];
			assign ch3_rx_data_in[65] = s0_22_1__core_periphery__data_to_core[24];
			assign ch3_rx_data_in[64] = s0_22_1__core_periphery__data_to_core[3];
			assign ch3_rx_data_in[63] = s0_22_1__core_periphery__data_to_core[2];
			assign ch3_rx_data_in[62] = s0_22_1__core_periphery__data_to_core[1];
			assign ch3_rx_data_in[61] = s0_22_1__core_periphery__data_to_core[31];
			assign ch3_rx_data_in[60] = s0_22_1__core_periphery__data_to_core[30];
			assign ch3_rx_data_in[59] = s0_22_1__core_periphery__data_to_core[28];
			assign ch3_rx_data_in[58] = s0_22_1__core_periphery__data_to_core[7];
			assign ch3_rx_data_in[57] = s0_22_1__core_periphery__data_to_core[5];
			assign ch3_rx_data_in[56] = s0_22_1__core_periphery__data_to_core[35];
			assign ch3_rx_data_in[55] = s0_22_1__core_periphery__data_to_core[33];
			assign ch3_rx_data_in[54] = s0_22_1__core_periphery__data_to_core[11];
			assign ch3_rx_data_in[53] = s0_22_1__core_periphery__data_to_core[10];
			assign ch3_rx_data_in[52] = s0_22_1__core_periphery__data_to_core[9];
			assign ch3_rx_data_in[51] = s0_22_1__core_periphery__data_to_core[8];
			assign ch3_rx_data_in[50] = s0_22_1__core_periphery__data_to_core[38];
			assign ch3_rx_data_in[49] = s0_22_1__core_periphery__data_to_core[36];
			assign ch3_rx_data_in[48] = s0_22_1__core_periphery__data_to_core[15];
			assign ch3_rx_data_in[47] = s0_22_1__core_periphery__data_to_core[14];
			assign ch3_rx_data_in[46] = s0_22_1__core_periphery__data_to_core[13];
			assign ch3_rx_data_in[45] = s0_22_1__core_periphery__data_to_core[43];
			assign ch3_rx_data_in[44] = s0_22_1__core_periphery__data_to_core[42];
			assign ch3_rx_data_in[43] = s0_22_1__core_periphery__data_to_core[40];
			assign ch3_rx_data_in[42] = s0_22_1__core_periphery__data_to_core[19];
			assign ch3_rx_data_in[41] = s0_22_1__core_periphery__data_to_core[17];
			assign ch3_rx_data_in[40] = s0_22_1__core_periphery__data_to_core[47];
			assign ch3_rx_data_in[39] = s0_22_1__core_periphery__data_to_core[45];
			//assign ch3_rx_data_in[39] = s0_22_1__core_periphery__data_to_core[23];
			assign ch3_rx_data_in[38] = s0_22_1__core_periphery__data_to_core[22];
			assign ch3_rx_data_in[37] = s0_22_1__core_periphery__data_to_core[20];
			assign ch3_rx_data_in[36] = s0_22_1__core_periphery__data_to_core[51];
			assign ch3_rx_data_in[35] = s0_22_1__core_periphery__data_to_core[49];
			assign ch3_rx_data_in[34] = s0_22_1__core_periphery__data_to_core[80];
			assign ch3_rx_data_in[33] = s0_22_1__core_periphery__data_to_core[82];
			assign ch3_rx_data_in[32] = s0_22_1__core_periphery__data_to_core[52];
			assign ch3_rx_data_in[31] = s0_22_1__core_periphery__data_to_core[54];
			assign ch3_rx_data_in[30] = s0_22_1__core_periphery__data_to_core[55];
			assign ch3_rx_data_in[29] = s0_22_1__core_periphery__data_to_core[84];
			assign ch3_rx_data_in[28] = s0_22_1__core_periphery__data_to_core[86];
			assign ch3_rx_data_in[27] = s0_22_1__core_periphery__data_to_core[87];
			assign ch3_rx_data_in[26] = s0_22_1__core_periphery__data_to_core[57];
			assign ch3_rx_data_in[25] = s0_22_1__core_periphery__data_to_core[58];
			assign ch3_rx_data_in[24] = s0_22_1__core_periphery__data_to_core[88];
			assign ch3_rx_data_in[23] = s0_22_1__core_periphery__data_to_core[90];
			assign ch3_rx_data_in[22] = s0_22_1__core_periphery__data_to_core[60];
			assign ch3_rx_data_in[21] = s0_22_1__core_periphery__data_to_core[62];
			assign ch3_rx_data_in[20] = s0_22_1__core_periphery__data_to_core[63];
			assign ch3_rx_data_in[19] = s0_22_1__core_periphery__data_to_core[92];
			assign ch3_rx_data_in[18] = s0_22_1__core_periphery__data_to_core[93];
			assign ch3_rx_data_in[17] = s0_22_1__core_periphery__data_to_core[95];
			assign ch3_rx_data_in[16] = s0_22_1__core_periphery__data_to_core[65];
			assign ch3_rx_data_in[15] = s0_22_1__core_periphery__data_to_core[66];
			assign ch3_rx_data_in[14] = s0_22_1__core_periphery__data_to_core[67];
			assign ch3_rx_data_in[13] = s0_22_1__core_periphery__data_to_core[96];
			assign ch3_rx_data_in[12] = s0_22_1__core_periphery__data_to_core[98];
			assign ch3_rx_data_in[11] = s0_22_1__core_periphery__data_to_core[99];
			assign ch3_rx_data_in[10] = s0_22_1__core_periphery__data_to_core[69];
			assign ch3_rx_data_in[9] = s0_22_1__core_periphery__data_to_core[70];
			assign ch3_rx_data_in[8] = s0_22_1__core_periphery__data_to_core[100];
			assign ch3_rx_data_in[7] = s0_22_1__core_periphery__data_to_core[102];
			assign ch3_rx_data_in[6] = s0_22_1__core_periphery__data_to_core[72];
			assign ch3_rx_data_in[5] = s0_22_1__core_periphery__data_to_core[74];
			assign ch3_rx_data_in[4] = s0_22_1__core_periphery__data_to_core[75];
			assign ch3_rx_data_in[3] = s0_22_1__core_periphery__data_to_core[104];
			assign ch3_rx_data_in[2] = s0_22_1__core_periphery__data_to_core[105];
			assign ch3_rx_data_in[1] = s0_22_1__core_periphery__data_to_core[107];
			assign ch3_rx_data_in[0] = s0_22_1__core_periphery__data_to_core[77];


			//assign ch4_rx_data_in[79] = s0_29_1__core_periphery__data_to_core[70];
			assign ch4_rx_data_in[77] = s0_29_1__core_periphery__data_to_core[100];
			assign ch4_rx_data_in[76] = s0_29_1__core_periphery__data_to_core[102];
			assign ch4_rx_data_in[75] = s0_29_1__core_periphery__data_to_core[72];
			assign ch4_rx_data_in[74] = s0_29_1__core_periphery__data_to_core[74];
			assign ch4_rx_data_in[73] = s0_29_1__core_periphery__data_to_core[75];
			assign ch4_rx_data_in[72] = s0_29_1__core_periphery__data_to_core[104];
			assign ch4_rx_data_in[71] = s0_29_1__core_periphery__data_to_core[105];
			assign ch4_rx_data_in[70] = s0_29_1__core_periphery__data_to_core[107];
			assign ch4_rx_data_in[69] = s0_29_1__core_periphery__data_to_core[77];
			assign ch4_rx_data_in[68] = s0_29_1__core_periphery__data_to_core[78];
			assign ch4_rx_data_in[67] = s0_29_1__core_periphery__data_to_core[79];
			assign ch4_rx_data_in[66] = s0_28_1__core_periphery__data_to_core[26];
			assign ch4_rx_data_in[65] = s0_28_1__core_periphery__data_to_core[24];
			assign ch4_rx_data_in[64] = s0_28_1__core_periphery__data_to_core[3];
			assign ch4_rx_data_in[63] = s0_28_1__core_periphery__data_to_core[2];
			assign ch4_rx_data_in[62] = s0_28_1__core_periphery__data_to_core[1];
			assign ch4_rx_data_in[61] = s0_28_1__core_periphery__data_to_core[31];
			assign ch4_rx_data_in[60] = s0_28_1__core_periphery__data_to_core[30];
			assign ch4_rx_data_in[59] = s0_28_1__core_periphery__data_to_core[28];
			assign ch4_rx_data_in[58] = s0_28_1__core_periphery__data_to_core[7];
			assign ch4_rx_data_in[57] = s0_28_1__core_periphery__data_to_core[5];
			assign ch4_rx_data_in[56] = s0_28_1__core_periphery__data_to_core[35];
			assign ch4_rx_data_in[55] = s0_28_1__core_periphery__data_to_core[33];
			assign ch4_rx_data_in[54] = s0_28_1__core_periphery__data_to_core[11];
			assign ch4_rx_data_in[53] = s0_28_1__core_periphery__data_to_core[10];
			assign ch4_rx_data_in[52] = s0_28_1__core_periphery__data_to_core[9];
			assign ch4_rx_data_in[51] = s0_28_1__core_periphery__data_to_core[8];
			assign ch4_rx_data_in[50] = s0_28_1__core_periphery__data_to_core[38];
			assign ch4_rx_data_in[49] = s0_28_1__core_periphery__data_to_core[36];
			assign ch4_rx_data_in[48] = s0_28_1__core_periphery__data_to_core[15];
			assign ch4_rx_data_in[47] = s0_28_1__core_periphery__data_to_core[14];
			assign ch4_rx_data_in[46] = s0_28_1__core_periphery__data_to_core[13];
			assign ch4_rx_data_in[45] = s0_28_1__core_periphery__data_to_core[43];
			assign ch4_rx_data_in[44] = s0_28_1__core_periphery__data_to_core[42];
			assign ch4_rx_data_in[43] = s0_28_1__core_periphery__data_to_core[40];
			assign ch4_rx_data_in[42] = s0_28_1__core_periphery__data_to_core[19];
			assign ch4_rx_data_in[41] = s0_28_1__core_periphery__data_to_core[17];
			assign ch4_rx_data_in[40] = s0_28_1__core_periphery__data_to_core[47];
			assign ch4_rx_data_in[39] = s0_28_1__core_periphery__data_to_core[45];
			//assign ch4_rx_data_in[39] = s0_28_1__core_periphery__data_to_core[23];
			assign ch4_rx_data_in[38] = s0_28_1__core_periphery__data_to_core[22];
			assign ch4_rx_data_in[37] = s0_28_1__core_periphery__data_to_core[20];
			assign ch4_rx_data_in[36] = s0_28_1__core_periphery__data_to_core[51];
			assign ch4_rx_data_in[35] = s0_28_1__core_periphery__data_to_core[49];
			assign ch4_rx_data_in[34] = s0_28_1__core_periphery__data_to_core[80];
			assign ch4_rx_data_in[33] = s0_28_1__core_periphery__data_to_core[82];
			assign ch4_rx_data_in[32] = s0_28_1__core_periphery__data_to_core[52];
			assign ch4_rx_data_in[31] = s0_28_1__core_periphery__data_to_core[54];
			assign ch4_rx_data_in[30] = s0_28_1__core_periphery__data_to_core[55];
			assign ch4_rx_data_in[29] = s0_28_1__core_periphery__data_to_core[84];
			assign ch4_rx_data_in[28] = s0_28_1__core_periphery__data_to_core[86];
			assign ch4_rx_data_in[27] = s0_28_1__core_periphery__data_to_core[87];
			assign ch4_rx_data_in[26] = s0_28_1__core_periphery__data_to_core[57];
			assign ch4_rx_data_in[25] = s0_28_1__core_periphery__data_to_core[58];
			assign ch4_rx_data_in[24] = s0_28_1__core_periphery__data_to_core[88];
			assign ch4_rx_data_in[23] = s0_28_1__core_periphery__data_to_core[90];
			assign ch4_rx_data_in[22] = s0_28_1__core_periphery__data_to_core[60];
			assign ch4_rx_data_in[21] = s0_28_1__core_periphery__data_to_core[62];
			assign ch4_rx_data_in[20] = s0_28_1__core_periphery__data_to_core[63];
			assign ch4_rx_data_in[19] = s0_28_1__core_periphery__data_to_core[92];
			assign ch4_rx_data_in[18] = s0_28_1__core_periphery__data_to_core[93];
			assign ch4_rx_data_in[17] = s0_28_1__core_periphery__data_to_core[95];
			assign ch4_rx_data_in[16] = s0_28_1__core_periphery__data_to_core[65];
			assign ch4_rx_data_in[15] = s0_28_1__core_periphery__data_to_core[66];
			assign ch4_rx_data_in[14] = s0_28_1__core_periphery__data_to_core[67];
			assign ch4_rx_data_in[13] = s0_28_1__core_periphery__data_to_core[96];
			assign ch4_rx_data_in[12] = s0_28_1__core_periphery__data_to_core[98];
			assign ch4_rx_data_in[11] = s0_28_1__core_periphery__data_to_core[99];
			assign ch4_rx_data_in[10] = s0_28_1__core_periphery__data_to_core[69];
			assign ch4_rx_data_in[9] = s0_28_1__core_periphery__data_to_core[70];
			assign ch4_rx_data_in[8] = s0_28_1__core_periphery__data_to_core[100];
			assign ch4_rx_data_in[7] = s0_28_1__core_periphery__data_to_core[102];
			assign ch4_rx_data_in[6] = s0_28_1__core_periphery__data_to_core[72];
			assign ch4_rx_data_in[5] = s0_28_1__core_periphery__data_to_core[74];
			assign ch4_rx_data_in[4] = s0_28_1__core_periphery__data_to_core[75];
			assign ch4_rx_data_in[3] = s0_28_1__core_periphery__data_to_core[104];
			assign ch4_rx_data_in[2] = s0_28_1__core_periphery__data_to_core[105];
			assign ch4_rx_data_in[1] = s0_28_1__core_periphery__data_to_core[107];
			assign ch4_rx_data_in[0] = s0_28_1__core_periphery__data_to_core[77];


			//assign ch5_rx_data_in[79] = s0_35_1__core_periphery__data_to_core[70];
			assign ch5_rx_data_in[77] = s0_35_1__core_periphery__data_to_core[100];
			assign ch5_rx_data_in[76] = s0_35_1__core_periphery__data_to_core[102];
			assign ch5_rx_data_in[75] = s0_35_1__core_periphery__data_to_core[72];
			assign ch5_rx_data_in[74] = s0_35_1__core_periphery__data_to_core[74];
			assign ch5_rx_data_in[73] = s0_35_1__core_periphery__data_to_core[75];
			assign ch5_rx_data_in[72] = s0_35_1__core_periphery__data_to_core[104];
			assign ch5_rx_data_in[71] = s0_35_1__core_periphery__data_to_core[105];
			assign ch5_rx_data_in[70] = s0_35_1__core_periphery__data_to_core[107];
			assign ch5_rx_data_in[69] = s0_35_1__core_periphery__data_to_core[77];
			assign ch5_rx_data_in[68] = s0_35_1__core_periphery__data_to_core[78];
			assign ch5_rx_data_in[67] = s0_35_1__core_periphery__data_to_core[79];
			assign ch5_rx_data_in[66] = s0_34_1__core_periphery__data_to_core[26];
			assign ch5_rx_data_in[65] = s0_34_1__core_periphery__data_to_core[24];
			assign ch5_rx_data_in[64] = s0_34_1__core_periphery__data_to_core[3];
			assign ch5_rx_data_in[63] = s0_34_1__core_periphery__data_to_core[2];
			assign ch5_rx_data_in[62] = s0_34_1__core_periphery__data_to_core[1];
			assign ch5_rx_data_in[61] = s0_34_1__core_periphery__data_to_core[31];
			assign ch5_rx_data_in[60] = s0_34_1__core_periphery__data_to_core[30];
			assign ch5_rx_data_in[59] = s0_34_1__core_periphery__data_to_core[28];
			assign ch5_rx_data_in[58] = s0_34_1__core_periphery__data_to_core[7];
			assign ch5_rx_data_in[57] = s0_34_1__core_periphery__data_to_core[5];
			assign ch5_rx_data_in[56] = s0_34_1__core_periphery__data_to_core[35];
			assign ch5_rx_data_in[55] = s0_34_1__core_periphery__data_to_core[33];
			assign ch5_rx_data_in[54] = s0_34_1__core_periphery__data_to_core[11];
			assign ch5_rx_data_in[53] = s0_34_1__core_periphery__data_to_core[10];
			assign ch5_rx_data_in[52] = s0_34_1__core_periphery__data_to_core[9];
			assign ch5_rx_data_in[51] = s0_34_1__core_periphery__data_to_core[8];
			assign ch5_rx_data_in[50] = s0_34_1__core_periphery__data_to_core[38];
			assign ch5_rx_data_in[49] = s0_34_1__core_periphery__data_to_core[36];
			assign ch5_rx_data_in[48] = s0_34_1__core_periphery__data_to_core[15];
			assign ch5_rx_data_in[47] = s0_34_1__core_periphery__data_to_core[14];
			assign ch5_rx_data_in[46] = s0_34_1__core_periphery__data_to_core[13];
			assign ch5_rx_data_in[45] = s0_34_1__core_periphery__data_to_core[43];
			assign ch5_rx_data_in[44] = s0_34_1__core_periphery__data_to_core[42];
			assign ch5_rx_data_in[43] = s0_34_1__core_periphery__data_to_core[40];
			assign ch5_rx_data_in[42] = s0_34_1__core_periphery__data_to_core[19];
			assign ch5_rx_data_in[41] = s0_34_1__core_periphery__data_to_core[17];
			assign ch5_rx_data_in[40] = s0_34_1__core_periphery__data_to_core[47];
			assign ch5_rx_data_in[39] = s0_34_1__core_periphery__data_to_core[45];
			//assign ch5_rx_data_in[39] = s0_34_1__core_periphery__data_to_core[23];
			assign ch5_rx_data_in[38] = s0_34_1__core_periphery__data_to_core[22];
			assign ch5_rx_data_in[37] = s0_34_1__core_periphery__data_to_core[20];
			assign ch5_rx_data_in[36] = s0_34_1__core_periphery__data_to_core[51];
			assign ch5_rx_data_in[35] = s0_34_1__core_periphery__data_to_core[49];
			assign ch5_rx_data_in[34] = s0_34_1__core_periphery__data_to_core[80];
			assign ch5_rx_data_in[33] = s0_34_1__core_periphery__data_to_core[82];
			assign ch5_rx_data_in[32] = s0_34_1__core_periphery__data_to_core[52];
			assign ch5_rx_data_in[31] = s0_34_1__core_periphery__data_to_core[54];
			assign ch5_rx_data_in[30] = s0_34_1__core_periphery__data_to_core[55];
			assign ch5_rx_data_in[29] = s0_34_1__core_periphery__data_to_core[84];
			assign ch5_rx_data_in[28] = s0_34_1__core_periphery__data_to_core[86];
			assign ch5_rx_data_in[27] = s0_34_1__core_periphery__data_to_core[87];
			assign ch5_rx_data_in[26] = s0_34_1__core_periphery__data_to_core[57];
			assign ch5_rx_data_in[25] = s0_34_1__core_periphery__data_to_core[58];
			assign ch5_rx_data_in[24] = s0_34_1__core_periphery__data_to_core[88];
			assign ch5_rx_data_in[23] = s0_34_1__core_periphery__data_to_core[90];
			assign ch5_rx_data_in[22] = s0_34_1__core_periphery__data_to_core[60];
			assign ch5_rx_data_in[21] = s0_34_1__core_periphery__data_to_core[62];
			assign ch5_rx_data_in[20] = s0_34_1__core_periphery__data_to_core[63];
			assign ch5_rx_data_in[19] = s0_34_1__core_periphery__data_to_core[92];
			assign ch5_rx_data_in[18] = s0_34_1__core_periphery__data_to_core[93];
			assign ch5_rx_data_in[17] = s0_34_1__core_periphery__data_to_core[95];
			assign ch5_rx_data_in[16] = s0_34_1__core_periphery__data_to_core[65];
			assign ch5_rx_data_in[15] = s0_34_1__core_periphery__data_to_core[66];
			assign ch5_rx_data_in[14] = s0_34_1__core_periphery__data_to_core[67];
			assign ch5_rx_data_in[13] = s0_34_1__core_periphery__data_to_core[96];
			assign ch5_rx_data_in[12] = s0_34_1__core_periphery__data_to_core[98];
			assign ch5_rx_data_in[11] = s0_34_1__core_periphery__data_to_core[99];
			assign ch5_rx_data_in[10] = s0_34_1__core_periphery__data_to_core[69];
			assign ch5_rx_data_in[9] = s0_34_1__core_periphery__data_to_core[70];
			assign ch5_rx_data_in[8] = s0_34_1__core_periphery__data_to_core[100];
			assign ch5_rx_data_in[7] = s0_34_1__core_periphery__data_to_core[102];
			assign ch5_rx_data_in[6] = s0_34_1__core_periphery__data_to_core[72];
			assign ch5_rx_data_in[5] = s0_34_1__core_periphery__data_to_core[74];
			assign ch5_rx_data_in[4] = s0_34_1__core_periphery__data_to_core[75];
			assign ch5_rx_data_in[3] = s0_34_1__core_periphery__data_to_core[104];
			assign ch5_rx_data_in[2] = s0_34_1__core_periphery__data_to_core[105];
			assign ch5_rx_data_in[1] = s0_34_1__core_periphery__data_to_core[107];
			assign ch5_rx_data_in[0] = s0_34_1__core_periphery__data_to_core[77];

			//assign ch6_rx_data_in[79] = s0_44_1__core_periphery__data_to_core[70];
			assign ch6_rx_data_in[77] = s0_44_1__core_periphery__data_to_core[100];
			assign ch6_rx_data_in[76] = s0_44_1__core_periphery__data_to_core[102];
			assign ch6_rx_data_in[75] = s0_44_1__core_periphery__data_to_core[72];
			assign ch6_rx_data_in[74] = s0_44_1__core_periphery__data_to_core[74];
			assign ch6_rx_data_in[73] = s0_44_1__core_periphery__data_to_core[75];
			assign ch6_rx_data_in[72] = s0_44_1__core_periphery__data_to_core[104];
			assign ch6_rx_data_in[71] = s0_44_1__core_periphery__data_to_core[105];
			assign ch6_rx_data_in[70] = s0_44_1__core_periphery__data_to_core[107];
			assign ch6_rx_data_in[69] = s0_44_1__core_periphery__data_to_core[77];
			assign ch6_rx_data_in[68] = s0_44_1__core_periphery__data_to_core[78];
			assign ch6_rx_data_in[67] = s0_44_1__core_periphery__data_to_core[79];
			assign ch6_rx_data_in[66] = s0_43_1__core_periphery__data_to_core[26];
			assign ch6_rx_data_in[65] = s0_43_1__core_periphery__data_to_core[24];
			assign ch6_rx_data_in[64] = s0_43_1__core_periphery__data_to_core[3];
			assign ch6_rx_data_in[63] = s0_43_1__core_periphery__data_to_core[2];
			assign ch6_rx_data_in[62] = s0_43_1__core_periphery__data_to_core[1];
			assign ch6_rx_data_in[61] = s0_43_1__core_periphery__data_to_core[31];
			assign ch6_rx_data_in[60] = s0_43_1__core_periphery__data_to_core[30];
			assign ch6_rx_data_in[59] = s0_43_1__core_periphery__data_to_core[28];
			assign ch6_rx_data_in[58] = s0_43_1__core_periphery__data_to_core[7];
			assign ch6_rx_data_in[57] = s0_43_1__core_periphery__data_to_core[5];
			assign ch6_rx_data_in[56] = s0_43_1__core_periphery__data_to_core[35];
			assign ch6_rx_data_in[55] = s0_43_1__core_periphery__data_to_core[33];
			assign ch6_rx_data_in[54] = s0_43_1__core_periphery__data_to_core[11];
			assign ch6_rx_data_in[53] = s0_43_1__core_periphery__data_to_core[10];
			assign ch6_rx_data_in[52] = s0_43_1__core_periphery__data_to_core[9];
			assign ch6_rx_data_in[51] = s0_43_1__core_periphery__data_to_core[8];
			assign ch6_rx_data_in[50] = s0_43_1__core_periphery__data_to_core[38];
			assign ch6_rx_data_in[49] = s0_43_1__core_periphery__data_to_core[36];
			assign ch6_rx_data_in[48] = s0_43_1__core_periphery__data_to_core[15];
			assign ch6_rx_data_in[47] = s0_43_1__core_periphery__data_to_core[14];
			assign ch6_rx_data_in[46] = s0_43_1__core_periphery__data_to_core[13];
			assign ch6_rx_data_in[45] = s0_43_1__core_periphery__data_to_core[43];
			assign ch6_rx_data_in[44] = s0_43_1__core_periphery__data_to_core[42];
			assign ch6_rx_data_in[43] = s0_43_1__core_periphery__data_to_core[40];
			assign ch6_rx_data_in[42] = s0_43_1__core_periphery__data_to_core[19];
			assign ch6_rx_data_in[41] = s0_43_1__core_periphery__data_to_core[17];
			assign ch6_rx_data_in[40] = s0_43_1__core_periphery__data_to_core[47];
			assign ch6_rx_data_in[39] = s0_43_1__core_periphery__data_to_core[45];
			//assign ch6_rx_data_in[39] = s0_43_1__core_periphery__data_to_core[23];
			assign ch6_rx_data_in[38] = s0_43_1__core_periphery__data_to_core[22];
			assign ch6_rx_data_in[37] = s0_43_1__core_periphery__data_to_core[20];
			assign ch6_rx_data_in[36] = s0_43_1__core_periphery__data_to_core[51];
			assign ch6_rx_data_in[35] = s0_43_1__core_periphery__data_to_core[49];
			assign ch6_rx_data_in[34] = s0_43_1__core_periphery__data_to_core[80];
			assign ch6_rx_data_in[33] = s0_43_1__core_periphery__data_to_core[82];
			assign ch6_rx_data_in[32] = s0_43_1__core_periphery__data_to_core[52];
			assign ch6_rx_data_in[31] = s0_43_1__core_periphery__data_to_core[54];
			assign ch6_rx_data_in[30] = s0_43_1__core_periphery__data_to_core[55];
			assign ch6_rx_data_in[29] = s0_43_1__core_periphery__data_to_core[84];
			assign ch6_rx_data_in[28] = s0_43_1__core_periphery__data_to_core[86];
			assign ch6_rx_data_in[27] = s0_43_1__core_periphery__data_to_core[87];
			assign ch6_rx_data_in[26] = s0_43_1__core_periphery__data_to_core[57];
			assign ch6_rx_data_in[25] = s0_43_1__core_periphery__data_to_core[58];
			assign ch6_rx_data_in[24] = s0_43_1__core_periphery__data_to_core[88];
			assign ch6_rx_data_in[23] = s0_43_1__core_periphery__data_to_core[90];
			assign ch6_rx_data_in[22] = s0_43_1__core_periphery__data_to_core[60];
			assign ch6_rx_data_in[21] = s0_43_1__core_periphery__data_to_core[62];
			assign ch6_rx_data_in[20] = s0_43_1__core_periphery__data_to_core[63];
			assign ch6_rx_data_in[19] = s0_43_1__core_periphery__data_to_core[92];
			assign ch6_rx_data_in[18] = s0_43_1__core_periphery__data_to_core[93];
			assign ch6_rx_data_in[17] = s0_43_1__core_periphery__data_to_core[95];
			assign ch6_rx_data_in[16] = s0_43_1__core_periphery__data_to_core[65];
			assign ch6_rx_data_in[15] = s0_43_1__core_periphery__data_to_core[66];
			assign ch6_rx_data_in[14] = s0_43_1__core_periphery__data_to_core[67];
			assign ch6_rx_data_in[13] = s0_43_1__core_periphery__data_to_core[96];
			assign ch6_rx_data_in[12] = s0_43_1__core_periphery__data_to_core[98];
			assign ch6_rx_data_in[11] = s0_43_1__core_periphery__data_to_core[99];
			assign ch6_rx_data_in[10] = s0_43_1__core_periphery__data_to_core[69];
			assign ch6_rx_data_in[9] = s0_43_1__core_periphery__data_to_core[70];
			assign ch6_rx_data_in[8] = s0_43_1__core_periphery__data_to_core[100];
			assign ch6_rx_data_in[7] = s0_43_1__core_periphery__data_to_core[102];
			assign ch6_rx_data_in[6] = s0_43_1__core_periphery__data_to_core[72];
			assign ch6_rx_data_in[5] = s0_43_1__core_periphery__data_to_core[74];
			assign ch6_rx_data_in[4] = s0_43_1__core_periphery__data_to_core[75];
			assign ch6_rx_data_in[3] = s0_43_1__core_periphery__data_to_core[104];
			assign ch6_rx_data_in[2] = s0_43_1__core_periphery__data_to_core[105];
			assign ch6_rx_data_in[1] = s0_43_1__core_periphery__data_to_core[107];
			assign ch6_rx_data_in[0] = s0_43_1__core_periphery__data_to_core[77];


			//assign ch7_rx_data_in[79] = s0_50_1__core_periphery__data_to_core[70];
			assign ch7_rx_data_in[77] = s0_50_1__core_periphery__data_to_core[100];
			assign ch7_rx_data_in[76] = s0_50_1__core_periphery__data_to_core[102];
			assign ch7_rx_data_in[75] = s0_50_1__core_periphery__data_to_core[72];
			assign ch7_rx_data_in[74] = s0_50_1__core_periphery__data_to_core[74];
			assign ch7_rx_data_in[73] = s0_50_1__core_periphery__data_to_core[75];
			assign ch7_rx_data_in[72] = s0_50_1__core_periphery__data_to_core[104];
			assign ch7_rx_data_in[71] = s0_50_1__core_periphery__data_to_core[105];
			assign ch7_rx_data_in[70] = s0_50_1__core_periphery__data_to_core[107];
			assign ch7_rx_data_in[69] = s0_50_1__core_periphery__data_to_core[77];
			assign ch7_rx_data_in[68] = s0_50_1__core_periphery__data_to_core[78];
			assign ch7_rx_data_in[67] = s0_50_1__core_periphery__data_to_core[79];
			assign ch7_rx_data_in[66] = s0_49_1__core_periphery__data_to_core[26];
			assign ch7_rx_data_in[65] = s0_49_1__core_periphery__data_to_core[24];
			assign ch7_rx_data_in[64] = s0_49_1__core_periphery__data_to_core[3];
			assign ch7_rx_data_in[63] = s0_49_1__core_periphery__data_to_core[2];
			assign ch7_rx_data_in[62] = s0_49_1__core_periphery__data_to_core[1];
			assign ch7_rx_data_in[61] = s0_49_1__core_periphery__data_to_core[31];
			assign ch7_rx_data_in[60] = s0_49_1__core_periphery__data_to_core[30];
			assign ch7_rx_data_in[59] = s0_49_1__core_periphery__data_to_core[28];
			assign ch7_rx_data_in[58] = s0_49_1__core_periphery__data_to_core[7];
			assign ch7_rx_data_in[57] = s0_49_1__core_periphery__data_to_core[5];
			assign ch7_rx_data_in[56] = s0_49_1__core_periphery__data_to_core[35];
			assign ch7_rx_data_in[55] = s0_49_1__core_periphery__data_to_core[33];
			assign ch7_rx_data_in[54] = s0_49_1__core_periphery__data_to_core[11];
			assign ch7_rx_data_in[53] = s0_49_1__core_periphery__data_to_core[10];
			assign ch7_rx_data_in[52] = s0_49_1__core_periphery__data_to_core[9];
			assign ch7_rx_data_in[51] = s0_49_1__core_periphery__data_to_core[8];
			assign ch7_rx_data_in[50] = s0_49_1__core_periphery__data_to_core[38];
			assign ch7_rx_data_in[49] = s0_49_1__core_periphery__data_to_core[36];
			assign ch7_rx_data_in[48] = s0_49_1__core_periphery__data_to_core[15];
			assign ch7_rx_data_in[47] = s0_49_1__core_periphery__data_to_core[14];
			assign ch7_rx_data_in[46] = s0_49_1__core_periphery__data_to_core[13];
			assign ch7_rx_data_in[45] = s0_49_1__core_periphery__data_to_core[43];
			assign ch7_rx_data_in[44] = s0_49_1__core_periphery__data_to_core[42];
			assign ch7_rx_data_in[43] = s0_49_1__core_periphery__data_to_core[40];
			assign ch7_rx_data_in[42] = s0_49_1__core_periphery__data_to_core[19];
			assign ch7_rx_data_in[41] = s0_49_1__core_periphery__data_to_core[17];
			assign ch7_rx_data_in[40] = s0_49_1__core_periphery__data_to_core[47];
			assign ch7_rx_data_in[39] = s0_49_1__core_periphery__data_to_core[45];
			//assign ch7_rx_data_in[39] = s0_49_1__core_periphery__data_to_core[23];
			assign ch7_rx_data_in[38] = s0_49_1__core_periphery__data_to_core[22];
			assign ch7_rx_data_in[37] = s0_49_1__core_periphery__data_to_core[20];
			assign ch7_rx_data_in[36] = s0_49_1__core_periphery__data_to_core[51];
			assign ch7_rx_data_in[35] = s0_49_1__core_periphery__data_to_core[49];
			assign ch7_rx_data_in[34] = s0_49_1__core_periphery__data_to_core[80];
			assign ch7_rx_data_in[33] = s0_49_1__core_periphery__data_to_core[82];
			assign ch7_rx_data_in[32] = s0_49_1__core_periphery__data_to_core[52];
			assign ch7_rx_data_in[31] = s0_49_1__core_periphery__data_to_core[54];
			assign ch7_rx_data_in[30] = s0_49_1__core_periphery__data_to_core[55];
			assign ch7_rx_data_in[29] = s0_49_1__core_periphery__data_to_core[84];
			assign ch7_rx_data_in[28] = s0_49_1__core_periphery__data_to_core[86];
			assign ch7_rx_data_in[27] = s0_49_1__core_periphery__data_to_core[87];
			assign ch7_rx_data_in[26] = s0_49_1__core_periphery__data_to_core[57];
			assign ch7_rx_data_in[25] = s0_49_1__core_periphery__data_to_core[58];
			assign ch7_rx_data_in[24] = s0_49_1__core_periphery__data_to_core[88];
			assign ch7_rx_data_in[23] = s0_49_1__core_periphery__data_to_core[90];
			assign ch7_rx_data_in[22] = s0_49_1__core_periphery__data_to_core[60];
			assign ch7_rx_data_in[21] = s0_49_1__core_periphery__data_to_core[62];
			assign ch7_rx_data_in[20] = s0_49_1__core_periphery__data_to_core[63];
			assign ch7_rx_data_in[19] = s0_49_1__core_periphery__data_to_core[92];
			assign ch7_rx_data_in[18] = s0_49_1__core_periphery__data_to_core[93];
			assign ch7_rx_data_in[17] = s0_49_1__core_periphery__data_to_core[95];
			assign ch7_rx_data_in[16] = s0_49_1__core_periphery__data_to_core[65];
			assign ch7_rx_data_in[15] = s0_49_1__core_periphery__data_to_core[66];
			assign ch7_rx_data_in[14] = s0_49_1__core_periphery__data_to_core[67];
			assign ch7_rx_data_in[13] = s0_49_1__core_periphery__data_to_core[96];
			assign ch7_rx_data_in[12] = s0_49_1__core_periphery__data_to_core[98];
			assign ch7_rx_data_in[11] = s0_49_1__core_periphery__data_to_core[99];
			assign ch7_rx_data_in[10] = s0_49_1__core_periphery__data_to_core[69];
			assign ch7_rx_data_in[9] = s0_49_1__core_periphery__data_to_core[70];
			assign ch7_rx_data_in[8] = s0_49_1__core_periphery__data_to_core[100];
			assign ch7_rx_data_in[7] = s0_49_1__core_periphery__data_to_core[102];
			assign ch7_rx_data_in[6] = s0_49_1__core_periphery__data_to_core[72];
			assign ch7_rx_data_in[5] = s0_49_1__core_periphery__data_to_core[74];
			assign ch7_rx_data_in[4] = s0_49_1__core_periphery__data_to_core[75];
			assign ch7_rx_data_in[3] = s0_49_1__core_periphery__data_to_core[104];
			assign ch7_rx_data_in[2] = s0_49_1__core_periphery__data_to_core[105];
			assign ch7_rx_data_in[1] = s0_49_1__core_periphery__data_to_core[107];
			assign ch7_rx_data_in[0] = s0_49_1__core_periphery__data_to_core[77];


			//assign ch8_rx_data_in[79] = s0_56_1__core_periphery__data_to_core[70];
			assign ch8_rx_data_in[77] = s0_56_1__core_periphery__data_to_core[100];
			assign ch8_rx_data_in[76] = s0_56_1__core_periphery__data_to_core[102];
			assign ch8_rx_data_in[75] = s0_56_1__core_periphery__data_to_core[72];
			assign ch8_rx_data_in[74] = s0_56_1__core_periphery__data_to_core[74];
			assign ch8_rx_data_in[73] = s0_56_1__core_periphery__data_to_core[75];
			assign ch8_rx_data_in[72] = s0_56_1__core_periphery__data_to_core[104];
			assign ch8_rx_data_in[71] = s0_56_1__core_periphery__data_to_core[105];
			assign ch8_rx_data_in[70] = s0_56_1__core_periphery__data_to_core[107];
			assign ch8_rx_data_in[69] = s0_56_1__core_periphery__data_to_core[77];
			assign ch8_rx_data_in[68] = s0_56_1__core_periphery__data_to_core[78];
			assign ch8_rx_data_in[67] = s0_56_1__core_periphery__data_to_core[79];
			assign ch8_rx_data_in[66] = s0_55_1__core_periphery__data_to_core[26];
			assign ch8_rx_data_in[65] = s0_55_1__core_periphery__data_to_core[24];
			assign ch8_rx_data_in[64] = s0_55_1__core_periphery__data_to_core[3];
			assign ch8_rx_data_in[63] = s0_55_1__core_periphery__data_to_core[2];
			assign ch8_rx_data_in[62] = s0_55_1__core_periphery__data_to_core[1];
			assign ch8_rx_data_in[61] = s0_55_1__core_periphery__data_to_core[31];
			assign ch8_rx_data_in[60] = s0_55_1__core_periphery__data_to_core[30];
			assign ch8_rx_data_in[59] = s0_55_1__core_periphery__data_to_core[28];
			assign ch8_rx_data_in[58] = s0_55_1__core_periphery__data_to_core[7];
			assign ch8_rx_data_in[57] = s0_55_1__core_periphery__data_to_core[5];
			assign ch8_rx_data_in[56] = s0_55_1__core_periphery__data_to_core[35];
			assign ch8_rx_data_in[55] = s0_55_1__core_periphery__data_to_core[33];
			assign ch8_rx_data_in[54] = s0_55_1__core_periphery__data_to_core[11];
			assign ch8_rx_data_in[53] = s0_55_1__core_periphery__data_to_core[10];
			assign ch8_rx_data_in[52] = s0_55_1__core_periphery__data_to_core[9];
			assign ch8_rx_data_in[51] = s0_55_1__core_periphery__data_to_core[8];
			assign ch8_rx_data_in[50] = s0_55_1__core_periphery__data_to_core[38];
			assign ch8_rx_data_in[49] = s0_55_1__core_periphery__data_to_core[36];
			assign ch8_rx_data_in[48] = s0_55_1__core_periphery__data_to_core[15];
			assign ch8_rx_data_in[47] = s0_55_1__core_periphery__data_to_core[14];
			assign ch8_rx_data_in[46] = s0_55_1__core_periphery__data_to_core[13];
			assign ch8_rx_data_in[45] = s0_55_1__core_periphery__data_to_core[43];
			assign ch8_rx_data_in[44] = s0_55_1__core_periphery__data_to_core[42];
			assign ch8_rx_data_in[43] = s0_55_1__core_periphery__data_to_core[40];
			assign ch8_rx_data_in[42] = s0_55_1__core_periphery__data_to_core[19];
			assign ch8_rx_data_in[41] = s0_55_1__core_periphery__data_to_core[17];
			assign ch8_rx_data_in[40] = s0_55_1__core_periphery__data_to_core[47];
			assign ch8_rx_data_in[39] = s0_55_1__core_periphery__data_to_core[45];
			//assign ch8_rx_data_in[39] = s0_55_1__core_periphery__data_to_core[23];
			assign ch8_rx_data_in[38] = s0_55_1__core_periphery__data_to_core[22];
			assign ch8_rx_data_in[37] = s0_55_1__core_periphery__data_to_core[20];
			assign ch8_rx_data_in[36] = s0_55_1__core_periphery__data_to_core[51];
			assign ch8_rx_data_in[35] = s0_55_1__core_periphery__data_to_core[49];
			assign ch8_rx_data_in[34] = s0_55_1__core_periphery__data_to_core[80];
			assign ch8_rx_data_in[33] = s0_55_1__core_periphery__data_to_core[82];
			assign ch8_rx_data_in[32] = s0_55_1__core_periphery__data_to_core[52];
			assign ch8_rx_data_in[31] = s0_55_1__core_periphery__data_to_core[54];
			assign ch8_rx_data_in[30] = s0_55_1__core_periphery__data_to_core[55];
			assign ch8_rx_data_in[29] = s0_55_1__core_periphery__data_to_core[84];
			assign ch8_rx_data_in[28] = s0_55_1__core_periphery__data_to_core[86];
			assign ch8_rx_data_in[27] = s0_55_1__core_periphery__data_to_core[87];
			assign ch8_rx_data_in[26] = s0_55_1__core_periphery__data_to_core[57];
			assign ch8_rx_data_in[25] = s0_55_1__core_periphery__data_to_core[58];
			assign ch8_rx_data_in[24] = s0_55_1__core_periphery__data_to_core[88];
			assign ch8_rx_data_in[23] = s0_55_1__core_periphery__data_to_core[90];
			assign ch8_rx_data_in[22] = s0_55_1__core_periphery__data_to_core[60];
			assign ch8_rx_data_in[21] = s0_55_1__core_periphery__data_to_core[62];
			assign ch8_rx_data_in[20] = s0_55_1__core_periphery__data_to_core[63];
			assign ch8_rx_data_in[19] = s0_55_1__core_periphery__data_to_core[92];
			assign ch8_rx_data_in[18] = s0_55_1__core_periphery__data_to_core[93];
			assign ch8_rx_data_in[17] = s0_55_1__core_periphery__data_to_core[95];
			assign ch8_rx_data_in[16] = s0_55_1__core_periphery__data_to_core[65];
			assign ch8_rx_data_in[15] = s0_55_1__core_periphery__data_to_core[66];
			assign ch8_rx_data_in[14] = s0_55_1__core_periphery__data_to_core[67];
			assign ch8_rx_data_in[13] = s0_55_1__core_periphery__data_to_core[96];
			assign ch8_rx_data_in[12] = s0_55_1__core_periphery__data_to_core[98];
			assign ch8_rx_data_in[11] = s0_55_1__core_periphery__data_to_core[99];
			assign ch8_rx_data_in[10] = s0_55_1__core_periphery__data_to_core[69];
			assign ch8_rx_data_in[9] = s0_55_1__core_periphery__data_to_core[70];
			assign ch8_rx_data_in[8] = s0_55_1__core_periphery__data_to_core[100];
			assign ch8_rx_data_in[7] = s0_55_1__core_periphery__data_to_core[102];
			assign ch8_rx_data_in[6] = s0_55_1__core_periphery__data_to_core[72];
			assign ch8_rx_data_in[5] = s0_55_1__core_periphery__data_to_core[74];
			assign ch8_rx_data_in[4] = s0_55_1__core_periphery__data_to_core[75];
			assign ch8_rx_data_in[3] = s0_55_1__core_periphery__data_to_core[104];
			assign ch8_rx_data_in[2] = s0_55_1__core_periphery__data_to_core[105];
			assign ch8_rx_data_in[1] = s0_55_1__core_periphery__data_to_core[107];
			assign ch8_rx_data_in[0] = s0_55_1__core_periphery__data_to_core[77];


			//assign ch9_rx_data_in[79] = s0_63_1__core_periphery__data_to_core[70];
			assign ch9_rx_data_in[77] = s0_63_1__core_periphery__data_to_core[100];
			assign ch9_rx_data_in[76] = s0_63_1__core_periphery__data_to_core[102];
			assign ch9_rx_data_in[75] = s0_63_1__core_periphery__data_to_core[72];
			assign ch9_rx_data_in[74] = s0_63_1__core_periphery__data_to_core[74];
			assign ch9_rx_data_in[73] = s0_63_1__core_periphery__data_to_core[75];
			assign ch9_rx_data_in[72] = s0_63_1__core_periphery__data_to_core[104];
			assign ch9_rx_data_in[71] = s0_63_1__core_periphery__data_to_core[105];
			assign ch9_rx_data_in[70] = s0_63_1__core_periphery__data_to_core[107];
			assign ch9_rx_data_in[69] = s0_63_1__core_periphery__data_to_core[77];
			assign ch9_rx_data_in[68] = s0_63_1__core_periphery__data_to_core[78];
			assign ch9_rx_data_in[67] = s0_63_1__core_periphery__data_to_core[79];
			assign ch9_rx_data_in[66] = s0_62_1__core_periphery__data_to_core[26];
			assign ch9_rx_data_in[65] = s0_62_1__core_periphery__data_to_core[24];
			assign ch9_rx_data_in[64] = s0_62_1__core_periphery__data_to_core[3];
			assign ch9_rx_data_in[63] = s0_62_1__core_periphery__data_to_core[2];
			assign ch9_rx_data_in[62] = s0_62_1__core_periphery__data_to_core[1];
			assign ch9_rx_data_in[61] = s0_62_1__core_periphery__data_to_core[31];
			assign ch9_rx_data_in[60] = s0_62_1__core_periphery__data_to_core[30];
			assign ch9_rx_data_in[59] = s0_62_1__core_periphery__data_to_core[28];
			assign ch9_rx_data_in[58] = s0_62_1__core_periphery__data_to_core[7];
			assign ch9_rx_data_in[57] = s0_62_1__core_periphery__data_to_core[5];
			assign ch9_rx_data_in[56] = s0_62_1__core_periphery__data_to_core[35];
			assign ch9_rx_data_in[55] = s0_62_1__core_periphery__data_to_core[33];
			assign ch9_rx_data_in[54] = s0_62_1__core_periphery__data_to_core[11];
			assign ch9_rx_data_in[53] = s0_62_1__core_periphery__data_to_core[10];
			assign ch9_rx_data_in[52] = s0_62_1__core_periphery__data_to_core[9];
			assign ch9_rx_data_in[51] = s0_62_1__core_periphery__data_to_core[8];
			assign ch9_rx_data_in[50] = s0_62_1__core_periphery__data_to_core[38];
			assign ch9_rx_data_in[49] = s0_62_1__core_periphery__data_to_core[36];
			assign ch9_rx_data_in[48] = s0_62_1__core_periphery__data_to_core[15];
			assign ch9_rx_data_in[47] = s0_62_1__core_periphery__data_to_core[14];
			assign ch9_rx_data_in[46] = s0_62_1__core_periphery__data_to_core[13];
			assign ch9_rx_data_in[45] = s0_62_1__core_periphery__data_to_core[43];
			assign ch9_rx_data_in[44] = s0_62_1__core_periphery__data_to_core[42];
			assign ch9_rx_data_in[43] = s0_62_1__core_periphery__data_to_core[40];
			assign ch9_rx_data_in[42] = s0_62_1__core_periphery__data_to_core[19];
			assign ch9_rx_data_in[41] = s0_62_1__core_periphery__data_to_core[17];
			assign ch9_rx_data_in[40] = s0_62_1__core_periphery__data_to_core[47];
			assign ch9_rx_data_in[39] = s0_62_1__core_periphery__data_to_core[45];
			//assign ch9_rx_data_in[39] = s0_62_1__core_periphery__data_to_core[23];
			assign ch9_rx_data_in[38] = s0_62_1__core_periphery__data_to_core[22];
			assign ch9_rx_data_in[37] = s0_62_1__core_periphery__data_to_core[20];
			assign ch9_rx_data_in[36] = s0_62_1__core_periphery__data_to_core[51];
			assign ch9_rx_data_in[35] = s0_62_1__core_periphery__data_to_core[49];
			assign ch9_rx_data_in[34] = s0_62_1__core_periphery__data_to_core[80];
			assign ch9_rx_data_in[33] = s0_62_1__core_periphery__data_to_core[82];
			assign ch9_rx_data_in[32] = s0_62_1__core_periphery__data_to_core[52];
			assign ch9_rx_data_in[31] = s0_62_1__core_periphery__data_to_core[54];
			assign ch9_rx_data_in[30] = s0_62_1__core_periphery__data_to_core[55];
			assign ch9_rx_data_in[29] = s0_62_1__core_periphery__data_to_core[84];
			assign ch9_rx_data_in[28] = s0_62_1__core_periphery__data_to_core[86];
			assign ch9_rx_data_in[27] = s0_62_1__core_periphery__data_to_core[87];
			assign ch9_rx_data_in[26] = s0_62_1__core_periphery__data_to_core[57];
			assign ch9_rx_data_in[25] = s0_62_1__core_periphery__data_to_core[58];
			assign ch9_rx_data_in[24] = s0_62_1__core_periphery__data_to_core[88];
			assign ch9_rx_data_in[23] = s0_62_1__core_periphery__data_to_core[90];
			assign ch9_rx_data_in[22] = s0_62_1__core_periphery__data_to_core[60];
			assign ch9_rx_data_in[21] = s0_62_1__core_periphery__data_to_core[62];
			assign ch9_rx_data_in[20] = s0_62_1__core_periphery__data_to_core[63];
			assign ch9_rx_data_in[19] = s0_62_1__core_periphery__data_to_core[92];
			assign ch9_rx_data_in[18] = s0_62_1__core_periphery__data_to_core[93];
			assign ch9_rx_data_in[17] = s0_62_1__core_periphery__data_to_core[95];
			assign ch9_rx_data_in[16] = s0_62_1__core_periphery__data_to_core[65];
			assign ch9_rx_data_in[15] = s0_62_1__core_periphery__data_to_core[66];
			assign ch9_rx_data_in[14] = s0_62_1__core_periphery__data_to_core[67];
			assign ch9_rx_data_in[13] = s0_62_1__core_periphery__data_to_core[96];
			assign ch9_rx_data_in[12] = s0_62_1__core_periphery__data_to_core[98];
			assign ch9_rx_data_in[11] = s0_62_1__core_periphery__data_to_core[99];
			assign ch9_rx_data_in[10] = s0_62_1__core_periphery__data_to_core[69];
			assign ch9_rx_data_in[9] = s0_62_1__core_periphery__data_to_core[70];
			assign ch9_rx_data_in[8] = s0_62_1__core_periphery__data_to_core[100];
			assign ch9_rx_data_in[7] = s0_62_1__core_periphery__data_to_core[102];
			assign ch9_rx_data_in[6] = s0_62_1__core_periphery__data_to_core[72];
			assign ch9_rx_data_in[5] = s0_62_1__core_periphery__data_to_core[74];
			assign ch9_rx_data_in[4] = s0_62_1__core_periphery__data_to_core[75];
			assign ch9_rx_data_in[3] = s0_62_1__core_periphery__data_to_core[104];
			assign ch9_rx_data_in[2] = s0_62_1__core_periphery__data_to_core[105];
			assign ch9_rx_data_in[1] = s0_62_1__core_periphery__data_to_core[107];
			assign ch9_rx_data_in[0] = s0_62_1__core_periphery__data_to_core[77];

			//assign ch12_rx_data_in[79] = s0_84_1__core_periphery__data_to_core[70];
			assign ch12_rx_data_in[77] = s0_84_1__core_periphery__data_to_core[100];
			assign ch12_rx_data_in[76] = s0_84_1__core_periphery__data_to_core[102];
			assign ch12_rx_data_in[75] = s0_84_1__core_periphery__data_to_core[72];
			assign ch12_rx_data_in[74] = s0_84_1__core_periphery__data_to_core[74];
			assign ch12_rx_data_in[73] = s0_84_1__core_periphery__data_to_core[75];
			assign ch12_rx_data_in[72] = s0_84_1__core_periphery__data_to_core[104];
			assign ch12_rx_data_in[71] = s0_84_1__core_periphery__data_to_core[105];
			assign ch12_rx_data_in[70] = s0_84_1__core_periphery__data_to_core[107];
			assign ch12_rx_data_in[69] = s0_84_1__core_periphery__data_to_core[77];
			assign ch12_rx_data_in[68] = s0_84_1__core_periphery__data_to_core[78];
			assign ch12_rx_data_in[67] = s0_84_1__core_periphery__data_to_core[79];
			assign ch12_rx_data_in[66] = s0_83_1__core_periphery__data_to_core[26];
			assign ch12_rx_data_in[65] = s0_83_1__core_periphery__data_to_core[24];
			assign ch12_rx_data_in[64] = s0_83_1__core_periphery__data_to_core[3];
			assign ch12_rx_data_in[63] = s0_83_1__core_periphery__data_to_core[2];
			assign ch12_rx_data_in[62] = s0_83_1__core_periphery__data_to_core[1];
			assign ch12_rx_data_in[61] = s0_83_1__core_periphery__data_to_core[31];
			assign ch12_rx_data_in[60] = s0_83_1__core_periphery__data_to_core[30];
			assign ch12_rx_data_in[59] = s0_83_1__core_periphery__data_to_core[28];
			assign ch12_rx_data_in[58] = s0_83_1__core_periphery__data_to_core[7];
			assign ch12_rx_data_in[57] = s0_83_1__core_periphery__data_to_core[5];
			assign ch12_rx_data_in[56] = s0_83_1__core_periphery__data_to_core[35];
			assign ch12_rx_data_in[55] = s0_83_1__core_periphery__data_to_core[33];
			assign ch12_rx_data_in[54] = s0_83_1__core_periphery__data_to_core[11];
			assign ch12_rx_data_in[53] = s0_83_1__core_periphery__data_to_core[10];
			assign ch12_rx_data_in[52] = s0_83_1__core_periphery__data_to_core[9];
			assign ch12_rx_data_in[51] = s0_83_1__core_periphery__data_to_core[8];
			assign ch12_rx_data_in[50] = s0_83_1__core_periphery__data_to_core[38];
			assign ch12_rx_data_in[49] = s0_83_1__core_periphery__data_to_core[36];
			assign ch12_rx_data_in[48] = s0_83_1__core_periphery__data_to_core[15];
			assign ch12_rx_data_in[47] = s0_83_1__core_periphery__data_to_core[14];
			assign ch12_rx_data_in[46] = s0_83_1__core_periphery__data_to_core[13];
			assign ch12_rx_data_in[45] = s0_83_1__core_periphery__data_to_core[43];
			assign ch12_rx_data_in[44] = s0_83_1__core_periphery__data_to_core[42];
			assign ch12_rx_data_in[43] = s0_83_1__core_periphery__data_to_core[40];
			assign ch12_rx_data_in[42] = s0_83_1__core_periphery__data_to_core[19];
			assign ch12_rx_data_in[41] = s0_83_1__core_periphery__data_to_core[17];
			assign ch12_rx_data_in[40] = s0_83_1__core_periphery__data_to_core[47];
			assign ch12_rx_data_in[39] = s0_83_1__core_periphery__data_to_core[45];
			//assign ch12_rx_data_in[39] = s0_83_1__core_periphery__data_to_core[23];
			assign ch12_rx_data_in[38] = s0_83_1__core_periphery__data_to_core[22];
			assign ch12_rx_data_in[37] = s0_83_1__core_periphery__data_to_core[20];
			assign ch12_rx_data_in[36] = s0_83_1__core_periphery__data_to_core[51];
			assign ch12_rx_data_in[35] = s0_83_1__core_periphery__data_to_core[49];
			assign ch12_rx_data_in[34] = s0_83_1__core_periphery__data_to_core[80];
			assign ch12_rx_data_in[33] = s0_83_1__core_periphery__data_to_core[82];
			assign ch12_rx_data_in[32] = s0_83_1__core_periphery__data_to_core[52];
			assign ch12_rx_data_in[31] = s0_83_1__core_periphery__data_to_core[54];
			assign ch12_rx_data_in[30] = s0_83_1__core_periphery__data_to_core[55];
			assign ch12_rx_data_in[29] = s0_83_1__core_periphery__data_to_core[84];
			assign ch12_rx_data_in[28] = s0_83_1__core_periphery__data_to_core[86];
			assign ch12_rx_data_in[27] = s0_83_1__core_periphery__data_to_core[87];
			assign ch12_rx_data_in[26] = s0_83_1__core_periphery__data_to_core[57];
			assign ch12_rx_data_in[25] = s0_83_1__core_periphery__data_to_core[58];
			assign ch12_rx_data_in[24] = s0_83_1__core_periphery__data_to_core[88];
			assign ch12_rx_data_in[23] = s0_83_1__core_periphery__data_to_core[90];
			assign ch12_rx_data_in[22] = s0_83_1__core_periphery__data_to_core[60];
			assign ch12_rx_data_in[21] = s0_83_1__core_periphery__data_to_core[62];
			assign ch12_rx_data_in[20] = s0_83_1__core_periphery__data_to_core[63];
			assign ch12_rx_data_in[19] = s0_83_1__core_periphery__data_to_core[92];
			assign ch12_rx_data_in[18] = s0_83_1__core_periphery__data_to_core[93];
			assign ch12_rx_data_in[17] = s0_83_1__core_periphery__data_to_core[95];
			assign ch12_rx_data_in[16] = s0_83_1__core_periphery__data_to_core[65];
			assign ch12_rx_data_in[15] = s0_83_1__core_periphery__data_to_core[66];
			assign ch12_rx_data_in[14] = s0_83_1__core_periphery__data_to_core[67];
			assign ch12_rx_data_in[13] = s0_83_1__core_periphery__data_to_core[96];
			assign ch12_rx_data_in[12] = s0_83_1__core_periphery__data_to_core[98];
			assign ch12_rx_data_in[11] = s0_83_1__core_periphery__data_to_core[99];
			assign ch12_rx_data_in[10] = s0_83_1__core_periphery__data_to_core[69];
			assign ch12_rx_data_in[9] = s0_83_1__core_periphery__data_to_core[70];
			assign ch12_rx_data_in[8] = s0_83_1__core_periphery__data_to_core[100];
			assign ch12_rx_data_in[7] = s0_83_1__core_periphery__data_to_core[102];
			assign ch12_rx_data_in[6] = s0_83_1__core_periphery__data_to_core[72];
			assign ch12_rx_data_in[5] = s0_83_1__core_periphery__data_to_core[74];
			assign ch12_rx_data_in[4] = s0_83_1__core_periphery__data_to_core[75];
			assign ch12_rx_data_in[3] = s0_83_1__core_periphery__data_to_core[104];
			assign ch12_rx_data_in[2] = s0_83_1__core_periphery__data_to_core[105];
			assign ch12_rx_data_in[1] = s0_83_1__core_periphery__data_to_core[107];
			assign ch12_rx_data_in[0] = s0_83_1__core_periphery__data_to_core[77];



			//assign ch13_rx_data_in[79] = s0_90_1__core_periphery__data_to_core[70];
			assign ch13_rx_data_in[77] = s0_90_1__core_periphery__data_to_core[100];
			assign ch13_rx_data_in[76] = s0_90_1__core_periphery__data_to_core[102];
			assign ch13_rx_data_in[75] = s0_90_1__core_periphery__data_to_core[72];
			assign ch13_rx_data_in[74] = s0_90_1__core_periphery__data_to_core[74];
			assign ch13_rx_data_in[73] = s0_90_1__core_periphery__data_to_core[75];
			assign ch13_rx_data_in[72] = s0_90_1__core_periphery__data_to_core[104];
			assign ch13_rx_data_in[71] = s0_90_1__core_periphery__data_to_core[105];
			assign ch13_rx_data_in[70] = s0_90_1__core_periphery__data_to_core[107];
			assign ch13_rx_data_in[69] = s0_90_1__core_periphery__data_to_core[77];
			assign ch13_rx_data_in[68] = s0_90_1__core_periphery__data_to_core[78];
			assign ch13_rx_data_in[67] = s0_90_1__core_periphery__data_to_core[79];
			assign ch13_rx_data_in[66] = s0_89_1__core_periphery__data_to_core[26];
			assign ch13_rx_data_in[65] = s0_89_1__core_periphery__data_to_core[24];
			assign ch13_rx_data_in[64] = s0_89_1__core_periphery__data_to_core[3];
			assign ch13_rx_data_in[63] = s0_89_1__core_periphery__data_to_core[2];
			assign ch13_rx_data_in[62] = s0_89_1__core_periphery__data_to_core[1];
			assign ch13_rx_data_in[61] = s0_89_1__core_periphery__data_to_core[31];
			assign ch13_rx_data_in[60] = s0_89_1__core_periphery__data_to_core[30];
			assign ch13_rx_data_in[59] = s0_89_1__core_periphery__data_to_core[28];
			assign ch13_rx_data_in[58] = s0_89_1__core_periphery__data_to_core[7];
			assign ch13_rx_data_in[57] = s0_89_1__core_periphery__data_to_core[5];
			assign ch13_rx_data_in[56] = s0_89_1__core_periphery__data_to_core[35];
			assign ch13_rx_data_in[55] = s0_89_1__core_periphery__data_to_core[33];
			assign ch13_rx_data_in[54] = s0_89_1__core_periphery__data_to_core[11];
			assign ch13_rx_data_in[53] = s0_89_1__core_periphery__data_to_core[10];
			assign ch13_rx_data_in[52] = s0_89_1__core_periphery__data_to_core[9];
			assign ch13_rx_data_in[51] = s0_89_1__core_periphery__data_to_core[8];
			assign ch13_rx_data_in[50] = s0_89_1__core_periphery__data_to_core[38];
			assign ch13_rx_data_in[49] = s0_89_1__core_periphery__data_to_core[36];
			assign ch13_rx_data_in[48] = s0_89_1__core_periphery__data_to_core[15];
			assign ch13_rx_data_in[47] = s0_89_1__core_periphery__data_to_core[14];
			assign ch13_rx_data_in[46] = s0_89_1__core_periphery__data_to_core[13];
			assign ch13_rx_data_in[45] = s0_89_1__core_periphery__data_to_core[43];
			assign ch13_rx_data_in[44] = s0_89_1__core_periphery__data_to_core[42];
			assign ch13_rx_data_in[43] = s0_89_1__core_periphery__data_to_core[40];
			assign ch13_rx_data_in[42] = s0_89_1__core_periphery__data_to_core[19];
			assign ch13_rx_data_in[41] = s0_89_1__core_periphery__data_to_core[17];
			assign ch13_rx_data_in[40] = s0_89_1__core_periphery__data_to_core[47];
			assign ch13_rx_data_in[39] = s0_89_1__core_periphery__data_to_core[45];
			//assign ch13_rx_data_in[39] = s0_89_1__core_periphery__data_to_core[23];
			assign ch13_rx_data_in[38] = s0_89_1__core_periphery__data_to_core[22];
			assign ch13_rx_data_in[37] = s0_89_1__core_periphery__data_to_core[20];
			assign ch13_rx_data_in[36] = s0_89_1__core_periphery__data_to_core[51];
			assign ch13_rx_data_in[35] = s0_89_1__core_periphery__data_to_core[49];
			assign ch13_rx_data_in[34] = s0_89_1__core_periphery__data_to_core[80];
			assign ch13_rx_data_in[33] = s0_89_1__core_periphery__data_to_core[82];
			assign ch13_rx_data_in[32] = s0_89_1__core_periphery__data_to_core[52];
			assign ch13_rx_data_in[31] = s0_89_1__core_periphery__data_to_core[54];
			assign ch13_rx_data_in[30] = s0_89_1__core_periphery__data_to_core[55];
			assign ch13_rx_data_in[29] = s0_89_1__core_periphery__data_to_core[84];
			assign ch13_rx_data_in[28] = s0_89_1__core_periphery__data_to_core[86];
			assign ch13_rx_data_in[27] = s0_89_1__core_periphery__data_to_core[87];
			assign ch13_rx_data_in[26] = s0_89_1__core_periphery__data_to_core[57];
			assign ch13_rx_data_in[25] = s0_89_1__core_periphery__data_to_core[58];
			assign ch13_rx_data_in[24] = s0_89_1__core_periphery__data_to_core[88];
			assign ch13_rx_data_in[23] = s0_89_1__core_periphery__data_to_core[90];
			assign ch13_rx_data_in[22] = s0_89_1__core_periphery__data_to_core[60];
			assign ch13_rx_data_in[21] = s0_89_1__core_periphery__data_to_core[62];
			assign ch13_rx_data_in[20] = s0_89_1__core_periphery__data_to_core[63];
			assign ch13_rx_data_in[19] = s0_89_1__core_periphery__data_to_core[92];
			assign ch13_rx_data_in[18] = s0_89_1__core_periphery__data_to_core[93];
			assign ch13_rx_data_in[17] = s0_89_1__core_periphery__data_to_core[95];
			assign ch13_rx_data_in[16] = s0_89_1__core_periphery__data_to_core[65];
			assign ch13_rx_data_in[15] = s0_89_1__core_periphery__data_to_core[66];
			assign ch13_rx_data_in[14] = s0_89_1__core_periphery__data_to_core[67];
			assign ch13_rx_data_in[13] = s0_89_1__core_periphery__data_to_core[96];
			assign ch13_rx_data_in[12] = s0_89_1__core_periphery__data_to_core[98];
			assign ch13_rx_data_in[11] = s0_89_1__core_periphery__data_to_core[99];
			assign ch13_rx_data_in[10] = s0_89_1__core_periphery__data_to_core[69];
			assign ch13_rx_data_in[9] = s0_89_1__core_periphery__data_to_core[70];
			assign ch13_rx_data_in[8] = s0_89_1__core_periphery__data_to_core[100];
			assign ch13_rx_data_in[7] = s0_89_1__core_periphery__data_to_core[102];
			assign ch13_rx_data_in[6] = s0_89_1__core_periphery__data_to_core[72];
			assign ch13_rx_data_in[5] = s0_89_1__core_periphery__data_to_core[74];
			assign ch13_rx_data_in[4] = s0_89_1__core_periphery__data_to_core[75];
			assign ch13_rx_data_in[3] = s0_89_1__core_periphery__data_to_core[104];
			assign ch13_rx_data_in[2] = s0_89_1__core_periphery__data_to_core[105];
			assign ch13_rx_data_in[1] = s0_89_1__core_periphery__data_to_core[107];
			assign ch13_rx_data_in[0] = s0_89_1__core_periphery__data_to_core[77];


			//assign ch14_rx_data_in[79] = s0_96_1__core_periphery__data_to_core[70];
			assign ch14_rx_data_in[77] = s0_96_1__core_periphery__data_to_core[100];
			assign ch14_rx_data_in[76] = s0_96_1__core_periphery__data_to_core[102];
			assign ch14_rx_data_in[75] = s0_96_1__core_periphery__data_to_core[72];
			assign ch14_rx_data_in[74] = s0_96_1__core_periphery__data_to_core[74];
			assign ch14_rx_data_in[73] = s0_96_1__core_periphery__data_to_core[75];
			assign ch14_rx_data_in[72] = s0_96_1__core_periphery__data_to_core[104];
			assign ch14_rx_data_in[71] = s0_96_1__core_periphery__data_to_core[105];
			assign ch14_rx_data_in[70] = s0_96_1__core_periphery__data_to_core[107];
			assign ch14_rx_data_in[69] = s0_96_1__core_periphery__data_to_core[77];
			assign ch14_rx_data_in[68] = s0_96_1__core_periphery__data_to_core[78];
			assign ch14_rx_data_in[67] = s0_96_1__core_periphery__data_to_core[79];
			assign ch14_rx_data_in[66] = s0_95_1__core_periphery__data_to_core[26];
			assign ch14_rx_data_in[65] = s0_95_1__core_periphery__data_to_core[24];
			assign ch14_rx_data_in[64] = s0_95_1__core_periphery__data_to_core[3];
			assign ch14_rx_data_in[63] = s0_95_1__core_periphery__data_to_core[2];
			assign ch14_rx_data_in[62] = s0_95_1__core_periphery__data_to_core[1];
			assign ch14_rx_data_in[61] = s0_95_1__core_periphery__data_to_core[31];
			assign ch14_rx_data_in[60] = s0_95_1__core_periphery__data_to_core[30];
			assign ch14_rx_data_in[59] = s0_95_1__core_periphery__data_to_core[28];
			assign ch14_rx_data_in[58] = s0_95_1__core_periphery__data_to_core[7];
			assign ch14_rx_data_in[57] = s0_95_1__core_periphery__data_to_core[5];
			assign ch14_rx_data_in[56] = s0_95_1__core_periphery__data_to_core[35];
			assign ch14_rx_data_in[55] = s0_95_1__core_periphery__data_to_core[33];
			assign ch14_rx_data_in[54] = s0_95_1__core_periphery__data_to_core[11];
			assign ch14_rx_data_in[53] = s0_95_1__core_periphery__data_to_core[10];
			assign ch14_rx_data_in[52] = s0_95_1__core_periphery__data_to_core[9];
			assign ch14_rx_data_in[51] = s0_95_1__core_periphery__data_to_core[8];
			assign ch14_rx_data_in[50] = s0_95_1__core_periphery__data_to_core[38];
			assign ch14_rx_data_in[49] = s0_95_1__core_periphery__data_to_core[36];
			assign ch14_rx_data_in[48] = s0_95_1__core_periphery__data_to_core[15];
			assign ch14_rx_data_in[47] = s0_95_1__core_periphery__data_to_core[14];
			assign ch14_rx_data_in[46] = s0_95_1__core_periphery__data_to_core[13];
			assign ch14_rx_data_in[45] = s0_95_1__core_periphery__data_to_core[43];
			assign ch14_rx_data_in[44] = s0_95_1__core_periphery__data_to_core[42];
			assign ch14_rx_data_in[43] = s0_95_1__core_periphery__data_to_core[40];
			assign ch14_rx_data_in[42] = s0_95_1__core_periphery__data_to_core[19];
			assign ch14_rx_data_in[41] = s0_95_1__core_periphery__data_to_core[17];
			assign ch14_rx_data_in[40] = s0_95_1__core_periphery__data_to_core[47];
			assign ch14_rx_data_in[39] = s0_95_1__core_periphery__data_to_core[45];
			//assign ch14_rx_data_in[39] = s0_95_1__core_periphery__data_to_core[23];
			assign ch14_rx_data_in[38] = s0_95_1__core_periphery__data_to_core[22];
			assign ch14_rx_data_in[37] = s0_95_1__core_periphery__data_to_core[20];
			assign ch14_rx_data_in[36] = s0_95_1__core_periphery__data_to_core[51];
			assign ch14_rx_data_in[35] = s0_95_1__core_periphery__data_to_core[49];
			assign ch14_rx_data_in[34] = s0_95_1__core_periphery__data_to_core[80];
			assign ch14_rx_data_in[33] = s0_95_1__core_periphery__data_to_core[82];
			assign ch14_rx_data_in[32] = s0_95_1__core_periphery__data_to_core[52];
			assign ch14_rx_data_in[31] = s0_95_1__core_periphery__data_to_core[54];
			assign ch14_rx_data_in[30] = s0_95_1__core_periphery__data_to_core[55];
			assign ch14_rx_data_in[29] = s0_95_1__core_periphery__data_to_core[84];
			assign ch14_rx_data_in[28] = s0_95_1__core_periphery__data_to_core[86];
			assign ch14_rx_data_in[27] = s0_95_1__core_periphery__data_to_core[87];
			assign ch14_rx_data_in[26] = s0_95_1__core_periphery__data_to_core[57];
			assign ch14_rx_data_in[25] = s0_95_1__core_periphery__data_to_core[58];
			assign ch14_rx_data_in[24] = s0_95_1__core_periphery__data_to_core[88];
			assign ch14_rx_data_in[23] = s0_95_1__core_periphery__data_to_core[90];
			assign ch14_rx_data_in[22] = s0_95_1__core_periphery__data_to_core[60];
			assign ch14_rx_data_in[21] = s0_95_1__core_periphery__data_to_core[62];
			assign ch14_rx_data_in[20] = s0_95_1__core_periphery__data_to_core[63];
			assign ch14_rx_data_in[19] = s0_95_1__core_periphery__data_to_core[92];
			assign ch14_rx_data_in[18] = s0_95_1__core_periphery__data_to_core[93];
			assign ch14_rx_data_in[17] = s0_95_1__core_periphery__data_to_core[95];
			assign ch14_rx_data_in[16] = s0_95_1__core_periphery__data_to_core[65];
			assign ch14_rx_data_in[15] = s0_95_1__core_periphery__data_to_core[66];
			assign ch14_rx_data_in[14] = s0_95_1__core_periphery__data_to_core[67];
			assign ch14_rx_data_in[13] = s0_95_1__core_periphery__data_to_core[96];
			assign ch14_rx_data_in[12] = s0_95_1__core_periphery__data_to_core[98];
			assign ch14_rx_data_in[11] = s0_95_1__core_periphery__data_to_core[99];
			assign ch14_rx_data_in[10] = s0_95_1__core_periphery__data_to_core[69];
			assign ch14_rx_data_in[9] = s0_95_1__core_periphery__data_to_core[70];
			assign ch14_rx_data_in[8] = s0_95_1__core_periphery__data_to_core[100];
			assign ch14_rx_data_in[7] = s0_95_1__core_periphery__data_to_core[102];
			assign ch14_rx_data_in[6] = s0_95_1__core_periphery__data_to_core[72];
			assign ch14_rx_data_in[5] = s0_95_1__core_periphery__data_to_core[74];
			assign ch14_rx_data_in[4] = s0_95_1__core_periphery__data_to_core[75];
			assign ch14_rx_data_in[3] = s0_95_1__core_periphery__data_to_core[104];
			assign ch14_rx_data_in[2] = s0_95_1__core_periphery__data_to_core[105];
			assign ch14_rx_data_in[1] = s0_95_1__core_periphery__data_to_core[107];
			assign ch14_rx_data_in[0] = s0_95_1__core_periphery__data_to_core[77];


			//assign ch15_rx_data_in[79] = s0_103_1__core_periphery__data_to_core[70];
			assign ch15_rx_data_in[77] = s0_103_1__core_periphery__data_to_core[100];
			assign ch15_rx_data_in[76] = s0_103_1__core_periphery__data_to_core[102];
			assign ch15_rx_data_in[75] = s0_103_1__core_periphery__data_to_core[72];
			assign ch15_rx_data_in[74] = s0_103_1__core_periphery__data_to_core[74];
			assign ch15_rx_data_in[73] = s0_103_1__core_periphery__data_to_core[75];
			assign ch15_rx_data_in[72] = s0_103_1__core_periphery__data_to_core[104];
			assign ch15_rx_data_in[71] = s0_103_1__core_periphery__data_to_core[105];
			assign ch15_rx_data_in[70] = s0_103_1__core_periphery__data_to_core[107];
			assign ch15_rx_data_in[69] = s0_103_1__core_periphery__data_to_core[77];
			assign ch15_rx_data_in[68] = s0_103_1__core_periphery__data_to_core[78];
			assign ch15_rx_data_in[67] = s0_103_1__core_periphery__data_to_core[79];
			assign ch15_rx_data_in[66] = s0_102_1__core_periphery__data_to_core[26];
			assign ch15_rx_data_in[65] = s0_102_1__core_periphery__data_to_core[24];
			assign ch15_rx_data_in[64] = s0_102_1__core_periphery__data_to_core[3];
			assign ch15_rx_data_in[63] = s0_102_1__core_periphery__data_to_core[2];
			assign ch15_rx_data_in[62] = s0_102_1__core_periphery__data_to_core[1];
			assign ch15_rx_data_in[61] = s0_102_1__core_periphery__data_to_core[31];
			assign ch15_rx_data_in[60] = s0_102_1__core_periphery__data_to_core[30];
			assign ch15_rx_data_in[59] = s0_102_1__core_periphery__data_to_core[28];
			assign ch15_rx_data_in[58] = s0_102_1__core_periphery__data_to_core[7];
			assign ch15_rx_data_in[57] = s0_102_1__core_periphery__data_to_core[5];
			assign ch15_rx_data_in[56] = s0_102_1__core_periphery__data_to_core[35];
			assign ch15_rx_data_in[55] = s0_102_1__core_periphery__data_to_core[33];
			assign ch15_rx_data_in[54] = s0_102_1__core_periphery__data_to_core[11];
			assign ch15_rx_data_in[53] = s0_102_1__core_periphery__data_to_core[10];
			assign ch15_rx_data_in[52] = s0_102_1__core_periphery__data_to_core[9];
			assign ch15_rx_data_in[51] = s0_102_1__core_periphery__data_to_core[8];
			assign ch15_rx_data_in[50] = s0_102_1__core_periphery__data_to_core[38];
			assign ch15_rx_data_in[49] = s0_102_1__core_periphery__data_to_core[36];
			assign ch15_rx_data_in[48] = s0_102_1__core_periphery__data_to_core[15];
			assign ch15_rx_data_in[47] = s0_102_1__core_periphery__data_to_core[14];
			assign ch15_rx_data_in[46] = s0_102_1__core_periphery__data_to_core[13];
			assign ch15_rx_data_in[45] = s0_102_1__core_periphery__data_to_core[43];
			assign ch15_rx_data_in[44] = s0_102_1__core_periphery__data_to_core[42];
			assign ch15_rx_data_in[43] = s0_102_1__core_periphery__data_to_core[40];
			assign ch15_rx_data_in[42] = s0_102_1__core_periphery__data_to_core[19];
			assign ch15_rx_data_in[41] = s0_102_1__core_periphery__data_to_core[17];
			assign ch15_rx_data_in[40] = s0_102_1__core_periphery__data_to_core[47];
			assign ch15_rx_data_in[39] = s0_102_1__core_periphery__data_to_core[45];
			//assign ch15_rx_data_in[39] = s0_102_1__core_periphery__data_to_core[23];
			assign ch15_rx_data_in[38] = s0_102_1__core_periphery__data_to_core[22];
			assign ch15_rx_data_in[37] = s0_102_1__core_periphery__data_to_core[20];
			assign ch15_rx_data_in[36] = s0_102_1__core_periphery__data_to_core[51];
			assign ch15_rx_data_in[35] = s0_102_1__core_periphery__data_to_core[49];
			assign ch15_rx_data_in[34] = s0_102_1__core_periphery__data_to_core[80];
			assign ch15_rx_data_in[33] = s0_102_1__core_periphery__data_to_core[82];
			assign ch15_rx_data_in[32] = s0_102_1__core_periphery__data_to_core[52];
			assign ch15_rx_data_in[31] = s0_102_1__core_periphery__data_to_core[54];
			assign ch15_rx_data_in[30] = s0_102_1__core_periphery__data_to_core[55];
			assign ch15_rx_data_in[29] = s0_102_1__core_periphery__data_to_core[84];
			assign ch15_rx_data_in[28] = s0_102_1__core_periphery__data_to_core[86];
			assign ch15_rx_data_in[27] = s0_102_1__core_periphery__data_to_core[87];
			assign ch15_rx_data_in[26] = s0_102_1__core_periphery__data_to_core[57];
			assign ch15_rx_data_in[25] = s0_102_1__core_periphery__data_to_core[58];
			assign ch15_rx_data_in[24] = s0_102_1__core_periphery__data_to_core[88];
			assign ch15_rx_data_in[23] = s0_102_1__core_periphery__data_to_core[90];
			assign ch15_rx_data_in[22] = s0_102_1__core_periphery__data_to_core[60];
			assign ch15_rx_data_in[21] = s0_102_1__core_periphery__data_to_core[62];
			assign ch15_rx_data_in[20] = s0_102_1__core_periphery__data_to_core[63];
			assign ch15_rx_data_in[19] = s0_102_1__core_periphery__data_to_core[92];
			assign ch15_rx_data_in[18] = s0_102_1__core_periphery__data_to_core[93];
			assign ch15_rx_data_in[17] = s0_102_1__core_periphery__data_to_core[95];
			assign ch15_rx_data_in[16] = s0_102_1__core_periphery__data_to_core[65];
			assign ch15_rx_data_in[15] = s0_102_1__core_periphery__data_to_core[66];
			assign ch15_rx_data_in[14] = s0_102_1__core_periphery__data_to_core[67];
			assign ch15_rx_data_in[13] = s0_102_1__core_periphery__data_to_core[96];
			assign ch15_rx_data_in[12] = s0_102_1__core_periphery__data_to_core[98];
			assign ch15_rx_data_in[11] = s0_102_1__core_periphery__data_to_core[99];
			assign ch15_rx_data_in[10] = s0_102_1__core_periphery__data_to_core[69];
			assign ch15_rx_data_in[9] = s0_102_1__core_periphery__data_to_core[70];
			assign ch15_rx_data_in[8] = s0_102_1__core_periphery__data_to_core[100];
			assign ch15_rx_data_in[7] = s0_102_1__core_periphery__data_to_core[102];
			assign ch15_rx_data_in[6] = s0_102_1__core_periphery__data_to_core[72];
			assign ch15_rx_data_in[5] = s0_102_1__core_periphery__data_to_core[74];
			assign ch15_rx_data_in[4] = s0_102_1__core_periphery__data_to_core[75];
			assign ch15_rx_data_in[3] = s0_102_1__core_periphery__data_to_core[104];
			assign ch15_rx_data_in[2] = s0_102_1__core_periphery__data_to_core[105];
			assign ch15_rx_data_in[1] = s0_102_1__core_periphery__data_to_core[107];
			assign ch15_rx_data_in[0] = s0_102_1__core_periphery__data_to_core[77];



			//assign ch16_rx_data_in[79] = s0_109_1__core_periphery__data_to_core[70];
			assign ch16_rx_data_in[77] = s0_109_1__core_periphery__data_to_core[100];
			assign ch16_rx_data_in[76] = s0_109_1__core_periphery__data_to_core[102];
			assign ch16_rx_data_in[75] = s0_109_1__core_periphery__data_to_core[72];
			assign ch16_rx_data_in[74] = s0_109_1__core_periphery__data_to_core[74];
			assign ch16_rx_data_in[73] = s0_109_1__core_periphery__data_to_core[75];
			assign ch16_rx_data_in[72] = s0_109_1__core_periphery__data_to_core[104];
			assign ch16_rx_data_in[71] = s0_109_1__core_periphery__data_to_core[105];
			assign ch16_rx_data_in[70] = s0_109_1__core_periphery__data_to_core[107];
			assign ch16_rx_data_in[69] = s0_109_1__core_periphery__data_to_core[77];
			assign ch16_rx_data_in[68] = s0_109_1__core_periphery__data_to_core[78];
			assign ch16_rx_data_in[67] = s0_109_1__core_periphery__data_to_core[79];
			assign ch16_rx_data_in[66] = s0_108_1__core_periphery__data_to_core[26];
			assign ch16_rx_data_in[65] = s0_108_1__core_periphery__data_to_core[24];
			assign ch16_rx_data_in[64] = s0_108_1__core_periphery__data_to_core[3];
			assign ch16_rx_data_in[63] = s0_108_1__core_periphery__data_to_core[2];
			assign ch16_rx_data_in[62] = s0_108_1__core_periphery__data_to_core[1];
			assign ch16_rx_data_in[61] = s0_108_1__core_periphery__data_to_core[31];
			assign ch16_rx_data_in[60] = s0_108_1__core_periphery__data_to_core[30];
			assign ch16_rx_data_in[59] = s0_108_1__core_periphery__data_to_core[28];
			assign ch16_rx_data_in[58] = s0_108_1__core_periphery__data_to_core[7];
			assign ch16_rx_data_in[57] = s0_108_1__core_periphery__data_to_core[5];
			assign ch16_rx_data_in[56] = s0_108_1__core_periphery__data_to_core[35];
			assign ch16_rx_data_in[55] = s0_108_1__core_periphery__data_to_core[33];
			assign ch16_rx_data_in[54] = s0_108_1__core_periphery__data_to_core[11];
			assign ch16_rx_data_in[53] = s0_108_1__core_periphery__data_to_core[10];
			assign ch16_rx_data_in[52] = s0_108_1__core_periphery__data_to_core[9];
			assign ch16_rx_data_in[51] = s0_108_1__core_periphery__data_to_core[8];
			assign ch16_rx_data_in[50] = s0_108_1__core_periphery__data_to_core[38];
			assign ch16_rx_data_in[49] = s0_108_1__core_periphery__data_to_core[36];
			assign ch16_rx_data_in[48] = s0_108_1__core_periphery__data_to_core[15];
			assign ch16_rx_data_in[47] = s0_108_1__core_periphery__data_to_core[14];
			assign ch16_rx_data_in[46] = s0_108_1__core_periphery__data_to_core[13];
			assign ch16_rx_data_in[45] = s0_108_1__core_periphery__data_to_core[43];
			assign ch16_rx_data_in[44] = s0_108_1__core_periphery__data_to_core[42];
			assign ch16_rx_data_in[43] = s0_108_1__core_periphery__data_to_core[40];
			assign ch16_rx_data_in[42] = s0_108_1__core_periphery__data_to_core[19];
			assign ch16_rx_data_in[41] = s0_108_1__core_periphery__data_to_core[17];
			assign ch16_rx_data_in[40] = s0_108_1__core_periphery__data_to_core[47];
			assign ch16_rx_data_in[39] = s0_108_1__core_periphery__data_to_core[45];
			//assign ch16_rx_data_in[39] = s0_108_1__core_periphery__data_to_core[23];
			assign ch16_rx_data_in[38] = s0_108_1__core_periphery__data_to_core[22];
			assign ch16_rx_data_in[37] = s0_108_1__core_periphery__data_to_core[20];
			assign ch16_rx_data_in[36] = s0_108_1__core_periphery__data_to_core[51];
			assign ch16_rx_data_in[35] = s0_108_1__core_periphery__data_to_core[49];
			assign ch16_rx_data_in[34] = s0_108_1__core_periphery__data_to_core[80];
			assign ch16_rx_data_in[33] = s0_108_1__core_periphery__data_to_core[82];
			assign ch16_rx_data_in[32] = s0_108_1__core_periphery__data_to_core[52];
			assign ch16_rx_data_in[31] = s0_108_1__core_periphery__data_to_core[54];
			assign ch16_rx_data_in[30] = s0_108_1__core_periphery__data_to_core[55];
			assign ch16_rx_data_in[29] = s0_108_1__core_periphery__data_to_core[84];
			assign ch16_rx_data_in[28] = s0_108_1__core_periphery__data_to_core[86];
			assign ch16_rx_data_in[27] = s0_108_1__core_periphery__data_to_core[87];
			assign ch16_rx_data_in[26] = s0_108_1__core_periphery__data_to_core[57];
			assign ch16_rx_data_in[25] = s0_108_1__core_periphery__data_to_core[58];
			assign ch16_rx_data_in[24] = s0_108_1__core_periphery__data_to_core[88];
			assign ch16_rx_data_in[23] = s0_108_1__core_periphery__data_to_core[90];
			assign ch16_rx_data_in[22] = s0_108_1__core_periphery__data_to_core[60];
			assign ch16_rx_data_in[21] = s0_108_1__core_periphery__data_to_core[62];
			assign ch16_rx_data_in[20] = s0_108_1__core_periphery__data_to_core[63];
			assign ch16_rx_data_in[19] = s0_108_1__core_periphery__data_to_core[92];
			assign ch16_rx_data_in[18] = s0_108_1__core_periphery__data_to_core[93];
			assign ch16_rx_data_in[17] = s0_108_1__core_periphery__data_to_core[95];
			assign ch16_rx_data_in[16] = s0_108_1__core_periphery__data_to_core[65];
			assign ch16_rx_data_in[15] = s0_108_1__core_periphery__data_to_core[66];
			assign ch16_rx_data_in[14] = s0_108_1__core_periphery__data_to_core[67];
			assign ch16_rx_data_in[13] = s0_108_1__core_periphery__data_to_core[96];
			assign ch16_rx_data_in[12] = s0_108_1__core_periphery__data_to_core[98];
			assign ch16_rx_data_in[11] = s0_108_1__core_periphery__data_to_core[99];
			assign ch16_rx_data_in[10] = s0_108_1__core_periphery__data_to_core[69];
			assign ch16_rx_data_in[9] = s0_108_1__core_periphery__data_to_core[70];
			assign ch16_rx_data_in[8] = s0_108_1__core_periphery__data_to_core[100];
			assign ch16_rx_data_in[7] = s0_108_1__core_periphery__data_to_core[102];
			assign ch16_rx_data_in[6] = s0_108_1__core_periphery__data_to_core[72];
			assign ch16_rx_data_in[5] = s0_108_1__core_periphery__data_to_core[74];
			assign ch16_rx_data_in[4] = s0_108_1__core_periphery__data_to_core[75];
			assign ch16_rx_data_in[3] = s0_108_1__core_periphery__data_to_core[104];
			assign ch16_rx_data_in[2] = s0_108_1__core_periphery__data_to_core[105];
			assign ch16_rx_data_in[1] = s0_108_1__core_periphery__data_to_core[107];
			assign ch16_rx_data_in[0] = s0_108_1__core_periphery__data_to_core[77];



			//assign ch17_rx_data_in[79] = s0_115_1__core_periphery__data_to_core[70];
			assign ch17_rx_data_in[77] = s0_115_1__core_periphery__data_to_core[100];
			assign ch17_rx_data_in[76] = s0_115_1__core_periphery__data_to_core[102];
			assign ch17_rx_data_in[75] = s0_115_1__core_periphery__data_to_core[72];
			assign ch17_rx_data_in[74] = s0_115_1__core_periphery__data_to_core[74];
			assign ch17_rx_data_in[73] = s0_115_1__core_periphery__data_to_core[75];
			assign ch17_rx_data_in[72] = s0_115_1__core_periphery__data_to_core[104];
			assign ch17_rx_data_in[71] = s0_115_1__core_periphery__data_to_core[105];
			assign ch17_rx_data_in[70] = s0_115_1__core_periphery__data_to_core[107];
			assign ch17_rx_data_in[69] = s0_115_1__core_periphery__data_to_core[77];
			assign ch17_rx_data_in[68] = s0_115_1__core_periphery__data_to_core[78];
			assign ch17_rx_data_in[67] = s0_115_1__core_periphery__data_to_core[79];
			assign ch17_rx_data_in[66] = s0_114_1__core_periphery__data_to_core[26];
			assign ch17_rx_data_in[65] = s0_114_1__core_periphery__data_to_core[24];
			assign ch17_rx_data_in[64] = s0_114_1__core_periphery__data_to_core[3];
			assign ch17_rx_data_in[63] = s0_114_1__core_periphery__data_to_core[2];
			assign ch17_rx_data_in[62] = s0_114_1__core_periphery__data_to_core[1];
			assign ch17_rx_data_in[61] = s0_114_1__core_periphery__data_to_core[31];
			assign ch17_rx_data_in[60] = s0_114_1__core_periphery__data_to_core[30];
			assign ch17_rx_data_in[59] = s0_114_1__core_periphery__data_to_core[28];
			assign ch17_rx_data_in[58] = s0_114_1__core_periphery__data_to_core[7];
			assign ch17_rx_data_in[57] = s0_114_1__core_periphery__data_to_core[5];
			assign ch17_rx_data_in[56] = s0_114_1__core_periphery__data_to_core[35];
			assign ch17_rx_data_in[55] = s0_114_1__core_periphery__data_to_core[33];
			assign ch17_rx_data_in[54] = s0_114_1__core_periphery__data_to_core[11];
			assign ch17_rx_data_in[53] = s0_114_1__core_periphery__data_to_core[10];
			assign ch17_rx_data_in[52] = s0_114_1__core_periphery__data_to_core[9];
			assign ch17_rx_data_in[51] = s0_114_1__core_periphery__data_to_core[8];
			assign ch17_rx_data_in[50] = s0_114_1__core_periphery__data_to_core[38];
			assign ch17_rx_data_in[49] = s0_114_1__core_periphery__data_to_core[36];
			assign ch17_rx_data_in[48] = s0_114_1__core_periphery__data_to_core[15];
			assign ch17_rx_data_in[47] = s0_114_1__core_periphery__data_to_core[14];
			assign ch17_rx_data_in[46] = s0_114_1__core_periphery__data_to_core[13];
			assign ch17_rx_data_in[45] = s0_114_1__core_periphery__data_to_core[43];
			assign ch17_rx_data_in[44] = s0_114_1__core_periphery__data_to_core[42];
			assign ch17_rx_data_in[43] = s0_114_1__core_periphery__data_to_core[40];
			assign ch17_rx_data_in[42] = s0_114_1__core_periphery__data_to_core[19];
			assign ch17_rx_data_in[41] = s0_114_1__core_periphery__data_to_core[17];
			assign ch17_rx_data_in[40] = s0_114_1__core_periphery__data_to_core[47];
			assign ch17_rx_data_in[39] = s0_114_1__core_periphery__data_to_core[45];
			//assign ch17_rx_data_in[39] = s0_114_1__core_periphery__data_to_core[23];
			assign ch17_rx_data_in[38] = s0_114_1__core_periphery__data_to_core[22];
			assign ch17_rx_data_in[37] = s0_114_1__core_periphery__data_to_core[20];
			assign ch17_rx_data_in[36] = s0_114_1__core_periphery__data_to_core[51];
			assign ch17_rx_data_in[35] = s0_114_1__core_periphery__data_to_core[49];
			assign ch17_rx_data_in[34] = s0_114_1__core_periphery__data_to_core[80];
			assign ch17_rx_data_in[33] = s0_114_1__core_periphery__data_to_core[82];
			assign ch17_rx_data_in[32] = s0_114_1__core_periphery__data_to_core[52];
			assign ch17_rx_data_in[31] = s0_114_1__core_periphery__data_to_core[54];
			assign ch17_rx_data_in[30] = s0_114_1__core_periphery__data_to_core[55];
			assign ch17_rx_data_in[29] = s0_114_1__core_periphery__data_to_core[84];
			assign ch17_rx_data_in[28] = s0_114_1__core_periphery__data_to_core[86];
			assign ch17_rx_data_in[27] = s0_114_1__core_periphery__data_to_core[87];
			assign ch17_rx_data_in[26] = s0_114_1__core_periphery__data_to_core[57];
			assign ch17_rx_data_in[25] = s0_114_1__core_periphery__data_to_core[58];
			assign ch17_rx_data_in[24] = s0_114_1__core_periphery__data_to_core[88];
			assign ch17_rx_data_in[23] = s0_114_1__core_periphery__data_to_core[90];
			assign ch17_rx_data_in[22] = s0_114_1__core_periphery__data_to_core[60];
			assign ch17_rx_data_in[21] = s0_114_1__core_periphery__data_to_core[62];
			assign ch17_rx_data_in[20] = s0_114_1__core_periphery__data_to_core[63];
			assign ch17_rx_data_in[19] = s0_114_1__core_periphery__data_to_core[92];
			assign ch17_rx_data_in[18] = s0_114_1__core_periphery__data_to_core[93];
			assign ch17_rx_data_in[17] = s0_114_1__core_periphery__data_to_core[95];
			assign ch17_rx_data_in[16] = s0_114_1__core_periphery__data_to_core[65];
			assign ch17_rx_data_in[15] = s0_114_1__core_periphery__data_to_core[66];
			assign ch17_rx_data_in[14] = s0_114_1__core_periphery__data_to_core[67];
			assign ch17_rx_data_in[13] = s0_114_1__core_periphery__data_to_core[96];
			assign ch17_rx_data_in[12] = s0_114_1__core_periphery__data_to_core[98];
			assign ch17_rx_data_in[11] = s0_114_1__core_periphery__data_to_core[99];
			assign ch17_rx_data_in[10] = s0_114_1__core_periphery__data_to_core[69];
			assign ch17_rx_data_in[9] = s0_114_1__core_periphery__data_to_core[70];
			assign ch17_rx_data_in[8] = s0_114_1__core_periphery__data_to_core[100];
			assign ch17_rx_data_in[7] = s0_114_1__core_periphery__data_to_core[102];
			assign ch17_rx_data_in[6] = s0_114_1__core_periphery__data_to_core[72];
			assign ch17_rx_data_in[5] = s0_114_1__core_periphery__data_to_core[74];
			assign ch17_rx_data_in[4] = s0_114_1__core_periphery__data_to_core[75];
			assign ch17_rx_data_in[3] = s0_114_1__core_periphery__data_to_core[104];
			assign ch17_rx_data_in[2] = s0_114_1__core_periphery__data_to_core[105];
			assign ch17_rx_data_in[1] = s0_114_1__core_periphery__data_to_core[107];
			assign ch17_rx_data_in[0] = s0_114_1__core_periphery__data_to_core[77];



			//assign ch18_rx_data_in[79] = s0_124_1__core_periphery__data_to_core[70];
			assign ch18_rx_data_in[77] = s0_124_1__core_periphery__data_to_core[100];
			assign ch18_rx_data_in[76] = s0_124_1__core_periphery__data_to_core[102];
			assign ch18_rx_data_in[75] = s0_124_1__core_periphery__data_to_core[72];
			assign ch18_rx_data_in[74] = s0_124_1__core_periphery__data_to_core[74];
			assign ch18_rx_data_in[73] = s0_124_1__core_periphery__data_to_core[75];
			assign ch18_rx_data_in[72] = s0_124_1__core_periphery__data_to_core[104];
			assign ch18_rx_data_in[71] = s0_124_1__core_periphery__data_to_core[105];
			assign ch18_rx_data_in[70] = s0_124_1__core_periphery__data_to_core[107];
			assign ch18_rx_data_in[69] = s0_124_1__core_periphery__data_to_core[77];
			assign ch18_rx_data_in[68] = s0_124_1__core_periphery__data_to_core[78];
			assign ch18_rx_data_in[67] = s0_124_1__core_periphery__data_to_core[79];
			assign ch18_rx_data_in[66] = s0_123_1__core_periphery__data_to_core[26];
			assign ch18_rx_data_in[65] = s0_123_1__core_periphery__data_to_core[24];
			assign ch18_rx_data_in[64] = s0_123_1__core_periphery__data_to_core[3];
			assign ch18_rx_data_in[63] = s0_123_1__core_periphery__data_to_core[2];
			assign ch18_rx_data_in[62] = s0_123_1__core_periphery__data_to_core[1];
			assign ch18_rx_data_in[61] = s0_123_1__core_periphery__data_to_core[31];
			assign ch18_rx_data_in[60] = s0_123_1__core_periphery__data_to_core[30];
			assign ch18_rx_data_in[59] = s0_123_1__core_periphery__data_to_core[28];
			assign ch18_rx_data_in[58] = s0_123_1__core_periphery__data_to_core[7];
			assign ch18_rx_data_in[57] = s0_123_1__core_periphery__data_to_core[5];
			assign ch18_rx_data_in[56] = s0_123_1__core_periphery__data_to_core[35];
			assign ch18_rx_data_in[55] = s0_123_1__core_periphery__data_to_core[33];
			assign ch18_rx_data_in[54] = s0_123_1__core_periphery__data_to_core[11];
			assign ch18_rx_data_in[53] = s0_123_1__core_periphery__data_to_core[10];
			assign ch18_rx_data_in[52] = s0_123_1__core_periphery__data_to_core[9];
			assign ch18_rx_data_in[51] = s0_123_1__core_periphery__data_to_core[8];
			assign ch18_rx_data_in[50] = s0_123_1__core_periphery__data_to_core[38];
			assign ch18_rx_data_in[49] = s0_123_1__core_periphery__data_to_core[36];
			assign ch18_rx_data_in[48] = s0_123_1__core_periphery__data_to_core[15];
			assign ch18_rx_data_in[47] = s0_123_1__core_periphery__data_to_core[14];
			assign ch18_rx_data_in[46] = s0_123_1__core_periphery__data_to_core[13];
			assign ch18_rx_data_in[45] = s0_123_1__core_periphery__data_to_core[43];
			assign ch18_rx_data_in[44] = s0_123_1__core_periphery__data_to_core[42];
			assign ch18_rx_data_in[43] = s0_123_1__core_periphery__data_to_core[40];
			assign ch18_rx_data_in[42] = s0_123_1__core_periphery__data_to_core[19];
			assign ch18_rx_data_in[41] = s0_123_1__core_periphery__data_to_core[17];
			assign ch18_rx_data_in[40] = s0_123_1__core_periphery__data_to_core[47];
			assign ch18_rx_data_in[39] = s0_123_1__core_periphery__data_to_core[45];
			//assign ch18_rx_data_in[39] = s0_123_1__core_periphery__data_to_core[23];
			assign ch18_rx_data_in[38] = s0_123_1__core_periphery__data_to_core[22];
			assign ch18_rx_data_in[37] = s0_123_1__core_periphery__data_to_core[20];
			assign ch18_rx_data_in[36] = s0_123_1__core_periphery__data_to_core[51];
			assign ch18_rx_data_in[35] = s0_123_1__core_periphery__data_to_core[49];
			assign ch18_rx_data_in[34] = s0_123_1__core_periphery__data_to_core[80];
			assign ch18_rx_data_in[33] = s0_123_1__core_periphery__data_to_core[82];
			assign ch18_rx_data_in[32] = s0_123_1__core_periphery__data_to_core[52];
			assign ch18_rx_data_in[31] = s0_123_1__core_periphery__data_to_core[54];
			assign ch18_rx_data_in[30] = s0_123_1__core_periphery__data_to_core[55];
			assign ch18_rx_data_in[29] = s0_123_1__core_periphery__data_to_core[84];
			assign ch18_rx_data_in[28] = s0_123_1__core_periphery__data_to_core[86];
			assign ch18_rx_data_in[27] = s0_123_1__core_periphery__data_to_core[87];
			assign ch18_rx_data_in[26] = s0_123_1__core_periphery__data_to_core[57];
			assign ch18_rx_data_in[25] = s0_123_1__core_periphery__data_to_core[58];
			assign ch18_rx_data_in[24] = s0_123_1__core_periphery__data_to_core[88];
			assign ch18_rx_data_in[23] = s0_123_1__core_periphery__data_to_core[90];
			assign ch18_rx_data_in[22] = s0_123_1__core_periphery__data_to_core[60];
			assign ch18_rx_data_in[21] = s0_123_1__core_periphery__data_to_core[62];
			assign ch18_rx_data_in[20] = s0_123_1__core_periphery__data_to_core[63];
			assign ch18_rx_data_in[19] = s0_123_1__core_periphery__data_to_core[92];
			assign ch18_rx_data_in[18] = s0_123_1__core_periphery__data_to_core[93];
			assign ch18_rx_data_in[17] = s0_123_1__core_periphery__data_to_core[95];
			assign ch18_rx_data_in[16] = s0_123_1__core_periphery__data_to_core[65];
			assign ch18_rx_data_in[15] = s0_123_1__core_periphery__data_to_core[66];
			assign ch18_rx_data_in[14] = s0_123_1__core_periphery__data_to_core[67];
			assign ch18_rx_data_in[13] = s0_123_1__core_periphery__data_to_core[96];
			assign ch18_rx_data_in[12] = s0_123_1__core_periphery__data_to_core[98];
			assign ch18_rx_data_in[11] = s0_123_1__core_periphery__data_to_core[99];
			assign ch18_rx_data_in[10] = s0_123_1__core_periphery__data_to_core[69];
			assign ch18_rx_data_in[9] = s0_123_1__core_periphery__data_to_core[70];
			assign ch18_rx_data_in[8] = s0_123_1__core_periphery__data_to_core[100];
			assign ch18_rx_data_in[7] = s0_123_1__core_periphery__data_to_core[102];
			assign ch18_rx_data_in[6] = s0_123_1__core_periphery__data_to_core[72];
			assign ch18_rx_data_in[5] = s0_123_1__core_periphery__data_to_core[74];
			assign ch18_rx_data_in[4] = s0_123_1__core_periphery__data_to_core[75];
			assign ch18_rx_data_in[3] = s0_123_1__core_periphery__data_to_core[104];
			assign ch18_rx_data_in[2] = s0_123_1__core_periphery__data_to_core[105];
			assign ch18_rx_data_in[1] = s0_123_1__core_periphery__data_to_core[107];
			assign ch18_rx_data_in[0] = s0_123_1__core_periphery__data_to_core[77];



			//assign ch19_rx_data_in[79] = s0_130_1__core_periphery__data_to_core[70];
			assign ch19_rx_data_in[77] = s0_130_1__core_periphery__data_to_core[100];
			assign ch19_rx_data_in[76] = s0_130_1__core_periphery__data_to_core[102];
			assign ch19_rx_data_in[75] = s0_130_1__core_periphery__data_to_core[72];
			assign ch19_rx_data_in[74] = s0_130_1__core_periphery__data_to_core[74];
			assign ch19_rx_data_in[73] = s0_130_1__core_periphery__data_to_core[75];
			assign ch19_rx_data_in[72] = s0_130_1__core_periphery__data_to_core[104];
			assign ch19_rx_data_in[71] = s0_130_1__core_periphery__data_to_core[105];
			assign ch19_rx_data_in[70] = s0_130_1__core_periphery__data_to_core[107];
			assign ch19_rx_data_in[69] = s0_130_1__core_periphery__data_to_core[77];
			assign ch19_rx_data_in[68] = s0_130_1__core_periphery__data_to_core[78];
			assign ch19_rx_data_in[67] = s0_130_1__core_periphery__data_to_core[79];
			assign ch19_rx_data_in[66] = s0_129_1__core_periphery__data_to_core[26];
			assign ch19_rx_data_in[65] = s0_129_1__core_periphery__data_to_core[24];
			assign ch19_rx_data_in[64] = s0_129_1__core_periphery__data_to_core[3];
			assign ch19_rx_data_in[63] = s0_129_1__core_periphery__data_to_core[2];
			assign ch19_rx_data_in[62] = s0_129_1__core_periphery__data_to_core[1];
			assign ch19_rx_data_in[61] = s0_129_1__core_periphery__data_to_core[31];
			assign ch19_rx_data_in[60] = s0_129_1__core_periphery__data_to_core[30];
			assign ch19_rx_data_in[59] = s0_129_1__core_periphery__data_to_core[28];
			assign ch19_rx_data_in[58] = s0_129_1__core_periphery__data_to_core[7];
			assign ch19_rx_data_in[57] = s0_129_1__core_periphery__data_to_core[5];
			assign ch19_rx_data_in[56] = s0_129_1__core_periphery__data_to_core[35];
			assign ch19_rx_data_in[55] = s0_129_1__core_periphery__data_to_core[33];
			assign ch19_rx_data_in[54] = s0_129_1__core_periphery__data_to_core[11];
			assign ch19_rx_data_in[53] = s0_129_1__core_periphery__data_to_core[10];
			assign ch19_rx_data_in[52] = s0_129_1__core_periphery__data_to_core[9];
			assign ch19_rx_data_in[51] = s0_129_1__core_periphery__data_to_core[8];
			assign ch19_rx_data_in[50] = s0_129_1__core_periphery__data_to_core[38];
			assign ch19_rx_data_in[49] = s0_129_1__core_periphery__data_to_core[36];
			assign ch19_rx_data_in[48] = s0_129_1__core_periphery__data_to_core[15];
			assign ch19_rx_data_in[47] = s0_129_1__core_periphery__data_to_core[14];
			assign ch19_rx_data_in[46] = s0_129_1__core_periphery__data_to_core[13];
			assign ch19_rx_data_in[45] = s0_129_1__core_periphery__data_to_core[43];
			assign ch19_rx_data_in[44] = s0_129_1__core_periphery__data_to_core[42];
			assign ch19_rx_data_in[43] = s0_129_1__core_periphery__data_to_core[40];
			assign ch19_rx_data_in[42] = s0_129_1__core_periphery__data_to_core[19];
			assign ch19_rx_data_in[41] = s0_129_1__core_periphery__data_to_core[17];
			assign ch19_rx_data_in[40] = s0_129_1__core_periphery__data_to_core[47];
			assign ch19_rx_data_in[39] = s0_129_1__core_periphery__data_to_core[45];
			//assign ch19_rx_data_in[39] = s0_129_1__core_periphery__data_to_core[23];
			assign ch19_rx_data_in[38] = s0_129_1__core_periphery__data_to_core[22];
			assign ch19_rx_data_in[37] = s0_129_1__core_periphery__data_to_core[20];
			assign ch19_rx_data_in[36] = s0_129_1__core_periphery__data_to_core[51];
			assign ch19_rx_data_in[35] = s0_129_1__core_periphery__data_to_core[49];
			assign ch19_rx_data_in[34] = s0_129_1__core_periphery__data_to_core[80];
			assign ch19_rx_data_in[33] = s0_129_1__core_periphery__data_to_core[82];
			assign ch19_rx_data_in[32] = s0_129_1__core_periphery__data_to_core[52];
			assign ch19_rx_data_in[31] = s0_129_1__core_periphery__data_to_core[54];
			assign ch19_rx_data_in[30] = s0_129_1__core_periphery__data_to_core[55];
			assign ch19_rx_data_in[29] = s0_129_1__core_periphery__data_to_core[84];
			assign ch19_rx_data_in[28] = s0_129_1__core_periphery__data_to_core[86];
			assign ch19_rx_data_in[27] = s0_129_1__core_periphery__data_to_core[87];
			assign ch19_rx_data_in[26] = s0_129_1__core_periphery__data_to_core[57];
			assign ch19_rx_data_in[25] = s0_129_1__core_periphery__data_to_core[58];
			assign ch19_rx_data_in[24] = s0_129_1__core_periphery__data_to_core[88];
			assign ch19_rx_data_in[23] = s0_129_1__core_periphery__data_to_core[90];
			assign ch19_rx_data_in[22] = s0_129_1__core_periphery__data_to_core[60];
			assign ch19_rx_data_in[21] = s0_129_1__core_periphery__data_to_core[62];
			assign ch19_rx_data_in[20] = s0_129_1__core_periphery__data_to_core[63];
			assign ch19_rx_data_in[19] = s0_129_1__core_periphery__data_to_core[92];
			assign ch19_rx_data_in[18] = s0_129_1__core_periphery__data_to_core[93];
			assign ch19_rx_data_in[17] = s0_129_1__core_periphery__data_to_core[95];
			assign ch19_rx_data_in[16] = s0_129_1__core_periphery__data_to_core[65];
			assign ch19_rx_data_in[15] = s0_129_1__core_periphery__data_to_core[66];
			assign ch19_rx_data_in[14] = s0_129_1__core_periphery__data_to_core[67];
			assign ch19_rx_data_in[13] = s0_129_1__core_periphery__data_to_core[96];
			assign ch19_rx_data_in[12] = s0_129_1__core_periphery__data_to_core[98];
			assign ch19_rx_data_in[11] = s0_129_1__core_periphery__data_to_core[99];
			assign ch19_rx_data_in[10] = s0_129_1__core_periphery__data_to_core[69];
			assign ch19_rx_data_in[9] = s0_129_1__core_periphery__data_to_core[70];
			assign ch19_rx_data_in[8] = s0_129_1__core_periphery__data_to_core[100];
			assign ch19_rx_data_in[7] = s0_129_1__core_periphery__data_to_core[102];
			assign ch19_rx_data_in[6] = s0_129_1__core_periphery__data_to_core[72];
			assign ch19_rx_data_in[5] = s0_129_1__core_periphery__data_to_core[74];
			assign ch19_rx_data_in[4] = s0_129_1__core_periphery__data_to_core[75];
			assign ch19_rx_data_in[3] = s0_129_1__core_periphery__data_to_core[104];
			assign ch19_rx_data_in[2] = s0_129_1__core_periphery__data_to_core[105];
			assign ch19_rx_data_in[1] = s0_129_1__core_periphery__data_to_core[107];
			assign ch19_rx_data_in[0] = s0_129_1__core_periphery__data_to_core[77];



			//assign ch20_rx_data_in[79] = s0_136_1__core_periphery__data_to_core[70];
			assign ch20_rx_data_in[77] = s0_136_1__core_periphery__data_to_core[100];
			assign ch20_rx_data_in[76] = s0_136_1__core_periphery__data_to_core[102];
			assign ch20_rx_data_in[75] = s0_136_1__core_periphery__data_to_core[72];
			assign ch20_rx_data_in[74] = s0_136_1__core_periphery__data_to_core[74];
			assign ch20_rx_data_in[73] = s0_136_1__core_periphery__data_to_core[75];
			assign ch20_rx_data_in[72] = s0_136_1__core_periphery__data_to_core[104];
			assign ch20_rx_data_in[71] = s0_136_1__core_periphery__data_to_core[105];
			assign ch20_rx_data_in[70] = s0_136_1__core_periphery__data_to_core[107];
			assign ch20_rx_data_in[69] = s0_136_1__core_periphery__data_to_core[77];
			assign ch20_rx_data_in[68] = s0_136_1__core_periphery__data_to_core[78];
			assign ch20_rx_data_in[67] = s0_136_1__core_periphery__data_to_core[79];
			assign ch20_rx_data_in[66] = s0_135_1__core_periphery__data_to_core[26];
			assign ch20_rx_data_in[65] = s0_135_1__core_periphery__data_to_core[24];
			assign ch20_rx_data_in[64] = s0_135_1__core_periphery__data_to_core[3];
			assign ch20_rx_data_in[63] = s0_135_1__core_periphery__data_to_core[2];
			assign ch20_rx_data_in[62] = s0_135_1__core_periphery__data_to_core[1];
			assign ch20_rx_data_in[61] = s0_135_1__core_periphery__data_to_core[31];
			assign ch20_rx_data_in[60] = s0_135_1__core_periphery__data_to_core[30];
			assign ch20_rx_data_in[59] = s0_135_1__core_periphery__data_to_core[28];
			assign ch20_rx_data_in[58] = s0_135_1__core_periphery__data_to_core[7];
			assign ch20_rx_data_in[57] = s0_135_1__core_periphery__data_to_core[5];
			assign ch20_rx_data_in[56] = s0_135_1__core_periphery__data_to_core[35];
			assign ch20_rx_data_in[55] = s0_135_1__core_periphery__data_to_core[33];
			assign ch20_rx_data_in[54] = s0_135_1__core_periphery__data_to_core[11];
			assign ch20_rx_data_in[53] = s0_135_1__core_periphery__data_to_core[10];
			assign ch20_rx_data_in[52] = s0_135_1__core_periphery__data_to_core[9];
			assign ch20_rx_data_in[51] = s0_135_1__core_periphery__data_to_core[8];
			assign ch20_rx_data_in[50] = s0_135_1__core_periphery__data_to_core[38];
			assign ch20_rx_data_in[49] = s0_135_1__core_periphery__data_to_core[36];
			assign ch20_rx_data_in[48] = s0_135_1__core_periphery__data_to_core[15];
			assign ch20_rx_data_in[47] = s0_135_1__core_periphery__data_to_core[14];
			assign ch20_rx_data_in[46] = s0_135_1__core_periphery__data_to_core[13];
			assign ch20_rx_data_in[45] = s0_135_1__core_periphery__data_to_core[43];
			assign ch20_rx_data_in[44] = s0_135_1__core_periphery__data_to_core[42];
			assign ch20_rx_data_in[43] = s0_135_1__core_periphery__data_to_core[40];
			assign ch20_rx_data_in[42] = s0_135_1__core_periphery__data_to_core[19];
			assign ch20_rx_data_in[41] = s0_135_1__core_periphery__data_to_core[17];
			assign ch20_rx_data_in[40] = s0_135_1__core_periphery__data_to_core[47];
			assign ch20_rx_data_in[39] = s0_135_1__core_periphery__data_to_core[45];
			//assign ch20_rx_data_in[39] = s0_135_1__core_periphery__data_to_core[23];
			assign ch20_rx_data_in[38] = s0_135_1__core_periphery__data_to_core[22];
			assign ch20_rx_data_in[37] = s0_135_1__core_periphery__data_to_core[20];
			assign ch20_rx_data_in[36] = s0_135_1__core_periphery__data_to_core[51];
			assign ch20_rx_data_in[35] = s0_135_1__core_periphery__data_to_core[49];
			assign ch20_rx_data_in[34] = s0_135_1__core_periphery__data_to_core[80];
			assign ch20_rx_data_in[33] = s0_135_1__core_periphery__data_to_core[82];
			assign ch20_rx_data_in[32] = s0_135_1__core_periphery__data_to_core[52];
			assign ch20_rx_data_in[31] = s0_135_1__core_periphery__data_to_core[54];
			assign ch20_rx_data_in[30] = s0_135_1__core_periphery__data_to_core[55];
			assign ch20_rx_data_in[29] = s0_135_1__core_periphery__data_to_core[84];
			assign ch20_rx_data_in[28] = s0_135_1__core_periphery__data_to_core[86];
			assign ch20_rx_data_in[27] = s0_135_1__core_periphery__data_to_core[87];
			assign ch20_rx_data_in[26] = s0_135_1__core_periphery__data_to_core[57];
			assign ch20_rx_data_in[25] = s0_135_1__core_periphery__data_to_core[58];
			assign ch20_rx_data_in[24] = s0_135_1__core_periphery__data_to_core[88];
			assign ch20_rx_data_in[23] = s0_135_1__core_periphery__data_to_core[90];
			assign ch20_rx_data_in[22] = s0_135_1__core_periphery__data_to_core[60];
			assign ch20_rx_data_in[21] = s0_135_1__core_periphery__data_to_core[62];
			assign ch20_rx_data_in[20] = s0_135_1__core_periphery__data_to_core[63];
			assign ch20_rx_data_in[19] = s0_135_1__core_periphery__data_to_core[92];
			assign ch20_rx_data_in[18] = s0_135_1__core_periphery__data_to_core[93];
			assign ch20_rx_data_in[17] = s0_135_1__core_periphery__data_to_core[95];
			assign ch20_rx_data_in[16] = s0_135_1__core_periphery__data_to_core[65];
			assign ch20_rx_data_in[15] = s0_135_1__core_periphery__data_to_core[66];
			assign ch20_rx_data_in[14] = s0_135_1__core_periphery__data_to_core[67];
			assign ch20_rx_data_in[13] = s0_135_1__core_periphery__data_to_core[96];
			assign ch20_rx_data_in[12] = s0_135_1__core_periphery__data_to_core[98];
			assign ch20_rx_data_in[11] = s0_135_1__core_periphery__data_to_core[99];
			assign ch20_rx_data_in[10] = s0_135_1__core_periphery__data_to_core[69];
			assign ch20_rx_data_in[9] = s0_135_1__core_periphery__data_to_core[70];
			assign ch20_rx_data_in[8] = s0_135_1__core_periphery__data_to_core[100];
			assign ch20_rx_data_in[7] = s0_135_1__core_periphery__data_to_core[102];
			assign ch20_rx_data_in[6] = s0_135_1__core_periphery__data_to_core[72];
			assign ch20_rx_data_in[5] = s0_135_1__core_periphery__data_to_core[74];
			assign ch20_rx_data_in[4] = s0_135_1__core_periphery__data_to_core[75];
			assign ch20_rx_data_in[3] = s0_135_1__core_periphery__data_to_core[104];
			assign ch20_rx_data_in[2] = s0_135_1__core_periphery__data_to_core[105];
			assign ch20_rx_data_in[1] = s0_135_1__core_periphery__data_to_core[107];
			assign ch20_rx_data_in[0] = s0_135_1__core_periphery__data_to_core[77];


			//assign ch21_rx_data_in[79] = s0_143_1__core_periphery__data_to_core[70];
			assign ch21_rx_data_in[77] = s0_143_1__core_periphery__data_to_core[100];
			assign ch21_rx_data_in[76] = s0_143_1__core_periphery__data_to_core[102];
			assign ch21_rx_data_in[75] = s0_143_1__core_periphery__data_to_core[72];
			assign ch21_rx_data_in[74] = s0_143_1__core_periphery__data_to_core[74];
			assign ch21_rx_data_in[73] = s0_143_1__core_periphery__data_to_core[75];
			assign ch21_rx_data_in[72] = s0_143_1__core_periphery__data_to_core[104];
			assign ch21_rx_data_in[71] = s0_143_1__core_periphery__data_to_core[105];
			assign ch21_rx_data_in[70] = s0_143_1__core_periphery__data_to_core[107];
			assign ch21_rx_data_in[69] = s0_143_1__core_periphery__data_to_core[77];
			assign ch21_rx_data_in[68] = s0_143_1__core_periphery__data_to_core[78];
			assign ch21_rx_data_in[67] = s0_143_1__core_periphery__data_to_core[79];
			assign ch21_rx_data_in[66] = s0_142_1__core_periphery__data_to_core[26];
			assign ch21_rx_data_in[65] = s0_142_1__core_periphery__data_to_core[24];
			assign ch21_rx_data_in[64] = s0_142_1__core_periphery__data_to_core[3];
			assign ch21_rx_data_in[63] = s0_142_1__core_periphery__data_to_core[2];
			assign ch21_rx_data_in[62] = s0_142_1__core_periphery__data_to_core[1];
			assign ch21_rx_data_in[61] = s0_142_1__core_periphery__data_to_core[31];
			assign ch21_rx_data_in[60] = s0_142_1__core_periphery__data_to_core[30];
			assign ch21_rx_data_in[59] = s0_142_1__core_periphery__data_to_core[28];
			assign ch21_rx_data_in[58] = s0_142_1__core_periphery__data_to_core[7];
			assign ch21_rx_data_in[57] = s0_142_1__core_periphery__data_to_core[5];
			assign ch21_rx_data_in[56] = s0_142_1__core_periphery__data_to_core[35];
			assign ch21_rx_data_in[55] = s0_142_1__core_periphery__data_to_core[33];
			assign ch21_rx_data_in[54] = s0_142_1__core_periphery__data_to_core[11];
			assign ch21_rx_data_in[53] = s0_142_1__core_periphery__data_to_core[10];
			assign ch21_rx_data_in[52] = s0_142_1__core_periphery__data_to_core[9];
			assign ch21_rx_data_in[51] = s0_142_1__core_periphery__data_to_core[8];
			assign ch21_rx_data_in[50] = s0_142_1__core_periphery__data_to_core[38];
			assign ch21_rx_data_in[49] = s0_142_1__core_periphery__data_to_core[36];
			assign ch21_rx_data_in[48] = s0_142_1__core_periphery__data_to_core[15];
			assign ch21_rx_data_in[47] = s0_142_1__core_periphery__data_to_core[14];
			assign ch21_rx_data_in[46] = s0_142_1__core_periphery__data_to_core[13];
			assign ch21_rx_data_in[45] = s0_142_1__core_periphery__data_to_core[43];
			assign ch21_rx_data_in[44] = s0_142_1__core_periphery__data_to_core[42];
			assign ch21_rx_data_in[43] = s0_142_1__core_periphery__data_to_core[40];
			assign ch21_rx_data_in[42] = s0_142_1__core_periphery__data_to_core[19];
			assign ch21_rx_data_in[41] = s0_142_1__core_periphery__data_to_core[17];
			assign ch21_rx_data_in[40] = s0_142_1__core_periphery__data_to_core[47];
			assign ch21_rx_data_in[39] = s0_142_1__core_periphery__data_to_core[45];
			//assign ch21_rx_data_in[39] = s0_142_1__core_periphery__data_to_core[23];
			assign ch21_rx_data_in[38] = s0_142_1__core_periphery__data_to_core[22];
			assign ch21_rx_data_in[37] = s0_142_1__core_periphery__data_to_core[20];
			assign ch21_rx_data_in[36] = s0_142_1__core_periphery__data_to_core[51];
			assign ch21_rx_data_in[35] = s0_142_1__core_periphery__data_to_core[49];
			assign ch21_rx_data_in[34] = s0_142_1__core_periphery__data_to_core[80];
			assign ch21_rx_data_in[33] = s0_142_1__core_periphery__data_to_core[82];
			assign ch21_rx_data_in[32] = s0_142_1__core_periphery__data_to_core[52];
			assign ch21_rx_data_in[31] = s0_142_1__core_periphery__data_to_core[54];
			assign ch21_rx_data_in[30] = s0_142_1__core_periphery__data_to_core[55];
			assign ch21_rx_data_in[29] = s0_142_1__core_periphery__data_to_core[84];
			assign ch21_rx_data_in[28] = s0_142_1__core_periphery__data_to_core[86];
			assign ch21_rx_data_in[27] = s0_142_1__core_periphery__data_to_core[87];
			assign ch21_rx_data_in[26] = s0_142_1__core_periphery__data_to_core[57];
			assign ch21_rx_data_in[25] = s0_142_1__core_periphery__data_to_core[58];
			assign ch21_rx_data_in[24] = s0_142_1__core_periphery__data_to_core[88];
			assign ch21_rx_data_in[23] = s0_142_1__core_periphery__data_to_core[90];
			assign ch21_rx_data_in[22] = s0_142_1__core_periphery__data_to_core[60];
			assign ch21_rx_data_in[21] = s0_142_1__core_periphery__data_to_core[62];
			assign ch21_rx_data_in[20] = s0_142_1__core_periphery__data_to_core[63];
			assign ch21_rx_data_in[19] = s0_142_1__core_periphery__data_to_core[92];
			assign ch21_rx_data_in[18] = s0_142_1__core_periphery__data_to_core[93];
			assign ch21_rx_data_in[17] = s0_142_1__core_periphery__data_to_core[95];
			assign ch21_rx_data_in[16] = s0_142_1__core_periphery__data_to_core[65];
			assign ch21_rx_data_in[15] = s0_142_1__core_periphery__data_to_core[66];
			assign ch21_rx_data_in[14] = s0_142_1__core_periphery__data_to_core[67];
			assign ch21_rx_data_in[13] = s0_142_1__core_periphery__data_to_core[96];
			assign ch21_rx_data_in[12] = s0_142_1__core_periphery__data_to_core[98];
			assign ch21_rx_data_in[11] = s0_142_1__core_periphery__data_to_core[99];
			assign ch21_rx_data_in[10] = s0_142_1__core_periphery__data_to_core[69];
			assign ch21_rx_data_in[9] = s0_142_1__core_periphery__data_to_core[70];
			assign ch21_rx_data_in[8] = s0_142_1__core_periphery__data_to_core[100];
			assign ch21_rx_data_in[7] = s0_142_1__core_periphery__data_to_core[102];
			assign ch21_rx_data_in[6] = s0_142_1__core_periphery__data_to_core[72];
			assign ch21_rx_data_in[5] = s0_142_1__core_periphery__data_to_core[74];
			assign ch21_rx_data_in[4] = s0_142_1__core_periphery__data_to_core[75];
			assign ch21_rx_data_in[3] = s0_142_1__core_periphery__data_to_core[104];
			assign ch21_rx_data_in[2] = s0_142_1__core_periphery__data_to_core[105];
			assign ch21_rx_data_in[1] = s0_142_1__core_periphery__data_to_core[107];
			assign ch21_rx_data_in[0] = s0_142_1__core_periphery__data_to_core[77];	

	end 							  
	endgenerate	
	
endmodule

`ifdef SIM_MODE
//module to insert delay in the datapath
module hip_aib_adaptor #(
//VCS coverage off
   parameter DWIDTH  = 16
)(
   input  [7:0]         delay,
   input                clk,
   input                rst_n,
   input  [DWIDTH-1:0]  d,
   output [DWIDTH-1:0]  q
);
   logic  [DWIDTH-1:0]  fifo[$];
   logic  [DWIDTH-1:0]  q_r;
   logic                dsk_r;

   always @ (posedge clk)
   begin
      if (rst_n === 1'b0)
      begin
         dsk_r <= 0;
         q_r <= 'h0;
         fifo = {};
      end
      else
      begin
         fifo.push_back(d);
         if (fifo.size() >= delay)
         begin
            dsk_r <= 1;
            q_r <= fifo.pop_front();
         end
      end
   end

   assign q = ~rst_n ? 'h0 : (delay === 8'h0) ? d : q_r;

//VCS coverage on
endmodule : hip_aib_adaptor
`endif